
function CreateGrants()
	CreateTrafficTerminal()
	CreateCargoStationDeliveries()
	CreateCargoStationGarbage()
	CreateCargoStationExports()
	CreateCargoStationIntake()
	CreateCargoStationEmergency()
	CreateCargoStationCallout()
	CreateBootstrapGrants()
	CreateRecycleGrant()
	CreateGarden()
	CreateGardenProduction()
	CreateBarberShop()
	CreateWigProduction()
	CreateMorgue2()
	CreateParlour2()
	CreateCemetery2()
	CreateCoffinWorkshop2()
	CreateCoffinProduction2()
	CreateCemetery2Jobs()
	CreateCottonPlantation()
	CreateCottonProduction()
	CreateManufactury()
	CreateJeanProduction()
	CreateLimoGarage2()
	CreateLimoMechanics2()
	CreateMoneyLaundry()
	CreateMoneyLaundryProduction()
	CreatePhonefactory()
	CreatePhonesProduction()
  	-- CreatePrisonBoxingGrant()
	CreatePrisonerForestry()
	CreateTazerTherapy3()
end

function CreateTrafficTerminal()
	Objective.CreateGrant			( "Grant_TrafficTerminal", 2000, 25000 )
		
	Objective.CreateGrant			( "Grant_TrafficTerminal_CreateTerminalA", 0, 0 )
	Objective.SetParent				( "Grant_TrafficTerminal" )
    Objective.RequireRoom           ( "Deliveries", true )
	
	Objective.CreateGrant			( "Grant_TrafficTerminal_CreateTerminalB", 0, 0 )
	Objective.SetParent				( "Grant_TrafficTerminal" )
	Objective.RequireObjects		( "GrantCheckerTerminal", 1 )
	
	Objective.CreateGrant			( "Grant_TrafficTerminal_CreateTerminalC", 0, 0 )
	Objective.SetParent				( "Grant_TrafficTerminal" )
	Objective.RequireObjects		( "PreviewTruckSkinBG", 1 )
end

function CreateCargoStationDeliveries()
	Objective.CreateGrant			( "Grant_CargoStation_Deliveries", 2000, 5000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_TrafficTerminal", 0 )
	
	Objective.CreateGrant			( "Grant_CargoStation_Deliveries_CreateStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Deliveries" )
    Objective.RequireRoom           ( "CargoStorage", true )
	
	Objective.CreateGrant			( "Grant_CargoStation_Deliveries_EnableStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Deliveries" )
	Objective.RequireObjects		( "GrantCheckerDeliveries", 1 )
end

function CreateCargoStationGarbage()
	Objective.CreateGrant			( "Grant_CargoStation_Garbage", 2000, 5000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_TrafficTerminal", 0 )

	Objective.CreateGrant			( "Grant_CargoStation_Garbage_CreateStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Garbage" )
    Objective.RequireRoom           ( "Garbage", true )
	
	Objective.CreateGrant			( "Grant_CargoStation_Garbage_EnableStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Garbage" )
	Objective.RequireObjects		( "GrantCheckerGarbage", 1 )
end

function CreateCargoStationExports()
	Objective.CreateGrant			( "Grant_CargoStation_Exports", 2000, 5000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_TrafficTerminal", 0 )
	
	Objective.CreateGrant			( "Grant_CargoStation_Exports_CreateStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Exports" )
    Objective.RequireRoom           ( "Exports", true )
	
	Objective.CreateGrant			( "Grant_CargoStation_Exports_EnableStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Exports" )
	Objective.RequireObjects		( "GrantCheckerExports", 1 )
end

function CreateCargoStationIntake()
	Objective.CreateGrant			( "Grant_CargoStation_Intake", 2000, 5000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_TrafficTerminal", 0 )
	
	Objective.CreateGrant			( "Grant_CargoStation_Intake_CreateStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Intake" )
    Objective.RequireRoom           ( "CargoIntake", true )
	
	Objective.CreateGrant			( "Grant_CargoStation_Intake_EnableStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Intake" )
	Objective.RequireObjects		( "GrantCheckerIntake", 1 )
end

function CreateCargoStationEmergency()
	Objective.CreateGrant			( "Grant_CargoStation_Emergency", 2000, 5000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_TrafficTerminal", 0 )
	Objective.CreateGrant			( "Grant_CargoStation_Emergency_CreateStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Emergency" )
    Objective.RequireRoom           ( "CargoEmergencies", true )
	
	Objective.CreateGrant			( "Grant_CargoStation_Emergency_EnableStation", 0, 0 )
	Objective.SetParent				( "Grant_CargoStation_Emergency" )
	Objective.RequireObjects		( "GrantCheckerEmergency", 1 )
end

function CreateCargoStationCallout()
	Objective.CreateGrant			( "Grant_ChinookCallout", 2000, 5000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_CargoStation_Emergency", 0 )
	
	Objective.CreateGrant			( "Grant_ChinookCallout_CreateEmergencyStation", 0, 0 )
	Objective.SetParent				( "Grant_ChinookCallout" )
	Objective.RequireObjects		( "CargoStationFireEngine", 1 )
	
	Objective.CreateGrant			( "Grant_ChinookCallout_FireStarter", 0, 0 )
	Objective.SetParent				( "Grant_ChinookCallout" )
	Objective.RequireObjects		( "Fire", 20 )
	
	Objective.CreateGrant			( "Grant_ChinookCallout_CalloutHelipad", 0, 0 )
	Objective.SetParent				( "Grant_ChinookCallout" )
	Objective.RequireObjects		( "CalloutHelipad", 2 )
	
	Objective.CreateGrant			( "Grant_ChinookCallout_Callout1", 0, 0 )
	Objective.SetParent				( "Grant_ChinookCallout" )
	Objective.RequireObjects		( "Chinook2", 1 )
	Objective.RequireObjects		( "Fireman", 8 )
	
	Objective.CreateGrant			( "Grant_ChinookCallout_Callout2", 0, 0 )
	Objective.SetParent				( "Grant_ChinookCallout" )
	Objective.RequireObjects		( "FireEngineTruckSkin", 1 )
	Objective.RequireObjects		( "Fireman", 16 )
end

function CreateBootstrapGrants()

	-- Basic Detention Centre
	
	Objective.CreateGrant			( "Grant_bootstraps", 20000, 10000 )
	
	Objective.CreateGrant			( "Grant_bootstraps_holdingcell", 0, 0 )	
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireEitherRoom		( "PaddedHoldingCell", "HoldingCell", true )
	
	Objective.CreateGrant			( "Grant_bootstraps_shower", 0, 0 )	
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireRoom			( "Shower", true )
	
	Objective.CreateGrant			( "Grant_bootstraps_yard", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireRoom			( "Yard", true )

	Objective.CreateGrant			( "Grant_bootstraps_kitchen", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireRoom			( "Kitchen", true )
	
	Objective.CreateGrant			( "Grant_bootstraps_canteen", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireRoom			( "Canteen", true )

	Objective.CreateGrant			( "Grant_bootstraps_guard", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireObjects		( "Guard", 2 )

	Objective.CreateGrant			( "Grant_bootstraps_chef", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireObjects		( "Cook", 2 )

	
	-- Basic Administrative set up
	
	Objective.CreateGrant			( "Grant_Administration", 5000, 5000 )
	
	Objective.CreateGrant			( "Grant_Administration_offices", 0, 0 )
	Objective.SetParent				( "Grant_Administration" )
	Objective.RequireRoomsAvailable	( "Office", 1 )
	
	Objective.CreateGrant			( "Grant_Administration_Warden", 0, 0 )
	Objective.SetParent				( "Grant_Administration" )
	Objective.RequireObjects		( "Warden", 1 )
	
	Objective.CreateGrant			( "Grant_Administration_headquarters", 0, 0 )
	Objective.SetParent				( "Grant_Administration" )
	Objective.RequireRoomsAvailable	( "Headquarters", 1 )
	
	Objective.CreateGrant			( "Grant_Administration_Accountant_Research", 0, 0 )
	Objective.SetParent				( "Grant_Administration" )
	Objective.RequireResearched		( "Finance" )
	
	Objective.CreateGrant			( "Grant_Administration_Accountant", 0, 0 )
	Objective.SetParent				( "Grant_Administration" )
	Objective.RequireObjects		( "Accountant", 1 )
	
end

function CreateChinookDeliveries()
	Objective.CreateGrant			( "Grant_ChinookDeliveries", 2000, 15000 )
		
	Objective.CreateGrant			( "Grant_ChinookDeliveries_ChinookControlTower", 0, 0 )
	Objective.SetParent				( "Grant_ChinookDeliveries" )
	Objective.RequireObjects		( "ChinookDeliveryTerminal", 1 )
	
	Objective.CreateGrant			( "Grant_ChinookDeliveries_ChinookHelipad", 0, 0 )
	Objective.SetParent				( "Grant_ChinookDeliveries" )
	Objective.RequireObjects		( "ChinookPadDelivery", 1 )
end

function CreateChinookIntake()
	Objective.CreateGrant			( "Grant_ChinookIntake", 2000, 15000 )
	
	Objective.CreateGrant			( "Grant_ChinookIntake_ChinookControlTower", 0, 0 )
	Objective.SetParent				( "Grant_ChinookIntake" )
	Objective.RequireObjects		( "ChinookIntakeTerminal", 1 )

	Objective.CreateGrant			( "Grant_ChinookIntake_ChinookHelipad", 0, 0 )
	Objective.SetParent				( "Grant_ChinookIntake" )
	Objective.RequireObjects		( "ChinookPadIntake", 1 )
	
	Objective.CreateGrant			( "Grant_ChinookIntake_ChinookFuelRoom", 0, 0 )
	Objective.SetParent				( "Grant_ChinookIntake" )
	Objective.RequireRoom			( "ChinookFuelDepot", true )
end

function CreateChinookExports()
	Objective.CreateGrant			( "Grant_ChinookExports", 2000, 15000 )
		
	Objective.CreateGrant			( "Grant_ChinookExports_ChinookHelipad", 0, 0 )
	Objective.SetParent				( "Grant_ChinookExports" )
	Objective.RequireObjects		( "ChinookPadExports", 1 )
end

function CreateChinookFiremen()
	Objective.CreateGrant			( "Grant_ChinookFiremen", 1500, 15000 )
		
	Objective.CreateGrant			( "Grant_ChinookFiremen_ChinookFireStarter", 0, 0 )
	Objective.SetParent				( "Grant_ChinookFiremen" )
	Objective.RequireObjects		( "Fire", 20 )
	
	Objective.CreateGrant			( "Grant_ChinookFiremen_ChinookHelipad", 0, 0 )
	Objective.SetParent				( "Grant_ChinookFiremen" )
	Objective.RequireObjects		( "ChinookPadFireman", 1 )
	
	
	Objective.CreateGrant			( "Grant_ChinookFiremen_ChinookCallout", 0, 0 )
	Objective.SetParent				( "Grant_ChinookFiremen" )
	Objective.RequireObjects		( "ChinookFireman", 1 )
end

function CreateFireBrigade()
	Objective.CreateGrant			( "Grant_FireBrigade", 1500, 2500 )

	Objective.CreateGrant			( "Grant_FireBrigade_WaterTankNumber", 0, 0 )
	Objective.SetParent				( "Grant_FireBrigade" )
	Objective.RequireObjects		( "WaterTank", 1 )
	
	Objective.CreateGrant			( "Grant_FireBrigade_FireBrigadeRoom", 0, 0 )
	Objective.SetParent				( "Grant_FireBrigade" )
	Objective.RequireRoom			( "PrisonFireBrigade", true )
	
	Objective.CreateGrant			( "Grant_FireBrigade_LockerNumber", 0, 0 )
	Objective.SetParent				( "Grant_FireBrigade" )
	Objective.RequireObjects		( "FiremanLocker", 4 )
	
	Objective.CreateGrant			( "Grant_FireBrigade_ShowerNumber", 0, 0 )
	Objective.SetParent				( "Grant_FireBrigade" )
	Objective.RequireObjects		( "FiremanShowerHead", 4 )
	
	Objective.CreateGrant			( "Grant_FireBrigade_FiremenNumber", 0, 0 )
	Objective.SetParent				( "Grant_FireBrigade" )
	Objective.RequireObjects		( "PrisonFiremanA0", 1 )
	Objective.RequireObjects		( "PrisonFiremanA1", 1 )
	Objective.RequireObjects		( "PrisonFiremanA2", 1 )
	Objective.RequireObjects		( "PrisonFiremanA3", 1 )
	
	Objective.CreateGrant			( "Grant_FireBrigade_FireStarter", 0, 0 )
	Objective.SetParent				( "Grant_FireBrigade" )
	Objective.RequireObjects		( "Fire", 20 )
end

function CreateBarberShop()

	Objective.CreateGrant			( "Grant_Barber_Shop", 1500, 2500 )
    Objective.SetPreRequisite       ( "Unlocked", "PrisonLabour", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_Barber_Shop_Research", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.Requires				( "Unlocked", "HairCut", 0 )
	
	Objective.CreateGrant			( "Grant_Barber_Shop_BarberShopRoom", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.RequireRoom			( "BarberShop", true )
	
	Objective.CreateGrant			( "Grant_Barber_Shop_BarberChairNumber", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.RequireObjects		( "BarberChair", 4 )
	
	Objective.CreateGrant			( "Grant_Barber_Shop_BarberMirrorNumber", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.RequireObjects		( "BarberMirror", 4 )
	
	Objective.CreateGrant			( "Grant_Barber_Shop_WigProductionRoom", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.RequireRoom			( "WigProductionRoom", true )
	
	Objective.CreateGrant			( "Grant_Barber_Shop_BlondNumber", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.RequireObjects		( "BlondBarberPress", 1 )
	
	Objective.CreateGrant			( "Grant_Barber_Shop_BrownNumber", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.RequireObjects		( "BrownBarberPress", 1 )
	
	Objective.CreateGrant			( "Grant_Barber_Shop_RedNumber", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.RequireObjects		( "RedBarberPress", 1 )
	
	Objective.CreateGrant			( "Grant_Barber_Shop_BarberChiefNumber", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.RequireObjects		( "BarberChief", 1 )
	
	Objective.CreateGrant			( "Grant_Barber_Shop_BarberNumber", 0, 0 )
	Objective.SetParent				( "Grant_Barber_Shop" )
	Objective.RequireObjects		( "Barber", 1 )
end

function CreateWigProduction()
	Objective.CreateGrant			( "Grant_Wig_Production", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "HairCut", 0 )
    Objective.HiddenWhileLocked     ()
	
	Objective.CreateGrant			( "Grant_Wig_Production_Research", 0, 0 )
	Objective.SetParent				( "Grant_Wig_Production" )
	Objective.Requires				( "Completed", "Grant_Barber_Shop", 0 )
	
	Objective.CreateGrant			( "Grant_Wig_Production_ProgramPassed", 0, 0 )
	Objective.SetParent				( "Grant_Wig_Production" )
	Objective.Requires				( "ReformPassed", "HowToCut", 2 )
	
	Objective.CreateGrant			( "Grant_Wig_Production_BarberAssigned", 0, 0 )
	Objective.SetParent				( "Grant_Wig_Production")
	Objective.Requires				( "PrisonerJobs", "BarberShop", 1 )
	
	Objective.CreateGrant			( "Grant_Wig_Production_WigAssigned", 0, 0 )
	Objective.SetParent				( "Grant_Wig_Production")
	Objective.Requires				( "PrisonerJobs", "WigProductionRoom", 1 )
	
	Objective.CreateGrant			( "Grant_Wig_Production_WigProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Wig_Production")
	Objective.RequireManufactured 	( "WigBox", 40 )
	
	Objective.CreateGrant			( "Grant_Wig_Production_RedWigProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Wig_Production")
	Objective.RequireManufactured 	( "RedWigBox", 5 )
end

-- function CreatePrisonBoxingGrant()
	-- Objective.CreateGrant			( "Grant_PrisonBoxing", 1500, 2500 )
    -- Objective.SetPreRequisite       ( "Unlocked", "MentalHealth", 0 )
    -- Objective.HiddenWhileLocked     ()

	-- Objective.CreateGrant			( "Grant_PrisonBoxing_Research", 0, 0 )
	-- Objective.SetParent				( "Grant_PrisonBoxing" )
	-- Objective.Requires				( "Unlocked", "PrisonBoxing", 0 )
	
	-- Objective.CreateGrant			( "Grant_PrisonBoxing_Arena", 0, 0 )
	-- Objective.SetParent				( "Grant_PrisonBoxing" )	
	-- Objective.RequireRoom        	( "BoxingArena", true )
	
	-- Objective.CreateGrant			( "Grant_PrisonBoxing_TrainingRoom", 0, 0 )
	-- Objective.SetParent				( "Grant_PrisonBoxing" )	
	-- Objective.RequireRoom        	( "BoxingTraining", true )

	-- Objective.CreateGrant			( "Grant_PrisonBoxing_BoxingRing", 0, 0 )
	-- Objective.SetParent				( "Grant_PrisonBoxing" )	
	-- Objective.RequireObjects        ( "BoxingRing", 1) 
	
	-- Objective.CreateGrant			( "Grant_PrisonBoxing_SpeedBag", 0, 0 )
	-- Objective.SetParent				( "Grant_PrisonBoxing" )	
	-- Objective.RequireObjects        ( "SpeedBag", 5) 
	
	-- Objective.CreateGrant			( "Grant_PrisonBoxing_WeightsBench", 0, 0 )
	-- Objective.SetParent				( "Grant_PrisonBoxing" )	
	-- Objective.RequireObjects        ( "WeightsBench", 5) 
-- end

function CreateRecycleGrant()
	Objective.CreateGrant			( "Grant_Recycle", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Cleaning", 0 )
    Objective.HiddenWhileLocked     ()

	Objective.CreateGrant			( "Grant_Recycle_Research", 0, 0 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.Requires				( "Unlocked", "GarbageRecycling", 0 )
	
	Objective.CreateGrant			( "Grant_Recycle_Requirement1", 0, 500 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.RequireRoom			( "Recycling", true )

	Objective.CreateGrant			( "Grant_Recycle_Requirement2", 0, 500 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.RequireObjects		( "RotatableRecycleDesk", 1 )
	
	Objective.CreateGrant			( "Grant_Recycle_Requirement3", 0, 500 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.RequireObjects		( "TrashBin10", 1 )
	
	Objective.CreateGrant			( "Grant_Recycle_Requirement4", 0, 500 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.RequireObjects		( "TrashCompactor", 1 )
end

function CreateCottonPlantation()
	Objective.CreateGrant			( "Grant_CottonPlantation", 1500, 2500 )
    Objective.SetPreRequisite       ( "Unlocked", "PrisonLabour", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_CottonPlantation_Research", 0, 0 )
	Objective.SetParent				( "Grant_CottonPlantation" )
	Objective.Requires				( "Unlocked", "Plantations", 0 )
	
	Objective.CreateGrant			( "Grant_CottonPlantation_CottonPlantationRoom", 0, 0 )
	Objective.SetParent				( "Grant_CottonPlantation" )
	Objective.RequireRoom			( "CottonPlantation", true )
	
	Objective.CreateGrant			( "Grant_CottonPlantation_CottonControlNumber", 0, 0 )
	Objective.SetParent				( "Grant_CottonPlantation" )
	Objective.RequireObjects		( "CottonPlantControl", 1 )
	
	Objective.CreateGrant			( "Grant_CottonPlantation_CottonSeedsNumber", 0, 0 )
	Objective.SetParent				( "Grant_CottonPlantation" )
	Objective.RequireObjects		( "CottonPlant", 8 )
	
	Objective.CreateGrant			( "Grant_CottonPlantation_CottonWorkerNumber", 0, 0 )
	Objective.SetParent				( "Grant_CottonPlantation" )
	Objective.RequireObjects		( "PlantationWorker", 2 )
end

function CreateCottonProduction()
	Objective.CreateGrant			( "Grant_Cotton_Production", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Plantations", 0 )
    Objective.HiddenWhileLocked     ()
	
	Objective.CreateGrant			( "Grant_Cotton_Production_Research", 0, 0 )
	Objective.SetParent				( "Grant_Cotton_Production" )
	Objective.Requires				( "Completed", "Grant_CottonPlantation", 0 )
	
	Objective.CreateGrant			( "Grant_Cotton_Production_ProgramPassed", 0, 0 )
	Objective.SetParent				( "Grant_Cotton_Production" )
	Objective.Requires				( "ReformPassed", "Plantation", 2 )
	
	Objective.CreateGrant			( "Grant_Cotton_Production_CottonPlantationAssigned", 0, 0 )
	Objective.SetParent				( "Grant_Cotton_Production")
	Objective.Requires				( "PrisonerJobs", "CottonPlantation", 2 )
	
	Objective.CreateGrant			( "Grant_Cotton_Production_CottonProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Cotton_Production")
	Objective.RequireObjects	 	( "RawCotton", 2500 )
end

function CreateManufactury()
	Objective.CreateGrant			( "Grant_Manufactury", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Plantations", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_Manufactury_Research", 0, 0 )
	Objective.SetParent				( "Grant_Manufactury" )
	Objective.Requires				( "Unlocked", "AdvancedManufactury", 0 )
	
	Objective.CreateGrant			( "Grant_Manufactury_ManufacturyRoom", 0, 0 )
	Objective.SetParent				( "Grant_Manufactury" )
	Objective.RequireRoom			( "Manufactury", true )
	
	Objective.CreateGrant			( "Grant_Manufactury_TextileMillNumber", 0, 0 )
	Objective.SetParent				( "Grant_Manufactury" )
	Objective.RequireObjects		( "TextileMill", 1 )
	
	Objective.CreateGrant			( "Grant_Manufactury_SewingStationNumber", 0, 0 )
	Objective.SetParent				( "Grant_Manufactury" )
	Objective.RequireObjects		( "SewingStation", 1 )
	
	Objective.CreateGrant			( "Grant_Manufactury_TailorNumber", 0, 0 )
	Objective.SetParent				( "Grant_Manufactury" )
	Objective.RequireObjects		( "Tailor", 1 )
end

function CreateJeanProduction()
	Objective.CreateGrant			( "Grant_Jean_Production", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "AdvancedManufactury", 0 )
    Objective.HiddenWhileLocked     ()
	
	Objective.CreateGrant			( "Grant_Jean_Production_Research", 0, 0 )
	Objective.SetParent				( "Grant_Jean_Production" )
	Objective.Requires				( "Completed", "Grant_Manufactury", 0 )
	
	Objective.CreateGrant			( "Grant_Jean_Production_ProgramPassed", 0, 0 )
	Objective.SetParent				( "Grant_Jean_Production" )
	Objective.Requires				( "ReformPassed", "ManufacturyInduction", 2 )
	
	Objective.CreateGrant			( "Grant_Jean_Production_ManufacturyAssigned", 0, 0 )
	Objective.SetParent				( "Grant_Jean_Production")
	Objective.Requires				( "PrisonerJobs", "Manufactury", 2 )
	
	Objective.CreateGrant			( "Grant_Jean_Production_JeanProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Jean_Production")
	Objective.RequireManufactured 	( "Jeans", 500 )
end

function CreatePhonefactory()
	Objective.CreateGrant			( "Grant_PhoneFactory", 1500, 2500 )
    Objective.SetPreRequisite       ( "Unlocked", "LegalPrep", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_PhoneFactory_Research", 0, 0 )
	Objective.SetParent				( "Grant_PhoneFactory" )
	Objective.Requires				( "Unlocked", "SmartPhones", 0 )
	
	Objective.CreateGrant			( "Grant_PhoneFactory_PhoneFactoryRoom", 0, 0 )
	Objective.SetParent				( "Grant_PhoneFactory" )
	Objective.RequireRoom			( "PhoneWorkshop", true )
	
	Objective.CreateGrant			( "Grant_PhoneFactory_PhoneTableNumber", 0, 0 )
	Objective.SetParent				( "Grant_PhoneFactory" )
	Objective.RequireObjects		( "PhoneTable", 2 )
end

function CreatePhonesProduction()
	Objective.CreateGrant			( "Grant_PhoneFactory_Production", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "SmartPhones", 0 )
    Objective.SetPreRequisite       ( "Unlocked", "PrisonLabour", 0 )
    Objective.HiddenWhileLocked     ()
	
	Objective.CreateGrant			( "Grant_PhoneFactory_Production_Research", 0, 0 )
	Objective.SetParent				( "Grant_PhoneFactory_Production" )
	Objective.Requires				( "Completed", "Grant_PhoneFactory", 0 )
	
	Objective.CreateGrant			( "Grant_PhoneFactory_Production_ProgramPassed", 0, 0 )
	Objective.SetParent				( "Grant_PhoneFactory_Production" )
	Objective.Requires				( "ReformPassed", "PhoneAssembly", 2 )
	
	Objective.CreateGrant			( "Grant_PhoneFactory_Production_PhoneFactoryAssigned", 0, 0 )
	Objective.SetParent				( "Grant_PhoneFactory_Production")
	Objective.Requires				( "PrisonerJobs", "PhoneWorkshop", 2 )
	
	Objective.CreateGrant			( "Grant_PhoneFactory_Production_PhonesProduction", 0, 5000 )
	Objective.SetParent				( "Grant_PhoneFactory_Production")
	Objective.RequireManufactured 	( "AssembledSmartPhone", 100 )
end

function CreateLimoGarage2()
	Objective.CreateGrant			( "Grant_LimoGarage2", 1500, 50000 )
    Objective.SetPreRequisite       ( "Unlocked", "PrisonLabour", 0 )
    Objective.HiddenWhileLocked     ()
	Objective.CreateGrant			( "Grant_LimoGarage2_Research", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.Requires				( "Unlocked", "LimoRepairShop", 0 )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_SpawnerNumber", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireObjects		( "GantryCrane2Spawner", 1 )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_RepairNumber", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireObjects		( "Limo2Preview", 4 )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_LessonNumber", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireObjects		( "Limo2LessonPreview", 2 )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_BoothNumber", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireObjects		( "GantryCrane2BoothPreview", 1 )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_RackNumber", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireObjects		( "CarPartsRack2Preview", 1 )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_DeskNumber", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireObjects		( "Limo2ServiceDeskPreview", 1 )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_FilingNumber", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireObjects		( "Limo2FilingCabinetPreview", 1 )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_LimoGarageRoom", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireRoom			( "LimoGarage2", true )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_LimoWaitingRoom", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireRoom			( "Limo2WaitingRoom", true )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_CarMechanicNumber", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireObjects		( "CarMechanic2", 1 )
	
	Objective.CreateGrant			( "Grant_LimoGarage2_CraneOperatorNumber", 0, 0 )
	Objective.SetParent				( "Grant_LimoGarage2" )
	Objective.RequireObjects		( "CraneOperator2", 1 )
	
end

function CreateLimoMechanics2()
	Objective.CreateGrant			( "Grant_LimoMechanics2", 1500, 2500 )
    Objective.SetPreRequisite       ( "Unlocked", "LimoRepairShop", 0 )
    Objective.HiddenWhileLocked     ()
	
	Objective.CreateGrant			( "Grant_LimoMechanics2_Research", 0, 0 )
	Objective.SetParent				( "Grant_LimoMechanics2" )
	Objective.Requires				( "Completed", "Grant_LimoGarage2", 0 )
	
	Objective.CreateGrant			( "Grant_LimoMechanics2_ProgramPassed1", 0, 5000 )
	Objective.SetParent				( "Grant_LimoMechanics2" )
	Objective.Requires				( "ReformPassed", "Limo2RepairTheoretic", 2 )
	
	Objective.CreateGrant			( "Grant_LimoMechanics2_ProgramPassed2", 0, 10000 )
	Objective.SetParent				( "Grant_LimoMechanics2" )
	Objective.Requires				( "ReformPassed", "Limo2RepairPractical", 2 )
	
	Objective.CreateGrant			( "Grant_LimoMechanics2_Assigned", 0, 0 )
	Objective.SetParent				( "Grant_LimoMechanics2")
	Objective.Requires				( "PrisonerJobs", "LimoGarage2", 2 )
	
	Objective.CreateGrant			( "Grant_LimoMechanics2_Repaired", 0, 0 )
	Objective.SetParent				( "Grant_LimoMechanics2" )
	Objective.RequireObjects		( "Limo2Repaired", 1 )
end

function CreateMoneyLaundry()
	Objective.CreateGrant			( "Grant_MoneyLaundry", 1500, 2500 )
    Objective.SetPreRequisite       ( "Unlocked", "PrisonLabour", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_MoneyLaundry_Accountant", 0, 0 )
	Objective.SetParent				( "Grant_MoneyLaundry" )
	Objective.RequireObjects		( "Accountant", 1 )
	
	Objective.CreateGrant			( "Grant_MoneyLaundry_Research", 0, 0 )
	Objective.SetParent				( "Grant_MoneyLaundry" )
	Objective.Requires				( "Unlocked", "MoneyLaundering", 0 )
	
	
	Objective.CreateGrant			( "Grant_MoneyLaundry_AccountingRoom", 0, 0 )
	Objective.SetParent				( "Grant_MoneyLaundry" )
	Objective.RequireRoom			( "Accounting", true )
	
	Objective.CreateGrant			( "Grant_MoneyLaundry_MoneyTableNumber", 0, 0 )
	Objective.SetParent				( "Grant_MoneyLaundry" )
	Objective.RequireObjects		( "MoneyTable", 2 )
	
end

function CreateMoneyLaundryProduction()
	Objective.CreateGrant			( "Grant_MoneyLaundry_Production", 1500, 235000 )
	Objective.SetPreRequisite		( "Unlocked", "MoneyLaundering", 0 )
    Objective.HiddenWhileLocked     ()
	
	Objective.CreateGrant			( "Grant_MoneyLaundry_Production_Research", 0, 0 )
	Objective.SetParent				( "Grant_MoneyLaundry_Production" )
	Objective.Requires				( "Completed", "Grant_MoneyLaundry", 0 )
	
	Objective.CreateGrant			( "Grant_MoneyLaundry_Production_ProgramPassed", 0, 0 )
	Objective.SetParent				( "Grant_MoneyLaundry_Production" )
	Objective.Requires				( "ReformPassed", "FinanceClass", 2 )
	
	Objective.CreateGrant			( "Grant_MoneyLaundry_Production_AccountingAssigned", 0, 0 )
	Objective.SetParent				( "Grant_MoneyLaundry_Production")
	Objective.Requires				( "PrisonerJobs", "Accounting", 2 )
	
	Objective.CreateGrant			( "Grant_MoneyLaundry_Production_MoneyProduction", 0, 15000 )
	Objective.SetParent				( "Grant_MoneyLaundry_Production")
	Objective.RequireManufactured 	( "CleanMoney", 2000 )
end

function CreatePrisonerForestry()
	Objective.CreateGrant			( "Grant_PrisonerForestry", 1500, 2500 )
    Objective.SetPreRequisite       ( "Unlocked", "PrisonLabour", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_PrisonerForestry_Research", 0, 0 )
	Objective.SetParent				( "Grant_PrisonerForestry" )
	Objective.Requires				( "Unlocked", "PrisonerForestry", 0 )
	
	Objective.CreateGrant			( "Grant_PrisonerForestry_ForestryRoom", 0, 0 )
	Objective.SetParent				( "Grant_PrisonerForestry" )
	Objective.RequireRoom			( "PrisonForestry", true )
	
	Objective.CreateGrant			( "Grant_PrisonerForestry_TreeNumber", 0, 0 )
	Objective.SetParent				( "Grant_PrisonerForestry" )
	Objective.RequireObjects		( "ForestryTreeSaplingPlanted", 4 )
	
	Objective.CreateGrant			( "Grant_PrisonerForestry_WoodRoom", 0, 0 )
	Objective.SetParent				( "Grant_PrisonerForestry" )
	Objective.RequireRoom			( "WoodWorkshop", true )
	
	Objective.CreateGrant			( "Grant_PrisonerForestry_SawNumber", 0, 0 )
	Objective.SetParent				( "Grant_PrisonerForestry" )
	Objective.RequireObjects		( "WoodSaw", 2 )
	
	Objective.CreateGrant			( "Grant_PrisonerForestry_LogRackNumber", 0, 0 )
	Objective.SetParent				( "Grant_PrisonerForestry" )
	Objective.RequireObjects		( "LogStorageRack", 1 )
	
	Objective.CreateGrant			( "Grant_PrisonerForestry_WoodRackNumber", 0, 0 )
	Objective.SetParent				( "Grant_PrisonerForestry" )
	Objective.RequireObjects		( "WoodStorageRack", 1 )
end

function CreateGarden()
	Objective.CreateGrant			( "Grant_Garden", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "GroundsKeeping", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_Garden_Research", 0, 0 )
	Objective.SetParent				( "Grant_Garden" )
	Objective.Requires				( "Unlocked", "Gardening", 0 )
	
	Objective.CreateGrant			( "Grant_Garden_GardenRoom", 0, 0 )
	Objective.SetParent				( "Grant_Garden" )
	Objective.RequireRoom			( "Garden", true )
	
	Objective.CreateGrant			( "Grant_Garden_GardenControlNumber", 0, 0 )
	Objective.SetParent				( "Grant_Garden" )
	Objective.RequireObjects		( "GardenPlantControl", 1 )
	
	Objective.CreateGrant			( "Grant_Garden_GardenPotNumber", 0, 0 )
	Objective.SetParent				( "Grant_Garden" )
	Objective.RequireObjects		( "GardenPot2Remote", 8 )
end

function CreateGardenProduction()
	Objective.CreateGrant			( "Grant_Garden_Production", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Gardening", 0 )
    Objective.HiddenWhileLocked     ()
	
	Objective.CreateGrant			( "Grant_Garden_Production_Research", 0, 0 )
	Objective.SetParent				( "Grant_Garden_Production" )
	Objective.Requires				( "Completed", "Grant_Garden", 0 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_ProgramPassed", 0, 0 )
	Objective.SetParent				( "Grant_Garden_Production" )
	Objective.Requires				( "ReformPassed", "PlantCultivation", 2 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenAssigned", 0, 0 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.Requires				( "PrisonerJobs", "Garden", 2 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenTomatoProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.RequireObjects	 	( "GardenTomato", 11 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenCucumberProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.RequireObjects	 	( "GardenCucumber", 11 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenRoseProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.RequireObjects	 	( "GardenRose", 11 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenLilyProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.RequireObjects	 	( "GardenLily", 11 )
end

function CreateTazerTherapy3()
	Objective.CreateGrant			( "Grant_TazerTherapy3", 4000, 35000 )
	Objective.SetPreRequisite		( "Unlocked", "TazersForEveryone", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_TazerTherapy3_Research", 0, 0 )
	Objective.SetParent				( "Grant_TazerTherapy3" )
	Objective.Requires				( "Unlocked", "TortureCells", 0 )
	
	Objective.CreateGrant			( "Grant_TazerTherapy3_TazerTherapyRoom", 0, 0 )
	Objective.SetParent				( "Grant_TazerTherapy3" )
	Objective.RequireRoom			( "TazerTherapy3", true )
	
	Objective.CreateGrant			( "Grant_TazerTherapy3_TeslaNumber", 0, 0 )
	Objective.SetParent				( "Grant_TazerTherapy3" )
	Objective.RequireObjects		( "TeslaMatic3", 1 )
	
	Objective.CreateGrant			( "Grant_TazerTherapy3_ChairNumber", 0, 0 )
	Objective.SetParent				( "Grant_TazerTherapy3" )
	Objective.RequireObjects		( "Chair", 8 )
	
	Objective.CreateGrant			( "Grant_TazerTherapy3_ProgramPassed1", 0, 25000 )
	Objective.SetParent				( "Grant_TazerTherapy3" )
	Objective.Requires				( "ReformPassed", "VoluntaryTazerTherapy3", 2 )
	
	Objective.CreateGrant			( "Grant_TazerTherapy3_ProgramPassed2", 0, 25000 )
	Objective.SetParent				( "Grant_TazerTherapy3" )
	Objective.Requires				( "ReformPassed", "AntiAlcoholTazerTherapy3", 1 )
	
	Objective.CreateGrant			( "Grant_TazerTherapy3_ProgramPassed3", 0, 25000 )
	Objective.SetParent				( "Grant_TazerTherapy3" )
	Objective.Requires				( "ReformPassed", "AntiDrugsTazerTherapy3", 1 )
end

function CreateMorgue2()
	Objective.CreateGrant			( "Grant_Morgue2", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Health", 0 )
	
 	Objective.CreateGrant			( "Grant_Morgue2_MorgueRoom", 0, 0 )
	Objective.SetParent				( "Grant_Morgue2" )
	Objective.RequireRoom			( "Morgue", true )
	
	Objective.CreateGrant			( "Grant_Morgue2_MorgueSlabNumber", 0, 0 )
	Objective.SetParent				( "Grant_Morgue2" )
	Objective.RequireObjects		( "MorgueSlab", 1 )
	
	Objective.CreateGrant			( "Grant_Morgue2_MorgueTableNumber", 0, 0 )
	Objective.SetParent				( "Grant_Morgue2" )
	Objective.RequireObjects		( "SmallTableMorgue", 1 )
	
	Objective.CreateGrant			( "Grant_Morgue2_CoffinNumber", 0, 0 )
	Objective.SetParent				( "Grant_Morgue2" )
	Objective.RequireObjects		( "GraveCoffin", 2 )
	
	Objective.CreateGrant			( "Grant_Morgue2_HearseRemoverNumber", 0, 0 )
	Objective.SetParent				( "Grant_Morgue2" )
	Objective.RequireObjects		( "HearseRemover", 1 )
	
end

function CreateParlour2()
	Objective.CreateGrant			( "Grant_Parlour2", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Health", 0 )
	Objective.SetPreRequisite		( "Completed", "Grant_Morgue2", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_Parlour2_ParlourRoom", 0, 0 )
	Objective.SetParent				( "Grant_Parlour2" )
	Objective.RequireRoom			( "FuneralParlour", true )
	
	Objective.CreateGrant			( "Grant_Parlour2_ParlourTableNumber", 0, 0 )
	Objective.SetParent				( "Grant_Parlour2" )
	Objective.RequireObjects		( "SmallTableFP", 1 )
	
	Objective.CreateGrant			( "Grant_Parlour2_AltarNumber", 0, 0 )
	Objective.SetParent				( "Grant_Parlour2" )
	Objective.RequireObjects		( "ParlourAltar", 1 )
	
	Objective.CreateGrant			( "Grant_Parlour2_ChairNumber", 0, 0 )
	Objective.SetParent				( "Grant_Parlour2" )
	Objective.RequireObjects		( "ParlourChair", 5 )
end

function CreateCemetery2()
	Objective.CreateGrant			( "Grant_Cemetery2", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Health", 0 )
	Objective.SetPreRequisite		( "Completed", "Grant_Parlour2", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_Cemetery2_CemeteryRoom", 0, 0 )
	Objective.SetParent				( "Grant_Cemetery2" )
	Objective.RequireRoom			( "Cemetery", true )
	
	Objective.CreateGrant			( "Grant_Cemetery2_GraveStoneNumber", 0, 0 )
	Objective.SetParent				( "Grant_Cemetery2" )
	Objective.RequireObjects		( "GraveStone", 2 )
	
	Objective.CreateGrant			( "Grant_Cemetery2_GraveNumber", 0, 0 )
	Objective.SetParent				( "Grant_Cemetery2" )
	Objective.RequireObjects		( "GraveUnderConstruction1", 2 )
	
	Objective.CreateGrant			( "Grant_Cemetery2_StaffGraveNumber", 0, 0 )
	Objective.SetParent				( "Grant_Cemetery2" )
	Objective.RequireObjects		( "GraveStaffUnderConstruction1", 2 )
	
	Objective.CreateGrant			( "Grant_Cemetery2_GraveDiggerNumber", 0, 0 )
	Objective.SetParent				( "Grant_Cemetery2" )
	Objective.RequireObjects		( "GraveDigger", 1 )
end

function CreateCoffinWorkshop2()
	Objective.CreateGrant			( "Grant_CoffinWorkshop2", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Health", 0 )
    Objective.SetPreRequisite       ( "Unlocked", "Maintainance", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_CoffinWorkshop2_Research", 0, 0 )
	Objective.SetParent				( "Grant_CoffinWorkshop2" )
	Objective.Requires				( "Unlocked", "PrisonLabour", 0 )
	
	Objective.CreateGrant			( "Grant_CoffinWorkshop2_CoffinWorkshopRoom", 0, 0 )
	Objective.SetParent				( "Grant_CoffinWorkshop2" )
	Objective.RequireRoom			( "CoffinWorkshop", true )
	
	Objective.CreateGrant			( "Grant_CoffinWorkshop2_CoffinTableNumber", 0, 0 )
	Objective.SetParent				( "Grant_CoffinWorkshop2" )
	Objective.RequireObjects		( "CoffinTable", 1 )
	
	Objective.CreateGrant			( "Grant_CoffinWorkshop2_GraveDiggerNumber", 0, 0 )
	Objective.SetParent				( "Grant_CoffinWorkshop2" )
	Objective.RequireObjects		( "GraveDigger", 1 )
end

function CreateCoffinProduction2()
	Objective.CreateGrant			( "Grant_CoffinProduction2", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Health", 0 )
    Objective.SetPreRequisite       ( "Unlocked", "Maintainance", 0 )
    Objective.HiddenWhileLocked     ()
	
	Objective.CreateGrant			( "Grant_CoffinProduction2_Research", 0, 0 )
	Objective.SetParent				( "Grant_CoffinProduction2" )
	Objective.Requires				( "Completed", "Grant_CoffinWorkshop2", 0 )
	
	Objective.CreateGrant			( "Grant_CoffinProduction2_ProgramPassed", 0, 0 )
	Objective.SetParent				( "Grant_CoffinProduction2" )
	Objective.Requires				( "ReformPassed", "CoffinProduction", 2 )
	
	Objective.CreateGrant			( "Grant_CoffinProduction2_Assigned", 0, 0 )
	Objective.SetParent				( "Grant_CoffinProduction2")
	Objective.Requires				( "PrisonerJobs", "CoffinWorkshop", 1 )
	
	Objective.CreateGrant			( "Grant_CoffinProduction2_CoffinNumber", 0, 0 )
	Objective.SetParent				( "Grant_CoffinProduction2" )
	Objective.RequireManufactured	( "GraveCoffin", 10 )
end

function CreateCemetery2Jobs()
	Objective.CreateGrant			( "Grant_Cemetery2Jobs", 1500, 2500 )
	Objective.SetPreRequisite		( "Completed", "Grant_Cemetery2", 0 )
    Objective.SetPreRequisite       ( "Unlocked", "PrisonLabour", 0 )
    Objective.HiddenWhileLocked     ()

	Objective.CreateGrant			( "Grant_Cemetery2Jobs_Research", 0, 0 )
	Objective.SetParent				( "Grant_Cemetery2Jobs" )
	Objective.Requires				( "Unlocked", "PrisonLabour", 0 )
	
	Objective.CreateGrant			( "Grant_Cemetery2Jobs_ProgramPassed", 0, 0 )
	Objective.SetParent				( "Grant_Cemetery2Jobs" )
	Objective.Requires				( "ReformPassed", "GraveDigging", 2 )
	
	Objective.CreateGrant			( "Grant_Cemetery2Jobs_Assigned", 0, 0 )
	Objective.SetParent				( "Grant_Cemetery2Jobs")
	Objective.Requires				( "PrisonerJobs", "Cemetery", 1 )
	
	Objective.CreateGrant			( "Grant_Cemetery2Jobs_BuryDead", 0, 0 )
	Objective.SetParent				( "Grant_Cemetery2Jobs")
	Objective.RequireObjects		( "GraveLoaded", 1 )
end
