--<Author: Brento666>--
--<Copyright: Brento666, the Netherlands, 2015>--
--<Don't redistribute: see base-language for cc>--

--IMPLEMENTED for v0.69:
-->Demolish perimiter walls
-->Better sound timing

--Possible future features if future API features allow:
--Reveal/Destroy tunnels (cannot sense tunnels atm)
--burnt-wall at 2 blocks away (increased wall-deconstruction affects burnt walls two atm)

local timer = 0
local nextTimeout = 0

local OutsideMaterials = {["Grass"]=true,["Water"]=true,["LongGrass"]=true,["Mud"]=true,["Gravel"]=true,["Stone"]=true,["Sand"]=true,["Road"]=true,["RoadMarkings"]=true,["RoadMarkingsLeft"]=true,["RoadMarkingsRight"]=true,["RoadCrossing"]=true,["RoadCrossingLeft"]=true,["RoadCrossingRight"]=true,["Fence"]=true,["PerimeterWall"]=true}
local AmbiguousMaterials = {["ConcreteTiles"]=true,["ConcreteWall"]=true,["BrickWall"]=true,["BurntFloor"]=true,["BurntWall"]=true,["Roof"]=true,["BuildingFrame"]=true}
local InsideMaterials = {["ConcreteFloor"]=true,["WoodenFloor"]=true,["CeramicFloor"]=true,["MosaicFloor"]=true,["MetalFloor"]=true,["MarbleTiles"]=true,["WhiteTiles"]=true,["FancyTiles"]=true}
local WallMaterials = {["ConcreteWall"]=true,["BrickWall"]=true,["BurntWall"]=true,["Fence"]=true,["PerimeterWall"]=true}

local started = true
local directions = { ["this"] = 0, ["north"] = 1, ["south"] = 2, ["west"] = 3, ["east"] = 4 }
local firewalls = {}

function Create()
	this.Countdown = 1.0
	this.Blown = false
	started = false
end

function Update(timePassed)
    timer = timer + timePassed;
    if timer > nextTimeout then
        nextTimeout = IntervalUpdate(timer)
        timer = 0
    end   
end   

function IntervalUpdate(timePassed)
	if started == false then
		StartFire(this.Pos.x, this.Pos.y)
		started = true
	else
		Explode()

		KillWalls()
		
		KillFires()
		
		this.Sound("__RiotAssault", "Explosion")
		
		local smoke = Object.Spawn("SmokeGenerator", this.Pos.x, this.Pos.y)
		smoke.Sound("_World", "Explosion");--crumble noise
		
		this.Delete(this)
	end
	return 0.5
end

function Explode()
	--local force = math.random(40, 100)/ 100;
	local force = 1.0;
	
	--this.Sound("__RiotAssault", "Explosion")
	--this.Sound("_Tools", "Attack_Shotgun")
	
    --local objectTypes = { "BrickWall", "ConcreteWall", "BuildingConcrete", "BuildingFrame", "PerimeterWall", "Fence" }
	
	--objectTypes = { "Brick" }
	
    --for i,objectType in ipairs( objectTypes ) do 
		--Echo("Test Brick again")
        --FindObjectsToDestroy(objectType, 5.0, force)
    --end
	
	-----------foodie app
	
	--normal entities
	local objectTypes = { "Prisoner", "Warden", "Chief", "Guard", "DogHandler", "Dog", "Cook", "Janitor", "Gardener", "Doctor", "Psychologist", "Accountant", "Lawyer", "Teacher", 
		"Visitor", "SpiritualLeader", "AppealsMagistrate", "AppealsLawyer", "ExecutionWitness", "Paramedic", "ParoleOfficer", "ParoleLawyer", "TruckDriver", "Surgeon", "Psychiatrist" }
	for i,objectType in ipairs( objectTypes ) do 
        FindEntitiesToDamage(objectType, 5.0, force)
    end
	
	--entities with protective clothing
	objectTypes = { "Workman", "Foreman", "ArmedGuard", "Soldier", "RiotGuard", "Fireman" }
	for i,objectType in ipairs( objectTypes ) do 
        FindEntitiesToDamage(objectType, 4.0, force / 2)
    end
	
	--"Fire" 
	
	--Rubble only gets velocity(no damage)
	local objects = Object.GetNearbyObjects("Rubble", 4.0)
    for obj, dist in pairs(objects) do
		local velX = obj.Pos.x - this.Pos.x
		if velX ~= 0 then
			velX = (dist/velX)*10
		end
		local velY = obj.Pos.y - this.Pos.y
		if velY ~= 0 then
			velY = (dist/velY)*10
		end
		Object.ApplyVelocity(obj, velX, velY)
    end
	
	--Nearby garbage gets deleted and replaced by rubble + fire!
	local objects = Object.GetNearbyObjects("Garbage", 4.0)
    for obj, dist in pairs(objects) do
		local rubble = Object.Spawn( "Rubble", obj.Pos.x, obj.Pos.y )
		local fire = Object.Spawn( "Fire", obj.Pos.x, obj.Pos.y )
		
		--apply velocity
		local velX = obj.Pos.x - this.Pos.x
		if velX ~= 0 then
			velX = (dist/velX)*10
		end
		local velY = obj.Pos.y - this.Pos.y
		if velY ~= 0 then
			velY = (dist/velY)*10
		end
		Object.ApplyVelocity(rubble, velX, velY)
		Object.ApplyVelocity(fire, velX, velY)
		
		obj.Delete();
    end
	
	--easily damaged goods
	objectTypes = { "Stack", "Bed", "SuperiorBed", "Toilet", "Table", "Chair", "Bench", "Door", "StaffDoor", "Window", "WindowLarge", "Tree", "Light", "Cooker", 
	"Fridge", "Bin", "Sink", "ServingTable", "ShowerHead", "Bleach", "SheetMetal", "LicensePlateBlank", "LicensePlate", "Ingredients", "IngredientsCooking", 
	"IngredientsCooked", "IngredientsSpoiled", "FoodWaste", "Meal", "FoodTray", "FoodTrayDirty", "GrassTurf", "PrisonerUniform", "DirtyPrisonerUniform", 
	"CrumpledPrisonerUniform", "Log", "Wood", "Bookshelf", "OfficeDesk", "SchoolDesk", "FilingCabinet", "MedicalBed", "SofaChairDouble", "SofaChairSingle", 
	"DrinkMachine", "Radio", "TvSmall" }
	for i,objectType in ipairs( objectTypes ) do 
        FindObjectsToDamage(objectType, 5.0, force)
    end
	
	--sturdy goods
	objectTypes = { "Box", "ElectricChair", "TreeStump", "JailDoor", "JailDoorLarge", "RoadGate", "SolitaryDoor", "RemoteDoor", "JailBars", "Brick", "Concrete", 
	"Steel", "MorgueSlab" }
	for i,objectType in ipairs( objectTypes ) do 
        FindObjectsToDamage(objectType, 4.0, force / 2)
    end
	
	--"SupplyTruck", "PrisonerBus", "FireEngine", "RiotVan", "Ambulance", "Hearse", "Limo", "TroopTruck"
end

function FindEntitiesToDamage(typeName, distance, damage) 
    local objects = Object.GetNearbyObjects(typeName, distance)
    for obj, dist in pairs(objects) do
        local curr = tonumber(obj.Damage) or 0

		--apply velocity
		local velX = obj.Pos.x - this.Pos.x
		if velX ~= 0 then
			velX = (dist/velX)*10;
		end
		local velY = obj.Pos.y - this.Pos.y
		if velY ~= 0 then
			velY = (dist/velY)*10;
		end
		Object.ApplyVelocity(obj, velX, velY)
		
        if curr < 1 then
			if dist < 1 then
				dist = 1;
			end
			curr = math.min(curr + (damage / dist), 1)
			if curr < 1 then
				obj.Damage = curr
			else
				--obj.StatusEffects.wounded = 1
				if SetStatus(Patient, "wounded", 1) then
					--Echo("Wounded!")
				else
					obj.Damage = curr
					--Echo("Wounding failed!")
				end
			end
        end
    end
end

function FindObjectsToDamage(typeName, distance, damage) 
    local objects = Object.GetNearbyObjects(typeName, distance)
    for obj, dist in pairs(objects) do
        local curr = tonumber(obj.Damage) or 0
		
		--calc velocity
		local velX = obj.Pos.x - this.Pos.x;
		if velX ~= 0 then
			velX = (dist/velX)*10;
		end
		local velY = obj.Pos.y - this.Pos.y;
		if velY ~= 0 then
			velY = (dist/velY)*10;
		end
		
		if dist < 1 then
			dist = 1;
		end
		curr = math.min(curr + (damage / dist), 1)
		if curr >= 1 then
			local rubble = Object.Spawn( "Rubble", obj.Pos.x, obj.Pos.y )
			local fire = Object.Spawn( "Fire", obj.Pos.x, obj.Pos.y )
			rubble.ApplyVelocity(velX, velY)
			fire.ApplyVelocity(velX, velY)
			fire.Spawned = this.Id.u
			obj.Delete()
		else
			obj.ApplyVelocity(velX, velY)
			obj.Damage = curr
        end
    end
end

function StartFire(targetX,targetY)
	local count = 0
	while count < 20 do
		local fire = Object.Spawn("Fire", targetX, targetY)
		fire.Fuel = 0.5
		fire.Intensity = 1.0
		fire.Spawned = this.Id.u
		count = count + 1
	end
end

function KillWalls()
	for name, value in pairs(directions) do --notice use of pairs not ipairs
		KillWall(value)
	end
end

function KillWall(direction)
	local fX = this.Pos.x
	local fY = this.Pos.y
	
	if direction == 1 then
		fY = fY - 1
	elseif direction == 2 then
		fY = fY + 1
	elseif direction == 3 then
		fX = fX - 1
	elseif direction == 4 then
		fX = fX + 1
	end
	
	local cell = World.GetCell(fX-0.5, fY-0.5)
	
	if cell and cell.Mat then
		--if WallMaterials[cell.Mat] then
		if Wall(fX, fY) then
			cell.Con = 0
			cell.Mat = "BurntFloor"
			--Echo("Burning: x:"..fX.." y:"..fY.." -> Mat: "..cell.Mat.." Con: "..cell.Con)
		end
	end
end
		
function KillFires()
	local objects = Object.GetNearbyObjects("Fire", 5)
	for obj, dist in pairs(objects) do
		if not obj.Spawned or obj.Spawned == this.Id.u then
			obj.Delete()
		end
	end
end

function SetStatus(obj, key, value)
	if pcall(TryTableEntry, obj, "StatusEffects", key, value) then
		--Echo("Set Status: "..key.." to: "..value)
		return true
	else                    
		--Echo("(Error!)Subject missing Status: "..key)
		return false
	end	
end


function Inside(x, y)
	local material = Object.GetMaterial( x, y )
	while AmbiguousMaterials[material] do
		if this.Or.x == 1 then
			x = x + 1
		elseif this.Or.x == -1 then
			x = x - 1
		else
			y = y + 1
		end
		material = Object.GetMaterial( x, y )
	end
	if InsideMaterials[material] then
		return true
	end
	return nil
end

function Outside(x, y)
	if Inside(x, y) then
		return nil
	end
	return true
end

function Wall(x, y)
	local material = Object.GetMaterial( x, y )
	Echo("Material: "..material.." x: "..x.." y:"..y)
	if WallMaterials[material] then
		Echo("WALL: "..material.." x: "..x.." y:"..y)
		return true
	end
	return nil
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function Echo(text)
    Game.DebugOut(text)
end