
-- Snake made by Introversion Software (found hidden inside the game files in autumn 2018)
-- Pong taken from https://blog.afoolishmanifesto.com/posts/pong/ and adjusted for this mod.

local gameNames = { "Snake", "Pong", "Invaders" }
local game = "None"
local gameOver = false
local screen = {}

--Snake
local snake = { 
    BoardSize = { X = 10, Y = 10 },
    Render = { X = 0, Y = 0, W = 1, H = 1 },
    UpdateTime = 0.5,   -- How often the snake will move
    MoveTimer = 0,      -- How long until the snake will move
    Dir = "Up",
    Head = { X = 0, Y = 0 },
    Tail = {},
    GameStarted = false,
    ChangedDir = false,
    ai = true,
    Food = { X = 0, Y = 0 }
}

--Pong
local pongball = { 
    BoardSize = { X = 20, Y = 20 },
    Render = { X = 10.5, Y = 10, W = 1, H = 1 },
    UpdateTime = 0.1,   -- How often the ball will move
    MoveTimer = 0,      -- How long until the ball will move
    Player = "PongBall",
    GameStarted = false,
	x = 10.5,
	y = 10,
	dx = 0,
	dy = 0
}

local p1paddle = { 
    BoardSize = { X = 20, Y = 20 },
    Render = { X = 2, Y = 10, W = 1, H = 1 },
    Dir = "Up",
    Player = "PlayerLeft",
    ai = true,
    Score = 0,
	x = 2,
	y = 10
}

local p2paddle = { 
    BoardSize = { X = 20, Y = 20 },
    Render = { X = 19, Y = 10, W = 1, H = 1 },
    Dir = "Up",
    Player = "PlayerRight",
    ai = true,
    Score = 0,
	x = 19,
	y = 10
}

--Invaders

local turret = { 
    BoardSize = { X = 20, Y = 20 },
    Render = { X = 10, Y = 19, W = 1, H = 1 },
    UpdateTime = 0.1,   -- How often the ball will move
    MoveTimer = 0,      -- How long until the ball will move
    Player = "Turret",
    ShotFired = false,
    GameStarted = false,
	Health = 3,
	InvadersLeft = 21,
    Dir = "Left",
    ai = true,
    Score = 0,
	x = 10,
	y = 19
}

local explosion = { 
    BoardSize = { X = 20, Y = 20 },
    Render = { X = 10, Y = 19, W = 1, H = 1 },
    Player = "Explosion",
	x = 0,
	y = 0
}

local invaders = {
		[1] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "Invader",
			Armour = 3,
			Killed = false,
			x = 0,
			y = 0 },
		[2] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "Invader",
			Armour = 3,
			Killed = false,
			x = 0,
			y = 0 },
		[3] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "Invader",
			Armour = 3,
			Killed = false,
			x = 0,
			y = 0 },
		[4] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "Invader",
			Armour = 3,
			Killed = false,
			x = 0,
			y = 0 },
		[5] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "Invader",
			Armour = 3,
			Killed = false,
			x = 0,
			y = 0 }
		}

local turretBullets = {
		[1] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "TurretBullet",
			Fired = false,
			x = 0,
			y = 0 },
		[2] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "TurretBullet",
			Fired = false,
			x = 0,
			y = 0 },
		[3] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "TurretBullet",
			Fired = false,
			x = 0,
			y = 0 },
		[4] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "TurretBullet",
			Fired = false,
			x = 0,
			y = 0 },
		[5] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "TurretBullet",
			Fired = false,
			x = 0,
			y = 0 }
		}

local invaderBullets = {
		[1] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "InvaderBullet",
			Fired = false,
			x = 0,
			y = 0 },
		[2] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "InvaderBullet",
			Fired = false,
			x = 0,
			y = 0 },
		[3] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "InvaderBullet",
			Fired = false,
			x = 0,
			y = 0 },
		[4] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "InvaderBullet",
			Fired = false,
			x = 0,
			y = 0 },
		[5] = {
			BoardSize = { X = 20, Y = 20 },
			Render = { X = 0, Y = 0, W = 0, H = 0 },
			Player = "InvaderBullet",
			Fired = false,
			x = 0,
			y = 0 }
		}

function Create()
    this.HasCustomReport = true
end


function Update( timePassed )
    timePassed = tonumber( timePassed )
    
    if gameOver then
        -- Do nothing
    elseif game == "Snake" then
        UpdateSnake( timePassed )
    elseif game == "Pong" then
        UpdatePong( timePassed )
    elseif game == "Invaders" then
        UpdateInvaders( timePassed )
    end
end

function Create()
    this.HasCustomReport = true
end


function Update( timePassed )
    timePassed = tonumber( timePassed )
    
    if gameOver then
        -- Do nothing
    elseif game == "Snake" then
        UpdateSnake( timePassed )
    elseif game == "Pong" then
        UpdatePong( timePassed )
    elseif game == "Invaders" then
        UpdateInvaders( timePassed )
    end
end


-- Begin Snake

function UpdateSnake( timePassed )
    snake.MoveTimer = snake.MoveTimer - timePassed
    
    if not snake.GameStarted then
        local t = math.floor( snake.MoveTimer )
        
        if snake.MoveTimer < 0 then
            Interface.SetComponentProperties( "StartingSnake", { Caption = "", Colour = "#41FF00" } )
            snake.GameStarted = true
            snake.MoveTimer = snake.UpdateTime
        else
            Interface.SetComponentProperties( "StartingSnake", { Caption = "arcade_snake_gamestarting", Colour = "#41FF00", Replacements = { X = tostring( t ) } } )
        end
    elseif snake.MoveTimer < 0 then
        -- Reset timer. Make sure we remove any extra time that has passed
        snake.MoveTimer = snake.UpdateTime + snake.MoveTimer
        
        -- Move now
        if SnakeCanMove() then
            MoveSnake()
            if snake.Head.X == snake.Food.X and snake.Head.Y == snake.Food.Y then
                -- We've eat some food. Spawn another body piece and a new food source
                SnakeSpawnBodyPiece()
                SnakeSpawnFood()
            end
        else
            -- Game over buddy
            Interface.SetComponentProperties( "StartingSnake", { Caption = "arcade_snake_gameover", Colour = "#41FF00" } )
            gameOver = true
        end
    end
    
    -- Remove the screen image and read it so that it's always on top. 
    -- Annoying, but bleh
    Interface.RemoveReportComponent( screen.Name )
    Interface.AddReportComponent( screen )
end


function SnakeWon()
    gameOver = true
    Interface.SetComponentProperties( "StartingSnake", { Caption = "arcade_snake_gamewon", Colour = "#41FF00" } )
end


function SnakeCanMove()
	if snake.ai == true then	-- dumb on purpose: it will bite in its own tail sooner or later, depending on x/y of spawned food, so the game can still end at any time.
		if snake.Head.X < snake.Food.X then snake.Dir = "Right";	Interface.SetComponentProperties( "SnakeHead", { Angle = math.pi/2 } )
		elseif snake.Head.X > snake.Food.X then snake.Dir = "Left";	Interface.SetComponentProperties( "SnakeHead", { Angle = -math.pi/2 } )
		elseif snake.Head.Y > snake.Food.Y then snake.Dir = "Up";	Interface.SetComponentProperties( "SnakeHead", { Angle = 0 } )
		elseif snake.Head.Y < snake.Food.Y then snake.Dir = "Down";	Interface.SetComponentProperties( "SnakeHead", { Angle = math.pi } )
		end
	end
	
    if snake.Dir == "Up" then 
        return snake.Head.Y > 1 and not SnakeTailWillBeAt( snake.Head.X, snake.Head.Y - 1 )
    elseif snake.Dir == "Down" then 
        return snake.Head.Y < snake.BoardSize.Y and not SnakeTailWillBeAt( snake.Head.X, snake.Head.Y + 1 )
    elseif snake.Dir == "Left" then 
        return snake.Head.X > 1  and not SnakeTailWillBeAt( snake.Head.X - 1, snake.Head.Y )
    elseif snake.Dir == "Right" then 
        return snake.Head.X < snake.BoardSize.X and not SnakeTailWillBeAt( snake.Head.X + 1, snake.Head.Y )
    end
    
    return false
end


function SnakeTailWillBeAt( boardX, boardY )
    for i=(#snake.Tail) - 1,1,-1 do
        if snake.Tail[i].X == boardX and snake.Tail[i].Y == boardY then
            return true
        end
    end
    
    return false
end


function MoveSnake()
    local snakeSize = SpriteSize(snake)
    local snakeX, snakeY
    
    -- Move all body positions to the position of the previous body position
    local num = #snake.Tail
    for i=num,2,-1 do
        snake.Tail[ i ].X = snake.Tail[ i - 1 ].X
        snake.Tail[ i ].Y = snake.Tail[ i - 1 ].Y
        
        snakeX, snakeY = SpriteRenderPos(snake, snake.Tail[ i ].X, snake.Tail[ i ].Y )        
        Interface.SetComponentProperties( "SnakeTail"..tostring(i), { X = snakeX, Y = snakeY, W = snakeSize, H = snakeSize } )
    end
    
    -- Move the first body piece to the head piece
    if num > 0 then
        snake.Tail[ 1 ].X = snake.Head.X
        snake.Tail[ 1 ].Y = snake.Head.Y
        
        snakeX, snakeY = SpriteRenderPos(snake, snake.Tail[ 1 ].X, snake.Tail[ 1 ].Y )
        Interface.SetComponentProperties( "SnakeTail1", { X = snakeX, Y = snakeY, W = snakeSize, H = snakeSize } )
    end
    
    -- Move the head to it's new place
    if snake.Dir == "Up" then snake.Head.Y = snake.Head.Y - 1
    elseif snake.Dir == "Down" then snake.Head.Y = snake.Head.Y + 1
    elseif snake.Dir == "Left" then snake.Head.X = snake.Head.X - 1
    elseif snake.Dir == "Right" then snake.Head.X = snake.Head.X + 1
    end
    
    -- Update the head image position
    snakeX, snakeY = SpriteRenderPos(snake, snake.Head.X, snake.Head.Y ) 
    Interface.SetComponentProperties( "SnakeHead", { X = snakeX, Y = snakeY, W = snakeSize, H = snakeSize } )
    
    snake.ChangedDir = false
end


function SnakeSpawnBodyPiece()
    -- Spawn the new body piece at the tail position (or head if there is no tail)
    local newTail
    local num = #snake.Tail
    if num == 0 then
        newTail = { X = snake.Head.X, Y = snake.Head.Y }
    else
        newTail = { X = snake.Tail[ num ].X, Y = snake.Tail[ num ].Y }
    end
    
    table.insert( snake.Tail, newTail )
    
    -- Add a new image to the interface
    local snakeSize = SpriteSize(snake)
    local snakeX, snakeY = SpriteRenderPos(snake, newTail.X, newTail.Y )
    Interface.AddReportComponent( { Type = "Image", Name = "SnakeTail" .. #snake.Tail, File = "Arcade/ArcadeCabinet_snaketail.png", Colour = "#41FF00", X = snakeX, Y = snakeY, W = snakeSize, H = snakeSize } )
end


function SnakeSpawnFood()
    -- List of all spaces
    local spaces = {}
    for x=1,snake.BoardSize.X,1 do
        spaces[x] = {}
        for y=1,snake.BoardSize.Y,1 do
            spaces[x][y] = true
        end
    end
    
    -- Remove head and body piece locations
    spaces[ snake.Head.X ][ snake.Head.Y ] = false
    for tailI, tailPart in ipairs( snake.Tail ) do
        spaces[ tailPart.X ][ tailPart.Y ] = false
    end
    
    -- List empty spaces
    local emptySpaces = {}
    for x=1,snake.BoardSize.X,1 do
        for y=1,snake.BoardSize.Y,1 do
            if spaces[x][y] then
                table.insert( emptySpaces, { X=x, Y=y } )
            end
        end
    end
    
    local num = #emptySpaces
    if num == 0 then
        SnakeWon()
        return
    end
    
    -- Random space
    local food = emptySpaces[ math.random( num ) ]
    snake.Food.X = food.X
    snake.Food.Y = food.Y
    
    local renderX, renderY = SpriteRenderPos(snake, food.X, food.Y )
    local renderSize = SpriteSize(snake)
    Interface.SetComponentProperties( "SnakeFood", { X = renderX, Y = renderY, W = renderSize, H = renderSize, Angle = 0 } )
end


function ButtonPressed_Up()
    if not snake.ChangedDir and game == "Snake" then
        if snake.Dir ~= "Down" then
            snake.Dir = "Up"
            Interface.SetComponentProperties( "SnakeHead", { Angle = 0 } )
            snake.ChangedDir = true
        end
    end
	snake.ai = false
	Interface.SetComponentProperties( "ImageSnakeAi", { Colour = "#000000" } )
end


function ButtonPressed_Down()
    if not snake.ChangedDir and  game == "Snake" then
        if snake.Dir ~= "Up" then
            snake.Dir = "Down"
            Interface.SetComponentProperties( "SnakeHead", { Angle = math.pi } )
            snake.ChangedDir = true
        end
    end
	snake.ai = false
	Interface.SetComponentProperties( "ImageSnakeAi", { Colour = "#000000" } )
end


function ButtonPressed_Left()            
    if not snake.ChangedDir and  game == "Snake" then
        if snake.Dir ~= "Right" then
            snake.Dir = "Left"
            Interface.SetComponentProperties( "SnakeHead", { Angle = -math.pi/2 } )
            snake.ChangedDir = true
        end
    end
	snake.ai = false
	Interface.SetComponentProperties( "ImageSnakeAi", { Colour = "#000000" } )
end


function ButtonPressed_Right()
    if not snake.ChangedDir and  game == "Snake" then
        if snake.Dir ~= "Left" then
            snake.Dir = "Right"
            Interface.SetComponentProperties( "SnakeHead", { Angle = math.pi/2 } )
            snake.ChangedDir = true
        end
    end
	snake.ai = false
	Interface.SetComponentProperties( "ImageSnakeAi", { Colour = "#000000" } )
end


function ButtonPressed_SnakeCentre()
    if gameOver then
		gameOver = false
		ResetSnakeGameState( snake.Render.W, snake.Render.H )
	else
		gameOver = true
		snake.GameStarted = false
		ResetSnakeGameState( snake.Render.W, snake.Render.H )
		Interface.SetComponentProperties( "StartingSnake", { Caption = "arcade_snake_pressbutton", Colour = "#41FF00" } )
    end
end


function ButtonPressed_SnakeAi()
	if snake.ai == false then
		snake.ai = true
		Interface.SetComponentProperties( "ImageSnakeAi", { Colour = "#41FF00" } )
	else
		snake.ai = false
		Interface.SetComponentProperties( "ImageSnakeAi", { Colour = "#000000" } )
	end
end

-- End Snake


-- Begin Pong


function UpdatePong( timePassed )
    pongball.MoveTimer = pongball.MoveTimer - timePassed
    
    if not pongball.GameStarted then
        local t = math.floor( pongball.MoveTimer )
        
        if pongball.MoveTimer < 0 then
            Interface.SetComponentProperties( "StartingPong", { Caption = "" } )
            pongball.GameStarted = true
            pongball.MoveTimer = pongball.UpdateTime
        else
            Interface.SetComponentProperties( "StartingPong", { Caption = "arcade_pong_gamestarting", Colour = "#FFB000", Replacements = { X = tostring( t ) } } )
        end
    elseif pongball.MoveTimer < 0 then
	
        pongball.MoveTimer = pongball.UpdateTime + pongball.MoveTimer
        
		UpdatePongPlayer(p1paddle, pongball)
		UpdatePongPlayer(p2paddle, pongball)
		UpdatePongBall(pongball)
		CheckPongIntersection(p1paddle, p2paddle, pongball)
		
        if p1paddle.Score == 10 or p2paddle.Score == 10 then
		
            Interface.SetComponentProperties( "StartingPong", { Caption = "arcade_pong_gameover", Colour = "#FFB000" } )
            gameOver = true
		else
			Interface.SetComponentProperties( "StartingPong", { Caption = "arcade_pong_scoreboard", Colour = "#FFB000", Replacements = { X = p1paddle.Score, Y = p2paddle.Score } } )
        end
    end
	
    Interface.RemoveReportComponent( screen.Name )
    Interface.AddReportComponent( screen )
end


function Do_PongAI(p, b)
	if b.y < p.y and p.y > 1 then	-- the ai can't react fast enough when the angle of pong changed when it hits top or bottom screen, so game can still end at any time.
		p.y = p.y - 0.5
	elseif b.y > p.y and p.y < 19 then
		p.y = p.y + 0.5
	end
end


function UpdatePongPlayer(p, b)
	if not p.ai then
		if p.Dir == "Up" and p.y > 1 then p.y = p.y - 0.5 end
		if p.Dir == "Down" and p.y < 19 then p.y = p.y + 0.5 end
	else
		Do_PongAI(p, b)
	end
    local paddleSize = SpriteSize(p)
	local paddleX, paddleY = SpriteRenderPos( p, p.x, p.y )
	Interface.SetComponentProperties( p.Player.."PaddleHead", { X = paddleX, Y = paddleY, W = paddleSize, H = paddleSize*2 } )
end


function UpdatePongBall(b)
	b.x = b.x + b.dx
	b.y = b.y + b.dy
    local pongSize = SpriteSize(b)
	local pongX, pongY = SpriteRenderPos( b, b.x, b.y )
	Interface.SetComponentProperties( "PongBall", { X = pongX, Y = pongY, W = pongSize, H = pongSize } )
end

function ResetPongBall(b,s)
	b.x  = s.x
	b.y  = s.y
	if s.Player == "PlayerLeft" then
		b.dx = 0.25
	elseif s.Player == "PlayerRight" then
		b.dx = -0.25
	end
	b.dy = math.random()
end

function CheckPongIntersection(l, r, b)
	calc_angle = false
	p = {}
	s = {}
	
	--print("b.x: "..b.x.." b.y: "..b.y.."   l.x: "..l.x.." l.y: "..l.y.."   r.x: "..r.x.." r.y: "..r.y)
	if b.x >= l.x and b.x <= l.x+0.5 and b.y >= l.y-1 and b.y <= l.y + 2 then
		--print("1d")
		b.x = l.x + 0.5
		b.dx = -b.dx
		calc_angle = true
		p = l
	elseif b.x >= r.x-0.5 and b.x <= r.x and b.y >= r.y-1 and b.y <= r.y + 2 then
		--print("1e")
		b.x = r.x - 0.5
		b.dx = -b.dx
		calc_angle = true
		p = r
	elseif b.x < 1 then
		--print("1a")
		r.Score = r.Score + 1
		--print("SCORE:  "..l.Score.." - "..r.Score)
		s = r
		ResetPongBall(b,s)
	elseif b.x > 20 then
		--print("1b")
		l.Score = l.Score + 1
		--print("SCORE:  "..l.Score.." - "..r.Score)
		s = l
		ResetPongBall(b,s)
	elseif b.y < 1 or b.y > 20 then
		--print("1c")
		b.dy = -b.dy
		calc_angle = true
		p.y = b.dy
	end
	if calc_angle then
		--print("1f")
		if math.random() > 0.9 then
			if b.dx >= 0 then
				b.dx = b.dx + 0.05
			else
				b.dx = b.dx - 0.05
			end
		end
		rl = (b.y - p.y) / 2
		rl = rl / 2 + 0.25
		angle = math.sin(rl)
		b.dy = angle
	end
end


function ButtonPressed_P1Up()
	p1paddle.ai = false
	Interface.SetComponentProperties( "ImagePongP1ai", { Colour = "#000000" } )
	p1paddle.Dir = "Up"
end


function ButtonPressed_P1Down()
	p1paddle.ai = false
	Interface.SetComponentProperties( "ImagePongP1ai", { Colour = "#000000" } )
	p1paddle.Dir = "Down"
end


function ButtonPressed_P2Up()
	p2paddle.ai = false
	Interface.SetComponentProperties( "ImagePongP2ai", { Colour = "#000000" } )
	p2paddle.Dir = "Up"
end


function ButtonPressed_P2Down()
	p2paddle.ai = false
	Interface.SetComponentProperties( "ImagePongP2ai", { Colour = "#000000" } )
	p2paddle.Dir = "Down"
end


function ButtonPressed_P1Ai()
	if p1paddle.ai == false then
		p1paddle.ai = true
		Interface.SetComponentProperties( "ImagePongP1ai", { Colour = "#FFB000" } )
	else
		p1paddle.ai = false
		Interface.SetComponentProperties( "ImagePongP1ai", { Colour = "#000000" } )
	end
end


function ButtonPressed_PongCentre()
    if gameOver then
		gameOver = false
		ResetPongGameState( pongball.Render.W, pongball.Render.H )
	else
		gameOver = true
		pongball.GameStarted = false
		ResetPongGameState( pongball.Render.W, pongball.Render.H )
		Interface.SetComponentProperties( "StartingPong", { Caption = "arcade_pong_pressbutton", Colour = "#FFB000" } )
    end
end


function ButtonPressed_P2Ai()
	if p2paddle.ai == false then
		p2paddle.ai = true
		Interface.SetComponentProperties( "ImagePongP2ai", { Colour = "#FFB000" } )
	else
		p2paddle.ai = false
		Interface.SetComponentProperties( "ImagePongP2ai", { Colour = "#000000" } )
	end
end



-- Begin Invaders


function UpdateInvaders( timePassed )
    turret.MoveTimer = turret.MoveTimer - timePassed
    
    if not turret.GameStarted then
        local t = math.floor( turret.MoveTimer )
        
        if turret.MoveTimer < 0 then
            Interface.SetComponentProperties( "StartingInvaders", { Caption = "" } )
            turret.GameStarted = true
            turret.MoveTimer = turret.UpdateTime
        else
            Interface.SetComponentProperties( "StartingInvaders", { Caption = "arcade_invaders_gamestarting", Colour = "#41FF00", Replacements = { X = tostring( t ) } } )
        end
    elseif turret.MoveTimer < 0 then
	
        turret.MoveTimer = turret.UpdateTime + turret.MoveTimer
        
        if turret.Health <= 0 or InvadersLanded == true or turret.BossDefeated == true then
		
			if turret.BossDefeated == true then
				Interface.SetComponentProperties( "StartingInvaders", { Caption = "arcade_invaders_gamewon", Colour = "#41FF00" } )
			else
				Interface.SetComponentProperties( "StartingInvaders", { Caption = "arcade_invaders_gameover", Colour = "#41FF00" } )
			end
            gameOver = true
		else
			UpdateTheTurret()
			CheckTurretBullets()
			
			UpdateTheInvaders()
			CheckInvaderBullets()
		
			Interface.SetComponentProperties( "StartingInvaders", { Caption = "arcade_invaders_scoreboard", Colour = "#41FF00", Replacements = { X = turret.Score, Y = invaderType, Z = turret.Health } } )
        end
		
    end
	
    Interface.RemoveReportComponent( screen.Name )
    Interface.AddReportComponent( screen )
end


function UpdateTheTurret()

	DoExplosion(0,0,0)
	
	if not turret.ai then
		if turret.Dir == "Left" and turret.x > 1.5 then turret.x = turret.x - 0.25 end
		if turret.Dir == "Right" and turret.x < 18.5 then turret.x = turret.x + 0.25 end
	else
		DoTurretAI()
	end
	if turret.ShotFired == true then
		for i = 1,5 do
			if turretBullets[i].Fired == false then
				turretBullets[i].x = turret.x + 0.5
				turretBullets[i].y = turret.y - 0.25
				local turretBulletsSize = SpriteSize(turretBullets[i])
				local turretBulletsX, turretBulletsY = SpriteRenderPos( turretBullets[i], turretBullets[i].x, turretBullets[i].y )
				Interface.SetComponentProperties( "TurretBullet"..i, { X = turretBulletsX, Y = turretBulletsY, W = turretBulletsSize, H = turretBulletsSize } )
				turretBullets[i].Fired = true
				break
			end
		end
		turret.ShotFired = false
	end
    local turretSize = SpriteSize(turret)
	local turretX, turretY = SpriteRenderPos( turret, turret.x, turret.y )
	Interface.SetComponentProperties( "Turret", { X = turretX, Y = turretY, W = turretSize*2, H = turretSize*2 } )
end


function DoTurretAI()
	for i = 1,5 do
	
		if invaders[i].Killed == false and invaderType < 15 and turret.x >= invaders[i].x - 1 and turret.x <= invaders[i].x + 1 then
			turret.ShotFired = true			-- fire a salvo at invader above turret
		elseif invaders[1].Killed == false and invaderType == 15 and turret.x >= invaders[i].x + 2 and turret.x <= invaders[i].x + 4 then
			turret.ShotFired = true			-- fire a salvo at boss above turret
		end
		
		if turret.Dir == "Left" and invaderBullets[i].x >= turret.x - 2 and invaderBullets[i].x <= turret.x and invaderBullets[i].y >= turret.y - 2 then
			turret.Dir = "Right"
			turret.x = turret.x + 0.25		-- try to dodge incoming bullets from invaders
		
		elseif turret.Dir == "Right" and invaderBullets[i].x >= turret.x and invaderBullets[i].x <= turret.x + 2 and invaderBullets[i].y >= turret.y - 2 then
			turret.Dir = "Left"
			turret.x = turret.x - 0.25		-- doesn't guarantee 100% success rate, so the game can still end at any time when the turret is trapped by invader bullets
		end
		
	end
	-- move left until not further possible, else move right until screen edge
	if turret.Dir == "Left" and turret.x > 1.5 then turret.x = turret.x - 0.25 else turret.Dir = "Right" end
	if turret.Dir == "Right" and turret.x < 18.5 then turret.x = turret.x + 0.25 else turret.Dir = "Left" end
end


function UpdateTheInvaders()
	-- move them left, right or down
	local left = false
	local down = false
	if math.random() > 0.5 then down = true else if math.random() > 0.5 then left = true end end
	if down == true then
		for i = 1,5 do
			if invaders[i].Killed == false then 
				if invaders[i].y < 19 then
					invaders[i].y = invaders[i].y+0.05
				else
					InvadersLanded = true
				end
				local invaderSize = SpriteSize(invaders[i])
				local invaderX, invaderY = SpriteRenderPos( invaders[i], invaders[i].x, invaders[i].y )
				if invaderType <= 14 then
					Interface.SetComponentProperties( "Invader"..i, { X = invaderX, Y = invaderY, W = invaderSize*2, H = invaderSize*2 } )
				else
					Interface.SetComponentProperties( "Invader"..i, { X = invaderX, Y = invaderY, W = invaderSize*6, H = invaderSize*3 } )
				end
			end
		end
	elseif left == true and invaders[1].x > 1 then
		for i = 1,5 do
			if invaders[i].Killed == false then 
				invaders[i].x = invaders[i].x-0.25
				local invaderSize = SpriteSize(invaders[i])
				local invaderX, invaderY = SpriteRenderPos( invaders[i], invaders[i].x, invaders[i].y )
				if invaderType <= 14 then
					Interface.SetComponentProperties( "Invader"..i, { X = invaderX, Y = invaderY, W = invaderSize*2, H = invaderSize*2 } )
				else
					Interface.SetComponentProperties( "Invader"..i, { X = invaderX, Y = invaderY, W = invaderSize*6, H = invaderSize*3 } )
				end
			end
		end
	elseif left == false and invaders[5].x < 19 then
		for i = 1,5 do
			if invaders[i].Killed == false then 
				invaders[i].x = invaders[i].x+0.25
				local invaderSize = SpriteSize(invaders[i])
				local invaderX, invaderY = SpriteRenderPos( invaders[i], invaders[i].x, invaders[i].y )
				if invaderType <= 14 then
					Interface.SetComponentProperties( "Invader"..i, { X = invaderX, Y = invaderY, W = invaderSize*2, H = invaderSize*2 } )
				else
					Interface.SetComponentProperties( "Invader"..i, { X = invaderX, Y = invaderY, W = invaderSize*6, H = invaderSize*3 } )
				end
			end
		end
	end
	
	-- check if invaders are exactly above the turret: then fire a shot
	for i = 1,5 do
		if invaders[i].Killed == false and invaders[i].x == turret.x then
			for j = 1,5 do
				if invaderBullets[j].Fired == false then
					invaderBullets[j].x = invaders[i].x + 0.5
					invaderBullets[j].y = invaders[i].y + 0.25
					local invaderBulletsSize = SpriteSize(invaderBullets[j])
					local invaderBulletsX, invaderBulletsY = SpriteRenderPos( invaderBullets[j], invaderBullets[j].x, invaderBullets[j].y )
					Interface.SetComponentProperties( "InvaderBullet"..i, { X = invaderBulletsX, Y = invaderBulletsY, W = invaderBulletsSize, H = invaderBulletsSize } )
					invaderBullets[j].Fired = true
					break
				end
			end
			break
		end
	end
	
	-- check if invaders are all dead: then spawn next batch of invaders
	local totalKilled = 0
	for i = 1,5 do
		if invaders[i].Killed == true then
			if invaderType <= 14 then
				totalKilled = totalKilled + 1
			elseif invaderType == 15 and invaders[1].Killed == true then
				turret.BossDefeated = true
				Interface.SetComponentProperties( "StartingInvaders", { Caption = "arcade_invaders_gamewon", Colour = "#41FF00" } )
			end
		end
	end
	if totalKilled == 5 then				-- all dead? then spawn a fresh batch of invaders
		invaderType = invaderType + 1
		--invaderType = 15
		if invaderType == 5 or invaderType == 10 or invaderType == 15 then turret.Health = turret.Health + 3 end
		if invaderType <= 14 then			-- spawn all types of invaders
			for i = 1,5 do
				invaders[i].Killed = false
				invaders[i].x = (i*4)-2		-- reposition to default spawn spot
				if invaderType < 5 then
					invaders[i].Armour = invaderType
				elseif invaderType < 10 then
					invaders[i].Armour = 7
				else
					invaders[i].Armour = 10
				end
				local invaderSize = SpriteSize(invaders[i])
				local invaderX, invaderY = SpriteRenderPos( invaders[i], invaders[i].x, invaders[i].y )
				Interface.SetComponentProperties( "Invader"..i, { File = "Arcade/ArcadeCabinet_invader"..invaderType..".png", X = invaderX, Y = invaderY, W = invaderSize*2, H = invaderSize*2 } )
			end
		else								-- spawn boss at the end level
			invaders[1].Killed = false
			turret.Health = turret.Health + 5
			invaders[1].Armour = 25
			invaders[5].x = 10
			invaders[1].x = 10
			invaders[1].y = 4
			local invaderSize = SpriteSize(invaders[1])
			local invaderX, invaderY = SpriteRenderPos( invaders[1], invaders[1].x, invaders[1].y )
			Interface.SetComponentProperties( "Invader"..1, { File = "Arcade/ArcadeCabinet_invader15.png", X = invaderX, Y = invaderY, W = invaderSize*6, H = invaderSize*3 } )
		end
	end
end


function CheckTurretBullets()
	for i = 1,5 do
		if turretBullets[i].Fired == true then
			for j = 1,5 do
				if invaderType < 15 and invaders[j].Killed == false and turretBullets[i].x >= invaders[j].x - 1 and turretBullets[i].x <= invaders[j].x + 1 and turretBullets[i].y >= invaders[j].y - 1 and turretBullets[i].y <= invaders[j].y + 1 then
					turretBullets[i].Fired = false
					
					DoExplosion(turretBullets[i].x,turretBullets[i].y,2)		-- normal explosion for levels < 15
					
					invaders[j].Armour = invaders[j].Armour - 1
					if invaders[j].Armour <= 0 then
						invaders[j].Killed = true
						turret.Score = turret.Score + 1
						invaders[j].x = 10			-- reposition killed invaders to the centre, so the living invaders can move more to left or right
						invaders[j].y = math.random(1,invaderType+1)
						local invaderSize = SpriteSize(invaders[j])
						local invaderX, invaderY = SpriteRenderPos( invaders[j], invaders[j].x, invaders[j].y )
						Interface.SetComponentProperties( "Invader"..j, { File = "Arcade/ArcadeCabinet_invader"..invaderType..".png", X = invaderX, Y = invaderY, W = 0, H = 0 } )
					end
				elseif invaderType == 15 and invaders[1].Killed == false and turretBullets[i].x >= invaders[1].x + 2 and turretBullets[i].x <= invaders[1].x + 4 and turretBullets[i].y >= invaders[j].y - 1 and turretBullets[i].y <= invaders[j].y + 1 then
					turretBullets[i].Fired = false
					
					DoExplosion(turretBullets[i].x,turretBullets[i].y,4)		-- bigger explosions for the boss
					
					invaders[j].Armour = invaders[1].Armour - 1
					if invaders[1].Armour <= 0 then
						invaders[1].Killed = true
						turret.Score = turret.Score + 1
						invaders[1].x = (j*4)-2
						invaders[1].y = 2
						local invaderSize = SpriteSize(invaders[j])
						local invaderX, invaderY = SpriteRenderPos( invaders[j], invaders[j].x, invaders[j].y )
						Interface.SetComponentProperties( "Invader"..j, { File = "Arcade/ArcadeCabinet_invader"..invaderType..".png", X = invaderX, Y = invaderY, W = 0, H = 0 } )
					end
				elseif turretBullets[i].y > 1 then								-- move bullet up
					turretBullets[i].y = turretBullets[i].y - 0.25
					local turretBulletsSize = SpriteSize(turretBullets[i])
					local turretBulletsX, turretBulletsY = SpriteRenderPos( turretBullets[i], turretBullets[i].x, turretBullets[i].y )
					Interface.SetComponentProperties( "TurretBullet"..i, { X = turretBulletsX, Y = turretBulletsY, W = turretBulletsSize, H = turretBulletsSize } )
				else
					turretBullets[i].Fired = false								-- bullet went out of screen on top, reset it
					turretBullets[i].x = turret.x
					turretBullets[i].y = turret.y
					local turretBulletsSize = SpriteSize(turretBullets[i])
					local turretBulletsX, turretBulletsY = SpriteRenderPos( turretBullets[i], turretBullets[i].x, turretBullets[i].y )
					Interface.SetComponentProperties( "TurretBullet"..i, { X = turretBulletsX, Y = turretBulletsY, W = 0, H = 0 } )
				end
			end
		else
			turretBullets[i].x = turret.x										-- keep bullets below the turret position
			turretBullets[i].y = turret.y
			local turretBulletsSize = SpriteSize(turretBullets[i])
			local turretBulletsX, turretBulletsY = SpriteRenderPos( turretBullets[i], turretBullets[i].x, turretBullets[i].y )
			Interface.SetComponentProperties( "TurretBullet"..i, { X = turretBulletsX, Y = turretBulletsY, W = 0, H = 0 } )
		end
	end	
end


function CheckInvaderBullets()
	for i = 1,5 do
		if invaderBullets[i].Fired == true then
			if invaderBullets[i].x >= turret.x - 1 and invaderBullets[i].x <= turret.x + 1 and invaderBullets[i].y >= turret.y - 1 and invaderBullets[i].y <= turret.y then
				invaderBullets[i].Fired = false
				turret.Health = turret.Health - 1
				
				DoExplosion(invaderBullets[i].x,invaderBullets[i].y,2)
				
			elseif invaderBullets[i].y < 19 then								-- move bullet down
				invaderBullets[i].y = invaderBullets[i].y + 0.25
				local invaderBulletsSize = SpriteSize(invaderBullets[i])
				local invaderBulletsX, invaderBulletsY = SpriteRenderPos( invaderBullets[i], invaderBullets[i].x, invaderBullets[i].y )
				Interface.SetComponentProperties( "InvaderBullet"..i, { X = invaderBulletsX, Y = invaderBulletsY, W = invaderBulletsSize, H = invaderBulletsSize } )
			else
				invaderBullets[i].Fired = false									-- bullet reached ground, reset it
				invaderBullets[i].x = invaders[i].x
				invaderBullets[i].y = invaders[i].y
				local invaderBulletsSize = SpriteSize(invaderBullets[i])
				local invaderBulletsX, invaderBulletsY = SpriteRenderPos( invaderBullets[i], invaderBullets[i].x, invaderBullets[i].y )
				Interface.SetComponentProperties( "InvaderBullet"..i, { X = invaderBulletsX, Y = invaderBulletsY, W = 0, H = 0 } )
			end
		else
			invaderBullets[i].x = invaders[i].x									-- keep bullets at invaders positions
			invaderBullets[i].y = invaders[i].y
			local invaderBulletsSize = SpriteSize(invaderBullets[i])
			local invaderBulletsX, invaderBulletsY = SpriteRenderPos( invaderBullets[i], invaderBullets[i].x, invaderBullets[i].y )
			Interface.SetComponentProperties( "InvaderBullet"..i, { X = invaderBulletsX, Y = invaderBulletsY, W = 0, H = 0 } )
		end
	end	
end


function DoExplosion(x,y,s)
	explosion.x = x
	explosion.y = y
	local explosionSize = SpriteSize(explosion)
	local explosionX, explosionY = SpriteRenderPos( explosion, explosion.x, explosion.y )
	Interface.SetComponentProperties( "Explosion", { X = explosionX, Y = explosionY, W = explosionSize*s, H = explosionSize*s } )
end


function ButtonPressed_TurretFire()
	turret.ai = false
	Interface.SetComponentProperties( "ImageInvadersAi", { Colour = "#000000" } )
	turret.ShotFired = true
end


function ButtonPressed_TurretLeft() 
	turret.ai = false
	Interface.SetComponentProperties( "ImageInvadersAi", { Colour = "#000000" } )
	turret.Dir = "Left"
end


function ButtonPressed_TurretRight()
	turret.ai = false
	Interface.SetComponentProperties( "ImageInvadersAi", { Colour = "#000000" } )
	turret.Dir = "Right"
end


function ButtonPressed_TurretCentre()
    if gameOver then
		gameOver = false
		ResetInvadersGameState( turret.Render.W, turret.Render.H )
	else
		gameOver = true
		turret.GameStarted = false
		ResetInvadersGameState( turret.Render.W, turret.Render.H )
		Interface.SetComponentProperties( "StartingInvaders", { Caption = "arcade_invaders_pressbutton", Colour = "#41FF00" } )
    end
end


function ButtonPressed_TurretAi()
	if turret.ai == false then
		turret.ai = true
		Interface.SetComponentProperties( "ImageInvadersAi", { Colour = "#41FF00" } )
	else
		turret.ai = false
		Interface.SetComponentProperties( "ImageInvadersAi", { Colour = "#000000" } )
	end
end







-- Custom Report Window

function SetTabNames()
    -- Game names make our tabs
    Interface.SetReportTabs( 
        "arcade_game_snake"
        ,"arcade_game_pong"
		,"arcade_game_invaders"
    )
end


function PopulateReport( tabIndex )
    game = gameNames[ tonumber( tabIndex ) ]
    local w, h = Interface.GetReportWindowSize()
    
    SetupCommonComponents( w, h )
    
    if game == "Snake" then
        SetupSnake( w, h )
    elseif game == "Pong" then
        SetupPong( w, h )
    elseif game == "Invaders" then
        SetupInvaders( w, h )
    end
    
end


-- Snake

function SetupSnake( w, h )
    -- Add some extra components:
    -- Snake head
    Interface.AddReportComponent( { Type = "Image", Name = "SnakeHead", File = "Arcade/ArcadeCabinet_snakehead.png", Colour = "#41FF00" } )
    Interface.AddReportComponent( { Type = "Image", Name = "SnakeFood", File = "Arcade/ArcadeCabinet_snaketail.png", Colour = "#41FF00" } )
    
    local minSize = math.min( w, h )
    local border = minSize / 10
    local borderX = border
    local borderY = border
    local borderX2 = minSize - border
    local borderY2 = minSize - border
    
    -- Starting caption
    Interface.AddReportComponent( { Type = "Caption", Name = "StartingSnake", Caption = "arcade_snake_gamestarting", Centred = true, 
        X = 0, Y = borderY2, W = w, H = border, Colour = "#41FF00", Replacements = { X = "5" } } )
    
    -- Render information
    snake.Render.X = borderX
    snake.Render.Y = borderY
    snake.Render.W = borderX2 - borderX
    snake.Render.H = borderY2 - borderY
    
    ResetSnakeGameState()
end


function ResetSnakeGameState()
    -- Remove old tail images
    for i=1,#snake.Tail,1 do
        Interface.RemoveReportComponent( "SnakeTail" .. tostring( i ) )
    end
    
    -- Set up our game state
    snake.MoveTimer = 5
    snake.ai = true
	Interface.SetComponentProperties( "ImageSnakeAi", { Colour = "#41FF00" } )
	
    snake.Head.X = math.floor( snake.BoardSize.X / 2 )
    snake.Head.Y = math.floor( snake.BoardSize.Y / 2 )
    
    snake.Tail = {}
    snake.Dir = "Up"
    snake.GameStarted = false
    snake.ChangedDir = false
    
    SnakeSpawnFood()
    
    local snakeSize = SpriteSize(snake)
    local snakeX, snakeY = SpriteRenderPos( snake, snake.Head.X, snake.Head.Y )
    Interface.SetComponentProperties( "SnakeHead", { X = snakeX, Y = snakeY, W = snakeSize, H = snakeSize, Angle = 0 } )
    
    Interface.SetComponentProperties( "StartingSnake", { Caption = "arcade_snake_gamestarting", Colour = "#41FF00", Replacements = { X = tostring(math.floor(snake.MoveTimer)) } } )
end


-- Pong

function SetupPong( w, h )
    -- Add some extra components:
    -- Pong ball and left/right bat
    Interface.AddReportComponent( { Type = "Image", Name = "PongBall", File = "Arcade/ArcadeCabinet_pongball.png", Colour = "#FFB000" } )
    Interface.AddReportComponent( { Type = "Image", Name = p1paddle.Player.."PaddleHead", File = "Arcade/ArcadeCabinet_pongpaddle.png", Colour = "#FFB000" } )
    Interface.AddReportComponent( { Type = "Image", Name = p2paddle.Player.."PaddleHead", File = "Arcade/ArcadeCabinet_pongpaddle.png", Colour = "#FFB000" } )
    
    local minSize = math.min( w, h )
    local border = minSize / 10
    local borderX = border
    local borderY = border
    local borderX2 = minSize - border
    local borderY2 = minSize - border
    
    -- Starting caption
    Interface.AddReportComponent( { Type = "Caption", Name = "StartingPong", Caption = "arcade_pong_gamestarting", Centred = true, 
        X = 0, Y = borderY2, W = w, H = border, Colour = "#FFB000", Replacements = { X = "5" } } )
    
    -- Render information
    pongball.Render.X = borderX
    pongball.Render.Y = borderY
    pongball.Render.W = borderX2 - borderX
    pongball.Render.H = borderY2 - borderY
    
    p1paddle.Render.X = borderX
    p1paddle.Render.Y = borderY
    p1paddle.Render.W = borderX2 - borderX
    p1paddle.Render.H = borderY2 - borderY
	
    p2paddle.Render.X = borderX
    p2paddle.Render.Y = borderY
    p2paddle.Render.W = borderX2 - borderX
    p2paddle.Render.H = borderY2 - borderY
    ResetPongGameState()
end


function ResetPongGameState()

    -- Set up our game state
    pongball.MoveTimer = 5
    pongball.GameStarted = false
	
	if math.random() > 0.5 then
		pongball.dx = 0.25
	else
		pongball.dx = -0.25
	end
	if math.random() > 0.5 then
		pongball.dy = -(math.random())
	else
		pongball.dy = math.random()
	end
	
    pongball.x = 10.5
    pongball.y = 10.5
    
    p1paddle.x = 2
    p1paddle.y = math.floor( p1paddle.BoardSize.Y / 2 )
	
    p2paddle.x = 19
    p2paddle.y = math.floor( p2paddle.BoardSize.Y / 2 )
	
	p1paddle.ai = true
	Interface.SetComponentProperties( "ImagePongP1ai", { Colour = "#FFB000" } )
    p1paddle.Dir = "Up"
	p1paddle.Score = 0
    p1paddle.ChangedDir = false
	
	p2paddle.ai = true
	Interface.SetComponentProperties( "ImagePongP2ai", { Colour = "#FFB000" } )
    p2paddle.Dir = "Up"
	p2paddle.Score = 0
    p2paddle.ChangedDir = false
    
    local pongSize = SpriteSize(pongball)
    local pongX, pongY = SpriteRenderPos( pongball, pongball.x, pongball.y )
    Interface.SetComponentProperties( "PongBall", { X = pongX, Y = pongY, W = pongSize, H = pongSize } )
	
    local paddle1Size = SpriteSize(p1paddle)
    local paddle1X, paddle1Y = SpriteRenderPos( p1paddle, p1paddle.x, p1paddle.y )
    Interface.SetComponentProperties( p1paddle.Player.."PaddleHead", { X = paddle1X, Y = paddle1Y, W = paddle1Size, H = paddle1Size*2 } )
    
    local paddle2Size = SpriteSize(p2paddle)
    local paddle2X, paddle2Y = SpriteRenderPos( p2paddle, p2paddle.x, p2paddle.y )
    Interface.SetComponentProperties( p2paddle.Player.."PaddleHead", { X = paddle2X, Y = paddle2Y, W = paddle2Size, H = paddle2Size*2 } )
    
    Interface.SetComponentProperties( "StartingPong", { Caption = "arcade_pong_gamestarting", Colour = "#FFB000", Replacements = { X = tostring(math.floor(pongball.MoveTimer)) } } )
end



-- Invaders

function SetupInvaders( w, h )
    -- Add some extra components:
    -- Pong ball and left/right bat
    Interface.AddReportComponent( { Type = "Image", Name = "Turret", File = "Arcade/ArcadeCabinet_turret.png", Colour = "#41FF00" } )
	Interface.AddReportComponent( { Type = "Image", Name = "Explosion", File = "Arcade/ArcadeCabinet_targethit.png", Colour = "#41FF00" } )
	
	for i = 1,5 do
		Interface.AddReportComponent( { Type = "Image", Name = "Invader"..i, File = "Arcade/ArcadeCabinet_invader0.png", Colour = "#41FF00" } )
		Interface.AddReportComponent( { Type = "Image", Name = "InvaderBullet"..i, File = "Arcade/ArcadeCabinet_bullet.png", Colour = "#41FF00" } )
		Interface.AddReportComponent( { Type = "Image", Name = "TurretBullet"..i, File = "Arcade/ArcadeCabinet_bullet.png", Colour = "#41FF00" } )
	end
	
    local minSize = math.min( w, h )
    local border = minSize / 10
    local borderX = border
    local borderY = border
    local borderX2 = minSize - border
    local borderY2 = minSize - border
    
    -- Starting caption
    Interface.AddReportComponent( { Type = "Caption", Name = "StartingInvaders", Caption = "arcade_invaders_gamestarting", Centred = true, 
        X = 0, Y = borderY2, W = w, H = border, Colour = "#41FF00", Replacements = { X = "5" } } )
    
    -- Render information
    turret.Render.X = borderX
    turret.Render.Y = borderY
    turret.Render.W = borderX2 - borderX
    turret.Render.H = borderY2 - borderY
	
    explosion.Render.X = borderX
    explosion.Render.Y = borderY
    explosion.Render.W = borderX2 - borderX
    explosion.Render.H = borderY2 - borderY
	
	for i = 1,5 do
		invaders[i].Render.X = borderX
		invaders[i].Render.Y = borderY
		invaders[i].Render.W = borderX2 - borderX
		invaders[i].Render.H = borderY2 - borderY
		
		turretBullets[i].Render.X = borderX
		turretBullets[i].Render.Y = borderY
		turretBullets[i].Render.W = borderX2 - borderX
		turretBullets[i].Render.H = borderY2 - borderY
		
		invaderBullets[i].Render.X = borderX
		invaderBullets[i].Render.Y = borderY
		invaderBullets[i].Render.W = borderX2 - borderX
		invaderBullets[i].Render.H = borderY2 - borderY
	end
    ResetInvadersGameState()
end


function ResetInvadersGameState()

    -- Set up our game state
    turret.MoveTimer = 5
    turret.GameStarted = false
	InvadersLanded = false
	invaderType = 0
	
	turret.ai = true
	Interface.SetComponentProperties( "ImageInvadersAi", { Colour = "#41FF00" } )
	
	
    turret.x = 10.5
    turret.y = 19
	
    turret.Dir = "Left"
	turret.Score = 0
	turret.Health = 3
    turret.ChangedDir = false
	
    explosion.x = 0
    explosion.y = 0
	
	for i = 1,5 do
		invaders[i].x = (i*4)-2
		invaders[i].y = 2
    	invaders[i].Armour = invaderType
    	invaders[i].Killed = false
		
		local invaderSize = SpriteSize(invaders[i])
		local invaderX, invaderY = SpriteRenderPos( invaders[i], invaders[i].x, invaders[i].y )
		Interface.SetComponentProperties( "Invader"..i, { File = "Arcade/ArcadeCabinet_invader"..invaderType..".png", X = invaderX, Y = invaderY, W = invaderSize*2, H = invaderSize*2 } )
		
		turretBullets[i].x = 10.5
		turretBullets[i].y = 19
    	turretBullets[i].Fired = false
		
		local turretBulletsSize = SpriteSize(turretBullets[i])
		local turretBulletsX, turretBulletsY = SpriteRenderPos( turretBullets[i], turretBullets[i].x, turretBullets[i].y )
		Interface.SetComponentProperties( "TurretBullet"..i, { X = turretBulletsX, Y = turretBulletsY, W = 0, H = 0 } )
		
		
		invaderBullets[i].x = (i*4)-2
		invaderBullets[i].y = 2
    	invaderBullets[i].Fired = false
		
		local invaderBulletsSize = SpriteSize(invaderBullets[i])
		local invaderBulletsX, invaderBulletsY = SpriteRenderPos( invaderBullets[i], invaderBullets[i].x, invaderBullets[i].y )
		Interface.SetComponentProperties( "InvaderBullet"..i, { X = invaderBulletsX, Y = invaderBulletsY, W = 0, H = 0 } )
	end
	
    local turretSize = SpriteSize(turret)
    local turretX, turretY = SpriteRenderPos( turret, turret.x, turret.y )
    Interface.SetComponentProperties( "Turret", { X = turretX, Y = turretY, W = turretSize*2, H = turretSize*2 } )
	
    local explosionSize = SpriteSize(explosion)
    local explosionX, explosionY = SpriteRenderPos( explosion, explosion.x, explosion.y )
    Interface.SetComponentProperties( "Explosion", { X = explosionX, Y = explosionY, W = 0, H = 0 } )
	
    Interface.SetComponentProperties( "StartingInvaders", { Caption = "arcade_invaders_gamestarting", Colour = "#41FF00", Replacements = { X = tostring(math.floor(turret.MoveTimer)) } } )
end




-- Common stuff

function SpriteSize(theSprite)
    return (theSprite.Render.W / theSprite.BoardSize.X)
end


function SpriteRenderPos(theSprite, boardX, boardY )
    local spriteSize = SpriteSize(theSprite)
    local x = theSprite.Render.X + ( spriteSize * ( boardX - 1 ) )
    local y = theSprite.Render.Y + ( spriteSize * ( boardY - 1 ) )
    return x, y
end


function SetupCommonComponents( w, h )
    local size = math.min( w, h )
    local y = 0
    
	
    if game == "Snake" then
	
		background = {
			Type = "Image",
			Name = "BackgroundSnake",
			X = (w / 2 ) - ( size / 2 ),
			Y = y,
			W = size,
			H = size,
			Colour = "White",
			File = "Arcade/ArcadeCabinet_backgroundsnake.png"
		}
		
		screen = {
			Type = "Image",
			Name = "ScreenSnake",
			X = (w / 2 ) - ( size / 2 ),
			Y = y,
			W = size,
			H = size,
			Colour = "White",
			File = "Arcade/ArcadeCabinet_screensnake.png"
		}
		
    elseif game == "Pong" then
	
		background = {
			Type = "Image",
			Name = "BackgroundPong",
			X = (w / 2 ) - ( size / 2 ),
			Y = y,
			W = size,
			H = size,
			Colour = "White",
			File = "Arcade/ArcadeCabinet_backgroundpong.png"
		}
		
		screen = {
			Type = "Image",
			Name = "ScreenPong",
			X = (w / 2 ) - ( size / 2 ),
			Y = y,
			W = size,
			H = size,
			Colour = "White",
			File = "Arcade/ArcadeCabinet_screenpong.png"
		}
    elseif game == "Invaders" then
	
		background = {
			Type = "Image",
			Name = "BackgroundInvaders",
			X = (w / 2 ) - ( size / 2 ),
			Y = y,
			W = size,
			H = size,
			Colour = "White",
			File = "Arcade/ArcadeCabinet_backgroundinvaders.png"
		}
		
		screen = {
			Type = "Image",
			Name = "ScreenInvaders",
			X = (w / 2 ) - ( size / 2 ),
			Y = y,
			W = size,
			H = size,
			Colour = "White",
			File = "Arcade/ArcadeCabinet_screeninvaders.png"
		}
		
    end
    
    -- Title
    Interface.AddReportComponent( { Type = "Title", Caption = "arcade_title" } )
    
    -- Background and screen
    Interface.AddReportComponent( background )
    Interface.AddReportComponent( screen )    
    
    y = y + background.H
    
    if game == "Snake" then
	
		-- Buttons for Snake. Up, down, left, right, and centre
		local buttonSize = w / 16
		local buttonGap = buttonSize / 4
		
		local up = { Type = "Button", Name = "Up", X = (w / 2 ) - ( buttonSize / 2 ), Y = y + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		local centre =  { Type = "Button", Name = "SnakeCentre", X = up.X - buttonSize*3 - buttonGap*3, Y = up.Y + buttonSize + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		local down = { Type = "Button", Name = "Down", X = up.X, Y = centre.Y + buttonSize + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		local left = { Type = "Button", Name = "Left", X = up.X - buttonSize - buttonGap, Y = centre.Y, W = buttonSize, H = buttonSize, Caption = "" }
		local right = { Type = "Button", Name = "Right", X = up.X + buttonSize + buttonGap, Y = centre.Y, W = buttonSize, H = buttonSize, Caption = "" }
		local Sai =  { Type = "Button", Name = "SnakeAi", X = right.X + buttonSize*2 + buttonGap*2, Y = right.Y, W = buttonSize, H = buttonSize, Caption = "" }
		
		Interface.AddReportComponent( up )
		Interface.AddReportComponent( centre )
		Interface.AddReportComponent( down )
		Interface.AddReportComponent( left )
		Interface.AddReportComponent( right )
		Interface.AddReportComponent( Sai )
		
		-- Cover the buttons with some nice images
		up.Name = "ImageSnakeUp"
		down.Name = "ImageSnakeDown"
		left.Name = "ImageSnakeLeft"
		right.Name = "ImageSnakeRight"
		centre.Name = "ImageSnakeCentre"
		Sai.Name = "ImageSnakeAi"
		
		up.Type = "Image"
		down.Type = "Image"
		left.Type = "Image"
		right.Type = "Image"
		centre.Type = "Image"
		Sai.Type = "Image"
		
		up.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		down.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		left.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		right.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		centre.File = "Arcade/ArcadeCabinet_circlebutton.png"
		Sai.File = "Arcade/ArcadeCabinet_aibutton.png"
		
		up.Colour = "White"
		down.Colour = "White"
		left.Colour = "White"
		right.Colour = "White"
		centre.Colour = "#41FF00"
		Sai.Colour = "#41FF00"
		
		down.Angle = math.pi
		left.Angle = -math.pi/2
		right.Angle = math.pi/2
		
		Interface.AddReportComponent( up )
		Interface.AddReportComponent( centre )
		Interface.AddReportComponent( down )
		Interface.AddReportComponent( left )
		Interface.AddReportComponent( right )
		Interface.AddReportComponent( Sai )
		
    elseif game == "Pong" then
	
		local buttonSize = w / 16
		local buttonGap = buttonSize / 4
		
		local P1up = { Type = "Button", Name = "P1Up", X = buttonSize*2, Y = y + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		local P1down = { Type = "Button", Name = "P1Down", X = buttonSize*2, Y = P1up.Y + buttonSize + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		local P1ai = { Type = "Button", Name = "P1Ai", X = (w / 6 ) + buttonSize, Y = P1up.Y + ( buttonSize / 2 ), W = buttonSize, H = buttonSize, Caption = "" }
		local centre = { Type = "Button", Name = "PongCentre", X = (w / 2 ) - ( buttonSize / 2 ), Y = P1up.Y + ( buttonSize / 2 ), W = buttonSize, H = buttonSize, Caption = "" }
		local P2ai = { Type = "Button", Name = "P2Ai", X = (w / 3 ) + (w / 3 ) + (buttonSize / 2), Y = P1up.Y + ( buttonSize / 2 ), W = buttonSize, H = buttonSize, Caption = "" }
		local P2up = { Type = "Button", Name = "P2Up", X = w - buttonSize*3, Y = y + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		local P2down = { Type = "Button", Name = "P2Down", X = w - buttonSize*3, Y = P2up.Y + buttonSize + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		
		Interface.AddReportComponent( P1up )
		Interface.AddReportComponent( P1ai )
		Interface.AddReportComponent( centre )
		Interface.AddReportComponent( P2ai )
		Interface.AddReportComponent( P1down )
		Interface.AddReportComponent( P2up )
		Interface.AddReportComponent( P2down )
		
		-- Cover the buttons with some nice images
		P1up.Name = "ImagePongP1Up"
		P1down.Name = "ImagePongP1Down"
		P1ai.Name = "ImagePongP1ai"
		centre.Name = "ImagePongCentre"
		P2ai.Name = "ImagePongP2ai"
		P2up.Name = "ImagePongP2Up"
		P2down.Name = "ImagePongP2Down"
		
		P1up.Type = "Image"
		P1down.Type = "Image"
		P1ai.Type = "Image"
		centre.Type = "Image"
		P2ai.Type = "Image"
		P2up.Type = "Image"
		P2down.Type = "Image"
		
		P1up.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		P1down.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		P1ai.File = "Arcade/ArcadeCabinet_aibutton.png"
		centre.File = "Arcade/ArcadeCabinet_circlebutton.png"
		P2ai.File = "Arcade/ArcadeCabinet_aibutton.png"
		P2up.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		P2down.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		
		P1up.Colour = "White"
		P1down.Colour = "White"
		P1ai.Colour = "#FFB000"
		centre.Colour = "#FFB000"
		P2ai.Colour = "#FFB000"
		P2up.Colour = "White"
		P2down.Colour = "White"
		
		P1down.Angle = math.pi
		P2down.Angle = math.pi
		
		Interface.AddReportComponent( P1up )
		Interface.AddReportComponent( P1ai )
		Interface.AddReportComponent( centre )
		Interface.AddReportComponent( P2ai )
		Interface.AddReportComponent( P1down )
		Interface.AddReportComponent( P2up )
		Interface.AddReportComponent( P2down )
		
    elseif game == "Invaders" then
	
		local buttonSize = w / 16
		local buttonGap = buttonSize / 4
		
		local fire = { Type = "Button", Name = "TurretFire", X = (w / 2 ) - ( buttonSize / 2 ), Y = y + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		local left = { Type = "Button", Name = "TurretLeft", X = fire.X - buttonSize - buttonGap, Y = fire.Y + buttonSize + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		local right = { Type = "Button", Name = "TurretRight", X = fire.X + buttonSize + buttonGap, Y = fire.Y + buttonSize + buttonGap, W = buttonSize, H = buttonSize, Caption = "" }
		local turretai = { Type = "Button", Name = "TurretAi", X = fire.X + buttonSize*3 + buttonGap*3, Y = right.Y, W = buttonSize, H = buttonSize, Caption = "" }
		local centre =  { Type = "Button", Name = "TurretCentre", X = fire.X - buttonSize*3 - buttonGap*3, Y = left.Y, W = buttonSize, H = buttonSize, Caption = "" }
		
		Interface.AddReportComponent( fire )
		Interface.AddReportComponent( turretai )
		Interface.AddReportComponent( centre )
		Interface.AddReportComponent( left )
		Interface.AddReportComponent( right )
		
		-- Cover the buttons with some nice images
		fire.Name = "ImageInvadersUp"
		left.Name = "ImageInvadersLeft"
		right.Name = "ImageInvadersRight"
		centre.Name = "ImageInvadersCentre"
		turretai.Name = "ImageInvadersAi"
		
		fire.Type = "Image"
		left.Type = "Image"
		right.Type = "Image"
		centre.Type = "Image"
		turretai.Type = "Image"
		
		fire.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		left.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		right.File = "Arcade/ArcadeCabinet_arrowbutton.png"
		centre.File = "Arcade/ArcadeCabinet_circlebutton.png"
		turretai.File = "Arcade/ArcadeCabinet_aibutton.png"
		
		fire.Colour = "White"
		left.Colour = "White"
		right.Colour = "White"
		centre.Colour = "#41FF00"
		turretai.Colour = "#41FF00"
		
		left.Angle = -math.pi/2
		right.Angle = math.pi/2
		
		Interface.AddReportComponent( fire )
		Interface.AddReportComponent( turretai )
		Interface.AddReportComponent( centre )
		Interface.AddReportComponent( left )
		Interface.AddReportComponent( right )
    end
end

