
local timeTot = 0
local timePerUpdate = (1+math.random()+math.random()) / World.TimeWarpFactor
local lastPerson = 0

function Create()
end

function Update(timePassed)
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if not this.JobIssued and tonumber(this.Slot0.i) > -1 then
			if lastPerson ~= this.Slot0.i then
				lastPerson = this.Slot0.i
				Object.CreateJob(this,"CutHair")
				this.JobIssued = true
			end
		elseif tonumber(this.Slot0.i) == -1 and this.JobIssued then
			this.JobIssued = false
			Object.CancelJob(this,"CutHair")
		end
	end
end

function JobComplete_CutHair()
	local H = math.random()
	if H <= 0.5 then
		Object.Spawn( "BrownHairStrand", Object.GetProperty("Pos.x"), Object.GetProperty("Pos.y") )
	elseif H > 0.5 and H <= 0.85 then
		Object.Spawn( "BlondHairStrand", Object.GetProperty("Pos.x"), Object.GetProperty("Pos.y") )
	elseif H > 0.85 then
		Object.Spawn( "RedHairStrand", Object.GetProperty("Pos.x"), Object.GetProperty("Pos.y") )
	end
	this.JobIssued = false
end





















-------------------------------------------------------------------------------------------
-- Helper Functions
------------------------------------------------------------------------------------------- 
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end--]]


-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
	if Object == nil then Set(ID,"None") end
    return Object
end