
local timeTot = 0
local timePerUpdate = 0.5

local Set = Object.SetProperty
local Get = Object.GetProperty
local Find = Object.GetNearbyObjects

local FloorTypeCurrent = { [1] = "Current" }

local FloorTypesDefault = { [1] = "Dirt",
					[2] = "Snow",
					[3] = "PavingStone",
					[4] = "Grass",
					[5] = "LongGrass",
					[6] = "Mud",
					[7] = "Gravel",
					[8] = "Road",
					[9] = "RoadMarkings",
					[10] = "RoadMarkingsLeft",
					[11] = "RoadMarkingsRight",
					[12] = "RoadCrossing",
					[13] = "RoadCrossingLeft",
					[14] = "RoadCrossingRight",
					[15] = "Stone",
					[16] = "ConcreteTiles",
					[17] = "ConcreteFloor",
					[18] = "WoodenFloor",
					[19] = "CeramicFloor",
					[20] = "MosaicFloor",
					[21] = "MetalFloor",
					[22] = "Sand",
					[23] = "MarbleTiles",
					[24] = "WhiteTiles",
					[25] = "FancyTiles",
					[26] = "Water",
					[27] = "WaterStable",
					[28] = "BurntFloor"					
					}
					
local FloorTypesDLC = { [1] = "NewIronFloor",
					[2] = "NewCargoFloor",
					[3] = "NewCheckeredFloor",
					[4] = "NewMud",
					[5] = "Sandstone",
					[6] = "LunarFloor",
					[7] = "GrassCornerFloor",
					[8] = "GrassCornerFloor1",
					[9] = "GrassCornerFloor2",
					[10] = "GrassCornerFloor3",
					[11] = "GrassStones",
					[12] = "PaddedFloor",
					[13] = "LimestoneFloor",
					[14] = "SolacoFloor",
					[15] = "GrateFloor",
					[16] = "BlueCarpet",
					[17] = "BrownCarpet",
					[18] = "RedCarpet",
					[19] = "RunningTrack",
					[20] = "BambooFloor",
					[21] = "FlowerField"
					}
					
local WallTypesDefault = { [1] = "Fence",
					[2] = "ConcreteWall",
					[3] = "BrickWall",
					[4] = "PerimeterWall",
					[5] = "BurntWall"
					}

local WallTypesDLC = { [1] = "NewBarredWall",
					[2] = "NewTiledWall",
					[3] = "NewHedgeWall",
					[4] = "NewBBlockWall",
					[5] = "YutaniWall",
					[6] = "ArtDecoWall",
					[7] = "OrientalWall",
					[8] = "BlueWall",
					[9] = "BurgundyWall",
					[10] = "CushionedWall",
					[11] = "GreenWall",
					[12] = "DerelictWall",
					[13] = "OvergrownWall",
					[14] = "RustyWall",
					[15] = "SlumWall",
					[16] = "BambooFence",
					[17] = "DecayedWall",
					[18] = "FenceAndGrass",
					[19] = "WallMinSec",
					[20] = "WallMedSec",
					[21] = "WallMaxSec",
					[22] = "WallInsaneSec",
					[23] = "WallProtective"
					}

local SelectedType = {}

local AllTypes = { FloorTypeCurrent, FloorTypesDefault, FloorTypesDLC, WallTypesDefault, WallTypesDLC }
local AllTypesDesc = { [1] = "Current", [2] = "DefaultFloors", [3] = "DLCFloors", [4] = "DefaultWalls", [5] = "DLCWalls" }

function Create()
	Set(this,"TileDecay","Clean")
	Set(this,"Indoor","No")
	Set(this,"Ind",false)
end

function Update(timePassed)
	if not ButtonsMade then
		FindCurrentTileType()
		Set(this,"Walk",false)
		Set(this,"Direction","None")
		Interface.AddComponent(this,"Caption_Using", "Caption", "tooltip_Caption_Using")
		Interface.AddComponent(this,"Caption_ActiveTileType", "Caption", "tooltip_Caption_ActiveTileType",SelectedType[this.TileNum],"X")
		Interface.AddComponent(this,"Caption_DecayType", "Caption", "tooltip_Caption_DecayType",this.TileDecay,"X")
		Interface.AddComponent(this,"Caption_Divider1", "Caption", "tooltip_Caption_Divider")
		
		Interface.AddComponent(this,"Caption_AutoWalk", "Caption", "tooltip_Caption_AutoWalk")
		Interface.AddComponent(this,"toggleWalking", "Button", "tooltip_Button_StopWalking")
		
		Interface.AddComponent(this,"Caption_MaterialDuper", "Caption", "tooltip_Caption_MaterialDuper")
		Interface.AddComponent(this,"copyUp", "Button", "tooltip_Button_MaterialDuper_Up")
		Interface.AddComponent(this,"copyDown", "Button", "tooltip_Button_MaterialDuper_Down")
		Interface.AddComponent(this,"copyLeft", "Button", "tooltip_Button_MaterialDuper_Left")
		Interface.AddComponent(this,"copyRight", "Button", "tooltip_Button_MaterialDuper_Right")
		
		Interface.AddComponent(this,"Caption_Decay", "Caption", "tooltip_Caption_Decay")
		Interface.AddComponent(this,"toggleCon", "Button", "tooltip_Button_Decay"..this.TileDecay)
		
		Interface.AddComponent(this,"Caption_IndoorOutdoor", "Caption", "tooltip_Caption_IndoorOutdoor")
		Interface.AddComponent(this,"toggleIndoor", "Button", "tooltip_Button_Indoor"..this.Indoor)
		
		Interface.AddComponent(this,"Caption_Divider2", "Caption", "tooltip_Caption_Divider")
		Interface.AddComponent(this,"Caption_TileSet", "Caption", "tooltip_Caption_TileSet")
		Interface.AddComponent(this,"toggleTileType", "Button", "tooltip_Button_TileType","tooltip_Button_Type"..this.TileType,"X")
		
		if this.TileType == "DefaultFloors" or this.TileType == "DLCFloors" then
			Interface.AddComponent(this,"toggleTileTypePlus", "Button", "tooltip_Button_TilePlus")
			Interface.AddComponent(this,"toggleTileTypeMinus", "Button", "tooltip_Button_TileMinus")
			Interface.AddComponent(this,"Caption_Divider3", "Caption", "tooltip_Caption_Divider")
			Interface.AddComponent(this,"Caption_ChangeBorder", "Caption", "tooltip_Caption_ChangeBorder")
			Interface.AddComponent(this,"toggleBorderType", "Button", "tooltip_Button_ChangeBorder")
		end
		ButtonsMade = true
	end
	
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if this.Walk == true then
			if this.Direction == "Up" then copyUpClicked()
			elseif this.Direction == "Down" then copyDownClicked()
			elseif this.Direction == "Left" then copyLeftClicked()
			elseif this.Direction == "Right" then copyRightClicked()
			end
		end
	end
end

function FindCurrentTileType()
	local x = math.floor(this.Pos.x)
	local y = math.floor(this.Pos.y)
	local cell = World.GetCell(x,y)
	CurrentTile = cell.Mat
	if cell.Ind == true then
		Set(this,"Indoor","Yes")
		Set(this,"Ind",true)
	else
		Set(this,"Indoor","No")
		Set(this,"Ind",false)
	end
	FloorTypeCurrent[1] = CurrentTile
	Set(this,"TileNum",1)
	Set(this,"TileType","Current")
	SelectedType = FloorTypeCurrent
	for T = 2,#AllTypes do
		for N = 1,#AllTypes[T] do
			if AllTypes[T][N] == CurrentTile then
				Set(this,"TileNum",N)
				Set(this,"TileType",AllTypesDesc[T])
				SelectedType = AllTypes[T]
				found = true
				break
			end
		end
		if found then break end
	end
end

function toggleWalkingClicked()
	if this.Walk == true then
		Set(this,"Walk",false)
		Set(this,"Direction","None")
		this.SetInterfaceCaption("toggleWalking", "tooltip_Button_StopWalking")
	else
		Set(this,"Walk",true)
		this.SetInterfaceCaption("toggleWalking", "tooltip_Button_StartWalking")
	end
end

function toggleTileTypeClicked()
	Set(this,"TileNum",1)
	if this.TileType == "Current" then
		Set(this,"TileType","DefaultFloors")
		SelectedType = FloorTypesDefault
		Interface.AddComponent(this,"toggleTileTypePlus", "Button", "tooltip_Button_TilePlus")
		Interface.AddComponent(this,"toggleTileTypeMinus", "Button", "tooltip_Button_TileMinus")
		Interface.AddComponent(this,"Caption_Divider3", "Caption", "tooltip_Caption_Divider")
		Interface.AddComponent(this,"Caption_ChangeBorder", "Caption", "tooltip_Caption_ChangeBorder")
		Interface.AddComponent(this,"toggleBorderType", "Button", "tooltip_Button_ChangeBorder")
	elseif this.TileType == "DefaultFloors" then
		Set(this,"TileType","DLCFloors")
		SelectedType = FloorTypesDLC
	elseif this.TileType == "DLCFloors" then
		Set(this,"TileType","DefaultWalls")
		SelectedType = WallTypesDefault
		Interface.RemoveComponent(this,"Caption_Divider3")
		Interface.RemoveComponent(this,"Caption_ChangeBorder")
		Interface.RemoveComponent(this,"toggleBorderType")
	elseif this.TileType == "DefaultWalls" then
		Set(this,"TileType","DLCWalls")
		SelectedType = WallTypesDLC
	else
		Set(this,"TileType","Current")
		SelectedType = FloorTypeCurrent
		Interface.RemoveComponent(this,"toggleTileTypePlus")
		Interface.RemoveComponent(this,"toggleTileTypeMinus")
	end
	SetTile(SelectedType[this.TileNum])
	this.SetInterfaceCaption("toggleTileType", "tooltip_Button_TileType","tooltip_Button_Type"..this.TileType,"X")
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType",SelectedType[this.TileNum],"X")
end

function toggleTileTypePlusClicked()
	Set(this,"TileNum",this.TileNum + 1)
	if this.TileNum > #SelectedType then Set(this,"TileNum",1) end
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType",SelectedType[this.TileNum],"X")
	SetTile(SelectedType[this.TileNum])
end

function toggleTileTypeMinusClicked()
	Set(this,"TileNum",this.TileNum - 1)
	if this.TileNum < 1 then Set(this,"TileNum",#SelectedType) end
	this.SetInterfaceCaption("Caption_ActiveTileType", "tooltip_Caption_ActiveTileType",SelectedType[this.TileNum],"X")
	SetTile(SelectedType[this.TileNum])
end

function copyUpClicked()
	if this.Direction ~= "Up" then
		Set(this,"Or.y",-1)
		Set(this,"Or.x",0)
		Set(this,"Direction","Up")
	else
		if this.Pos.y >= 1 then
			this.Pos.y = math.floor(this.Pos.y) - 0.5
			SetTile(SelectedType[this.TileNum])
		else
			Set(this,"Walk",false)
			Set(this,"Direction","None")
			this.SetInterfaceCaption("toggleWalking", "tooltip_Button_StopWalking")
		end
	end
end

function copyDownClicked()
	if this.Direction ~= "Down" then
		Set(this,"Or.y",1)
		Set(this,"Or.x",0)
		Set(this,"Direction","Down")
	else
		if this.Pos.y < World.NumCellsY - 1 then
			this.Pos.y = math.floor(this.Pos.y) + 1.5
			SetTile(SelectedType[this.TileNum])
		else
			Set(this,"Walk",false)
			Set(this,"Direction","None")
			this.SetInterfaceCaption("toggleWalking", "tooltip_Button_StopWalking")
		end
	end
end

function copyRightClicked()
	if this.Direction ~= "Right" then
		Set(this,"Or.x",1)
		Set(this,"Or.y",0)
		Set(this,"Direction","Right")
	else
		if this.Pos.x < World.NumCellsX - 1 then
			this.Pos.x = this.Pos.x + 1
			SetTile(SelectedType[this.TileNum])
		else
			Set(this,"Walk",false)
			Set(this,"Direction","None")
			this.SetInterfaceCaption("toggleWalking", "tooltip_Button_StopWalking")
		end
	end
end

function copyLeftClicked()
	if this.Direction ~= "Left" then
		Set(this,"Or.x",-1)
		Set(this,"Or.y",0)
		Set(this,"Direction","Left")
	else
		if this.Pos.x >= 1 then
			this.Pos.x = this.Pos.x - 1
			SetTile(SelectedType[this.TileNum])
		else
			Set(this,"Walk",false)
			Set(this,"Direction","None")
			this.SetInterfaceCaption("toggleWalking", "tooltip_Button_StopWalking")
		end
	end
end

function toggleConClicked()
	if this.TileDecay == "Clean" then
		Set(this,"TileDecay","Dirty")
	elseif this.TileDecay == "Dirty" then
		Set(this,"TileDecay","Filthy")
	elseif this.TileDecay == "Filthy" then
		Set(this,"TileDecay","Disgusting")
	elseif this.TileDecay == "Disgusting" then
		Set(this,"TileDecay","Clean")
	end
	this.SetInterfaceCaption("toggleCon", "tooltip_Button_Decay"..this.TileDecay)
end

function toggleIndoorClicked()
	if this.Ind == true then
		Set(this,"Ind",false)
		Set(this,"Indoor","No")
	else
		Set(this,"Ind",true)
		Set(this,"Indoor","Yes")
	end
	this.SetInterfaceCaption("toggleIndoor", "tooltip_Button_Indoor"..this.Indoor)
end

function SetTile(TileType)
	local x = math.floor(this.Pos.x)
	local y = math.floor(this.Pos.y)
	local cell = World.GetCell(x,y)
	cell.Mat = TileType
	cell.Ind = this.Ind
	if this.TileDecay == "Clean" then			 cell.Con = 0
	elseif this.TileDecay == "Dirty" then		 cell.Con = math.random(1,33)
	elseif this.TileDecay == "Filthy" then		 cell.Con = math.random(34,66)
	elseif this.TileDecay == "Disgusting" then	 cell.Con = math.random(67,100)
	end
	this.SetInterfaceCaption("Caption_DecayType", "tooltip_Caption_DecayType",cell.Con,"X")
end

function toggleBorderTypeClicked()
	MakeBorder(SelectedType[this.TileNum])
end

function MakeBorder(BorderType)
	local endX = -1
	local endY = -1
	local foundEndX=false
	local foundEndY=false
	local Decay = 0
	if this.TileDecay == "Clean" then			 Decay = 0
	elseif this.TileDecay == "Dirty" then		 Decay = math.random(1,33)
	elseif this.TileDecay == "Filthy" then		 Decay = math.random(34,66)
	elseif this.TileDecay == "Disgusting" then	 Decay = math.random(67,100)
	end
	
	while foundEndX == false do	-- left map edge
		endX = endX + 1
		local cell = World.GetCell(0,endX)
		if cell.Mat ~= nil then
			if BorderType == "Water" or BorderType == "WaterStable" then
				cell.Mat = "BorderWater"
			else
				cell.Mat = BorderType
			end
			cell.Con = Decay
			cell.Ind = false
		else
			endX = endX - 1
			foundEndX = true
		end
	end

	while foundEndY == false do	-- top & bottom map edge
		endY = endY + 1
		local TopRowCell = World.GetCell(endY,0)
		local BottomRowCell = World.GetCell(endY,endX)
		if TopRowCell.Mat ~= nil then
			if TopRowCell.Mat == "RoadMarkingsLeft" then
				local prevTopRowCell = World.GetCell(endY-1,0)
				local prevBottomRowCell = World.GetCell(endY-1,endX)
				prevTopRowCell.Mat = "ConcreteTiles"
				prevBottomRowCell.Mat = "ConcreteTiles"
				local SingleLaneRoadCheck = World.GetCell(endY+1,0)
				if SingleLaneRoadCheck.Mat == "RoadMarkingsRight" then
					endY = endY + 2
				else
					endY = endY + 5
				end
			else
				if BorderType == "Water" or BorderType == "WaterStable" then
					TopRowCell.Mat = "BorderWater"
					BottomRowCell.Mat = "BorderWater"
				else
					TopRowCell.Mat = BorderType
					BottomRowCell.Mat = BorderType
				end
				TopRowCell.Con = Decay
				BottomRowCell.Con = Decay
				TopRowCell.Ind = false
				BottomRowCell.Ind = false
			end
		else
			endY = endY - 1
			foundEndY = true
		end
		
	end
	
	for i=0,endX do	-- right map edge
		local cell = World.GetCell(endY,i)
		if BorderType == "Water" or BorderType == "WaterStable" then
			cell.Mat = "BorderWater"
		else
			cell.Mat = BorderType
		end
		cell.Con = Decay
		cell.Ind = false
 	end
	
end
