
local timeTot = 0
local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local TreeTypes = { "Tree", "SpookyTree", "SnowyConiferTree", "CactusTree", "SakuraTree", "PalmTree", "Bush" }

local CargoStationObjects	= { "CargoStationTruck","CargoTruckBay","IntakeStationTruck","IntakeTruckBay","EmergencyStationTruck","EmergencyTruckBay","LoadChecker",
								"CargoStopSign","CargoStationControl","CargoStationGantryCrane","CargoStationGantryHook","CargoStationFireEngine","WallLight","JailDoorLarge"  }
						
local TruckBayObjects = { "CargoTruckBay","IntakeTruckBay","EmergencyTruckBay" }

local TruckDrivers = { "DeliveriesTruckDriver", "ExportsTruckDriver", "GarbageTruckDriver", "IntakeTruckDriver", "EmergencyTruckDriver" }

local ObjectsToLoad = { "Garbage", "Stack", "Box", "CargoGarbage",													-- Default stuff

						"GraveCoffin",  "CrematoriumUrn",															-- Cemetery mods
						
						"WigBox", "RedWigBox",																		-- Barber mods

						"Jeans", "RawCotton",																		-- Manufactury mods
						
						"GardenCucumber", "GardenTomato", "GardenLily", "GardenRose", "Apple", "Cherry",			-- Recycling mods
						"SortedGarbageExport", "GreenGarbage", "FertilizerGarden",
						
						"Orange", "WaterBottleEmpty", "VendingEarnings",											-- Vending Machines
						
						"VendingApple", "VendingCherry",															-- Vending Machines 2.0 / Prison Lottery
						"Win5000", "Lost5000", "LotteryJackpot", "PrisonLotterySuperJackpot",
						"PrisonLotteryMegaJackpot", "SylvesterLotterySuperJackpot", "SylvesterLotteryMegaJackpot",
						
						"DocumentExport",																			-- Computers and More
						
						"ImportantDocumentsExport", "UselessDocumentsExport",										-- Servers and More
						
						"AssembledSmartPhone", "SeizedSmartPhone",													-- Explosive "Smart" Phones
						
						"CashBack",																					-- Prison FireBrigade
						
						"MetroStationEarnings",																		-- Metro Stations 2.0
						 
						"DepletedTeslaBattery",																		-- Tesla-Matic 2.0
						
						"Limo2Bill1", "Limo2Bill2", "Limo2Bill3", "Limo2Bill4", "Limo2Bill5",
						"Limo2Bill6", "Limo2Bill7", "Limo2Bill8", "Limo2Bill9","Limo2Bill10",						-- Limo Garage 2.0
						
						"LimoBill1", "LimoBill2", "LimoBill3", "LimoBill4", "LimoBill5",
						"LimoBill6", "LimoBill7", "LimoBill8", "LimoBill9", "LimoBill10"							-- Limo Garage
					}

local StopSignTypes = { ["Deliveries"] = 0, ["Exports"] = 1, ["Garbage"] = 2, ["Intake"] = 3, ["Emergency"] = 4,
						["MinSec"] = 9, ["Normal"] = 10, ["MaxSec"] = 11, ["SuperMax"] = 12, ["Protected"] = 13, ["DeathRow"] = 14, ["Insane"] = 15, ["ALL"] = 16 }

local CargoStationsLarge = { ["Deliveries"] = 0, ["Exports"] = 1, ["Garbage"] = 2, ["Intake"] = 3, ["Emergency"] = 4 }
local CargoStationsSmallLeft = { ["Deliveries"] = 5, ["Exports"] = 6, ["Garbage"] = 7, ["Intake"] = 8, ["Emergency"] = 9 }
local CargoStationsSmallRight = { ["Deliveries"] = 10, ["Exports"] = 11, ["Garbage"] = 12, ["Intake"] = 13, ["Emergency"] = 14 }
local CargoStationColour = { [0] = "Orange", [1] = "Blue", [2] = "Beige", [3] = "Green", [4] = "White", [5] = "Orange", [6] = "Blue", [7] = "Beige", [8] = "Green", [9] = "White", [10] = "Orange", [11] = "Blue", [12] = "Beige", [13] = "Green", [14] = "White", }

local EquipmentTypes = {
		Fireman		 = { [1] = "Extinguisher", [2] = "Hose" },
		Paramedic	 = { [1] = "Needle" },
		ArmedGuard	 = { [1] = "Shotgun", [2] = "AssaultRifle", [3] = "AK47", [4] = "Axe", [5] = "Baton", [6] = "BatteringRam", [7] = "Gun", [8] = "Knife", [9] = "Rifle", [10] = "SubMachineGun", [11] = "Tazer" },
		RiotGuard	 = { [1] = "Baton", [2] = "AssaultRifle", [3] = "AK47", [4] = "Axe", [5] = "BatteringRam", [6] = "Gun", [7] = "Knife", [8] = "Rifle", [9] = "Shotgun", [10] = "SubMachineGun", [11] = "Tazer" },
		Soldier		 = { [1] = "AssaultRifle", [2] = "Baton", [3] = "AK47", [4] = "Axe", [5] = "BatteringRam", [6] = "Gun", [7] = "Knife", [8] = "Rifle", [9] = "Shotgun", [10] = "SubMachineGun", [11] = "Tazer" }
		}

local EquipmentNumbers = {
		Fireman		 = { [1] = 0, [2] = 24 },
		Paramedic	 = { [1] = 9 },
		ArmedGuard	 = { [1] = 32, [2] = 45, [3] = 0, [4] = 43, [5] = 2, [6] = 48, [7] = 7, [8] = 5, [9] = 42, [10] = 46, [11] = 37 },
		RiotGuard	 = { [1] = 2, [2] = 45, [3] = 0, [4] = 43, [5] = 48, [6] = 7, [7] = 5, [8] = 42, [9] = 32, [10] = 46, [11] = 37 },
		Soldier		 = { [1] = 45, [2] = 2, [3] = 0, [4] = 43, [5] = 48, [6] = 7, [7] = 5, [8] = 42, [9] = 32, [10] = 46, [11] = 37 }
		}

local CalloutEquipment

function Create()
	Set(this,"HomeUID","CargoStation_"..string.sub(me["id-uniqueId"],-2))
	this.Tooltip = "tooltip_CargoStation_Placement"
end

function BuildRoadClicked()
	FindMyRoadMarker()
	if this.CargoFloor == "LARGE" then
		CreateLargeDeliveryFloor()
		BuildMyRoad("CENTRE","DOUBLE")
	else
		CreateSmallDeliveryFloor()
		if this.CargoSide == "RIGHT" then
			BuildMyRoad("LEFT","SINGLE")
		else
			BuildMyRoad("RIGHT","SINGLE")
		end
	end
	Interface.RemoveComponent(this,"BuildRoad")
	Interface.RemoveComponent(this,"SeparatorOr")
	Interface.RemoveComponent(this,"DeleteStation")
	Interface.AddComponent(this,"RemoveStation", "Button", "tooltip_CargoStation_Button_Delete")
	Interface.AddComponent(this,"SeparatorPad0", "Caption", "tooltip_CargoStation_Separatorline")
	Interface.AddComponent(this,"toggleStationSubType", "Button", "tooltip_CargoStation_Button_SubType","tooltip_CargoStation_Button_"..CargoStationColour[this.SubType],"X")
	Interface.AddComponent(this,"toggleLights", "Button", "tooltip_CargoStation_Button_ToggleLights")
	Interface.AddComponent(this,"RemoveStack", "Button", "tooltip_CargoStation_Button_DeleteStack")
	Interface.AddComponent(this,"SeparatorPad1", "Caption", "tooltip_CargoStation_Separatorline")
	Interface.AddComponent(this,"toggleCargoSide", "Button", "tooltip_CargoStation_Button_CargoSide","tooltip_CargoStation_Button_"..this.CargoSide,"X")
	Interface.AddComponent(this,"toggleCargoType", "Button", "tooltip_CargoStation_Button_CargoType","tooltip_CargoStation_Button_"..MyCargoStopSign.CargoType,"X")
	Interface.AddComponent(this,"toggleTraffic", "Button", "tooltip_CargoStation_Button_TrafficEnabled","tooltip_CargoStation_Button_"..MyCargoStopSign.TrafficEnabled,"X")
	Interface.AddComponent(this,"SeparatorPad2", "Caption", "tooltip_CargoStation_SeparatorlineCARGO")
	Interface.AddComponent(this,"toggleFoodDelivery", "Button", "tooltip_CargoStation_Button_FoodDelivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleVendingDelivery", "Button", "tooltip_CargoStation_Button_VendingDelivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleBuildingDelivery", "Button", "tooltip_CargoStation_Button_BuildingDelivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleFloorsDelivery", "Button", "tooltip_CargoStation_Button_FloorsDelivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleLaundryDelivery", "Button", "tooltip_CargoStation_Button_LaundryDelivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleForestDelivery", "Button", "tooltip_CargoStation_Button_ForestDelivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleWorkshop1Delivery", "Button", "tooltip_CargoStation_Button_Workshop1Delivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleWorkshop2Delivery", "Button", "tooltip_CargoStation_Button_Workshop2Delivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleWorkshop3Delivery", "Button", "tooltip_CargoStation_Button_Workshop3Delivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleWorkshop4Delivery", "Button", "tooltip_CargoStation_Button_Workshop4Delivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleWorkshop5Delivery", "Button", "tooltip_CargoStation_Button_Workshop5Delivery","tooltip_CargoStation_Button_Delivery_no","X")
	Interface.AddComponent(this,"toggleOtherDelivery", "Button", "tooltip_CargoStation_Button_Otherdelivery","tooltip_CargoStation_Button_Delivery_no","X")

	
	UpdateTooltip()
	Set(this,"RoadMade",true)
end

function CreateSmallDeliveryFloor()
	MyCargoStopSign = Object.Spawn("CargoStopSign",this.Pos.x,math.floor(this.Pos.y)+4)
	MyCargoStopSign.HomeUID = this.HomeUID
		
	MyCargoControl = Object.Spawn("CargoStationControl",this.Pos.x,this.Pos.y+3.75)
	MyCargoControl.HomeUID = this.HomeUID
			
	MyCrane = Object.Spawn("CargoStationGantryCrane",this.Pos.x,this.Pos.y-4)	
	MyCrane.HomeUID = this.HomeUID
	
	MyHook = Object.Spawn("CargoStationGantryHook",this.Pos.x,this.Pos.y-2)
	MyHook.HomeUID = this.HomeUID
	
	MyLoadChecker = Object.Spawn("LoadChecker",this.Pos.x-2,this.Pos.y-1)
	MyLoadChecker.HomeUID = this.HomeUID
	MyLoadChecker.Hidden = true
	
	RemoveTrees(MyHook,9)
	
	Set(MyCargoStopSign,"CargoStationID",MyCargoStopSign.Id.u)
    Set(MyCargoStopSign,"InUse","no")
    Set(MyCargoStopSign,"Number",0)
	Set(MyCargoStopSign,"TrafficEnabled","no")
	Set(MyCargoStopSign,"FoodDelivery","no")
	Set(MyCargoStopSign,"FoodQuantity",0)
	Set(MyCargoStopSign,"VendingDelivery","no")
	Set(MyCargoStopSign,"VendingQuantity",0)
	Set(MyCargoStopSign,"BuildingDelivery","no")
	Set(MyCargoStopSign,"BuildingQuantity",0)
	Set(MyCargoStopSign,"FloorDelivery","no")
	Set(MyCargoStopSign,"FloorQuantity",0)
	Set(MyCargoStopSign,"ForestDelivery","no")
	Set(MyCargoStopSign,"ForestQuantity",0)
	Set(MyCargoStopSign,"LaundryDelivery","no")
	Set(MyCargoStopSign,"LaundryQuantity",0)
	Set(MyCargoStopSign,"Workshop1Delivery","no")
	Set(MyCargoStopSign,"WorkshopQuantity",0)
	Set(MyCargoStopSign,"Workshop2Delivery","no")
	Set(MyCargoStopSign,"Workshop2Quantity",0)
	Set(MyCargoStopSign,"Workshop3Delivery","no")
	Set(MyCargoStopSign,"Workshop3Quantity",0)
	Set(MyCargoStopSign,"Workshop4Delivery","no")
	Set(MyCargoStopSign,"Workshop4uantity",0)
	Set(MyCargoStopSign,"Workshop5Delivery","no")
	Set(MyCargoStopSign,"Workshop5Quantity",0)
	Set(MyCargoStopSign,"OtherDelivery","no")
	Set(MyCargoStopSign,"OtherQuantity",0)
	Set(MyCargoStopSign,"AllQuantity",0)
	Set(MyCargoStopSign,"Status","DISABLED")
	Set(MyCargoStopSign,"SubType",5)
	Set(MyCargoStopSign,"Tooltip","tooltip_CargoStopSign_TrafficTerminalRequired")
	Set(MyCargoStopSign,"CargoType","Deliveries")
	Set(MyCargoStopSign,"VehicleSpawned","no")
	Set(MyCargoStopSign,"LoadAvailable",false)
	Set(MyCargoStopSign,"CargoStored",0)
	
	Set(MyCargoStopSign,"IDtoRemove","None")
	Set(MyCargoStopSign,"IntakeCancelled",false)
	Set(MyCargoStopSign,"SecLevel","ALL")
	Set(MyCargoStopSign,"IsIntake","no")
	Set(MyCargoStopSign,"PrisQuantity",0)
	
	Set(MyCargoStopSign,"WaitForFiremen",false)
	
	Set(MyCargoStopSign,"EquipmentFiremanNr",2)
	Set(MyCargoStopSign,"EquipmentParamedicNr",1)
	Set(MyCargoStopSign,"EquipmentRiotGuardNr",1)
	Set(MyCargoStopSign,"EquipmentArmedGuardNr",1)
	Set(MyCargoStopSign,"EquipmentSoldierNr",1)
	Set(MyCargoStopSign,"EquipmentFireman",24)
	Set(MyCargoStopSign,"EquipmentParamedic",9)
	Set(MyCargoStopSign,"EquipmentRiotGuard",2)
	Set(MyCargoStopSign,"EquipmentArmedGuard",32)
	Set(MyCargoStopSign,"EquipmentSoldier",45)
	
	Set(MyCrane,"CargoStationID",MyCargoStopSign.Id.u)
	Set(MyHook,"CargoStationID",MyCargoStopSign.Id.u)
	Set(MyLoadChecker,"CargoStationID",MyCargoStopSign.Id.u)
	Set(MyCargoControl,"CargoStationID",MyCargoStopSign.Id.u)
	Set(MyCargoControl,"BayNr",0)
	
	MyCargoStopSign.MarkerUID = this.MarkerUID
	MyCargoControl.MarkerUID = this.MarkerUID
	MyCrane.MarkerUID = this.MarkerUID
	MyHook.MarkerUID = this.MarkerUID
	MyLoadChecker.MarkerUID = this.MarkerUID
	
	CreateCargoArea("Deliveries",this.CargoSide)
	UpdateInventoryPositions()
end

function UpdateInventoryPositions()
	print("UpdateInventoryPositions")
	if not Exists(MyCargoStopSign) then FindMyCargoStopSign() end
	if not Exists(MyCargoControl) then FindMyCargoControl() end
	if not Exists(MyCrane) then FindMyCrane() end
	if not Exists(MyHook) then FindMyHook() end
	if not Exists(MyLoadChecker) then FindMyLoadChecker() end
	if not Exists(MyIntakeDoor) then FindMyIntakeDoor() end
	if not Exists(MyFireEquipment) then FindMyFireEquipment() end
	if this.CargoFloor == "COMPACT" then
		if this.CargoSide == "RIGHT" then
			if Exists(MyLoadChecker) then MyLoadChecker.Pos.x = this.Pos.x+2 end
			MyCargoStopSign.Pos.x = this.Pos.x
			MyCargoStopSign.CheckPointX = this.Pos.x+2
			MyCargoStopSign.CheckPointY = this.Pos.y-1
			MyCargoStopSign.RoadX = this.Pos.x-1.5
			MyCargoControl.Pos.x = this.Pos.x+2
			MyCargoControl.TruckX = this.Pos.x-1.5
			MyCargoControl.RoadX = this.Pos.x+2
			MyCargoControl.CheckPointX = this.Pos.x+2
			MyCargoControl.CheckPointY = this.Pos.y-1
			if Exists(MyCrane) then MyCrane.Pos.x = this.Pos.x-1.5 end
			if Exists(MyHook) then MyHook.Pos.x = this.Pos.x-1.5 end
			if Exists(MyIntakeDoor) then MyIntakeDoor.Pos.x = this.Pos.x+4 end
			if Exists(MyFireEquipment) then MyFireEquipment.Pos.x = this.Pos.x+2 end
		else
			if Exists(MyLoadChecker) then MyLoadChecker.Pos.x = this.Pos.x-2 end
			MyCargoStopSign.Pos.x = this.Pos.x
			MyCargoStopSign.CheckPointX = this.Pos.x-2
			MyCargoStopSign.CheckPointY = this.Pos.y-1
			MyCargoStopSign.RoadX = this.Pos.x+1.5
			MyCargoControl.Pos.x = this.Pos.x-2
			MyCargoControl.TruckX = this.Pos.x+1.5
			MyCargoControl.RoadX = this.Pos.x-2
			MyCargoControl.CheckPointX = this.Pos.x-2
			MyCargoControl.CheckPointY = this.Pos.y-1
			if Exists(MyCrane) then MyCrane.Pos.x = this.Pos.x+1.5 end
			if Exists(MyHook) then MyHook.Pos.x = this.Pos.x+1.5 end
			if Exists(MyIntakeDoor) then MyIntakeDoor.Pos.x = this.Pos.x-4 end
			if Exists(MyFireEquipment) then MyFireEquipment.Pos.x = this.Pos.x-2 end
		end
	else
		if Exists(MyLoadCheckerLeft) then MyLoadCheckerLeft.Pos.x = this.Pos.x-5 end
		if Exists(MyLoadCheckerRight) then MyLoadCheckerRight.Pos.x = this.Pos.x+5 end
		MyCargoSignLeft.RoadX = this.Pos.x-1.5
		MyCargoSignLeft.CheckPointX = this.Pos.x-5
		MyCargoSignLeft.CheckPointY = this.Pos.y-1
		MyCargoSignRight.RoadX = this.Pos.x+1.5
		MyCargoSignRight.CheckPointX = this.Pos.x+5
		MyCargoSignRight.CheckPointY = this.Pos.y-1
		MyCargoControlLeft.TruckX = this.Pos.x-1.5
		MyCargoControlLeft.RoadX = this.Pos.x-5
		MyCargoControlLeft.CheckPointX = this.Pos.x-5
		MyCargoControlLeft.CheckPointY = this.Pos.y-1
		MyCargoControlRight.TruckX = this.Pos.x+1.5
		MyCargoControlRight.RoadX = this.Pos.x+5
		MyCargoControlRight.CheckPointX = this.Pos.x+5
		MyCargoControlRight.CheckPointY = this.Pos.y-1
		if Exists(MyIntakeDoorLeft) then MyIntakeDoorLeft.Pos.x = this.Pos.x-7 end
		if Exists(MyIntakeDoorRight) then MyIntakeDoorRight.Pos.x = this.Pos.x+7 end
	end
	Set(this,"NumCellsX",World.NumCellsX)
	Set(this,"NumCellsY",World.NumCellsY)
	for MyStreetManager in next, Find(this,"StreetManager2",10000) do
		Set(MyStreetManager,"UpdateCargoStations",true)
	end
end

function CreateLargeDeliveryFloor()
print("CreateLargeDeliveryFloor")
	MyCargoSignLeft = Object.Spawn("CargoStopSign",this.Pos.x-3,math.floor(this.Pos.y)+4)
	MyCargoSignLeft.HomeUID = this.HomeUID
	
	MyCargoSignRight = Object.Spawn("CargoStopSign",this.Pos.x+3,math.floor(this.Pos.y)+4)
	MyCargoSignRight.HomeUID = this.HomeUID
	
	MyCargoControlLeft = Object.Spawn("CargoStationControl",this.Pos.x-5,this.Pos.y+3.75)
	MyCargoControlLeft.HomeUID = this.HomeUID
	
	MyCargoControlRight = Object.Spawn("CargoStationControl",this.Pos.x+5,this.Pos.y+3.75)
	MyCargoControlRight.HomeUID = this.HomeUID
		
	MyCraneLeft = Object.Spawn("CargoStationGantryCrane",this.Pos.x-1.5,this.Pos.y-4)
	MyCraneLeft.HomeUID = this.HomeUID
	
	MyCraneRight = Object.Spawn("CargoStationGantryCrane",this.Pos.x+1.5,this.Pos.y-4)
	MyCraneRight.HomeUID = this.HomeUID
	
	MyHookLeft = Object.Spawn("CargoStationGantryHook",this.Pos.x-1.5,this.Pos.y-2)
	MyHookLeft.HomeUID = this.HomeUID
	
	MyHookRight = Object.Spawn("CargoStationGantryHook",this.Pos.x+1.5,this.Pos.y-2)
	MyHookRight.HomeUID = this.HomeUID
	
	MyLoadCheckerLeft = Object.Spawn("LoadChecker",this.Pos.x-5,this.Pos.y-1)
	MyLoadCheckerLeft.HomeUID = this.HomeUID
	MyLoadCheckerLeft.Hidden = true
	
	MyLoadCheckerRight = Object.Spawn("LoadChecker",this.Pos.x-5,this.Pos.y-1)
	MyLoadCheckerRight.HomeUID = this.HomeUID
	MyLoadCheckerRight.Hidden = true
	
	RemoveTrees(MyHookLeft,9)
	RemoveTrees(MyHookRight,9)
		
	Set(MyCargoSignLeft,"CargoStationID",MyCargoSignLeft.Id.u)
    Set(MyCargoSignLeft,"InUse","no")
    Set(MyCargoSignLeft,"Number",0)
	Set(MyCargoSignLeft,"TrafficEnabled","no")
	Set(MyCargoSignLeft,"FoodDelivery","no")
	Set(MyCargoSignLeft,"FoodQuantity",0)
	Set(MyCargoSignLeft,"VendingDelivery","no")
	Set(MyCargoSignLeft,"VendingQuantity",0)
	Set(MyCargoSignLeft,"BuildingDelivery","no")
	Set(MyCargoSignLeft,"BuildingQuantity",0)
	Set(MyCargoSignLeft,"FloorDelivery","no")
	Set(MyCargoSignLeft,"FloorQuantity",0)
	Set(MyCargoSignLeft,"ForestDelivery","no")
	Set(MyCargoSignLeft,"ForestQuantity",0)
	Set(MyCargoSignLeft,"LaundryDelivery","no")
	Set(MyCargoSignLeft,"LaundryQuantity",0)
	Set(MyCargoSignLeft,"Workshop1Delivery","no")
	Set(MyCargoSignLeft,"Workshop1Quantity",0)
	Set(MyCargoSignLeft,"Workshop2Delivery","no")
	Set(MyCargoSignLeft,"Workshop2Quantity",0)
	Set(MyCargoSignLeft,"Workshop3Delivery","no")
	Set(MyCargoSignLeft,"Workshop3Quantity",0)
	Set(MyCargoSignLeft,"Workshop4Delivery","no")
	Set(MyCargoSignLeft,"Workshop4Quantity",0)
	Set(MyCargoSignLeft,"Workshop5Delivery","no")
	Set(MyCargoSignLeft,"Workshop5Quantity",0)
	Set(MyCargoSignLeft,"OtherDelivery","no")
	Set(MyCargoSignLeft,"OtherQuantity",0)
	Set(MyCargoSignLeft,"AllQuantity",0)
	Set(MyCargoSignLeft,"Status","DISABLED")
	Set(MyCargoSignLeft,"SubType",5)
	Set(MyCargoSignLeft,"Tooltip","tooltip_CargoStopSign_TrafficTerminalRequired")
	Set(MyCargoSignLeft,"CargoType","Deliveries")
	Set(MyCargoSignLeft,"VehicleSpawned","no")
	Set(MyCargoSignLeft,"LoadAvailable",false)
	Set(MyCargoSignLeft,"CargoStored",0)
	
	Set(MyCargoSignLeft,"IDtoRemove","None")
	Set(MyCargoSignLeft,"IntakeCancelled",false)
	Set(MyCargoSignLeft,"SecLevel","ALL")
	Set(MyCargoSignLeft,"IsIntake","no")
	Set(MyCargoSignLeft,"PrisQuantity",0)
	
	Set(MyCargoSignLeft,"WaitForFiremen",false)
	Set(MyCargoSignLeft,"EquipmentFiremanNr",2)
	Set(MyCargoSignLeft,"EquipmentParamedicNr",1)
	Set(MyCargoSignLeft,"EquipmentRiotGuardNr",1)
	Set(MyCargoSignLeft,"EquipmentArmedGuardNr",1)
	Set(MyCargoSignLeft,"EquipmentSoldierNr",1)
	Set(MyCargoSignLeft,"EquipmentFireman",24)
	Set(MyCargoSignLeft,"EquipmentParamedic",9)
	Set(MyCargoSignLeft,"EquipmentRiotGuard",2)
	Set(MyCargoSignLeft,"EquipmentArmedGuard",32)
	Set(MyCargoSignLeft,"EquipmentSoldier",45)
	
	Set(MyCargoSignRight,"CargoStationID",MyCargoSignRight.Id.u)
    Set(MyCargoSignRight,"InUse","no")
    Set(MyCargoSignRight,"Number",0)
	Set(MyCargoSignRight,"TrafficEnabled","no")
	Set(MyCargoSignRight,"FoodDelivery","no")
	Set(MyCargoSignRight,"FoodQuantity",0)
	Set(MyCargoSignRight,"VendingDelivery","no")
	Set(MyCargoSignRight,"VendingQuantity",0)
	Set(MyCargoSignRight,"BuildingDelivery","no")
	Set(MyCargoSignRight,"BuildingQuantity",0)
	Set(MyCargoSignRight,"FloorDelivery","no")
	Set(MyCargoSignRight,"FloorQuantity",0)
	Set(MyCargoSignRight,"ForestDelivery","no")
	Set(MyCargoSignRight,"ForestQuantity",0)
	Set(MyCargoSignRight,"LaundryDelivery","no")
	Set(MyCargoSignRight,"LaundryQuantity",0)
	Set(MyCargoSignRight,"Workshop1Delivery","no")
	Set(MyCargoSignRight,"Workshop1Quantity",0)
	Set(MyCargoSignRight,"Workshop2Delivery","no")
	Set(MyCargoSignRight,"Workshop2Quantity",0)
	Set(MyCargoSignRight,"Workshop3Delivery","no")
	Set(MyCargoSignRight,"Workshop3Quantity",0)
	Set(MyCargoSignRight,"Workshop4Delivery","no")
	Set(MyCargoSignRight,"Workshop4Quantity",0)
	Set(MyCargoSignRight,"Workshop5Delivery","no")
	Set(MyCargoSignRight,"Workshop5Quantity",0)
	Set(MyCargoSignRight,"OtherDelivery","no")
	Set(MyCargoSignRight,"OtherQuantity",0)
	Set(MyCargoSignRight,"AllQuantity",0)
	Set(MyCargoSignRight,"Status","DISABLED")
	Set(MyCargoSignRight,"SubType",5)
	Set(MyCargoSignRight,"Tooltip","tooltip_CargoStopSign_TrafficTerminalRequired")
	Set(MyCargoSignRight,"CargoType","Garbage")
	Set(MyCargoSignRight,"VehicleSpawned","no")
	Set(MyCargoSignRight,"LoadAvailable",false)
	Set(MyCargoSignRight,"CargoStored",0)
	
	Set(MyCargoSignRight,"IDtoRemove","None")
	Set(MyCargoSignRight,"IntakeCancelled",false)
	Set(MyCargoSignRight,"SecLevel","ALL")
	Set(MyCargoSignRight,"IsIntake","no")
	Set(MyCargoSignRight,"PrisQuantity",0)
	
	Set(MyCargoSignRight,"WaitForFiremen",false)
	Set(MyCargoSignRight,"EquipmentFiremanNr",2)
	Set(MyCargoSignRight,"EquipmentParamedicNr",1)
	Set(MyCargoSignRight,"EquipmentRiotGuardNr",1)
	Set(MyCargoSignRight,"EquipmentArmedGuardNr",1)
	Set(MyCargoSignRight,"EquipmentSoldierNr",1)
	Set(MyCargoSignRight,"EquipmentFireman",24)
	Set(MyCargoSignRight,"EquipmentParamedic",9)
	Set(MyCargoSignRight,"EquipmentRiotGuard",2)
	Set(MyCargoSignRight,"EquipmentArmedGuard",32)
	Set(MyCargoSignRight,"EquipmentSoldier",45)
	
	Set(MyCraneLeft,"CargoStationID",MyCargoSignLeft.Id.u)
	Set(MyCraneRight,"CargoStationID",MyCargoSignRight.Id.u)
	Set(MyHookLeft,"CargoStationID",MyCargoSignLeft.Id.u)
	Set(MyHookRight,"CargoStationID",MyCargoSignRight.Id.u)
	Set(MyLoadCheckerLeft,"CargoStationID",MyCargoSignLeft.Id.u)
	Set(MyLoadCheckerRight,"CargoStationID",MyCargoSignRight.Id.u)
	Set(MyCargoControlLeft,"CargoStationID",MyCargoSignLeft.Id.u)
	Set(MyCargoControlRight,"CargoStationID",MyCargoSignRight.Id.u)
	Set(MyCargoControlLeft,"BayNr",0)
	Set(MyCargoControlRight,"BayNr",0)
	
	MyCargoSignLeft.MarkerUID = this.LeftMarkerUID
	MyCargoSignRight.MarkerUID = this.RightMarkerUID
	MyCargoControlLeft.MarkerUID = this.LeftMarkerUID
	MyCargoControlRight.MarkerUID = this.RightMarkerUID
	MyCraneLeft.MarkerUID = this.LeftMarkerUID
	MyCraneRight.MarkerUID = this.RightMarkerUID
	MyHookLeft.MarkerUID = this.LeftMarkerUID
	MyHookRight.MarkerUID = this.RightMarkerUID
	MyLoadCheckerLeft.MarkerUID = this.LeftMarkerUID
	MyLoadCheckerRight.MarkerUID = this.RightMarkerUID
	
	MyCargoControl = MyCargoControlLeft
	MyCargoStopSign = MyCargoSignLeft
	MyHook = MyHookLeft
	MyCrane = MyCraneLeft
	MyLoadChecker = MyLoadCheckerLeft
	this.CargoSide = "LEFT"
	CreateCargoArea("Deliveries","LEFT")
	CreateCargoArea("Garbage","RIGHT")
	UpdateInventoryPositions()
end

function CreateCargoArea(theType,theSide)
print("CreateCargoArea "..theType.."  "..theSide)
local CompactFloorLeft = {
			{ 1, 1, 1, 1, 1, 0, 0, 0, 1 },
			{ 1, 3, 3, 3, 1, 0, 0, 0, 1 },
			{ 1, 3, 3, 3, 1, 0, 0, 0, 1 },
			{ 1, 3, 4, 3, 1, 0, 0, 0, 1 },
			{ 1, 3, 3, 3, 1, 0, 0, 0, 1 },
			{ 1, 3, 3, 3, 1, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 1, 0, 0, 0, 1 },
			{ 1, 2, 2, 2, 1, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 1, 0, 0, 0, 1 }
			}
			
local CompactFloorRight = {
			{ 1, 0, 0, 0, 1, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 1, 3, 3, 3, 1 },
			{ 1, 0, 0, 0, 1, 3, 3, 3, 1 },
			{ 1, 0, 0, 0, 1, 3, 4, 3, 1 },
			{ 1, 0, 0, 0, 1, 3, 3, 3, 1 },
			{ 1, 0, 0, 0, 1, 3, 3, 3, 1 },
			{ 1, 0, 0, 0, 1, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 1, 2, 2, 2, 1 },
			{ 1, 0, 0, 0, 1, 1, 1, 1, 1 }
			}
			
local LargeFloorLeft = {
			{ 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 3, 3, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 3, 3, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 3, 4, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 3, 3, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 3, 3, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 2, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
			}
			
local LargeFloorRight = {
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3, 3, 3, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3, 3, 3, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3, 4, 3, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3, 3, 3, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3, 3, 3, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 2, 2, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1 }
			}
			
local CompactIntakeFloorLeft = {
			{ 2, 2, 2, 2, 2, 0, 0, 0, 1 },
			{ 2, 3, 3, 3, 2, 0, 0, 0, 1 },
			{ 2, 3, 3, 3, 2, 0, 0, 0, 1 },
			{ 1, 3, 4, 3, 2, 0, 0, 0, 1 },
			{ 1, 3, 3, 3, 2, 0, 0, 0, 1 },
			{ 2, 3, 3, 3, 2, 0, 0, 0, 1 },
			{ 2, 1, 1, 1, 2, 0, 0, 0, 1 },
			{ 2, 2, 2, 2, 2, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 1, 0, 0, 0, 1 }
			}
			
local CompactIntakeFloorRight = {
			{ 1, 0, 0, 0, 2, 2, 2, 2, 2 },
			{ 1, 0, 0, 0, 2, 3, 3, 3, 2 },
			{ 1, 0, 0, 0, 2, 3, 3, 3, 2 },
			{ 1, 0, 0, 0, 2, 3, 4, 3, 1 },
			{ 1, 0, 0, 0, 2, 3, 3, 3, 1 },
			{ 1, 0, 0, 0, 2, 3, 3, 3, 2 },
			{ 1, 0, 0, 0, 2, 1, 1, 1, 2 },
			{ 1, 0, 0, 0, 2, 2, 2, 2, 2 },
			{ 1, 0, 0, 0, 1, 1, 1, 1, 1 }
			}
			
local LargeIntakeFloorLeft = {
			{ 2, 2, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 2, 3, 3, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 2, 3, 3, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 3, 4, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 3, 3, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 2, 3, 3, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 2, 1, 1, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 2, 2, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
			{ 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
			}
			
local LargeIntakeFloorRight = {
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 3, 3, 2 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 3, 3, 2 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 3, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 3, 3, 1 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 3, 3, 2 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 1, 1, 2 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2 },
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1 }
			}
			
local Tiles = {
			[0] = "Excluded", -- 0 = excluded from changing, since this is the road
			[1] = "ConcreteTiles",
			[2] = "TiledFence",
			[3] = "NewCargoFloor",
			[4] = "NewCargoFloor"
			}

	if theType == "Deliveries"		 then Tiles[3],Tiles[4] = "NewCargoFloor",	 "NewCargoFloor"
	elseif theType == "Exports"		 then Tiles[3],Tiles[4] = "MetallTiles",	 "MetallTiles"
	elseif theType == "Garbage"		 then Tiles[3],Tiles[4] = "NewIronFloor",	 "NewIronFloor"
	elseif theType == "Intake"		 then Tiles[3],Tiles[4] = "BlackTiles",		 "BlackTiles"
	elseif theType == "Emergency"	 then Tiles[3],Tiles[4] = "T0_WhiteTile",	 "C_MaximumTile"
	else
		Tiles[3],Tiles[4] = "ConcreteTiles","ConcreteTiles"
	end
	
	
	if this.CargoFloor == "COMPACT" then
		RemoveWallLights(theSide)
		local CompactFloor = {}
		if theSide == "RIGHT" then
			if theType == "Intake" then
				CompactFloor = CompactIntakeFloorRight
			else
				CompactFloor = CompactFloorRight
			end
		else
			if theType == "Intake" then
				CompactFloor = CompactIntakeFloorLeft
			else
				CompactFloor = CompactFloorLeft
			end
		end
		local x = this.Pos.x-5
		local y = this.Pos.y-5
				
		for X = 1,9 do
			for Y = 1,9 do
				local cell = World.GetCell(x+X,y+Y)
				if Tiles[CompactFloor[Y][X]] ~= "Excluded" then
					cell.Mat = Tiles[CompactFloor[Y][X]]
					cell.Ind = true
				end
				if not cell.Ind then cell.Ind = true end
			end
		end
		if Get(this,"LightsOn"..theSide) == true then
			MakeWallLights(theSide)
		end
	else
		RemoveWallLights("LEFT")
		RemoveWallLights("RIGHT")
		if theSide == "RIGHT" then
			if theType == "Intake" then
				LargeFloor = LargeIntakeFloorRight
			else
				LargeFloor = LargeFloorRight
			end
		else
			if theType == "Intake" then
				LargeFloor = LargeIntakeFloorLeft
			else
				LargeFloor = LargeFloorLeft
			end
		end
		local x = math.floor(this.Pos.x)-8
		local y = math.floor(this.Pos.y)-5
		for X = 1,15 do
			for Y = 1,9 do
				local cell = World.GetCell(x+X,y+Y)
				if Tiles[LargeFloor[Y][X]] ~= "Excluded" then
					cell.Mat = Tiles[LargeFloor[Y][X]]
					cell.Ind = true
				end
				if not cell.Ind then cell.Ind = true end
			end
		end
		if Get(this,"LightsOnLEFT") == true then
			MakeWallLights("LEFT")
		end
		if Get(this,"LightsOnRIGHT") == true then
			MakeWallLights("RIGHT")
		end
	end
end

function RemoveWallLights(theSide)
	for thatLight in next, Find(this,"WallLight",7) do
		if thatLight.HomeUID == this.HomeUID and thatLight.CargoSide == theSide then
			thatLight.Delete()
		end
	end
end

function MakeWallLights(theSide)
	local LightPosX = this.Pos.x-2
	if theSide == "RIGHT" then
		if this.CargoFloor == "LARGE" then
			LightPosX = this.Pos.x+5
		else
			LightPosX = this.Pos.x+2
		end
	else
		if this.CargoFloor == "LARGE" then
			LightPosX = this.Pos.x-5
		end
	end
	local MyWallLight1 = Object.Spawn("WallLight",LightPosX,this.Pos.y-4)
	MyWallLight1.HomeUID = this.HomeUID
	MyWallLight1.CargoSide = theSide
	
	local MyWallLight2 = Object.Spawn("WallLight",LightPosX,this.Pos.y+2.25)
	MyWallLight2.Or.y = -1
	MyWallLight2.HomeUID = this.HomeUID
	MyWallLight2.CargoSide = theSide
	
	local MyWallLight3 = Object.Spawn("WallLight",LightPosX,this.Pos.y+2.25)
	MyWallLight3.HomeUID = this.HomeUID
	MyWallLight3.CargoSide = theSide	
end

function BuildMyRoad(theSide, theSize)
	if markerFound == false then	-- if no roadmarker was on this lane yet, then build a road. otherwise a roadmarker was already placed by a cargo station
		print("BuildMyRoad")
		local endY=-1
		local PosX = 0
		if theSide == "LEFT" then
			PosX = this.Pos.x-1.5
		elseif theSide == "CENTRE" then
			PosX = this.Pos.x
		elseif theSide == "RIGHT" then
			PosX = this.Pos.x+1.5
		end
		local foundEndY=false
		MyTreeRemover = Object.Spawn("TreeRemover",PosX,1)
		local TreeRemoverPriorPosY = MyTreeRemover.Pos.y
		while foundEndY==false do
			endY=endY+1
			local myCell = World.GetCell(PosX,endY)
			if myCell.Mat==nil then
				foundEndY=true
				endY=endY-1
				RemoveTrees(MyTreeRemover,4)
				MyTreeRemover.Delete()
			elseif theSize == "SINGLE" then
				MyTreeRemover.Pos.y = endY
				if MyTreeRemover.Pos.y >= TreeRemoverPriorPosY+3 then
					TreeRemoverPriorPosY = MyTreeRemover.Pos.y
					RemoveTrees(MyTreeRemover,4)
				end
				local myCTL = World.GetCell(PosX-2,endY)
				local myRML = World.GetCell(PosX-1,endY)
				local myRMR = World.GetCell(PosX,endY)
				local myCTR = World.GetCell(PosX+1,endY)
				myCTL.Mat="ConcreteTiles"; myRML.Mat="RoadMarkingsLeft"; myRMR.Mat="RoadMarkingsRight"; myCTR.Mat="ConcreteTiles"
			elseif theSize == "DOUBLE" then
				local myCTL = World.GetCell(PosX-3,endY)
				local myRML = World.GetCell(PosX-2,endY)
				local myRL = World.GetCell(PosX-1,endY)
				local myRC = World.GetCell(PosX,endY)
				local myRR = World.GetCell(PosX+1,endY)
				local myRMR = World.GetCell(PosX+2,endY)
				local myCTR = World.GetCell(PosX+3,endY)
				MyTreeRemover.Pos.y = endY
				if MyTreeRemover.Pos.y >= TreeRemoverPriorPosY+3 then
					TreeRemoverPriorPosY = MyTreeRemover.Pos.y
					RemoveTrees(MyTreeRemover,4)
				end
				if TickTock==false then				-- toggle for center road markings on double lane
					myCTL.Mat="ConcreteTiles"; myRML.Mat="RoadMarkingsLeft"; myRL.Mat="Road"; myRC.Mat="RoadMarkings"; myRR.Mat="Road"; myRMR.Mat="RoadMarkingsRight"; myCTR.Mat="ConcreteTiles"
					TickTock=true
				else
					myCTL.Mat="ConcreteTiles"; myRML.Mat="RoadMarkingsLeft"; myRL.Mat="Road"; myRC.Mat="Road"; myRR.Mat="Road"; myRMR.Mat="RoadMarkingsRight"; myCTR.Mat="ConcreteTiles"
					TickTock=false
				end
			end
		end
	end
end

function RemoveMyRoad(theSide, theSize)
	print("RemoveMyRoad")
	local endY=-1
	local PosX = 0
	if theSide == "LEFT" then
		PosX = this.Pos.x-1.5
	elseif theSide == "CENTRE" then
		PosX = this.Pos.x
	elseif theSide == "RIGHT" then
		PosX = this.Pos.x+1.5
	end
	local foundEndY=false
	while foundEndY==false do
		endY=endY+1
		local myCell = World.GetCell(PosX,endY)
		if myCell.Mat==nil then
			foundEndY=true
			endY=endY-1
		elseif theSize == "SINGLE" then
			local myCTL = World.GetCell(PosX-2,endY)
			local myRML = World.GetCell(PosX-1,endY)
			local myRMR = World.GetCell(PosX,endY)
			local myCTR = World.GetCell(PosX+1,endY)
			myCTL.Mat="Dirt"; myRML.Mat="Dirt"; myRMR.Mat="Dirt"; myCTR.Mat="Dirt"
		elseif theSize == "DOUBLE" then
			local myCTL = World.GetCell(PosX-3,endY)
			local myRML = World.GetCell(PosX-2,endY)
			local myRL = World.GetCell(PosX-1,endY)
			local myRC = World.GetCell(PosX,endY)
			local myRR = World.GetCell(PosX+1,endY)
			local myRMR = World.GetCell(PosX+2,endY)
			local myCTR = World.GetCell(PosX+3,endY)
			myCTL.Mat="Dirt"; myRML.Mat="Dirt"; myRL.Mat="Dirt"; myRC.Mat="Dirt"; myRR.Mat="Dirt"; myRMR.Mat="Dirt"; myCTR.Mat="Dirt"
		end
	end
end

function FindMyRoadMarker()
	markerFound = false
	markerFoundLeft = false
	markerFoundRight = false
    local roadMarkers = Find(this,"RoadMarker2",10000)
	if this.CargoFloor == "LARGE" then
		if next(roadMarkers) then
			for thatMarker,dist in pairs(roadMarkers) do
				if thatMarker.Pos.x == this.Pos.x+1.5 then
					MyRoadMarkerRight = thatMarker
					Set(this,"RightMarkerUID",thatMarker.Id.u)
					markerFoundRight = true
					markerFound = true
					break
				end
			end
			for thatMarker,dist in pairs(roadMarkers) do
				if thatMarker.Pos.x == this.Pos.x-1.5 then
					MyRoadMarkerLeft = thatMarker
					Set(this,"LeftMarkerUID",thatMarker.Id.u)
					markerFoundLeft = true
					markerFound = true
					break
				end
			end
		end
		roadMarkers = nil
		
		if markerFoundLeft == false then
			MyRoadMarkerLeft = Object.Spawn("RoadMarker2",this.Pos.x-1.5,0.5000000)
			Set(this,"LeftMarkerUID",MyRoadMarkerLeft.Id.u)
			local cell = World.GetCell(math.floor(MyRoadMarkerLeft.Pos.x)-1,0)
			cell.Mat = "RoadMarkerTile"
		end
			
		if markerFoundRight == false then
			MyRoadMarkerRight = Object.Spawn("RoadMarker2",this.Pos.x+1.5,0.5000000)
			Set(this,"RightMarkerUID",MyRoadMarkerRight.Id.u)
		end
	else
		local MarkerPosX = this.Pos.x + 1.5
		if this.CargoSide == "RIGHT" then MarkerPosX = this.Pos.x - 1.5 end
		if next(roadMarkers) then
			for thatMarker,distance in pairs(roadMarkers) do
				if thatMarker.Pos.x == MarkerPosX then
					print("MyRoadMarker found at "..distance)
					MyRoadMarker = thatMarker
					Set(this,"MarkerUID",thatMarker.Id.u)
					markerFound = true
					break
				end
			end
		end
		roadMarkers = nil
		
		if markerFound == false then
			print("MyRoadMarker spawned")
			MyRoadMarker = Object.Spawn("RoadMarker2",MarkerPosX,0.5000000)
			Set(this,"MarkerUID",MyRoadMarker.Id.u)
			local cell = World.GetCell(math.floor(MyRoadMarker.Pos.x)-1,0)
			cell.Mat = "RoadMarkerTile"
		end
	end
	if this.CargoFloor == "LARGE" then
		if this.CargoSide == "LEFT" then
			MyRoadMarker = MyRoadMarkerLeft
		else
			MyRoadMarker = MyRoadMarkerRight
		end
	end
	if not Exists(MyRoadMarker) then
		print(" -- ERROR --- MyRoadMarker not found")
	end
end

function FindMyCrane()
	print("---")
	print("--- HOMEUID "..this.HomeUID.." --- FindMyCrane")
	local craneFound = false
	local craneFoundLeft = false
	local craneFoundRight = false
	local nearbyObject = Find("CargoStationGantryCrane",8)
	if next(nearbyObject) then
		for thatCrane, distance in pairs(nearbyObject) do
			if thatCrane.MarkerUID == this.MarkerUID and thatCrane.HomeUID == this.HomeUID then
				MyCrane = thatCrane
				craneFound = true
				print("MyCrane found at dist "..distance)
				break
			end
			if thatCrane.MarkerUID == this.LeftMarkerUID and thatCrane.HomeUID == this.HomeUID then
				MyCraneLeft = thatCrane
				craneFoundLeft = true
				print("MyCraneLeft found at dist "..distance)
			end
			if thatCrane.MarkerUID == this.RightMarkerUID and thatCrane.HomeUID == this.HomeUID then
				MyCraneRight = thatCrane
				craneFoundRight = true
				print("MyCraneRight found at dist "..distance)
			end
		end
	end
	nearbyObject = nil
	if this.CargoFloor == "LARGE" then
		if this.CargoSide == "LEFT" then
			MyCrane = MyCraneLeft
		else
			MyCrane = MyCraneRight
		end
	end
	if not Exists(MyCrane) then
		print(" -- ERROR --- MyCrane not found")
	end
end

function FindMyHook()
	print("FindMyHook")
	local hookFound = false
	local hookFoundLeft = false
	local hookFoundRight = false
	local nearbyObject = Find("CargoStationGantryHook",8)
	if next(nearbyObject) then
		for thatHook, distance in pairs(nearbyObject) do
			if thatHook.MarkerUID == this.MarkerUID and thatHook.HomeUID == this.HomeUID then
				MyHook = thatHook
				print("MyHook found at "..distance)
				break
			end
			if thatHook.MarkerUID == this.LeftMarkerUID and thatHook.HomeUID == this.HomeUID then
				MyHookLeft = thatHook
				hookFoundLeft = true
				print("MyHookLeft found at dist "..distance)
			end
			if thatHook.MarkerUID == this.RightMarkerUID and thatHook.HomeUID == this.HomeUID then
				MyHookRight = thatHook
				hookFoundRight = true
				print("MyHookRight found at dist "..distance)
			end
		end
	end
	nearbyObject = nil
	if this.CargoFloor == "LARGE" then
		if this.CargoSide == "LEFT" then
			MyHook = MyHookLeft
		else
			MyHook = MyHookRight
		end
	end
	if not Exists(MyHook) then
		print(" -- ERROR --- MyHook not found")
	end
end

function FindMyLoadChecker()
	print("FindMyLoadChecker")
	local checkerFound = false
	local checkerFoundLeft = false
	local checkerFoundRight = false
	local nearbyObject = Find("LoadChecker",8)
	if next(nearbyObject) then
		for thatChecker, distance in pairs(nearbyObject) do
			if thatChecker.MarkerUID == this.MarkerUID and thatChecker.HomeUID == this.HomeUID then
				MyLoadChecker = thatChecker
				print("MyLoadChecker found at "..distance)
				break
			end
			if thatChecker.MarkerUID == this.LeftMarkerUID and thatChecker.HomeUID == this.HomeUID then
				MyLoadCheckerLeft = thatChecker
				checkerFoundLeft = true
				print("MyLoadCheckerLeft found at dist "..distance)
			end
			if thatChecker.MarkerUID == this.RightMarkerUID and thatChecker.HomeUID == this.HomeUID then
				MyLoadCheckerRight = thatChecker
				checkerFoundRight = true
				print("MyLoadCheckerRight found at dist "..distance)
			end
		end
	end
	nearbyObject = nil
	if this.CargoFloor == "LARGE" then
		if this.CargoSide == "LEFT" then
			MyLoadChecker = MyLoadCheckerLeft
		else
			MyLoadChecker = MyLoadCheckerRight
		end
	end
	if not Exists(MyLoadChecker) then
		print(" -- ERROR --- MyLoadChecker not found")
	end
end

function FindMyIntakeDoor()
	print("FindMyIntakeDoor")
	local doorFound = false
	local doorFoundLeft = false
	local doorFoundRight = false
	local nearbyObject = Find("JailDoorLarge",8)
	if next(nearbyObject) then
		for thatDoor, distance in pairs(nearbyObject) do
			if thatDoor.MarkerUID == this.MarkerUID and thatDoor.HomeUID == this.HomeUID then
				MyIntakeDoor = thatDoor
				doorFound = true
				print("MyIntakeDoor found at "..distance)
				break
			end
			if thatDoor.MarkerUID == this.LeftMarkerUID and thatDoor.HomeUID == this.HomeUID then
				MyIntakeDoorLeft = thatDoor
				doorFoundLeft = true
				print("MyIntakeDoorLeft found at dist "..distance)
			end
			if thatDoor.MarkerUID == this.RightMarkerUID and thatDoor.HomeUID == this.HomeUID then
				MyIntakeDoorRight = thatDoor
				doorFoundRight = true
				print("MyIntakeDoorRight found at dist "..distance)
			end
		end
	end
	nearbyObject = nil
	if this.CargoFloor == "LARGE" then
		if this.CargoSide == "LEFT" then
			MyIntakeDoor = MyIntakeDoorLeft
		else
			MyIntakeDoor = MyIntakeDoorRight
		end
	end
	if not Exists(MyIntakeDoor) then
		print(" -- ERROR --- MyIntakeDoor not found")
	end
end

function FindMyFireEquipment()
	print("FindMyFireEquipment")
	local equipFound = false
	local equipFoundLeft = false
	local equipFoundRight = false
	local nearbyObject = Find("CargoStationFireEngine",8)
	if next(nearbyObject) then
		for thatEquip, distance in pairs(nearbyObject) do
			if thatEquip.MarkerUID == this.MarkerUID and thatEquip.HomeUID == this.HomeUID then
				MyFireEquipment = thatEquip
				print("MyFireEquipment found at "..distance)
				break
			end
			if thatEquip.MarkerUID == this.LeftMarkerUID and thatEquip.HomeUID == this.HomeUID then
				MyFireEquipmentLeft = thatEquip
				equipFoundLeft = true
				print("MyFireEquipmentLeft found at dist "..distance)
			end
			if thatEquip.MarkerUID == this.RightMarkerUID and thatEquip.HomeUID == this.HomeUID then
				MyFireEquipmentRight = thatEquip
				equipFoundRight = true
				print("MyFireEquipmentRight found at dist "..distance)
			end
		end
	end
	nearbyObject = nil
	if this.CargoFloor == "LARGE" then
		if this.CargoSide == "LEFT" then
			MyFireEquipment = MyFireEquipmentLeft
		else
			MyFireEquipment = MyFireEquipmentRight
		end
	end
	if not Exists(MyFireEquipment) then
		print(" -- ERROR --- MyFireEquipment not found")
	end
end

function FindMyCargoControl()
	print("FindMyCargoControl")
	local controlFound = false
	local controlFoundLeft = false
	local controlFoundRight = false
	local nearbyObject = Find("CargoStationControl",7)
	if next(nearbyObject) then
		print("Found some CargoControls")
		for thatControl, distance in pairs(nearbyObject) do
			if thatControl.MarkerUID == this.MarkerUID and thatControl.HomeUID == this.HomeUID then
				MyCargoControl = thatControl
				controlFound = true
				print("CargoStationControl found at "..distance)
				break
			end
			if thatControl.MarkerUID == this.LeftMarkerUID and thatControl.HomeUID == this.HomeUID then
				MyCargoControlLeft = thatControl
				controlFoundLeft = true
				print("MyCargoControlLeft found at dist "..distance)
			end
			if thatControl.MarkerUID == this.RightMarkerUID and thatControl.HomeUID == this.HomeUID then
				MyCargoControlRight = thatControl
				controlFoundRight = true
				print("MyCargoControlRight found at dist "..distance)
			end
		end
	end
	nearbyObject = nil
	if this.CargoFloor == "LARGE" then
		if this.CargoSide == "LEFT" then
			MyCargoControl = MyCargoControlLeft
		else
			MyCargoControl = MyCargoControlRight
		end
	end
	if not Exists(MyCargoControl) then
		print(" -- ERROR --- MyCargoControl not found")
	end
end

function FindMyCargoStopSign()
	print("FindMyCargoStopSign")
	local signFound = false
	local signFoundLeft = false
	local signFoundRight = false
	local nearbyObject = Find("CargoStopSign",5)
	if next(nearbyObject) then
		for thatSign, distance in pairs(nearbyObject) do
			if thatSign.MarkerUID == this.MarkerUID and thatSign.HomeUID == this.HomeUID then
				MyCargoStopSign = thatSign
				signFound = true
				print("Sign found at dist "..distance)
				break
			end
			if thatSign.MarkerUID == this.LeftMarkerUID and thatSign.HomeUID == this.HomeUID then
				MyCargoSignLeft = thatSign
				signFoundLeft = true
				print("MyCargoSignLeft found at dist "..distance)
			end
			if thatSign.MarkerUID == this.RightMarkerUID and thatSign.HomeUID == this.HomeUID then
				MyCargoSignRight = thatSign
				signFoundRight = true
				print("MyCargoSignRight found at dist "..distance)
			end
		end
	end
	nearbyObject = nil
	if this.CargoFloor == "LARGE" then
		if this.CargoSide == "LEFT" then
			MyCargoStopSign = MyCargoSignLeft
		else
			MyCargoStopSign = MyCargoSignRight
		end
	end
	if not Exists(MyCargoStopSign) then
		print(" -- ERROR --- MyCargoStopSign not found")
	end
end

function Update(timePassed)
	if timePerUpdate == nil then
		if this.RoadMade == true then
			FindMyRoadMarker()
			FindMyCargoStopSign()
			UpdateTooltip()
			Interface.AddComponent(this,"RemoveStation", "Button", "tooltip_CargoStation_Button_Delete")
			Interface.AddComponent(this,"SeparatorPad0", "Caption", "tooltip_CargoStation_Separatorline")
			Interface.AddComponent(this,"toggleStationSubType", "Button", "tooltip_CargoStation_Button_SubType","tooltip_CargoStation_Button_"..CargoStationColour[this.SubType],"X")
			Interface.AddComponent(this,"toggleLights", "Button", "tooltip_CargoStation_Button_ToggleLights")
			Interface.AddComponent(this,"RemoveStack", "Button", "tooltip_CargoStation_Button_DeleteStack")
			Interface.AddComponent(this,"SeparatorPad1", "Caption", "tooltip_CargoStation_Separatorline")
			Interface.AddComponent(this,"toggleCargoSide", "Button", "tooltip_CargoStation_Button_CargoSide","tooltip_CargoStation_Button_"..this.CargoSide,"X")
			Interface.AddComponent(this,"toggleCargoType", "Button", "tooltip_CargoStation_Button_CargoType","tooltip_CargoStation_Button_"..MyCargoStopSign.CargoType,"X")
			Interface.AddComponent(this,"toggleTraffic", "Button", "tooltip_CargoStation_Button_TrafficEnabled","tooltip_CargoStation_Button_"..MyCargoStopSign.TrafficEnabled,"X")
			if MyCargoStopSign.CargoType == "Deliveries" then
				Interface.AddComponent(this,"SeparatorPad2", "Caption", "tooltip_CargoStation_SeparatorlineCARGO")
				Interface.AddComponent(this,"toggleFoodDelivery", "Button", "tooltip_CargoStation_Button_FoodDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.FoodDelivery,"X")
				Interface.AddComponent(this,"toggleVendingDelivery", "Button", "tooltip_CargoStation_Button_VendingDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.VendingDelivery,"X")
				Interface.AddComponent(this,"toggleBuildingDelivery", "Button", "tooltip_CargoStation_Button_BuildingDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.BuildingDelivery,"X")
				Interface.AddComponent(this,"toggleFloorsDelivery", "Button", "tooltip_CargoStation_Button_FloorsDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.FloorDelivery,"X")
				Interface.AddComponent(this,"toggleLaundryDelivery", "Button", "tooltip_CargoStation_Button_LaundryDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.LaundryDelivery,"X")
				Interface.AddComponent(this,"toggleForestDelivery", "Button", "tooltip_CargoStation_Button_ForestDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.ForestDelivery,"X")
				Interface.AddComponent(this,"toggleWorkshop1Delivery", "Button", "tooltip_CargoStation_Button_Workshop1Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop1Delivery,"X")
				Interface.AddComponent(this,"toggleWorkshop2Delivery", "Button", "tooltip_CargoStation_Button_Workshop2Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop2Delivery,"X")
				Interface.AddComponent(this,"toggleWorkshop3Delivery", "Button", "tooltip_CargoStation_Button_Workshop3Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop3Delivery,"X")
				Interface.AddComponent(this,"toggleWorkshop4Delivery", "Button", "tooltip_CargoStation_Button_Workshop4Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop4Delivery,"X")
				Interface.AddComponent(this,"toggleWorkshop5Delivery", "Button", "tooltip_CargoStation_Button_Workshop5Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop5Delivery,"X")
				Interface.AddComponent(this,"toggleOtherDelivery", "Button", "tooltip_CargoStation_Button_OtherDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.OtherDelivery,"X")
			elseif MyCargoStopSign.CargoType == "Intake" then
				Interface.AddComponent(this,"SeparatorPad2", "Caption", "tooltip_CargoStation_Separatorline")
				Interface.AddComponent(this,"toggleSecLevel", "Button", "tooltip_CargoStation_Button_SecLevel","tooltip_CargoStation_Button_SecLevel_"..MyCargoStopSign.SecLevel,"X")
				Interface.AddComponent(this,"toggleIsIntake", "Button", "tooltip_CargoStation_Button_IsIntake","tooltip_CargoStation_Button_"..MyCargoStopSign.IsIntake,"X")
			elseif MyCargoStopSign.CargoType == "Emergency" then
				FindSomeEquipmentNumbers()
				Interface.AddComponent(this,"SeparatorEquipment", "Caption", "tooltip_CargoStation_SeparatorEquipment")
				Interface.AddComponent(this,"toggleEquipmentArmedGuard", "Button", "tooltip_CargoStation_Button_CalloutEquipmentArmedGuard","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["ArmedGuard"][MyCargoStopSign.EquipmentArmedGuardNr],"X")
				Interface.AddComponent(this,"toggleEquipmentFireman", "Button", "tooltip_CargoStation_Button_CalloutEquipmentFireman","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Fireman"][MyCargoStopSign.EquipmentFiremanNr],"X")
				-- Interface.AddComponent(this,"toggleEquipmentParamedic", "Button", "tooltip_CargoStation_Button_CalloutEquipmentParamedic","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Paramedic"][MyCargoStopSign.EquipmentParamedicNr],"X")
				Interface.AddComponent(this,"toggleEquipmentRiotGuard", "Button", "tooltip_CargoStation_Button_CalloutEquipmentRiotGuard","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["RiotGuard"][MyCargoStopSign.EquipmentRiotGuardNr],"X")
				Interface.AddComponent(this,"toggleEquipmentSoldier", "Button", "tooltip_CargoStation_Button_CalloutEquipmentSoldier","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Soldier"][MyCargoStopSign.EquipmentSoldierNr],"X")
			end
		else
			Interface.AddComponent(this,"DeleteStation", "Button", "tooltip_CargoStation_Button_Delete")
			Interface.AddComponent(this,"SeparatorOr", "Caption", "tooltip_CargoStation_Or")
			Interface.AddComponent(this,"BuildRoad", "Button", "tooltip_CargoStation_Button_BuildRoad")
		end
		timePerUpdate = 0.25
	end
	
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if this.RoadMade == true and this.CargoFloor == "LARGE" then
			if not Exists(MyRoadMarkerRight) or not Exists(MyRoadMarkerLeft) then
				local OldLeftMarkerUID = this.LeftMarkerUID
				local OldRightMarkerUID = this.RightMarkerUID
				print("Old Left MarkerUID: "..OldLeftMarkerUID.."  OldRightMarkerUID: "..OldRightMarkerUID)
				FindMyRoadMarker()
				if OldLeftMarkerUID ~= this.LeftMarkerUID or OldRightMarkerUID ~= this.RightMarkerUID then
					print("Updating my Cargo Station objects with new MarkerUID...")
					for _, typ in pairs(CargoStationObjects) do
						local nearbyObjects = Find(this,typ,10000)
						for thatObject, _ in pairs(nearbyObjects) do
							if OldLeftMarkerUID ~= this.LeftMarkerUID and Get(thatObject,"MarkerUID") == OldLeftMarkerUID then
								print("Found "..thatObject.Type.." with old left MarkerUID "..OldLeftMarkerUID..", updating to MarkerUID "..this.LeftMarkerUID)
								Set(thatObject,"MarkerUID",this.LeftMarkerUID)
							elseif OldRightMarkerUID ~= this.RightMarkerUID and Get(thatObject,"MarkerUID") == OldRightMarkerUID then
								print("Found "..thatObject.Type.." with old right MarkerUID "..OldRightMarkerUID..", updating to MarkerUID "..this.RightMarkerUID)
								Set(thatObject,"MarkerUID",this.RightMarkerUID)
							end
						end
					end
				end
			end
			if World.NumCellsX ~= this.NumCellsX or World.NumCellsY ~= this.NumCellsY then
				UpdateInventoryPositions()
			end
			if MyCargoStopSign.Status == "TerminalRemoved" then DisableTraffic() end
		elseif this.RoadMade == true and this.CargoFloor == "COMPACT" then
			if not Exists(MyRoadMarker) then
				local OldMarkerUID = this.MarkerUID
				print("Old MarkerUID: "..OldMarkerUID)
				FindMyRoadMarker()
				if OldMarkerUID ~= this.MarkerUID then
					print("Updating my Cargo Station objects with new MarkerUID...")
					for _, typ in pairs(CargoStationObjects) do
						local nearbyObjects = Find(this,typ,10000)
						for thatObject, _ in pairs(nearbyObjects) do
							if Get(thatObject,"MarkerUID") == OldMarkerUID then
								print("Found "..thatObject.Type.." with old MarkerUID "..OldMarkerUID..", updating to MarkerUID "..this.MarkerUID)
								Set(thatObject,"MarkerUID",this.MarkerUID)
							end
						end
					end
				end
			end
			if World.NumCellsX ~= this.NumCellsX or World.NumCellsY ~= this.NumCellsY then
				UpdateInventoryPositions()
			end
			if MyCargoStopSign.Status == "TerminalRemoved" then DisableTraffic() end
		end
	end
end

function toggleCargoSideClicked()
	if (Get(MyCargoStopSign,"InUse") == "no" and this.CargoFloor == "COMPACT") or this.CargoFloor == "LARGE" then
		if not Exists(MyCrane) then FindMyCrane(); FindMyHook(); FindMyLoadChecker(); FindMyIntakeDoor(); FindMyCargoControl() end
		if MyCargoStopSign.CargoType == "Deliveries" then
			Interface.RemoveComponent(this,"SeparatorPad2")
			Interface.RemoveComponent(this,"toggleFoodDelivery")
			Interface.RemoveComponent(this,"toggleVendingDelivery")
			Interface.RemoveComponent(this,"toggleBuildingDelivery")
			Interface.RemoveComponent(this,"toggleFloorsDelivery")
			Interface.RemoveComponent(this,"toggleForestDelivery")
			Interface.RemoveComponent(this,"toggleLaundryDelivery")
			Interface.RemoveComponent(this,"toggleWorkshop1Delivery")
			Interface.RemoveComponent(this,"toggleWorkshop2Delivery")
			Interface.RemoveComponent(this,"toggleWorkshop3Delivery")
			Interface.RemoveComponent(this,"toggleWorkshop4Delivery")
			Interface.RemoveComponent(this,"toggleWorkshop5Delivery")
			Interface.RemoveComponent(this,"toggleOtherDelivery")
		elseif MyCargoStopSign.CargoType == "Intake" then
			Interface.RemoveComponent(this,"SeparatorPad2")
			Interface.RemoveComponent(this,"toggleSecLevel")
			Interface.RemoveComponent(this,"toggleIsIntake")
		elseif MyCargoStopSign.CargoType == "Emergency" then
			Interface.RemoveComponent(this,"SeparatorEquipment")
			Interface.RemoveComponent(this,"toggleEquipmentArmedGuard")
			Interface.RemoveComponent(this,"toggleEquipmentFireman")
			-- Interface.RemoveComponent(this,"toggleEquipmentParamedic")
			Interface.RemoveComponent(this,"toggleEquipmentRiotGuard")
			Interface.RemoveComponent(this,"toggleEquipmentSoldier")
		end
		if this.CargoFloor == "LARGE" then
			if this.CargoSide == "LEFT" then
				MyCargoStopSign = MyCargoSignRight
				if Exists(MyCrane) then MyCrane = MyCraneRight end
				if Exists(MyHook) then MyHook = MyHookRight end
				if Exists(MyIntakeDoor) then MyIntakeDoor = MyIntakeDoorRight end
				if Exists(MyFireEquipment) then MyFireEquipment = MyFireEquipmentRight end
				if Exists(MyCargoControl) then MyCargoControl = MyCargoControlRight end
				if Exists(MyLoadChecker) then MyLoadChecker = MyLoadCheckerRight end
				Set(this,"CargoSide","RIGHT")
			else
				MyCargoStopSign = MyCargoSignLeft
				if Exists(MyCrane) then MyCrane = MyCraneLeft end
				if Exists(MyHook) then MyHook = MyHookLeft end
				if Exists(MyIntakeDoor) then MyIntakeDoor = MyIntakeDoorLeft end
				if Exists(MyFireEquipment) then MyFireEquipment = MyFireEquipmentLeft end
				if Exists(MyCargoControl) then MyCargoControl = MyCargoControlLeft end
				if Exists(MyLoadChecker) then MyLoadChecker = MyLoadCheckerLeft end
				Set(this,"CargoSide","LEFT")
			end
		else
			RemoveLoaders()
			RemoveFloor()
			if this.CargoSide == "LEFT" then
				this.Pos.x = this.Pos.x+3
				Set(this,"CargoSide","RIGHT")
				Set(this,"LightsOnRIGHT",this.LightsOnLEFT)
				this.SubType = CargoStationsSmallRight[MyCargoStopSign.CargoType]
			else
				this.Pos.x = this.Pos.x-3
				Set(this,"CargoSide","LEFT")
				Set(this,"LightsOnLEFT",this.LightsOnRIGHT)
				this.SubType = CargoStationsSmallLeft[MyCargoStopSign.CargoType]
			end
			this.SetInterfaceCaption("toggleStationSubType","tooltip_CargoStation_Button_SubType","tooltip_CargoStation_Button_"..CargoStationColour[this.SubType],"X")
			CreateCargoArea(MyCargoStopSign.CargoType,this.CargoSide)
			UpdateInventoryPositions()
		end
		this.SetInterfaceCaption("toggleCargoSide", "tooltip_CargoStation_Button_CargoSide","tooltip_CargoStation_Button_"..this.CargoSide,"X")
		this.SetInterfaceCaption("toggleCargoType", "tooltip_CargoStation_Button_CargoType","tooltip_CargoStation_Button_"..MyCargoStopSign.CargoType,"X")
		this.SetInterfaceCaption("toggleTraffic", "tooltip_CargoStation_Button_TrafficEnabled","tooltip_CargoStation_Button_"..MyCargoStopSign.TrafficEnabled,"X")
		if MyCargoStopSign.CargoType == "Deliveries" then
			Interface.AddComponent(this,"SeparatorPad2", "Caption", "tooltip_CargoStation_SeparatorlineCARGO")
			Interface.AddComponent(this,"toggleFoodDelivery", "Button", "tooltip_CargoStation_Button_FoodDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.FoodDelivery,"X")
			Interface.AddComponent(this,"toggleVendingDelivery", "Button", "tooltip_CargoStation_Button_VendingDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.VendingDelivery,"X")
			Interface.AddComponent(this,"toggleBuildingDelivery", "Button", "tooltip_CargoStation_Button_BuildingDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.BuildingDelivery,"X")
			Interface.AddComponent(this,"toggleFloorsDelivery", "Button", "tooltip_CargoStation_Button_FloorsDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.FloorDelivery,"X")
			Interface.AddComponent(this,"toggleLaundryDelivery", "Button", "tooltip_CargoStation_Button_LaundryDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.LaundryDelivery,"X")
			Interface.AddComponent(this,"toggleForestDelivery", "Button", "tooltip_CargoStation_Button_ForestDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.ForestDelivery,"X")
			Interface.AddComponent(this,"toggleWorkshop1Delivery", "Button", "tooltip_CargoStation_Button_Workshop1Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop1Delivery,"X")
			Interface.AddComponent(this,"toggleWorkshop2Delivery", "Button", "tooltip_CargoStation_Button_Workshop2Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop2Delivery,"X")
			Interface.AddComponent(this,"toggleWorkshop3Delivery", "Button", "tooltip_CargoStation_Button_Workshop3Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop3Delivery,"X")
			Interface.AddComponent(this,"toggleWorkshop4Delivery", "Button", "tooltip_CargoStation_Button_Workshop4Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop4Delivery,"X")
			Interface.AddComponent(this,"toggleWorkshop5Delivery", "Button", "tooltip_CargoStation_Button_Workshop5Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop5Delivery,"X")
			Interface.AddComponent(this,"toggleOtherDelivery", "Button", "tooltip_CargoStation_Button_OtherDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.OtherDelivery,"X")
		elseif MyCargoStopSign.CargoType == "Intake" then
			Interface.AddComponent(this,"SeparatorPad2", "Caption", "tooltip_CargoStation_Separatorline")
			Interface.AddComponent(this,"toggleSecLevel", "Button", "tooltip_CargoStation_Button_SecLevel","tooltip_CargoStation_Button_SecLevel_"..MyCargoStopSign.SecLevel,"X")
			Interface.AddComponent(this,"toggleIsIntake", "Button", "tooltip_CargoStation_Button_IsIntake","tooltip_CargoStation_Button_"..MyCargoStopSign.IsIntake,"X")
		elseif MyCargoStopSign.CargoType == "Emergency" then
			if EquipmentNumbers["Fireman"][1] == 0 then FindSomeEquipmentNumbers() end
			Interface.AddComponent(this,"SeparatorEquipment", "Caption", "tooltip_CargoStation_SeparatorEquipment")
			Interface.AddComponent(this,"toggleEquipmentArmedGuard", "Button", "tooltip_CargoStation_Button_CalloutEquipmentArmedGuard","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["ArmedGuard"][MyCargoStopSign.EquipmentArmedGuardNr],"X")
			Interface.AddComponent(this,"toggleEquipmentFireman", "Button", "tooltip_CargoStation_Button_CalloutEquipmentFireman","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Fireman"][MyCargoStopSign.EquipmentFiremanNr],"X")
			-- Interface.AddComponent(this,"toggleEquipmentParamedic", "Button", "tooltip_CargoStation_Button_CalloutEquipmentParamedic","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Paramedic"][MyCargoStopSign.EquipmentParamedicNr],"X")
			Interface.AddComponent(this,"toggleEquipmentRiotGuard", "Button", "tooltip_CargoStation_Button_CalloutEquipmentRiotGuard","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["RiotGuard"][MyCargoStopSign.EquipmentRiotGuardNr],"X")
			Interface.AddComponent(this,"toggleEquipmentSoldier", "Button", "tooltip_CargoStation_Button_CalloutEquipmentSoldier","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Soldier"][MyCargoStopSign.EquipmentSoldierNr],"X")
		end
		UpdateTooltip()
		this.Sound("_Deployment","SetNone")
	end
end

function toggleCargoTypeClicked()
	RemoveLoaders()
	if Get(MyCargoStopSign,"InUse") == "no" then
		if Get(MyCargoStopSign,"CargoType") == "Deliveries" then
			Interface.RemoveComponent(this,"SeparatorPad2")
			Interface.RemoveComponent(this,"toggleFoodDelivery")
			Interface.RemoveComponent(this,"toggleVendingDelivery")
			Interface.RemoveComponent(this,"toggleBuildingDelivery")
			Interface.RemoveComponent(this,"toggleFloorsDelivery")
			Interface.RemoveComponent(this,"toggleForestDelivery")
			Interface.RemoveComponent(this,"toggleLaundryDelivery")
			Interface.RemoveComponent(this,"toggleWorkshop1Delivery")
			Interface.RemoveComponent(this,"toggleWorkshop2Delivery")
			Interface.RemoveComponent(this,"toggleWorkshop3Delivery")
			Interface.RemoveComponent(this,"toggleWorkshop4Delivery")
			Interface.RemoveComponent(this,"toggleWorkshop5Delivery")
			Interface.RemoveComponent(this,"toggleOtherDelivery")
			Set(MyCargoStopSign,"CargoType","Exports")
			Set(MyCargoStopSign,"LoadAvailable",false)
		elseif Get(MyCargoStopSign,"CargoType") == "Exports" then
			Set(MyCargoStopSign,"CargoType","Garbage")
			Set(MyCargoStopSign,"LoadAvailable",false)
		elseif Get(MyCargoStopSign,"CargoType") == "Garbage" then
			if not Exists(MyCrane) then FindMyCrane(); FindMyHook(); FindMyCargoControl() end
			MyCrane.Delete()
			MyHook.Delete()
			MyCargoControl.SubType = StopSignTypes[MyCargoStopSign.SecLevel]
			if this.CargoFloor == "LARGE" then
				if this.CargoSide == "LEFT" then
					MyIntakeDoorLeft = Object.Spawn("JailDoorLarge",this.Pos.x-7,this.Pos.y-0.5)
					MyIntakeDoorLeft.Or.x = 1
					MyIntakeDoorLeft.Or.y = 0
					MyIntakeDoorLeft.OpenDir.x = 0
					MyIntakeDoorLeft.OpenDir.y = 2
					MyIntakeDoorLeft.MarkerUID = this.LeftMarkerUID
					MyIntakeDoorLeft.HomeUID = this.HomeUID
					
					MyIntakeDoor = MyIntakeDoorLeft
				else
					MyIntakeDoorRight = Object.Spawn("JailDoorLarge",this.Pos.x+7,this.Pos.y-0.5)
					MyIntakeDoorRight.Or.x = 1
					MyIntakeDoorRight.Or.y = 0
					MyIntakeDoorRight.OpenDir.x = 0
					MyIntakeDoorRight.OpenDir.y = 2
					MyIntakeDoorRight.MarkerUID = this.RightMarkerUID
					MyIntakeDoorRight.HomeUID = this.HomeUID
					
					MyIntakeDoor = MyIntakeDoorRight
				end
			else
				local DoorPosX = this.Pos.x-4
				if this.CargoSide == "RIGHT" then DoorPosX = this.Pos.x+4 end
				MyIntakeDoor = Object.Spawn("JailDoorLarge",DoorPosX,this.Pos.y)
				MyIntakeDoor.Or.x = 1
				MyIntakeDoor.Or.y = 0
				MyIntakeDoor.OpenDir.x = 0
				MyIntakeDoor.OpenDir.y = 2
				MyIntakeDoor.MarkerUID = this.MarkerUID
				MyIntakeDoor.HomeUID = this.HomeUID
			end	
			Interface.AddComponent(this,"SeparatorPad2", "Caption", "tooltip_CargoStation_Separatorline")
			Interface.AddComponent(this,"toggleSecLevel", "Button", "tooltip_CargoStation_Button_SecLevel","tooltip_CargoStation_Button_SecLevel_"..MyCargoStopSign.SecLevel,"X")
			Interface.AddComponent(this,"toggleIsIntake", "Button", "tooltip_CargoStation_Button_IsIntake","tooltip_CargoStation_Button_"..MyCargoStopSign.IsIntake,"X")
			Set(MyCargoStopSign,"CargoType","Intake")
		elseif Get(MyCargoStopSign,"CargoType") == "Intake" then
			if not Exists(MyIntakeDoor) then FindMyIntakeDoor() end
			if Exists(MyIntakeDoor) then MyIntakeDoor.Delete() end
			if not Exists(MyCargoControl) then FindMyCargoControl() end
			MyCargoControl.SubType = 19
			
			if this.CargoFloor == "LARGE" then
				if this.CargoSide == "LEFT" then
					MyCraneLeft = Object.Spawn("CargoStationGantryCrane",this.Pos.x-1.5,this.Pos.y-4)
					MyCraneLeft.MarkerUID = this.LeftMarkerUID
					MyCraneLeft.HomeUID = this.HomeUID
					MyCraneLeft.CargoStationID = MyCargoControl.CargoStationID
		
					MyHookLeft = Object.Spawn("CargoStationGantryHook",this.Pos.x-1.5,this.Pos.y-2)
					MyHookLeft.MarkerUID = this.LeftMarkerUID
					MyHookLeft.HomeUID = this.HomeUID
					MyHookLeft.CargoStationID = MyCargoControl.CargoStationID
					MyHookLeft.SubType = 3
									
					MyFireEquipmentLeft = Object.Spawn("CargoStationFireEngine",this.Pos.x-5,this.Pos.y-3.5)
					MyFireEquipmentLeft.MarkerUID = this.LeftMarkerUID
					MyFireEquipmentLeft.HomeUID = this.HomeUID
					MyFireEquipmentLeft.CargoStationID = MyCargoControl.CargoStationID
					
					MyCrane = MyCraneLeft
					MyHook = MyHookLeft
					MyFireEquipment = MyFireEquipmentLeft
				else
					MyCraneRight = Object.Spawn("CargoStationGantryCrane",this.Pos.x+1.5,this.Pos.y-4)
					MyCraneRight.MarkerUID = this.RightMarkerUID
					MyCraneRight.HomeUID = this.HomeUID
					MyCraneRight.CargoStationID = MyCargoControl.CargoStationID
					
					MyHookRight = Object.Spawn("CargoStationGantryHook",this.Pos.x+1.5,this.Pos.y-2)
					MyHookRight.MarkerUID = this.RightMarkerUID
					MyHookRight.HomeUID = this.HomeUID
					MyHookRight.CargoStationID = MyCargoControl.CargoStationID
					MyHookRight.SubType = 3
										
					MyFireEquipmentRight = Object.Spawn("CargoStationFireEngine",this.Pos.x+5,this.Pos.y-3.5)
					MyFireEquipmentRight.SubType = 2
					MyFireEquipmentRight.MarkerUID = this.RightMarkerUID
					MyFireEquipmentRight.HomeUID = this.HomeUID
					MyFireEquipmentRight.CargoStationID = MyCargoControl.CargoStationID
					
					MyCrane = MyCraneRight
					MyHook = MyHookRight
					MyFireEquipment = MyFireEquipmentRight					
				end
			else
				local CranePosX,FireX,LoadX = this.Pos.x+1.5,this.Pos.x-2,this.Pos.x-2
				if this.CargoSide == "RIGHT" then CranePosX,FireX,LoadX = this.Pos.x-1.5,this.Pos.x+2,this.Pos.x+2 end
				MyCrane = Object.Spawn("CargoStationGantryCrane",CranePosX,this.Pos.y-4)
				MyCrane.MarkerUID = this.MarkerUID
				MyCrane.HomeUID = this.HomeUID
				MyCrane.CargoStationID = MyCargoControl.CargoStationID
				
				MyHook = Object.Spawn("CargoStationGantryHook",CranePosX,this.Pos.y-2)
				MyHook.MarkerUID = this.MarkerUID
				MyHook.HomeUID = this.HomeUID
				MyHook.CargoStationID = MyCargoControl.CargoStationID
				MyHook.SubType = 3
								
				MyFireEquipment = Object.Spawn("CargoStationFireEngine",FireX,this.Pos.y-3.5)
				if this.CargoSide == "RIGHT" then
					MyFireEquipment.SubType = 2
				end
				MyFireEquipment.MarkerUID = this.MarkerUID
				MyFireEquipment.HomeUID = this.HomeUID
				MyFireEquipment.CargoStationID = MyCargoControl.CargoStationID
			end
			Interface.RemoveComponent(this,"SeparatorPad2")
			Interface.RemoveComponent(this,"toggleSecLevel")
			Interface.RemoveComponent(this,"toggleIsIntake")
			if EquipmentNumbers["Fireman"][1] == 0 then FindSomeEquipmentNumbers() end
			Interface.AddComponent(this,"SeparatorEquipment", "Caption", "tooltip_CargoStation_SeparatorEquipment")
			Interface.AddComponent(this,"toggleEquipmentArmedGuard", "Button", "tooltip_CargoStation_Button_CalloutEquipmentArmedGuard","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["ArmedGuard"][MyCargoStopSign.EquipmentArmedGuardNr],"X")
			Interface.AddComponent(this,"toggleEquipmentFireman", "Button", "tooltip_CargoStation_Button_CalloutEquipmentFireman","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Fireman"][MyCargoStopSign.EquipmentFiremanNr],"X")
			-- Interface.AddComponent(this,"toggleEquipmentParamedic", "Button", "tooltip_CargoStation_Button_CalloutEquipmentParamedic","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Paramedic"][MyCargoStopSign.EquipmentParamedicNr],"X")
			Interface.AddComponent(this,"toggleEquipmentRiotGuard", "Button", "tooltip_CargoStation_Button_CalloutEquipmentRiotGuard","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["RiotGuard"][MyCargoStopSign.EquipmentRiotGuardNr],"X")
			Interface.AddComponent(this,"toggleEquipmentSoldier", "Button", "tooltip_CargoStation_Button_CalloutEquipmentSoldier","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Soldier"][MyCargoStopSign.EquipmentSoldierNr],"X")
			Set(MyCargoStopSign,"CargoType","Emergency")
			Set(MyCargoStopSign,"LoadAvailable",false)
		elseif Get(MyCargoStopSign,"CargoType") == "Emergency" then
			Interface.RemoveComponent(this,"SeparatorEquipment")
			Interface.RemoveComponent(this,"toggleEquipmentArmedGuard")
			Interface.RemoveComponent(this,"toggleEquipmentFireman")
			-- Interface.RemoveComponent(this,"toggleEquipmentParamedic")
			Interface.RemoveComponent(this,"toggleEquipmentRiotGuard")
			Interface.RemoveComponent(this,"toggleEquipmentSoldier")
			if not Exists(MyCargoControl) then FindMyCargoControl() end
			if not Exists(MyHook) then FindMyHook() end
			if not Exists(MyFireEquipment) then FindMyFireEquipment() end
			MyFireEquipment.Delete()
			Set(MyCargoStopSign,"WaitForFiremen",false)
			MyCargoControl.SubType = 0
			MyHook.SubType = 0
			Set(MyCargoStopSign,"FoodQuantity",0)
			Set(MyCargoStopSign,"VendingQuantity",0)
			Set(MyCargoStopSign,"BuildingQuantity",0)
			Set(MyCargoStopSign,"FloorQuantity",0)
			Set(MyCargoStopSign,"ForestQuantity",0)
			Set(MyCargoStopSign,"LaundryQuantity",0)
			Set(MyCargoStopSign,"Workshop1Quantity",0)
			Set(MyCargoStopSign,"Workshop2Quantity",0)
			Set(MyCargoStopSign,"Workshop3Quantity",0)
			Set(MyCargoStopSign,"Workshop4Quantity",0)
			Set(MyCargoStopSign,"Workshop5Quantity",0)
			Set(MyCargoStopSign,"OtherQuantity",0)
			Set(MyCargoStopSign,"AllQuantity",0)
			Set(MyCargoStopSign,"InUse","no")
			Set(MyCargoStopSign,"VehicleSpawned","no")
			Set(MyCargoStopSign,"Status","Waiting...")
			
			Interface.AddComponent(this,"SeparatorPad2", "Caption", "tooltip_CargoStation_SeparatorlineCARGO")
			Interface.AddComponent(this,"toggleFoodDelivery", "Button", "tooltip_CargoStation_Button_FoodDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.FoodDelivery,"X")
			Interface.AddComponent(this,"toggleVendingDelivery", "Button", "tooltip_CargoStation_Button_VendingDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.VendingDelivery,"X")
			Interface.AddComponent(this,"toggleBuildingDelivery", "Button", "tooltip_CargoStation_Button_BuildingDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.BuildingDelivery,"X")
			Interface.AddComponent(this,"toggleFloorsDelivery", "Button", "tooltip_CargoStation_Button_FloorsDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.FloorDelivery,"X")
			Interface.AddComponent(this,"toggleLaundryDelivery", "Button", "tooltip_CargoStation_Button_LaundryDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.LaundryDelivery,"X")
			Interface.AddComponent(this,"toggleForestDelivery", "Button", "tooltip_CargoStation_Button_ForestDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.ForestDelivery,"X")
			Interface.AddComponent(this,"toggleWorkshop1Delivery", "Button", "tooltip_CargoStation_Button_Workshop1Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop1Delivery,"X")
			Interface.AddComponent(this,"toggleWorkshop2Delivery", "Button", "tooltip_CargoStation_Button_Workshop2Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop2Delivery,"X")
			Interface.AddComponent(this,"toggleWorkshop3Delivery", "Button", "tooltip_CargoStation_Button_Workshop3Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop3Delivery,"X")
			Interface.AddComponent(this,"toggleWorkshop4Delivery", "Button", "tooltip_CargoStation_Button_Workshop4Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop4Delivery,"X")
			Interface.AddComponent(this,"toggleWorkshop5Delivery", "Button", "tooltip_CargoStation_Button_Workshop5Delivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.Workshop5Delivery,"X")
			Interface.AddComponent(this,"toggleOtherDelivery", "Button", "tooltip_CargoStation_Button_OtherDelivery","tooltip_CargoStation_Button_Delivery_"..MyCargoStopSign.OtherDelivery,"X")
			Set(MyCargoStopSign,"CargoType","Deliveries")
		end
		if Get(MyCargoStopSign,"TrafficEnabled") == "yes" then
			MyCargoStopSign.SubType = StopSignTypes[MyCargoStopSign.CargoType]
		end
		CreateCargoArea(MyCargoStopSign.CargoType,this.CargoSide)
		if this.CargoFloor == "LARGE" then
			this.SubType = CargoStationsLarge[MyCargoStopSign.CargoType]
		else
			if this.CargoSide == "RIGHT" then
				this.SubType = CargoStationsSmallRight[MyCargoStopSign.CargoType]
			else
				this.SubType = CargoStationsSmallLeft[MyCargoStopSign.CargoType]
			end
		end
		this.SetInterfaceCaption("toggleStationSubType","tooltip_CargoStation_Button_SubType","tooltip_CargoStation_Button_"..CargoStationColour[this.SubType],"X")
		this.SetInterfaceCaption("toggleCargoType","tooltip_CargoStation_Button_CargoType","tooltip_CargoStation_Button_"..MyCargoStopSign.CargoType,"X")
		
		UpdateTooltip()
		this.Sound("_Deployment","SetNone")
	end
end

function toggleTrafficClicked()
	if Get(MyCargoStopSign,"InUse") == "no" and Get(MyCargoStopSign,"Number") > 0 then
		if Get(MyCargoStopSign,"TrafficEnabled") == "no" then
			RemoveWallLights(this.CargoSide)
			MakeWallLights(this.CargoSide)
			Set(this,"LightsOn"..this.CargoSide,true)
			Set(MyCargoStopSign,"TrafficEnabled","yes")
			Set(MyCargoStopSign,"Status","Waiting...")
			MyCargoStopSign.SubType = StopSignTypes[MyCargoStopSign.CargoType]
			if this.CargoFloor == "COMPACT" then
				if not this.GrantCheckerSpawned then
					for MyStreetManager in next, Find(this,"StreetManager2",10000) do
						local GrantChecker = Object.Spawn("GrantChecker"..MyCargoStopSign.CargoType,MyStreetManager.Pos.x-0.5,MyStreetManager.Pos.y+2)
						-- Set(this,"GrantCheckerSpawned",true)
					end
				end
			else
				if this.CargoSide == "LEFT" and not this.GrantCheckerLeftSpawned then
					for MyStreetManager in next, Find(this,"StreetManager2",10000) do
						local GrantChecker = Object.Spawn("GrantChecker"..MyCargoStopSign.CargoType,MyStreetManager.Pos.x-0.5,MyStreetManager.Pos.y+2)
						-- Set(this,"GrantCheckerLeftSpawned",true)
					end
				elseif this.CargoSide == "RIGHT" and not this.GrantCheckerRightSpawned then
					for MyStreetManager in next, Find(this,"StreetManager2",10000) do
						local GrantChecker = Object.Spawn("GrantChecker"..MyCargoStopSign.CargoType,MyStreetManager.Pos.x-0.5,MyStreetManager.Pos.y+2)
						-- Set(this,"GrantCheckerRightSpawned",true)
					end
				end
			end
		else
			RemoveLoaders()
			RemoveWallLights(this.CargoSide)
			Set(this,"LightsOn"..this.CargoSide,nil)
			Set(MyCargoStopSign,"TrafficEnabled","no")
			Set(MyCargoStopSign,"Status","DISABLED")
			MyCargoStopSign.SubType = 5
		end
		UpdateTooltip()
		this.Sound("_Deployment","SetNone")
		this.SetInterfaceCaption("toggleTraffic","tooltip_CargoStation_Button_TrafficEnabled","tooltip_CargoStation_Button_"..MyCargoStopSign.TrafficEnabled,"X")
	end
end

function DisableTraffic()
	RemoveLoaders()
	RemoveWallLights(this.CargoSide)
	Set(this,"LightsOn"..this.CargoSide,nil)
	Set(MyCargoStopSign,"TrafficEnabled","no")
	Set(MyCargoStopSign,"Status","DISABLED")
	MyCargoStopSign.SubType = 5
	UpdateTooltip()
	this.SetInterfaceCaption("toggleTraffic","tooltip_CargoStation_Button_TrafficEnabled","tooltip_CargoStation_Button_"..MyCargoStopSign.TrafficEnabled,"X")
end

function ToggleYesNo(property,var)
	-- if Get(MyCargoStopSign,"InUse") == "no" then
		local Property = Get(MyCargoStopSign,property)
		if Property == "yes" then Property = "no" else Property = "yes" end
		Set(MyCargoStopSign,property,Property)
		var = Property
		this.Sound("_Deployment","SetNone")
		return var
	-- end
end

function toggleFoodDeliveryClicked()	
	this.SetInterfaceCaption("toggleFoodDelivery","tooltip_CargoStation_Button_FoodDelivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("FoodDelivery"),"X")
end

function toggleForestDeliveryClicked()
	this.SetInterfaceCaption("toggleForestDelivery","tooltip_CargoStation_Button_ForestDelivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("ForestDelivery"),"X")
end

function toggleVendingDeliveryClicked()
	this.SetInterfaceCaption("toggleVendingDelivery","tooltip_CargoStation_Button_VendingDelivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("VendingDelivery"),"X")
end

function toggleBuildingDeliveryClicked()
	this.SetInterfaceCaption("toggleBuildingDelivery","tooltip_CargoStation_Button_BuildingDelivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("BuildingDelivery"),"X")
end

function toggleFloorsDeliveryClicked()
	this.SetInterfaceCaption("toggleFloorsDelivery","tooltip_CargoStation_Button_FloorsDelivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("FloorDelivery"),"X")
end

function toggleLaundryDeliveryClicked()
	this.SetInterfaceCaption("toggleLaundryDelivery","tooltip_CargoStation_Button_LaundryDelivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("LaundryDelivery"),"X")
end

function toggleWorkshop1DeliveryClicked()
	this.SetInterfaceCaption("toggleWorkshop1Delivery","tooltip_CargoStation_Button_Workshop1Delivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("Workshop1Delivery"),"X")
end

function toggleWorkshop2DeliveryClicked()
	this.SetInterfaceCaption("toggleWorkshop2Delivery","tooltip_CargoStation_Button_Workshop2Delivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("Workshop2Delivery"),"X")
end

function toggleWorkshop3DeliveryClicked()
	this.SetInterfaceCaption("toggleWorkshop3Delivery","tooltip_CargoStation_Button_Workshop3Delivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("Workshop3Delivery"),"X")
end

function toggleWorkshop4DeliveryClicked()
	this.SetInterfaceCaption("toggleWorkshop4Delivery","tooltip_CargoStation_Button_Workshop4Delivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("Workshop4Delivery"),"X")
end

function toggleWorkshop5DeliveryClicked()
	this.SetInterfaceCaption("toggleWorkshop5Delivery","tooltip_CargoStation_Button_Workshop5Delivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("Workshop5Delivery"),"X")
end

function toggleOtherDeliveryClicked()
	this.SetInterfaceCaption("toggleOtherDelivery","tooltip_CargoStation_Button_OtherDelivery","tooltip_CargoStation_Button_Delivery_"..ToggleYesNo("OtherDelivery"),"X")
end

function toggleSecLevelClicked()
	if Get(MyCargoStopSign,"InUse") == "no" then
		if Get(MyCargoStopSign,"SecLevel")=="ALL" then
			Set(MyCargoStopSign,"SecLevel","MinSec")
		elseif Get(MyCargoStopSign,"SecLevel")=="MinSec" then
			Set(MyCargoStopSign,"SecLevel","Normal")
		elseif Get(MyCargoStopSign,"SecLevel")=="Normal" then
			Set(MyCargoStopSign,"SecLevel","MaxSec")
		elseif Get(MyCargoStopSign,"SecLevel")=="MaxSec" then
			Set(MyCargoStopSign,"SecLevel","SuperMax")
		elseif Get(MyCargoStopSign,"SecLevel")=="SuperMax" then
			Set(MyCargoStopSign,"SecLevel","DeathRow")
		elseif Get(MyCargoStopSign,"SecLevel")=="DeathRow" then
			Set(MyCargoStopSign,"SecLevel","Protected")
		elseif Get(MyCargoStopSign,"SecLevel")=="Protected" then
			Set(MyCargoStopSign,"SecLevel","Insane")
		elseif Get(MyCargoStopSign,"SecLevel")=="Insane" then
			Set(MyCargoStopSign,"SecLevel","ALL")
		end
		if not Exists(MyCargoControl) then FindMyCargoControl() end
		MyCargoControl.SubType = StopSignTypes[MyCargoStopSign.SecLevel]
		this.SetInterfaceCaption("toggleSecLevel", "tooltip_CargoStation_Button_SecLevel","tooltip_CargoStation_Button_SecLevel_"..MyCargoStopSign.SecLevel,"X")
		this.Sound("_Deployment","SetNone")
	end
end

function toggleIsIntakeClicked()
	this.SetInterfaceCaption("toggleIsIntake", "tooltip_CargoStation_Button_IsIntake","tooltip_CargoStation_Button_"..ToggleYesNo("IsIntake"),"X")
end

function toggleEquipmentFiremanClicked()
	MyCargoStopSign.EquipmentFiremanNr = MyCargoStopSign.EquipmentFiremanNr + 1
	if EquipmentTypes["Fireman"][MyCargoStopSign.EquipmentFiremanNr] == nil then
		MyCargoStopSign.EquipmentFiremanNr = 1
	end
	Set(MyCargoStopSign,"EquipmentFireman",EquipmentNumbers["Fireman"][MyCargoStopSign.EquipmentFiremanNr])
	CalloutEquipment = EquipmentTypes["Fireman"][MyCargoStopSign.EquipmentFiremanNr]
	print(CalloutEquipment.." (number: "..MyCargoStopSign.EquipmentFireman..")")
	this.SetInterfaceCaption("toggleEquipmentFireman", "tooltip_CargoStation_Button_CalloutEquipmentFireman","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Fireman"][MyCargoStopSign.EquipmentFiremanNr],"X")
end

-- function toggleEquipmentParamedicClicked()
	-- MyCargoStopSign.EquipmentParamedicNr = MyCargoStopSign.EquipmentParamedicNr + 1
	-- if EquipmentTypes["Paramedic"][MyCargoStopSign.EquipmentParamedicNr] == nil then
		-- MyCargoStopSign.EquipmentParamedicNr = 1
	-- end
	-- Set(MyCargoStopSign,"EquipmentParamedic",EquipmentNumbers["Paramedic"][MyCargoStopSign.EquipmentParamedicNr])
	-- CalloutEquipment = EquipmentTypes["Paramedic"][MyCargoStopSign.EquipmentParamedicNr]
	-- print(CalloutEquipment.." (number: "..MyCargoStopSign.EquipmentParamedic..")")
	-- this.SetInterfaceCaption("toggleEquipmentParamedic", "tooltip_CargoStation_Button_CalloutEquipmentParamedic","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Paramedic"][MyCargoStopSign.EquipmentParamedicNr],"X")
-- end

function toggleEquipmentArmedGuardClicked()
	MyCargoStopSign.EquipmentArmedGuardNr = MyCargoStopSign.EquipmentArmedGuardNr + 1
	if EquipmentTypes["ArmedGuard"][MyCargoStopSign.EquipmentArmedGuardNr] == nil then
		MyCargoStopSign.EquipmentArmedGuardNr = 1
	end
	Set(MyCargoStopSign,"EquipmentArmedGuard",EquipmentNumbers["ArmedGuard"][MyCargoStopSign.EquipmentArmedGuardNr])
	CalloutEquipment = EquipmentTypes["ArmedGuard"][MyCargoStopSign.EquipmentArmedGuardNr]
	print(CalloutEquipment.." (number: "..MyCargoStopSign.EquipmentArmedGuard..")")
	this.SetInterfaceCaption("toggleEquipmentArmedGuard", "tooltip_CargoStation_Button_CalloutEquipmentArmedGuard","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["ArmedGuard"][MyCargoStopSign.EquipmentArmedGuardNr],"X")
end

function toggleEquipmentRiotGuardClicked()
	MyCargoStopSign.EquipmentRiotGuardNr = MyCargoStopSign.EquipmentRiotGuardNr + 1
	if EquipmentTypes["RiotGuard"][MyCargoStopSign.EquipmentRiotGuardNr] == nil then
		MyCargoStopSign.EquipmentRiotGuardNr = 1
	end
	Set(MyCargoStopSign,"EquipmentRiotGuard",EquipmentNumbers["RiotGuard"][MyCargoStopSign.EquipmentRiotGuardNr])
	CalloutEquipment = EquipmentTypes["RiotGuard"][MyCargoStopSign.EquipmentRiotGuardNr]
	print(CalloutEquipment.." (number: "..MyCargoStopSign.EquipmentRiotGuard..")")
	this.SetInterfaceCaption("toggleEquipmentRiotGuard", "tooltip_CargoStation_Button_CalloutEquipmentRiotGuard","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["RiotGuard"][MyCargoStopSign.EquipmentRiotGuardNr],"X")
end

function toggleEquipmentSoldierClicked()
	MyCargoStopSign.EquipmentSoldierNr = MyCargoStopSign.EquipmentSoldierNr + 1
	if EquipmentTypes["Soldier"][MyCargoStopSign.EquipmentSoldierNr] == nil then
		MyCargoStopSign.EquipmentSoldierNr = 1
	end
	Set(MyCargoStopSign,"EquipmentSoldier",EquipmentNumbers["Soldier"][MyCargoStopSign.EquipmentSoldierNr])
	CalloutEquipment = EquipmentTypes["Soldier"][MyCargoStopSign.EquipmentSoldierNr]
	print(CalloutEquipment.." (number: "..MyCargoStopSign.EquipmentSoldier..")")
	this.SetInterfaceCaption("toggleEquipmentSoldier", "tooltip_CargoStation_Button_CalloutEquipmentSoldier","tooltip_CargoStation_CalloutEquipment_"..EquipmentTypes["Soldier"][MyCargoStopSign.EquipmentSoldierNr],"X")
end


function FindSomeEquipmentNumbers()
	local TestEntity = Object.Spawn("IntakeChinookPilot",this.Pos.x,this.Pos.y)
	for e = 0,1000 do
		TestEntity.Equipment = e
		if TestEntity.Equipment == "Extinguisher" then
			EquipmentNumbers["Fireman"][1] = e
			hoseFound = true
		end
		-- if TestEntity.Equipment == "SedativeSyringe" then
			-- EquipmentNumbers["Orderly"][1] = e
			-- syringeFound = true
		-- end
		if TestEntity.Equipment == "AK47" then
			EquipmentNumbers["ArmedGuard"][3] = e
			EquipmentNumbers["RiotGuard"][3] = e
			EquipmentNumbers["Soldier"][3] = e
			akFound = true
		end
		if hoseFound and syringeFound and akFound then break end
	end
	TestEntity.Delete()
end

function toggleLightsClicked()
	if Get(this,"LightsOn"..this.CargoSide) == true then
		RemoveWallLights(this.CargoSide)
		Set(this,"LightsOn"..this.CargoSide,nil)
	else
		RemoveWallLights(this.CargoSide)
		MakeWallLights(this.CargoSide)
		Set(this,"LightsOn"..this.CargoSide,true)
	end
	this.Sound("_Deployment","SetNone")
end

function toggleStationSubTypeClicked()
	if this.CargoFloor == "LARGE" then
		if this.SubType == 0 then
			this.SubType = 1
		elseif this.SubType == 1 then
			this.SubType = 2
		elseif this.SubType == 2 then
			this.SubType = 3
		elseif this.SubType == 3 then
			this.SubType = 4
		elseif this.SubType == 4 then
			this.SubType = 0
		end
	else
		if this.CargoSide == "RIGHT" then
			if this.SubType == 10 then
				this.SubType = 11
			elseif this.SubType == 11 then
				this.SubType = 12
			elseif this.SubType == 12 then
				this.SubType = 13
			elseif this.SubType == 13 then
				this.SubType = 14
			else
				this.SubType = 10
			end
		else
			if this.SubType == 5 then
				this.SubType = 6
			elseif this.SubType == 6 then
				this.SubType = 7
			elseif this.SubType == 7 then
				this.SubType = 8
			elseif this.SubType == 8 then
				this.SubType = 9
			else
				this.SubType = 5
			end
		end
	end
	this.SetInterfaceCaption("toggleStationSubType","tooltip_CargoStation_Button_SubType","tooltip_CargoStation_Button_"..CargoStationColour[this.SubType],"X")
	this.Sound("_Deployment","SetNone")
end

function UpdateTooltip()
	if this.CargoFloor == "COMPACT" then
		this.Tooltip = { "tooltip_CargoStation_Compact",this.HomeUID,"H",MyCargoStopSign.TrafficEnabled,"X","tooltip_CargoStation_"..MyCargoStopSign.CargoType,"Y" }
	else
		this.Tooltip = { "tooltip_CargoStation_Large",this.HomeUID,"H",MyCargoSignLeft.TrafficEnabled,"A","tooltip_CargoStation_"..MyCargoSignLeft.CargoType,"B",MyCargoSignRight.TrafficEnabled,"C","tooltip_CargoStation_"..MyCargoSignRight.CargoType,"D" }
	end
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end

function RemoveTrees(from,dist)
	for j = 1, #TreeTypes do
		for thatTree in next, Find(from,TreeTypes[j],dist) do
			thatTree.Delete()
		end
	end
	-- local nearbyTrees = Find(MyTreeRemover,"Tree",4)
	-- if next(nearbyTrees) then
		-- for thatTree, distance in pairs(nearbyTrees) do
			-- thatTree.Delete()
		-- end
	-- end
	-- nearbyTrees=nil
end

function RemoveStackClicked()
	if Get(MyCargoStopSign,"InUse") == "no" then
		print("RemoveStackClicked")
		if this.CargoFloor == "LARGE" then
			if this.CargoSide == "LEFT" then
				local removeChecker = Object.Spawn("LoadChecker",MyCargoSignLeft.CheckPointX,MyCargoSignLeft.CheckPointY)
				for j = 1, #ObjectsToLoad do
					for thatObject in next, Find(removeChecker,ObjectsToLoad[j],3) do
						thatObject.Delete()
					end
				end
				removeChecker.Delete()
			else
				local removeChecker = Object.Spawn("LoadChecker",MyCargoSignRight.CheckPointX,MyCargoSignRight.CheckPointY)
				for j = 1, #ObjectsToLoad do
					for thatObject in next, Find(removeChecker,ObjectsToLoad[j],3) do
						thatObject.Delete()
					end
				end
				removeChecker.Delete()
			end
		else
			local removeChecker = Object.Spawn("LoadChecker",MyCargoStopSign.CheckPointX,MyCargoStopSign.CheckPointY)
			for j = 1, #ObjectsToLoad do
				for thatObject in next, Find(removeChecker,ObjectsToLoad[j],3) do
					thatObject.Delete()
				end
			end
			removeChecker.Delete()
		end
		RemoveLoaders()
	end
end

function RemoveLoaders()
	print("RemoveLoaders")
	if this.CargoFloor == "LARGE" then
		if this.CargoSide == "LEFT" then
			local removeChecker = Object.Spawn("LoadChecker",MyCargoSignLeft.CheckPointX,MyCargoSignLeft.CheckPointY)
			for j = 1, #TruckBayObjects do
				for thatLoader in next, Find(removeChecker,TruckBayObjects[j],5) do
					if thatLoader.CargoStationID == MyCargoSignLeft.CargoStationID then
						print("Removed left loader")
						thatLoader.Delete()
					end
				end
			end
			removeChecker.Delete()
		else
			local removeChecker = Object.Spawn("LoadChecker",MyCargoSignRight.CheckPointX,MyCargoSignRight.CheckPointY)
			for j = 1, #TruckBayObjects do
				for thatLoader in next, Find(removeChecker,TruckBayObjects[j],5) do
					if thatLoader.CargoStationID == MyCargoSignRight.CargoStationID then
						print("Removed right loader")
						thatLoader.Delete()
					end
				end
			end
			removeChecker.Delete()
		end
	else
		local removeChecker = Object.Spawn("LoadChecker",MyCargoStopSign.CheckPointX,MyCargoStopSign.CheckPointY)
		for j = 1, #TruckBayObjects do
			for thatObject in next, Find(removeChecker,TruckBayObjects[j],5) do
				if thatObject.CargoStationID == MyCargoStopSign.CargoStationID then
					print("Removed loader")
					thatObject.Delete()
				end
			end
		end
		removeChecker.Delete()
	end
end

function DeleteStationClicked()
	this.Delete()
end

function RemoveFloor()
local CompactFloorLeft = {
			{ 1, 1, 1, 1, 2, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 1 },
			}
			
local CompactFloorRight = {
			{ 1, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 0, 0, 0, 2, 1, 1, 1, 1 },
			}
			
local LargeFloor = {
			{ 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 2, 1, 1, 1, 1 },
			{ 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 2, 1, 1, 1, 1 },
			}
			
local Tiles = {
			[0] = "Excluded", -- 0 = excluded from changing, since this is the road
			[1] = "LooseStone",
			[2] = "ConcreteTiles"
			}

	if this.CargoFloor == "COMPACT" then
		local CompactFloor = {}
		if this.CargoSide == "RIGHT" then CompactFloor = CompactFloorRight else CompactFloor = CompactFloorLeft end
		local x = this.Pos.x-5
		local y = this.Pos.y-5
		
		for X = 1,9 do
			for Y = 1,9 do
				local cell = World.GetCell(x+X,y+Y)
				if Tiles[CompactFloor[Y][X]] ~= "Excluded" then
					cell.Mat = Tiles[CompactFloor[Y][X]]
				end
				cell.Ind = false
			end
		end
	else
		local x = math.floor(this.Pos.x)-8
		local y = math.floor(this.Pos.y)-5
		for X = 1,15 do
			for Y = 1,9 do
				local cell = World.GetCell(x+X,y+Y)
				if Tiles[LargeFloor[Y][X]] ~= "Excluded" then
					cell.Mat = Tiles[LargeFloor[Y][X]]
				end
				cell.Ind = false
			end
		end
	end
end

function RemoveStationClicked()
	RemoveFloor()
	
	if this.CargoFloor == "LARGE" and Exists(MyRoadMarker) and FoundOtherCargoStation(MyRoadMarker) == false then
		MyRoadMarker.Delete()
		if Exists(MyRoadMarkerLeft) then
			MyRoadMarkerLeft.Delete()
		end
		if Exists(MyRoadMarkerRight) then
			MyRoadMarkerRight.Delete()
		end
		RemoveMyRoad("CENTRE","DOUBLE")
	elseif this.CargoFloor == "COMPACT" and Exists(MyRoadMarker) and FoundOtherCargoStation(MyRoadMarker) == false then
		MyRoadMarker.Delete()
		if this.CargoSide == "RIGHT" then
			RemoveMyRoad("LEFT","SINGLE")
		else
			RemoveMyRoad("RIGHT","SINGLE")
		end
	end
	
	for _, typ in pairs(CargoStationObjects) do
		local nearbyObjects = Find(this,typ,10000)
		for thatObject, _ in pairs(nearbyObjects) do
			if thatObject.Id.u ~= this.Id.u then
				if thatObject.Type == "CargoStationTruck" then
					if this.CargoFloor == "LARGE" then
						if (Get(thatObject,"CargoStationID") == MyCargoSignLeft.CargoStationID or Get(thatObject,"CargoStationID") == MyCargoSignRight.CargoStationID or Get(thatObject,"CargoStationID") == 0) then
							for __, driver in pairs(TruckDrivers) do
								local truckDrivers = Find(thatObject,driver,10)
								for thatTruckDriver, dist in pairs(truckDrivers) do
									if thatTruckDriver.TruckID == thatObject.Id.i then
										thatTruckDriver.Delete()
									end
								end
							end
							Set(thatObject,"DeleteMe",true)
						end
					else
						if (Get(thatObject,"CargoStationID") == MyCargoStopSign.CargoStationID or Get(thatObject,"CargoStationID") == 0) then
							for __, driver in pairs(TruckDrivers) do
								local truckDrivers = Find(thatObject,driver,10)
								for thatTruckDriver, dist in pairs(truckDrivers) do
									if thatTruckDriver.TruckID == thatObject.Id.i then
										thatTruckDriver.Delete()
									end
								end
							end
							Set(thatObject,"DeleteMe",true)
						end
					end
				elseif Get(thatObject,"MarkerUID") == this.MarkerUID and thatObject.HomeUID == this.HomeUID then
					thatObject.Delete()
				elseif Get(thatObject,"MarkerUID") == this.LeftMarkerUID and thatObject.HomeUID == this.HomeUID then
					thatObject.Delete()
				elseif Get(thatObject,"MarkerUID") == this.RightMarkerUID and thatObject.HomeUID == this.HomeUID then
					thatObject.Delete()
				end
			end
		end
	end
	
	for j = 1, #ObjectsToLoad do
		for thatObject in next, Find(this,ObjectsToLoad[j],8) do
			thatObject.Delete()
		end
	end
	
	this.Delete()
end

function FoundOtherCargoStation(myMarker)
	local sameLane = false
	for OtherStopSign in next, Find(this,"CargoStopSign",10000) do
		if OtherStopSign.Id.i ~= MyCargoStopSign.Id.i and OtherStopSign.RoadX == myMarker.Pos.x then
			sameLane = true
			break
		end
	end
	return sameLane
end
