--<Author: Brento666>--
--<Copyright: Brento666, the Netherlands, 2015>--
--<Don't redistribute: see base-language for cc>--

--IMPLEMENTED for version 0.777 > Unpacking job enabled
--IMPLEMENTED for version 0.777 > Button to start/pause unpacking added
--IMPLEMENTED for version 0.777 > Random present spawning from list of possible presents
--IMPLEMENTED for version 0.777 > Created 5 locations for spawning presents
--IMPLEMENTED for version 0.777 > Recording what presents spawn and reporting after all pressents spawn

--IMPLEMENTED for version 0.669 > Corrected tooltip texts

--IMPLEMENTED for version 0.668 > Second stage enabled:
--IMPLEMENTED for version 0.668 > -Presents are now brought to the tree by personel (occasionally)
--IMPLEMENTED for version 0.668 > -Personel now admired the tree (occasionally)

--IMPLEMENTED for version 0.667 (Release) > Sounds when top 3 positions of carolers are (partly) filled (not very good sounds atm)
--IMPLEMENTED for version 0.667 (Release) > Bare minimm structure for present spawn and unwrapping (both will be added to and enabled closer to Xmas)
--IMPLEMENTED for version 0.667 (Release) > Last minute change: personel in stead of prisoners now do the eventual gift-unwrapping!

--Possible future features:
--Unwrapping should leave custom garbage (shredded wrapping paper)
--Pinning down Sounds (and detection) for when unwrapping. (Shredding sounds and Excitement/Dissapointment)
--Snowball misschief

local timer = 0
local stage = 1
local chanters = 0
local buttons

local locations = {
	[1] = {["x"] = -1.2, ["y"] = 0.5},
	[2] = {["x"] = -1, ["y"] = 1.5},
	[3] = {["x"] = 0, ["y"] = 2},
	[4] = {["x"] = 1, ["y"] = 1.5},
	[5] = {["x"] = 1.2, ["y"] = 0.5}
}

local presents = {"BunkBed","Crib","PlayMat","Toilet","Chair","Cooker","Bin","Workman","Guard","ArmedGuard","Doctor","Cook","Gardener","Janitor","Bookshelf","SchoolDesk","FilingCabinet","Capacitor","MetalDetector","WeightsBench","PhoneBooth","Tv","Cctv","Servo","LaundryMachine","LaundryBasket","DogCrate","GuardLocker","WeaponRack","SofaChairSingle","SofaChairDouble","DrinkMachine","Radio","PrayerMat"}
--"Bed","JailDoor","SolitaryDoor","ShowerHead",
local received = {}

function Create()
	this.Presents = 0
end 

function Update(ticks)
	timer = timer + ticks
	if timer > 10 then
		timer = 0
		if chanters >= 2 then
			chanters = 0
		else
			for i = 1,3 do
				if this["Slot"..i].i ~= -1 then
					chanters = chanters + 1
				end
			end
			if chanters >= 2 then
				Caroling()
			end
		end
		if this.SubType > 0 then
			Unpack()
		else
			Pack()
	--		Unpack()
		end
	end
end

function Pack()
	if not this.Job and math.random() > 0.987 then
		this.Job = true
		if stage == 1 and this.Presents < 5 and math.random() > 0.6 then
			this.CreateJob("PackPresent")
		else
			this.CreateJob("AdmireTree")
		end
	end
end

function JobComplete_PackPresent()
    PlacePresent()
	this.Job = nil
end

function PlacePresent()
	if stage == 1 and this.Presents < 5 then
		this.Presents = this.Presents + 1
		if this.SubType <= 0 then
			this.SubType = 1
			this.Tooltip = "1 Present under the Tree"
		else
			this.Tooltip = this.Presents.." Presents under the Tree"
		end
		
	end
end

function TreeBtn1Clicked()
	if this.EnabledUnpack then
		this.EnabledUnpack = nil
		if this.Presents > 0 then
			this.SetInterfaceCaption("TreeBtn1", "christmas_interface_unpack")
		else
			this.RemoveInterfaceComponent("TreeBtn1", "Button", "christmas_interface_unpack")
		end
	else
		this.EnabledUnpack = true
		this.SetInterfaceCaption("TreeBtn1", "christmas_interface_stop")
	end
end

function Unpack()
	if stage == 7 and this.Presents > 0 then
		if this.EnabledUnpack then
			if not this.Job and math.random() > 0.987 then
				this.Job = true
				this.CreateJob("UnpackPresent")
			end
		elseif not buttons then
			this.AddInterfaceComponent("TreeBtn1", "Button", "christmas_interface_unpack")
			buttons = true
		end
	end
end

function JobComplete_UnpackPresent()
    SpawnGift()
	this.Job = nil
	if this.Presents <= 0 then
		this.RemoveInterfaceComponent("TreeBtn1", "Button", "christmas_interface_unpack")
	end
end

function SpawnGift()
	local Pos = locations[this.Presents]
	Pos.x = Pos.x + this.Pos.x
	Pos.y = Pos.y + this.Pos.y
	
	local gift = presents[math.random(#presents)]
	
	local present = Object.Spawn(gift, Pos.x, Pos.y)
	if not present then
		SpawnGift()
		return
	end
	
	RandomFloatOr(present)
	
	if not received[gift] then
		received[gift] = 1
	else
		received[gift] = received[gift] + 1
	end
	
	this.Presents = this.Presents - 1
	
	this.Sound("_Tools","HitBy_DogBite")
	--Echo("HitBy_DogBite")
	if this.Presents > 0 then
		if this.Presents == 1 then
			this.Tooltip = "1 Present under the Tree"
		else
			this.Tooltip = this.Presents.." Presents under the Tree"
		end
	else
		if this.SubType > 0 then
			this.SubType = 0
		end
		ReportPresents()
	end
end

function ReportPresents()
	--Echo("ReportPresents()")
	local giftstr = "Unpacked"
	for id, nr in pairs(received) do
		giftstr = (giftstr.." "..nr.." x "..id)
	end
	this.Tooltip = giftstr
end

function Caroling()
	this.Sound("Prisoner","Heckle")
	--Echo("Heckle")
end

function JobComplete_AdmireTree()
    --todo: make a sound?
	this.Job = nil
end

function round(num, idp, consistent)
	local mult = 10^(idp or 0)
	if consistent == true then
		mult = (""..(math.floor(num * mult + 0.5) / mult))
		if string.find(mult, '.', 1, true) == nil then
			return (mult..".0")
		end
		return mult
	end
	return math.floor(num * mult + 0.5) / mult
end

function RandomFloatOr(obj)
	if not obj then
		--this.Or.x = math.random(-10,10)/10.0
		--this.Or.y = math.random(-10,10)/10.0
	else
		obj.Or.x = math.random(-10,10)/10.0
		obj.Or.y = math.random(-10,10)/10.0
	end
end

function Echo(text)
    Game.DebugOut(text)
end