local timeTot = 0
local Find = this.GetNearbyObjects

function Create()
	this.HasCustomReport = true
	this.HomeUID = this.Id.u
	if not Exists(MyDetector) then
		MyDetector = Object.Spawn("MetalDetector",this.Pos.x-1.5,this.Pos.y-0.5)
		MyDetector.HomeUID = this.HomeUID
		MyDetector.Tooltip = "tooltip_isolatorcontrolbox2"
	end
	if not Exists(MyPrimarySwitch) then
		MyPrimarySwitch = Object.Spawn("PowerSwitch",this.Pos.x-0.5,this.Pos.y-0.5)
		MyPrimarySwitch.HomeUID = this.HomeUID
		MyPrimarySwitch.IsPrimary = true
		MyPrimarySwitch.Tooltip = "tooltip_isolatorprimaryswitch2"
	end
	if not Exists(MySecondarySwitch) then
		MySecondarySwitch = Object.Spawn("PowerSwitch",this.Pos.x+1.5,this.Pos.y-0.5)
		MySecondarySwitch.HomeUID = this.HomeUID
		MySecondarySwitch.IsSecondary = true
		MySecondarySwitch.Switch = false
		MySecondarySwitch.Tooltip = "tooltip_isolatorsecondaryswitch2"
	end
end

function FindMyStuff()
	local DoorTimerFound = false
	local PrimaryFound = false
	local SecondaryFound = false
	nearbyObject = Find("MetalDetector",3)
	for thatObject, dist in pairs(nearbyObject) do
		if thatObject.HomeUID == this.HomeUID then
			MyDetector = thatObject
			DoorTimerFound = true
		end
	end
	nearbyObject = Find("PowerSwitch",3)
	for thatObject, dist in pairs(nearbyObject) do
		if thatObject.HomeUID == this.HomeUID then
			if thatObject.IsPrimary == true then
				MyPrimarySwitch = thatObject
				PrimaryFound = true
			elseif thatObject.IsSecondary == true then
				MySecondarySwitch = thatObject
				SecondaryFound = true
			end
		end
	end
	nearbyObject = nil
	if DoorTimerFound == false or PrimaryFound == false or SecondaryFound == false then
		Create()
	end
end

function Update(timePassed)
	if timePerUpdate == nil then
		FindMyStuff()
		timePerUpdate = 0.25 / World.TimeWarpFactor
	else
		timeTot = timeTot + timePassed
		if timeTot >= timePerUpdate then
			timeTot = 0
			
			if not Exists(MyDetector) or not Exists(MyPrimarySwitch) or not Exists(MySecondarySwitch) then Create() end
		
			if MyDetector.On == true then
				MySecondarySwitch.Switch = false
				MyPrimarySwitch.Switch = true
				this.SubType = 0
			else
				MyPrimarySwitch.Switch = false
				MySecondarySwitch.Switch = true
				this.SubType = 1
			end
			
			if MyPrimarySwitch.Switch == true then this.Tooltip = "tooltip_controlbox_primary2" else this.Tooltip = "tooltip_controlbox_secondary2" end
				
		end
	end
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end

-- Custom Reports window

function SetTabNames()
	Interface.SetReportTabs( "reportTab_IsolatorTab1" )
end

function PopulateReport( tabIndex )
	tabIndex = tonumber( tabIndex)
    local w, h = Interface.GetReportWindowSize()
	if w == nil	or h == nil then return end
	
    w = w - 20  -- Top level canvas scrollbar
    
    local rowHeight = math.min(w, h) / 25.0
    local rowGap = rowHeight * 2
    local y = 0
    
    -- Title
    Interface.AddReportComponent( 
        {
            Type = "Title", 
            Caption = "reportTitle_IsolatorTitle"
        }
    )

    if tabIndex == 1 then
		Interface.AddReportComponent(
			{
				Type = "Caption", 
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 1.25, 
				Caption = "reportTooltip_CaptionIsolatorTips",
				Centred = true
			}
		)
		y = y + rowGap
		
		Interface.AddReportComponent(
			{
				Type = "MultiLineText", 
				Name = "IsolatorTips",
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 10, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_IsolatorTips"
			}
		)
		y = y + (rowHeight * 11) + rowGap
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgIsolatorPowerCableA", 
				X = 0,
				Y = y, 
				W = w, 
				H = w / 3, 
				File = "Report/report_IsolatorPowerCablesA.png", 
				Colour = "White"
			}
		)
		y = y + (rowHeight * 7) + rowGap
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgIsolatorPowerCableB", 
				X = 0,
				Y = y, 
				W = w, 
				H = w / 3, 
				File = "Report/report_IsolatorPowerCablesB.png", 
				Colour = "White"
			}
		)
	end
end
