
local timeTot = 0

local Find = Object.GetNearbyObjects
local Get = Object.GetProperty
local Set = Object.SetProperty

function Create()
	Set(this,"GatewayID",0)
	UpdateServers()
end

function UpdateServers()
	local nearbyServers = Find(this,"Server",10000)
	if next(nearbyServers) then
		for thatServer,dist in pairs(nearbyServers) do
			Set(thatServer,"UpdateClients",true)
		end
	end
end

function IsGatewayOrSwitch()
	if tonumber(this.TriggeredBy.i) > -1 and tonumber(this.TriggeredBy.i) == tonumber(this.GatewayID) then
		return true
	else
		--local ModuleTypes = { "NetworkSwitch", "LogicCircuit" }
		local ModuleTypes = { "LogicCircuit" }
		MyModule = nil
		for _, ModuleType in ipairs(ModuleTypes) do
			local Modules = Find(this,ModuleType,10000)
			for thatModule, _ in next, Modules do
				if thatModule.Id.i == tonumber(this.TriggeredBy.i) and thatModule.AvailableConnections ~= nil and tonumber(thatModule.AvailableConnections) > 0 then
					MyModule = thatModule
					Set(this,"GatewayID",this.TriggeredBy.i)
					break
				end
			end
			Modules = nil
		end
		if MyModule == nil then
			Set(this,"GatewayID",0)
			return false
		else
			return true
		end
	end
end

function Update( timePassed )
	if timePerUpdate == nil then
		timePerUpdate = (1+math.random()+math.random()) / World.TimeWarpFactor
	end
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if tonumber(this.Triggered) >= 4 and IsGatewayOrSwitch() == true then
			if tonumber(this.Slot0.i) > -1 then
				this.SubType = 1 --change display to on
				this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nIn use"
			else
				this.SubType = 0 --change display to off
				this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nReady to use"
			end
		else
			Set(this,"TriggeredBy.i",-1)
			Set(this,"TriggeredBy.u",-1)
			this.SubType = 0 --change display to off
			this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nNot connected to Gateway or Server is down"
		end
	end
end
