
local HourToHarvest = { [0] = "disabled", [1] = "01:00", [2] = "02:00", [3] = "03:00", [4] = "04:00", [5] = "05:00", [6] = "06:00", [7] = "07:00", [8] = "08:00", [9] = "09:00", [10] = "10:00", [11] = "11:00", [12] = "12:00", [13] = "13:00", [14] = "14:00", [15] = "15:00", [16] = "16:00", [17] = "17:00", [18] = "18:00", [19] = "19:00", [20] = "20:00", [21] = "21:00", [22] = "22:00", [23] = "23:00" }

function Create()
    Object.SetProperty(this,"PlantType", "Cotton")
	Object.SetProperty(this,"Tooltip","tooltip_need_CottonControl")
end

function JobComplete_PlantCottonSeed()
	Object.SetProperty(this,"IsEmpty", "No")
	Object.SetProperty(this,"AgeHours", 0.0)
	Object.SetProperty(this,"AgeMinutes", 0.0)
	if math.random() > .5 then
		Object.SetProperty(this,"SubType", 1)
			else
		Object.SetProperty(this,"SubType", 5)
	end
	Object.SetProperty(this,"RemainHarvest", math.random(3,6))			-- can be harvested 3-6 times before the plant is dead and a new seed must be planted

	if this.NeedsTending == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsTending", "Yes")
	end
	SetPlantTooltip()
end

function JobComplete_TendCottonPlant()
    Object.SetProperty(this,"NeedsTending","No")
	if this.NeedsDDT == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsDDT","Yes")
	end
	SetPlantTooltip()
end

function JobComplete_PruneCottonPlant()
	if math.random() > .5 then
		Object.SetProperty(this,"SubType", 1)
			else
		Object.SetProperty(this,"SubType", 5)
	end
	local name = Object.Spawn( "CottonPrunedPlant", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	Object.SetProperty(this,"NeedsPruning","No")
	if this.NeedsTending == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsTending","Yes")
	end
	SetPlantTooltip()
end

function JobComplete_WaterCottonPlant()
    Object.SetProperty(this,"NeedsWater","No")
	SetPlantTooltip()
end

function JobComplete_FertilizeCottonPlant()
    Object.SetProperty(this,"NeedsFerti","No")
	
	if this.NeedsDDT == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsDDT","Yes")
	end
	SetPlantTooltip()
end

function JobComplete_DDTCottonPlant()
    Object.SetProperty(this,"NeedsDDT","No")
	SetPlantTooltip()
end

function JobComplete_RemoveStruckCottonPlant()
	Object.CancelJob(this,"RemoveDeadCottonPlant")
	local name = Object.Spawn( "CottonPlantStruck", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	local newSeed = Object.Spawn( "CottonPlant", this.Pos.x, this.Pos.y )
	Object.SetProperty(newSeed,"SubType", 0)
	Object.SetProperty(newSeed,"Tooltip","tooltip_PlantSeed")
	this.Delete()
end

function JobComplete_RemoveDeadCottonPlant()
	Object.CancelJob(this,"RemoveStruckGardenPlant")
	local name = Object.Spawn( "CottonDeadPlant", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	local newSeed = Object.Spawn( "CottonPlant", this.Pos.x, this.Pos.y )
	Object.SetProperty(newSeed,"SubType", 0)
	Object.SetProperty(newSeed,"Tooltip","tooltip_PlantSeed")
	this.Delete()
end

function JobComplete_HarvestCottonPlant()
	Object.SetProperty(this,"AgeHours", 0.0)
	Object.SetProperty(this,"AgeMinutes", 0.0)
	
	Object.SetProperty(this,"IsRipe","No")
	
	local outNum = math.random(10)
	local name = Object.Spawn("Stack", this.Pos.x, this.Pos.y )
	Object.SetProperty(name,"Contents",this.RawCottonNr)
	Object.SetProperty(name,"Quantity",outNum)
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)

	if math.random() > .5 then
		Object.SetProperty(this,"SubType", 10)
			else
		Object.SetProperty(this,"SubType", 11)
	end
	if this.RemainHarvest == 0 then		-- harvest times before plant is dead and needs replacement
		Object.SetProperty(this,"IsDead", "Yes")
	else
		if this.NeedsPruning == "No" and this.IsRipe == "No" and this.IsDead == "No" then
			Object.SetProperty(this,"NeedsPruning","Yes")
			Object.SetProperty(this,"RemainHarvest", this.RemainHarvest-1)
		end
	end
	
	SetPlantTooltip()
end

function SetPlantTooltip()
	if this.IsDead =="Yes" then
		this.Tooltip = "tooltip_PlantDead"
	elseif this.IsEmpty =="Yes" then
		this.Tooltip = "tooltip_PlantSeed"
	else
		this.Tooltip = { "tooltip_PlantStatus",this.PlantType,"A",this.AgeHours,"B",this.AgeMinutes,"C",HourToHarvest[this.HarvestHour],"D",this.NeedsTending,"E",this.NeedsWater,"F",this.NeedsDDT,"G",this.NeedsFerti,"H",this.NeedsPruning,"I",this.IsRipe,"J", this.RemainHarvest,"K"}
	end
end
