
local timeInit = 0
local initTimer = 0.1 + math.random()	-- only used when object is placed down.
								-- this will prevent a dozen objects being placed down at the same time from starting to calculate
								-- the TimeWarp all at the same moment, give your potato a break and spread the cpu load a bit :)
local Now = 0
local StartingMinute = 0
local EndingMinute = 0

local myMapSize = "UNKNOWN"
local mySlowTime = "UNKNOWN"

local myTimeWarpFactor = 0
local timeWarpFound = false

local timeTot = 0

local maxAge = 24		-- 24 game hours
local deathAge = 32
local Get = Object.GetProperty
local Set = Object.SetProperty
local CurrentHour = math.floor(math.mod(World.TimeIndex,1440) /60)
local CurrentMinute = math.floor(math.mod(World.TimeIndex,60))
local myHarvestHour = 0		-- set to 0 (midnight) (=disabled)

local HourToHarvest = { [0] = "disabled", [1] = "01:00", [2] = "02:00", [3] = "03:00", [4] = "04:00", [5] = "05:00", [6] = "06:00", [7] = "07:00", [8] = "08:00", [9] = "09:00", [10] = "10:00", [11] = "11:00", [12] = "12:00", [13] = "13:00", [14] = "14:00", [15] = "15:00", [16] = "16:00", [17] = "17:00", [18] = "18:00", [19] = "19:00", [20] = "20:00", [21] = "21:00", [22] = "22:00", [23] = "23:00" }
local subToPlantType = { Cotton = 4 }
local plantTypeToSub = { [4] = "Cotton" }
local setPlantType=""
local PlantToFind = "CottonPlant"
local plantType = 4
local CoveredArea = {}
local plantRange = 5
local CottonNr = 1
local CompostNr = 1
local FertiNr = 1
local DDTNr = 1
local IngredientsNr = 1

function Create()
	if CurrentHour == 0 then							-- when placed at midnight set harvest hour to 11pm, otherwise it would say -1
		myHarvestHour = 23
	end
	Set(this,"HarvestHour", myHarvestHour)
	Set(this,"PlantType","Cotton")
	Set(this,"HarvestDone","No")
	Set(this,"DoorTimerDone","No")
	Set(this,"Range",5)
	Set(this,"LightSpawned",false)
	Set(this,"Tooltip","tooltip_Init_TimeWarpA")
end

function FindStackNumbers()
	local newStack = Object.Spawn("Stack", this.Pos.x-1, this.Pos.y)
	for i = 1,2000 do
		Set(newStack,"Quantity",2)
		Set(newStack,"Contents",i)
		if newStack.Contents == "Ingredients" then
			IngredientsNr = i
		elseif newStack.Contents == "CottonCompost" then
			CompostNr = i
		elseif newStack.Contents == "CottonFertilizer" then
			FertiNr = i
		elseif newStack.Contents == "RawCotton" then
			CottonNr = i
		elseif newStack.Contents == "CottonDDT" then
			DDTNr = i
		end
		if IngredientsNr > 1 and DDTNr > 1 and FertiNr > 1 and CompostNr > 1 and CottonNr > 1 then
			newStack.Delete()
			print("Stack Compost: "..CompostNr)
			print("Stack Ferti: "..FertiNr)
			print("Stack Cotton: "..CottonNr)
			print("Stack DDT: "..DDTNr)
			break
		end
	end
end

function CalculateTimeWarpFactor(timePassed)
	if timeInit > initTimer then
	
		if timePerUpdate == nil then
			Now = math.floor(math.mod(World.TimeIndex,60))
			if not StartCountdown then
				if Now ~= StartingMinute then
				--	this.SubType = 1
					StartingMinute = Now
					if Now < 59 then
						EndingMinute = Now + 1				-- calculate TimeWarp within the next minute
						StartCountdown = true
					else
						return				-- wait another minute if object is placed 1 minute before next whole hour
					end
				end
			else
				timeTot=timeTot+timePassed
				this.Tooltip = {"tooltip_Init_TimeWarpB",StartingMinute,"A",EndingMinute,"B",Now,"C",timeTot,"D" }	-- show stopwatch
				if Now >= StartingMinute+1 then
					if timeTot >= 5.4 then			-- the result should be around 8 (1/8) for large map with slow time enabled, compare with 5.4 to compensate for lag
						myTimeWarpFactor = 0.125
					--	this.SubType = 2
						myMapSize = "LARGE"
						mySlowTime = "YES"
						timeWarpFound = true
					elseif timeTot >= 4.1 then		-- the result should be around 5.33 (3/16) for medium map with slow time enabled
						myTimeWarpFactor = 0.1875
					--	this.SubType = 3
						myMapSize = "MEDIUM"
						mySlowTime = "YES"
						timeWarpFound = true
					elseif timeTot >= 2.1 then		-- the result should be around 4 (1/4) for small map with slow time enabled
						myTimeWarpFactor = 0.25
					--	this.SubType = 4
						myMapSize = "SMALL"
						mySlowTime = "YES"
						timeWarpFound = true
					elseif timeTot >= 1.4 then		-- the result should be around 2 (1/2) for large map
						myTimeWarpFactor = 0.5
					--	this.SubType = 5
						myMapSize = "LARGE"
						mySlowTime = "NO"
						timeWarpFound = true
					elseif timeTot >= 1.1 then		-- the result should be around 1.33 (3/4) for medium map
						myTimeWarpFactor = 0.75
					--	this.SubType = 6
						myMapSize = "MEDIUM"
						mySlowTime = "NO"
						timeWarpFound = true
					else							-- the result should be around 1 (1) for small map
						myTimeWarpFactor = 1
					--	this.SubType = 7
						myMapSize = "SMALL"
						mySlowTime = "NO"
						timeWarpFound = true
					end
					
					-- Instead of using the hard coded TimeWarp values (found in de saved game and mentioned above),
					-- you could also calculate your own by dividing 1 minute by the time it took to get to that minute.
					-- The result will be approximately the hard coded TimeWarp value, but can be different for each object you place,
					-- depending on how busy the game is, this is should not be used by default:
					
					--timeWarpFound = false					-- enable to see this calculation result in action
					--if timeWarpFound == false then myTimeWarpFactor = 1 / timeTot end
					
					this.Tooltip = {"tooltip_Init_TimeWarpC",StartingMinute,"A",EndingMinute,"B",Now,"C",timeTot,"D",myMapSize,"E",myTimeWarpFactor,"F",mySlowTime,"G" }	-- show results
					
					-- set the timePerUpdate here so we get out of this function
					timePerUpdate = 1 / myTimeWarpFactor	-- will show the results for 3 game minutes
				end
			end
		else		-- calculation completed, so save the results
			timeTot = timeTot+timePassed
			if timeTot > timePerUpdate then
			--	this.SubType = 0						-- change sprite back to normal
				Set(this,"TimeWarp",myTimeWarpFactor)	-- this tells function Update() to proceed
				this.Tooltip = "tooltip_ReadyForAction"
				timePerUpdate = nil				-- reset to nil so function Update() can proceed with normal activity
			end
		end
	else
		timeInit = timeInit+timePassed
		StartingMinute = math.floor(math.mod(World.TimeIndex,60))
	end
end


function toggleRemoveStackClicked()
	local myStacks = Find("Stack",this.Range+5)
	if next(myStacks) then
		for thatStack, dist in pairs(myStacks) do
			if thatStack.Contents == "CottonCompost" or thatStack.Contents == "CottonFertilizer" or thatStack.Contents == "CottonDDT" then thatStack.Delete() end
		end
	end
	myStacks = nil
end

--function toggleTypeClicked()
--	plantType=plantType+1
--	if plantType>9 then
--		plantType=3
--	end
--	setPlantType = plantTypeToSub[plantType]
--	Set(this,"PlantType",setPlantType)
--	this.SetInterfaceCaption("toggleType", "Type: "..this.PlantType.."")
--	Set(this,"PlantsFound",0)
--	local myPlants = Find(PlantToFind,this.Range)
--	if next(myPlants) then
--		for myPlant, dist in pairs(myPlants) do
--			Set(this,"PlantsFound",this.PlantsFound+1)
--			if myPlant.AgeHours ~= nil then
--				if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
--					if plantType == 9 then setPlantType = plantTypeToSub[math.random(3,8)] end
--					Set(myPlant,"PlantType",setPlantType)
--					local subType = 1
--					if myPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
--					subType = subToPlantType[Get(myPlant,"PlantType")]
--					Set(myPlant,"IsRipe", "Yes")
--					elseif myPlant.AgeHours >= 18 then
--						subType = subToPlantType[Get(myPlant,"PlantType")]
--					elseif myPlant.AgeHours >=12 then
--						subType = 2
--					end
--					if Get(myPlant,"SubType") ~= subType then
--						Set(myPlant,"SubType", subType)
--					end
--					SetPlantTooltip(myPlant)
--				end
--			else
--				InitPlant(myPlant,0.0)
--			end
--		end
--	end
--	myPlants = nil
--	SetMyTooltip()
--end

function togglePlantRangePlusClicked()
	if plantRange<=27 then
		if Covered==true then
			HideCoveredArea("Cotton")
			Covered=false
		end
		plantRange=plantRange+2
		Set(this,"Range",plantRange)
		Set(this,"PlantsFound",0)
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				if myPlant.IsEmpty ~= nil then
					if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
						local subType = myPlant.SubType
						local rndSubType = 0
						if myPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
						subType = subToPlantType[Get(myPlant,"PlantType")]
						Set(myPlant,"IsRipe", "Yes")
						elseif myPlant.AgeHours >= 18 then
							subType = subToPlantType[Get(myPlant,"PlantType")]+rndSubType
						elseif myPlant.AgeHours >=12 then
							subType = 3+rndSubType
						elseif myPlant.AgeHours >=6 then
							subType = 2+rndSubType
						end
						if myPlant.SubType ~= subType then
							myPlant.SubType = subType
						end
						SetPlantTooltip(myPlant)
					end
				else
					InitPlant(myPlant)
				end
			end
		end
		myPlants = nil
		this.SetInterfaceCaption("togglePlantRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredPlantArea", "tooltip_button_ShowHideRange",this.Range,"X")
		this.SetInterfaceCaption("togglePlantRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.Range,"Cotton")
		Covered=true
	end
	SetMyTooltip()
end

function toggleShowCoveredPlantAreaClicked()
--	if Covered==true then
--		HideCoveredArea("Cotton")
--		Covered=false
--	else
		ShowCoveredArea(this.Range,"Cotton")
--		Covered=true
--	end
end

function toggleLightningStrikeClicked()
	if this.Lightning == "Off" then
		Set(this,"Lightning","On")
	else
		Set(this,"Lightning","Off")
	end
	this.SetInterfaceCaption("toggleLightningStrike", "tooltip_button_ToggleLightning",this.Lightning,"X")
end

function togglePlantRangeMinusClicked()
	if plantRange>=5 then
		if Covered==true then
			HideCoveredArea("Cotton")
			Covered=false
		end
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				Set(myPlant,"SubType",9)
				Set(myPlant,"Tooltip","tooltip_CottonPlantNotManaged")
			end
		end
		plantRange=plantRange-2
		Set(this,"Range",plantRange)
		Set(this,"PlantsFound",0)
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				if myPlant.IsEmpty ~= nil then
					if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
						local subType = myPlant.SubType
						local rndSubType = 0
						if myPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
						subType = subToPlantType[Get(myPlant,"PlantType")]
						Set(myPlant,"IsRipe", "Yes")
						elseif myPlant.AgeHours >= 18 then
							subType = subToPlantType[Get(myPlant,"PlantType")]+rndSubType
						elseif myPlant.AgeHours >=12 then
							subType = 3+rndSubType
						elseif myPlant.AgeHours >=6 then
							subType = 2+rndSubType
						end
						if myPlant.SubType ~= subType then
							myPlant.SubType = subType
						end
						SetPlantTooltip(myPlant)
					end
				else
					InitPlant(myPlant)
				end
			end
		end
		myPlants = nil
		this.SetInterfaceCaption("togglePlantRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredPlantArea", "tooltip_button_ShowHideRange",this.Range,"X")
		this.SetInterfaceCaption("togglePlantRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.Range,"Cotton")
		Covered=true
	end
	SetMyTooltip()
end

function toggleHarvestHourPlusClicked()
	myHarvestHour=myHarvestHour+1
	if myHarvestHour>23 then
		myHarvestHour=0
	end
	Set(this,"HarvestHour",myHarvestHour)
	this.SetInterfaceCaption("toggleHarvestHour", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
	if myHarvestHour > 0 then
		local newAge = 0
		if CurrentHour > myHarvestHour then
			newAge = CurrentHour-myHarvestHour
		else
			newAge = CurrentHour-myHarvestHour+24
		end
		if CurrentHour == myHarvestHour then
			newAge = 0
		end
		AgePlants(newAge)
	else
		ResetHarvestHour()
	end
	SetMyTooltip()
end

function toggleHarvestHourClicked()
	if myHarvestHour > 0 then
		myHarvestHour=0
	else
		myHarvestHour = CurrentHour
		Set(this,"HarvestDone","Yes")
		AgePlants(0.0)
	end
	Set(this,"HarvestHour",myHarvestHour)
	this.SetInterfaceCaption("toggleHarvestHour", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
	ResetHarvestHour()
	SetMyTooltip()
end

function toggleHarvestHourMinusClicked()
	myHarvestHour=myHarvestHour-1
	if myHarvestHour<0 then
		myHarvestHour=23
	end
	Set(this,"HarvestHour",myHarvestHour)
	this.SetInterfaceCaption("toggleHarvestHour", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
	if myHarvestHour > 0 then
		local newAge = 0
		if CurrentHour > myHarvestHour then
			newAge = CurrentHour-myHarvestHour
		else
			newAge = CurrentHour-myHarvestHour+24
		end
		if CurrentHour == myHarvestHour then
			newAge = 0
		end
		AgePlants(newAge)
	else
		ResetHarvestHour()
	end
	SetMyTooltip()
end

function AgePlants(theAge)
	Set(this,"PlantsFound",0)
	local myPlants = Find(PlantToFind,this.Range)
	if next(myPlants) then
		for myPlant, dist in pairs(myPlants) do
			Set(this,"PlantsFound",this.PlantsFound+1)
			if myPlant.IsEmpty ~= nil then
				if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
					local subType = myPlant.SubType
					local rndSubType = 0
					Set(myPlant,"AgeHours",theAge)
					Set(myPlant,"HarvestHour",myHarvestHour)
					if myPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
						subType = subToPlantType[Get(myPlant,"PlantType")]
						Set(myPlant,"IsRipe", "Yes")
					elseif myPlant.AgeHours >= 18 then
						subType = subToPlantType[Get(myPlant,"PlantType")]+rndSubType
					elseif myPlant.AgeHours >=12 then
						subType = 3+rndSubType
					elseif myPlant.AgeHours >=6 then
						subType = 2+rndSubType
					end
					if myPlant.SubType ~= subType then
						myPlant.SubType = subType
					end
					SetPlantTooltip(myPlant)
				end
			else
				InitPlant(myPlant)
			end
		end
	end
	myPlants = nil
end

function ResetHarvestHour()
	Set(this,"PlantsFound",0)
	local myPlants = Find(PlantToFind,this.Range)
	if next(myPlants) then
		for myPlant, dist in pairs(myPlants) do
			Set(this,"PlantsFound",this.PlantsFound+1)
			if myPlant.IsEmpty ~= nil then
				if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
					Set(myPlant,"HarvestHour",myHarvestHour)
					SetPlantTooltip(myPlant)
				end
			else
				InitPlant(myPlant)
			end
		end
	end
	myPlants = nil
end

function HarvestPlants()
	Set(this,"PlantsFound",0)
	local myPlants = Find(PlantToFind,this.Range)
	if next(myPlants) then
		for myPlant, dist in pairs(myPlants) do
			Set(this,"PlantsFound",this.PlantsFound+1)
			if myPlant.IsEmpty ~= nil then
				if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" and myPlant.NeedsPruning == "No" then
					Set(myPlant,"IsRipe", "Yes")
					Set(myPlant,"NeedsPruning","No")
					Set(myPlant,"NeedsTending","No")
					Set(myPlant,"NeedsWater","No")
					Set(myPlant,"NeedsFerti","No")
					Set(myPlant,"NeedsDDT","No")
					Set(myPlant,"IsEmpty","No")
					Set(myPlant,"IsDead","No")
				--	Set(myPlant,"AgeHours",0.0)
				--	Set(myPlant,"AgeMinutes",0.0)
					Set(myPlant,"SubType",subToPlantType[Get(myPlant,"PlantType")])
					Set(myPlant,"HarvestHour",myHarvestHour)
					Set(myPlant,"RawCottonNr",CottonNr)
					Object.CancelJob(myPlant,"PlantCottonSeed")
					Object.CancelJob(myPlant,"RemoveDeadCottonPlant")
					Object.CancelJob(myPlant,"PruneCottonPlant")
					Object.CancelJob(myPlant,"TendCottonPlant")
					Object.CancelJob(myPlant,"WaterCottonPlant")
					Object.CancelJob(myPlant,"FertilizeCottonPlant")
					Object.CancelJob(myPlant,"DDTCottonPlant")
					Object.CreateJob(myPlant,"HarvestCottonPlant")
					SetPlantTooltip(myPlant)
				end
			else
				InitPlant(myPlant)
			end
		end
	end
	myPlants = nil
	toggleRemoveStackClicked()
	SpawnCompost()
	SpawnFerti()
	SpawnDDT()
end

function SpawnCompost()
	if this.PlantsFound > 0 then
		local newCompost = Object.Spawn("Stack",this.Pos.x-0.5,this.Pos.y)
		Set(newCompost,"Contents",CompostNr)
		Set(newCompost,"Quantity",this.PlantsFound)
	end
end

function SpawnFerti()
	if this.PlantsFound > 0 then
		local newFerti = Object.Spawn("Stack",this.Pos.x+0.6,this.Pos.y)
		Set(newFerti,"Contents",FertiNr)
		Set(newFerti,"Quantity",this.PlantsFound)
	end
end

function SpawnDDT()
	if this.PlantsFound > 0 then
		local newDDT = Object.Spawn("Stack",this.Pos.x-0.6,this.Pos.y)
		Set(newDDT,"Contents",DDTNr)
		Set(newDDT,"Quantity",this.PlantsFound)
	end
end

function InitPlant(thisPlant)
	local ourX = Get(thisPlant,"Pos.x")
	local ourY = Get(thisPlant,"Pos.y")
	local material = Object.GetMaterial( ourX, ourY )
	if material ~= "Farmland" then
		Set(thisPlant,"SubType",9)
		thisPlant.Tooltip = "tooltip_need_Compost"
	elseif thisPlant.IsEmpty == nil then
		Set(thisPlant,"SubType",0)
		Set(thisPlant,"IsEmpty","Yes")
		Set(thisPlant,"NeedsPruning","No")
		Set(thisPlant,"NeedsTending","No")
		Set(thisPlant,"NeedsWater","No")
		Set(thisPlant,"NeedsFerti","No")
		Set(thisPlant,"NeedsDDT","No")
		Set(thisPlant,"IsRipe","No")
		Set(thisPlant,"IsDead","No")
		Set(thisPlant,"HarvestHour",myHarvestHour)
		Set(thisPlant,"AgeHours",0.0)
		Set(thisPlant,"AgeMinutes",0.0)
		thisPlant.Tooltip = "tooltip_PlantSeed"
		Object.CreateJob(thisPlant,"PlantCottonSeed")
	end
end

function Update( timePassed )
	if this.TimeWarp == nil then
		if World.TimeWarpFactor ~= nil then
			Set(this,"TimeWarp",World.TimeWarpFactor)
			this.Tooltip = "tooltip_ReadyForAction"
		else
			CalculateTimeWarpFactor(timePassed)
		end
		return
	end
	if timePerUpdate == nil then
		FindStackNumbers()
		if this.LightSpawned == nil then Set(this,"LightSpawned",false) end
		if this.Lightning == nil then
			if World.EnabledEvents == true or World.EnabledWeather == true then
				Set(this,"Lightning","On")
			else
				Set(this,"Lightning","Off")
			end
		end
		myHarvestHour = Get(this,"HarvestHour")
		myTimeWarpFactor = Get(this,"TimeWarp")
		plantRange = Get(this,"Range")
		Interface.AddComponent(this,"togglePlantRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredPlantArea", "Button", "tooltip_button_ShowHideRange",this.Range,"X")
		Interface.AddComponent(this,"togglePlantRangeMinus", "Button", "tooltip_button_changerangeminus")

		Interface.AddComponent(this,"CaptionSeparatorCotton1", "Caption", "tooltip_separatorline")
		Interface.AddComponent(this,"toggleRemoveStack", "Button", "tooltip_removestack")
		Interface.AddComponent(this,"CaptionSeparatorCotton2", "Caption", "tooltip_separatorline")

		Interface.AddComponent(this,"toggleHarvestHourPlus", "Button", "tooltip_button_HarvestHourPlus")
		Interface.AddComponent(this,"toggleHarvestHour", "Button", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
		Interface.AddComponent(this,"toggleHarvestHourMinus", "Button", "tooltip_button_HarvestHourMinus")
	
		Interface.AddComponent(this,"CaptionSeparatorCotton3", "Caption", "tooltip_separatorline")
		Interface.AddComponent(this,"toggleLightningStrike", "Button", "tooltip_button_ToggleLightning",this.Lightning,"X")
		
		CurrentMinute = math.floor(math.mod(World.TimeIndex,60))
		if CurrentMinute >= 45 then
			timePerUpdate = (60 - CurrentMinute )+math.random()+math.random()+math.random() / myTimeWarpFactor	-- next update is ~1 minute after the next whole hour.
		elseif CurrentMinute >= 30 then
			timePerUpdate = (45 - CurrentMinute )+math.random()+math.random()+math.random() / myTimeWarpFactor	-- next update is ~15 minutes before the next whole hour.
		elseif CurrentMinute >= 15 then
			timePerUpdate = (30 - CurrentMinute )+math.random()+math.random()+math.random() / myTimeWarpFactor	-- next update is ~30 minutes past current hour.
		else
			timePerUpdate = (15 - CurrentMinute )+math.random()+math.random()+math.random() / myTimeWarpFactor	-- next update is ~15 minutes past current hour.
		end
		
		Set(this,"PlantsFound",0)
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				if myPlant.IsEmpty == nil then
					InitPlant(myPlant)
				else
					if myPlant.NeedsPruning == nil then myPlant.NeedsPruning = "No" end
					if myPlant.NeedsDDT == nil then myPlant.NeedsDDT = "No" end
					if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
						SetPlantTooltip(myPlant)
					end
				end
			end
		end
		myPlants = nil
		
		SetMyTooltip()
	end
	
	timeTot=timeTot+timePassed
	if timeTot>timePerUpdate then
		timeTot=0
		
		if myTimeWarpFactor < 1 then
			if myTimeWarpFactor == 0.75 then
				timePerUpdate = 20
			elseif myTimeWarpFactor == 0.5 then
				timePerUpdate = 30
			end
		else
			timePerUpdate = 15
		end
		
		PreviousHour = CurrentHour
		CurrentHour = math.floor(math.mod(World.TimeIndex,1440) /60)
		CurrentMinute = math.floor(math.mod(World.TimeIndex,60))
		
		if CurrentHour == 20 and this.LightSpawned == false then
			LightOn()
			Set(this,"LightSpawned",true)
		elseif CurrentHour == 6 and this.LightSpawned == true then
			LightOff()
			Set(this,"LightSpawned",false)
		end
		
		if CurrentHour ~= myHarvestHour and PreviousHour ~= CurrentHour then
			if CurrentHour == 8 or CurrentHour == 12 or CurrentHour == 16 or CurrentHour == 20 then
				SpawnFerti()
				SpawnDDT()
			end
		end
		
		
		-- forced harvest by game hour
		
		if CurrentHour == myHarvestHour and myHarvestHour > 0 then
			if this.HarvestDone == "No" then
				Set(this,"HarvestDone","Yes")
				HarvestPlants()
				SetMyTooltip()
				return
			end
		else
			if this.HarvestDone == "Yes" then
				Set(this,"HarvestDone","No")
			end
		end
		
		-- end harvest
		
		
		-- forced harvest by doortimer
		
		local hasPower = ( this.Triggered or 0 ) > 0
		if hasPower then
			if this.DoorTimerDone == "No" then
				myHarvestHour = CurrentHour
				Set(this,"HarvestHour",myHarvestHour)
				this.SetInterfaceCaption("toggleHarvestHour", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
				HarvestPlants()
				Set(this,"DoorTimerDone","Yes")
				SetMyTooltip()
				return
			end
		else
			if this.DoorTimerDone == "Yes" then
				Set(this,"DoorTimerDone","No")
			end
		end
		
		-- end doortimer
		
		
		Set(this,"PlantsFound",0)
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				
				if myPlant.IsEmpty == nil then
					InitPlant(myPlant)
				else
					if myPlant.IsEmpty == "No" then
						if myHarvestHour == 0 then	-- myHarvestHour 0 = forced harvest disabled, just let the plants grow until they reach maxAge
							Set(myPlant,"AgeMinutes", myPlant.AgeMinutes+15)
							if myPlant.AgeMinutes >= 60 then
								Set(myPlant,"AgeHours", myPlant.AgeHours+1)
								Set(myPlant,"AgeMinutes",myPlant.AgeMinutes-60)
							end
						else						-- forced harvest at specific hour, stricter growing times so all plants grow at same age
							Set(myPlant,"AgeMinutes", CurrentMinute)
							if PreviousHour~=CurrentHour then	-- set the exact age after the first hour passes, to not have big plants showing up after a seed was planted, this should somewhat cover it up
								if myPlant.IsRipe == "No" and myPlant.NeedsPruning == "No" then	
									local newAge = 0
									if CurrentHour > myHarvestHour then
										newAge = CurrentHour-myHarvestHour
									else
										newAge = CurrentHour-myHarvestHour+24
									end
									Set(myPlant,"AgeHours",newAge)
								else		-- if the plant is ripe then let the hours count up to maxAge+4
									Set(myPlant,"AgeHours",myPlant.AgeHours+1)
								end
							end
						end
						IssueWaterOrFertiJobs(myPlant)
						if myPlant.NeedsPruning == "No" and myPlant.IsRipe == "No" and myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
							local subType = myPlant.SubType
							local rndSubType = 0
							if math.random() > 0.5 then
								rndSubType = 4
							end
							if myPlant.AgeHours >= deathAge then	-- harvest failed within reasonable time, plant dies
								Set(myPlant,"IsDead","Yes")
								if math.random() > 0.5 then
									subType = 10
								else
									subType = 11
								end
							elseif myPlant.AgeHours >= maxAge then	-- plant life at 100% then harvest if myHarvestHour is disabled
								Set(myPlant,"IsRipe","Yes")
							elseif myPlant.AgeHours >= 18 then		-- show...
								subType = subToPlantType[Get(myPlant,"PlantType")]+rndSubType
							elseif myPlant.AgeHours >=12 then		-- ...different ...
								subType = 3+rndSubType
							elseif myPlant.AgeHours >=6 then		-- ...random...
								subType = 2+rndSubType
							end
							if math.random(0,666) == 11 then		-- oops, plant died for some reason
								Set(myPlant,"IsDead","Yes")
								if math.random() > 0.5 then
									subType = 10
								else
									subType = 11
								end
							end
							if myPlant.SubType ~= subType then
								myPlant.SubType = subType
							end
						end
					end
					
					if myPlant.IsRipe == "Yes" then
						Set(myPlant,"RawCottonNr",CottonNr)
						Object.CancelJob(myPlant,"PlantCottonSeed")
						Object.CancelJob(myPlant,"RemoveDeadCottonPlant")
						Object.CancelJob(myPlant,"PruneCottonPlant")
						Object.CancelJob(myPlant,"TendCottonPlant")
						Object.CancelJob(myPlant,"WaterCottonPlant")
						Object.CancelJob(myPlant,"FertilizeCottonPlant")
						Object.CancelJob(myPlant,"DDTCottonPlant")
						Object.CreateJob(myPlant,"HarvestCottonPlant")
					elseif myPlant.IsEmpty == "Yes" then
						Object.CreateJob(myPlant,"PlantCottonSeed")
					elseif myPlant.IsDead == "Yes" or myPlant.Damage > 0 then
						Object.CreateJob(myPlant,"RemoveDeadCottonPlant")
					elseif myPlant.NeedsPruning == "Yes" then
						Object.CreateJob(myPlant,"PruneCottonPlant")
					elseif CurrentHour >= 8 and CurrentHour <= 22 then
						if myPlant.NeedsTending == "Yes" then
							Object.CreateJob(myPlant,"TendCottonPlant")
						elseif myPlant.NeedsWater == "Yes" then
							Object.CreateJob(myPlant,"WaterCottonPlant")
						elseif myPlant.NeedsFerti == "Yes" then
							Object.CreateJob(myPlant,"FertilizeCottonPlant")
						elseif myPlant.NeedsDDT == "Yes" then
							Object.CreateJob(myPlant,"DDTCottonPlant")
						end
					end
					SetPlantTooltip(myPlant)
				end
			end
		end
		SetMyTooltip()
		myPlants = nil
		CheckLightning()
	end
end

function IssueWaterOrFertiJobs(thePlant)
	if CurrentHour ~= myHarvestHour and PreviousHour ~= CurrentHour then
		if CurrentHour == 8 or CurrentHour == 12 or CurrentHour == 16 or CurrentHour == 20 then
			if thePlant.NeedsPruning == "No" and thePlant.NeedsDDT == "No" and thePlant.NeedsTending == "No" and thePlant.NeedsFerti == "No" and thePlant.IsRipe == "No" and thePlant.IsEmpty == "No" and thePlant.IsDead == "No" then
				thePlant.NeedsFerti = "Yes"	-- do this stuff once at certain hours
			end
		end
	end
	if CurrentHour >= 8 and CurrentHour <= 22 then
		if thePlant.NeedsPruning == "No" and thePlant.NeedsDDT == "No" and thePlant.NeedsTending == "No" and thePlant.NeedsFerti == "No" and thePlant.IsRipe == "No" and thePlant.IsEmpty == "No" and thePlant.IsDead == "No" then
			thePlant.NeedsWater = "Yes" -- damn these plants drink a lot of water, up to 4x during these hours when they get to it
		end
	end
end

function SetMyTooltip()
	this.Tooltip = {"tooltip_PlantControl",HourToHarvest[this.HarvestHour],"A",this.PlantsFound,"B",this.Range,"C"}
end

function SetPlantTooltip(thePlant)
	if thePlant.IsDead =="Yes" then
		thePlant.Tooltip = "tooltip_PlantDead"
	elseif thePlant.IsEmpty =="Yes" then
		thePlant.Tooltip = "tooltip_PlantSeed"
	else
		thePlant.Tooltip = { "tooltip_PlantStatus",thePlant.PlantType,"A",thePlant.AgeHours,"B",thePlant.AgeMinutes,"C",HourToHarvest[thePlant.HarvestHour],"D",thePlant.NeedsTending,"E",thePlant.NeedsWater,"F",thePlant.NeedsDDT,"G",thePlant.NeedsFerti,"H",thePlant.NeedsPruning,"I",thePlant.IsRipe,"J",thePlant.RemainHarvest,"K"}
	end
end

function LightOn()
	local myLight = Object.Spawn("Light",this.Pos.x,this.Pos.y)
	Set(myLight,"Or.x",this.Or.x)
	Set(myLight,"Or.y",this.Or.y)
end

function LightOff()
	local myLight = this.GetNearbyObjects("Light",1)
	for thatLight, dist in pairs(myLight) do
		thatLight.Delete()
	end
	local myLight = this.GetNearbyObjects("LightOff",1)
	for thatLight, dist in pairs(myLight) do
		thatLight.Delete()
	end
	myLight = nil
end

function CheckLightning()
	if this.Lightning == "On" then
		if math.random(1,10000) == 666 then	-- sometimes shit just happens and lightning struck the plantation...
			Set(this,"PlantsFound",0)
			local myPlants = Find(PlantToFind,this.Range)
			if next(myPlants) then
				for myPlant, dist in pairs(myPlants) do
					Set(this,"PlantsFound",this.PlantsFound+1)
				end
			end
			local location = math.random(1,this.PlantsFound)
			local i = 0
			for thatLocation, dist in pairs(myPlants) do
				i=i+1
				if i==location then
					if math.random() > 0.5 then
						thatLocation.SubType = 12
					else
						thatLocation.SubType = 13
					end
					Set(thatLocation,"Damage", 0.85)
					Set(thatLocation,"IsDead","Yes")
					thatLocation.Sound("CottonPlant","Lightning")
					thatLocation.Tooltip = "tooltip_PlantStruck"
					Object.CreateJob(thatLocation,"RemoveStruckGardenPlant")
					
				--	newStruckPlant = Object.Spawn("CottonPlantStruck",thatLocation.Pos.x,thatLocation.Pos.y)
				--	newStruckPlant.Sound("CottonPlant","Lightning")
				--	newStruckPlant.Tooltip = "tooltip_PlantStruck"
				--	Object.CreateJob(newStruckPlant,"RemoveStruckCottonPlant")
					Object.Spawn("Fire",thatLocation.Pos.x-0.5+math.random(),thatLocation.Pos.y-0.5+math.random())
					Object.Spawn("Fire",thatLocation.Pos.x-0.5+math.random(),thatLocation.Pos.y-0.5+math.random())
					Object.Spawn("Fire",thatLocation.Pos.x-0.5+math.random(),thatLocation.Pos.y-0.5+math.random())
				--	thatLocation.Delete()
				end
			end
			this.Tooltip = "tooltip_PlantControlLightning"
			myPlants = nil
			return
		end
	end
end

function Find(theObject,theRange) -- returns target objects in a square around the object
	local Xmin=math.ceil(this.Pos.x-theRange/2)
	local Xmax=math.ceil(this.Pos.x+theRange/2)
	local Ymin=math.ceil(this.Pos.y-theRange/2)
	local Ymax=math.ceil(this.Pos.y+theRange/2)
	local ListOfObjects = this.GetNearbyObjects(theObject,theRange*1.2)
	for thatObject, distance in pairs(ListOfObjects) do
		if (thatObject.Pos.x>=Xmin and thatObject.Pos.x<=Xmax) and (thatObject.Pos.y>=Ymin and thatObject.Pos.y<=Ymax) then
		-- it's ok, put other stuff here if you need
		else
			ListOfObjects[thatObject]=nil -- remove the out of bounds object from the list
		end
	end
	return ListOfObjects
end	

function HideCoveredArea(theCoverType)
	for n,v in pairs(CoveredArea[theCoverType]) do
		CoveredArea[theCoverType][n].Delete()
	end
	CoveredArea[theCoverType] = nil
end

function ShowCoveredArea(theRange,theCoverType)
	local Xmin=math.ceil(this.Pos.x-theRange/2)
	local Xmax=math.ceil(this.Pos.x+theRange/2)
	local Ymin=math.ceil(this.Pos.y-theRange/2)
	local Ymax=math.ceil(this.Pos.y+theRange/2)
	local n=0
	CoveredArea[theCoverType] = {}
	for i=Ymin,Ymax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmin,i)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredPlantArea"}
		n=n+1
	end
	for i=Xmin,Xmax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymin)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredPlantArea"}
		n=n+1
	end
	for i=Ymin,Ymax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmax,i)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredPlantArea"}
		n=n+1
	end
	for i=Xmin,Xmax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymax)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredPlantArea"}
		n=n+1
	end
end
