--<Author: Brento666>--
--<Copyright: Brento666, the Netherlands, 2015>--
--<Don't redistribute: see base-language for cc>--

--IMPLEMENTED for version 0.668 > Fix: Connection reset on Cancel click -> Now another detonator can couple!

--IMPLEMENTED for version 0.667 (Release) > Now using new Api function for Interface Buttons!
--IMPLEMENTED for version 0.667 (Release) > Charge that can be detonated manually or together with others by a wireless detonator
--IMPLEMENTED for version 0.667 (Release) > User in-game sounds during countdown, then Spawns "Aftermath"!

--Possible future features:
--btr gfx (subtypes w. flashing lights)
--make a true wired object(?)
--spawn object that makes people avoid radius of Charge(!)

--Ideas:
--C4 with larger radius
--Breach Charges to blow-out single portions of wall fast
--Mines


local timer = 0
local nextTimeout = 0.2
local init

local msg = { 
	"tooltip_explosivecharge0",
	"tooltip_explosivecharge1",
	"tooltip_explosivecharge2",
	"tooltip_explosivecharge3"
}

function Create()
	this.State = 0
	this.Loaded = true
	
	Init()
	
	--this.SubType = 0
	
	RandomFloatOr()
	
	this.CreateJob("PlaceExplosiveCharge")
end

function Init()
	Echo("Init")
	if not this.Countdown then this.Countdown = 3 end
	if this.State > 0 then
		local t = tostring(math.ceil(this.Countdown - 0.5)).."s"
		--this.AddInterfaceComponent("ChargeBtn1", "Button", "mymod_interface_cancelX", "X", t)
		this.AddInterfaceComponent("ChargeBtn1", "Button", "Cancel Detonation ("..t..")")
	else
		this.AddInterfaceComponent("ChargeBtn1", "Button", "mymod_interface_manual")
	end
	if this.State < 1 then
		this.Idle = true
	end
	init = true
end

function Update(timePassed)
    timer = timer + timePassed;
    if timer > nextTimeout then
		if not init then Init() end
		if this.Idle then 
			nextTimeout = 5
			this.Tooltip = NextMsg()
		else
			nextTimeout = IntervalUpdate(timer)
		end
        timer = 0
    end   
end   

function IntervalUpdate(timePassed)
	if this.State == 0 then--check for detonator
		if this.Armed then
			--todo: update sprite
			--todo: add state lookup
			--todo: add global Idle toggle
			this.State = 1
			local t = tostring(math.ceil(this.Countdown - 0.5)).."s"
			--this.SetInterfaceCaption("ChargeBtn1", "mymod_interface_cancelX", "X", t)
			this.SetInterfaceCaption("ChargeBtn1", "Cancel Detonation ("..t..")")
			this.SubType = 2
			return 1
		end
	elseif this.State == 1 then--wired:check for trigger&wire
		if this.Armed then
			if this.Cued then
				--todo: update sprite
				this.State = 2
				this.Countdown = 4
				--Object.Spawn("Avoid666", this.Pos.x, this.Pos.y)
				return 1
			end
			return 0.5
		else
			this.State = 0
			this.Cued = nil
			--todo: reset sprite
			this.SetInterfaceCaption("ChargeBtn1", "mymod_interface_manual")
			this.SubType = 1
			this.Idle = true
		end
	elseif this.State == 2 then--countdown
		if this.Armed and this.Cued then
			if this.Countdown > 0 then
				local t = tostring(math.ceil(this.Countdown - 0.5)).."s"
				if this.SubType == 1 then
					this.SubType = 2
					this.Sound("Chef", "Place")--bleeps
				else
					this.SubType = 1
				end
				this.Tooltip = ("Detonation in " ..t.." seconds")
				--this.SetInterfaceCaption("ChargeBtn1", "mymod_interface_cancelX", "X", t)
				this.SetInterfaceCaption("ChargeBtn1", "Cancel Detonation ("..t..")")
				this.Countdown = this.Countdown - timePassed
				return 0.5
			else
				this.Detonated = true
				Object.Spawn("Aftermath666", this.Pos.x, this.Pos.y)
				this.Delete()
			end
			return 1
		elseif this.Armed then
			this.State = 1
			--this.SetInterfaceCaption("ChargeBtn1", "mymod_interface_cancelX", "X", "3s")
			this.SetInterfaceCaption("ChargeBtn1", "Cancel Detonation (5s)")
			--todo: update sprite
		else
			this.State = 0
			this.Cued = nil
			this.Idle = true
			--todo: update sprite
			this.SetInterfaceCaption("ChargeBtn1", "mymod_interface_manual")
		end
	end
	return 3
end

function JobComplete_PlaceExplosiveCharge()
    this.SubType = 1
end

function ChargeBtn1Clicked()
	if this.Armed then
	    --Echo("Cancel Click!")
		this.State = 0
		this.Armed = nil
		this.Cued = nil
		this.Connected = nil
		this.SetInterfaceCaption("ChargeBtn1", "mymod_interface_manual")
		this.Idle = true
	else
		--Echo("Manual Click!")
		this.State = 1
		this.Armed = true
		this.Cued = true
		this.SetInterfaceCaption("ChargeBtn1", "mymod_interface_cancel")
		this.Idle = nil
	end
end

function RandomFloatOr(obj)
	if not obj then
		this.Or.x = math.random(-10,10)/10.0
		this.Or.y = math.random(-10,10)/10.0
	else
		obj.Or.x = math.random(-10,10)/10.0
		obj.Or.y = math.random(-10,10)/10.0
	end
end

--
function NextMsg()
	local m = msg[m_count]
	if m == nil then
		m_count = 0
		m = msg[0]
	end
	m_count = m_count + 1
	return m
end

function Echo(text)
    Game.DebugOut(text)
end