
local timeTot = 0

local Find = Object.GetNearbyObjects
local Get = Object.GetProperty
local Set = Object.SetProperty

function Create()
	Set(this,"DefaultSubType",this.SubType)
	Set(this,"NeedsRepair",false)
	Set(this,"HasVirus",false)
	Set(this,"Locked",false)
	Set(this,"GatewayID",0)
	ComputerIsLocked(true)
	UpdateServers()
end

function UpdateServers()
	local nearbyServers = Find(this,"Server",10000)
	if next(nearbyServers) then
		for thatServer,dist in pairs(nearbyServers) do
			Set(thatServer,"UpdateClients",true)
		end
	end
end

function IsGatewayOrSwitch()
	if tonumber(this.TriggeredBy.i) > -1 and tonumber(this.TriggeredBy.i) == tonumber(this.GatewayID) then
		return true
	else
		--local ModuleTypes = { "NetworkSwitch", "LogicCircuit" }
		local ModuleTypes = { "LogicCircuit" }
		MyModule = nil
		for _, ModuleType in ipairs(ModuleTypes) do
			local Modules = Find(this,ModuleType,10000)
			for thatModule, _ in next, Modules do
				if thatModule.Id.i == tonumber(this.TriggeredBy.i) and thatModule.AvailableConnections ~= nil and tonumber(thatModule.AvailableConnections) > 0 then
					MyModule = thatModule
					Set(this,"GatewayID",this.TriggeredBy.i)
					break
				end
			end
			Modules = nil
		end
		if MyModule == nil then
			Set(this,"GatewayID",0)
			return false
		else
			return true
		end
	end
end

function MakeUserMad()
	local myUser = Find(this,"Prisoner",2)
	if next(myUser) then
		for thatUser, dist in pairs(myUser) do
			if thatUser.Id.i == this.Slot0.i then
				this.Slot0.i = -1
				this.Slot0.u = -1
				thatUser.CarrierId.i = -1
				thatUser.CarrierId.u = -1
				thatUser.Loaded = false
				local rndChance = math.random()
				if rndChance >= 0.8 then
					thatUser.Misbehavior = 3
				end
				break
			end
		end
	else
		this.Slot0.i = -1
		this.Slot0.u = -1
	end
end

function CheckVirusChance()
	local rndChance1 = math.random(0,5000)
	if rndChance1 == 666 then
		Set(this,"HasVirus",true)
	end
end

function CheckNeedsRepairChance()
	local rndChance1 = math.random(0,5000)
	if rndChance1 == 666 then
		Set(this,"NeedsRepair",true)
	end
end

function InfectComputer()
	myVirus = Object.Spawn("ComputerVirus",this.Pos.x,this.Pos.y)
	this.Slot0.i = myVirus.Id.i
	this.Slot0.u = myVirus.Id.u
	myVirus.CarrierId.i = this.Id.i
	myVirus.CarrierId.u = this.Id.u
	myVirus.Loaded = true
	myVirus.Hidden = true
	this.SubType = Get(this,"DefaultSubType") + 2
end

function ShutdownComputer()
	myFailure = Object.Spawn("ComputerFailure",this.Pos.x,this.Pos.y)
	this.Slot0.i = myFailure.Id.i
	this.Slot0.u = myFailure.Id.u
	myFailure.CarrierId.i = this.Id.i
	myFailure.CarrierId.u = this.Id.u
	myFailure.Loaded = true
	myFailure.Hidden = true
	this.SubType = Get(this,"DefaultSubType")
end

function ComputerIsLocked(setState)
	if setState == true then
		myLock = Object.Spawn("ComputerLock",this.Pos.x,this.Pos.y)
		this.Slot0.i = myLock.Id.i
		this.Slot0.u = myLock.Id.u
		myLock.CarrierId.i = this.Id.i
		myLock.CarrierId.u = this.Id.u
		myLock.Loaded = true
		myLock.Hidden = true
		this.SubType = Get(this,"DefaultSubType") + 2
		Set(this,"Locked",true)
	else
		myLock = Find(this,"ComputerLock",2)
		if next(myLock) then
			for thatLock, dist in pairs(myLock) do
				if thatLock.Id.i == this.Slot0.i then
					this.Slot0.i = -1
					this.Slot0.u = -1
					thatLock.CarrierId.i = -1
					thatLock.CarrierId.u = -1
					thatLock.Loaded = false
					thatLock.Delete()
					break
				end
			end
		end
		Set(this,"Locked",false)
	end
end

function Update( timePassed )
	if timePerUpdate == nil then
		timePerUpdate = (1+math.random()+math.random()) / World.TimeWarpFactor
		if this.NeedsRepair == nil then Set(this,"NeedsRepair",false) end
	end
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if tonumber(this.Triggered) >= 4 and IsGatewayOrSwitch() == true then
		
			if Get(this,"Locked") == true then ComputerIsLocked(false) end
			if tonumber(this.Slot0.i) > -1 then
				if this.NeedsRepair == false then
					if this.HasVirus == false then
						this.SubType = Get(this,"DefaultSubType") + 1 --change display to on
						this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nIn use"
						CheckVirusChance()
						CheckNeedsRepairChance()
					else
						if this.SubType ~= Get(this,"DefaultSubType") + 2 then
							MakeUserMad()
							InfectComputer()
						end
						this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nThis computer needs maintenance"
						Object.CreateJob(this,"RemoveVirus")
					end
				else
					if this.SubType ~= Get(this,"DefaultSubType") then
						MakeUserMad()
						ShutdownComputer()
					end
					this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nThis computer needs to be repaired"
					Object.CreateJob(this,"RepairComputer")
				end
			else
				this.SubType = Get(this,"DefaultSubType") --change display to off
				this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nReady to use"
			end
			
		else
			Set(this,"TriggeredBy.i",-1)
			Set(this,"TriggeredBy.u",-1)
			if this.SubType == Get(this,"DefaultSubType") + 1 then
				MakeUserMad()
			end
			if Get(this,"Locked") == false then
				ComputerIsLocked(true)
			end
			this.SubType = Get(this,"DefaultSubType") --change display to off
			this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nNot connected to Gateway or Server is down"
		end
	end
end

function JobComplete_RepairComputer()
	local myFailure = Find(this,"ComputerFailure",2)
	if next(myFailure) then
		for thatFailure, dist in pairs(myFailure) do
			if thatFailure.Id.i == this.Slot0.i then
				this.Slot0.i = -1
				this.Slot0.u = -1
				thatFailure.CarrierId.i = -1
				thatFailure.CarrierId.u = -1
				thatFailure.Loaded = false
				thatFailure.Delete()
				Set(this,"NeedsRepair",false)
				Object.CancelJob(this,"RepairComputer")
				this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nReady to use"
				this.SubType = Get(this,"DefaultSubType")
				break
			end
		end
	end
end

function JobComplete_RemoveVirus()
	local myVirus = Find(this,"ComputerVirus",2)
	if next(myVirus) then
		for thatVirus, dist in pairs(myVirus) do
			if thatVirus.Id.i == this.Slot0.i then
				this.Slot0.i = -1
				this.Slot0.u = -1
				thatVirus.CarrierId.i = -1
				thatVirus.CarrierId.u = -1
				thatVirus.Loaded = false
				thatVirus.Delete()
				Set(this,"HasVirus",false)
				Object.CancelJob(this,"RemoveVirus")
				this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nReady to use"
				this.SubType = Get(this,"DefaultSubType")
				break
			end
		end
	end
end
