
local HourToHarvest = { [0] = "disabled", [1] = "01:00", [2] = "02:00", [3] = "03:00", [4] = "04:00", [5] = "05:00", [6] = "06:00", [7] = "07:00", [8] = "08:00", [9] = "09:00", [10] = "10:00", [11] = "11:00", [12] = "12:00", [13] = "13:00", [14] = "14:00", [15] = "15:00", [16] = "16:00", [17] = "17:00", [18] = "18:00", [19] = "19:00", [20] = "20:00", [21] = "21:00", [22] = "22:00", [23] = "23:00" }

function Create()
--    Object.SetProperty(this,"PlantType", "Cotton")
	Object.SetProperty(this,"Tooltip","tooltip_need_GardenControl")
end

function JobComplete_PlantGardenSeed()
    Object.SetProperty(this,"IsEmpty", "No")
	Object.SetProperty(this,"AgeHours", 0.0)
	Object.SetProperty(this,"AgeMinutes", 0.0)
--	if math.random() > .5 then
		Object.SetProperty(this,"SubType", 1)
--			else
--		Object.SetProperty(this,"SubType", 5)
--	end
	Object.SetProperty(this,"RemainHarvest", math.random(3,6))			-- can be harvested 3-6 times before the plant is dead and a new seed must be planted

	if this.NeedsTending == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsTending", "Yes")
	end
	SetPlantTooltip()
end

function JobComplete_TendGardenPlant()
    Object.SetProperty(this,"NeedsTending","No")
	if this.NeedsDDT == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsDDT","Yes")
	end
	SetPlantTooltip()
end

function JobComplete_PruneGardenPlant()
--	if math.random() > .5 then
		Object.SetProperty(this,"SubType", 1)
--			else
--		Object.SetProperty(this,"SubType", 5)
--	end
	local name = Object.Spawn( "GardenPrunedPlant", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	Object.SetProperty(this,"NeedsPruning","No")
	if this.NeedsTending == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsTending","Yes")
	end
	SetPlantTooltip()
end

function JobComplete_WaterGardenPlant()
    Object.SetProperty(this,"NeedsWater","No")
	SetPlantTooltip()
end

function JobComplete_FertilizeGardenPlant()
    Object.SetProperty(this,"NeedsFerti","No")
	
	if this.NeedsDDT == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsDDT","Yes")
	end
	SetPlantTooltip()
end

function JobComplete_DDTGardenPlant()
    Object.SetProperty(this,"NeedsDDT","No")
	SetPlantTooltip()
end

function JobComplete_RemoveStruckGardenPlant()
	Object.CancelJob(this,"RemoveDeadGardenPlant")
	local name = Object.Spawn( "GardenPlantStruck", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	local newSeed = Object.Spawn( "GardenPot2Remote", this.Pos.x, this.Pos.y )
	Object.SetProperty(newSeed,"SubType", 0)
	Object.SetProperty(newSeed,"PlantType", this.PlantType)
	Object.SetProperty(newSeed,"Tooltip","tooltip_PlantSeed")
	this.Delete()
end

function JobComplete_RemoveDeadGardenPlant()
	Object.CancelJob(this,"RemoveStruckGardenPlant")
	local name = Object.Spawn( "GardenDeadPlant", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	local newSeed = Object.Spawn( "GardenPot2Remote", this.Pos.x, this.Pos.y )
	Object.SetProperty(newSeed,"SubType", 0)
	Object.SetProperty(newSeed,"PlantType", this.PlantType)
	Object.SetProperty(newSeed,"Tooltip","tooltip_PlantSeed")
	this.Delete()
end

function JobComplete_HarvestGardenPlant()
	Object.SetProperty(this,"AgeHours", 0.0)
	Object.SetProperty(this,"AgeMinutes", 0.0)
	
	Object.SetProperty(this,"IsRipe","No")
	
	local outNum = math.random(10)
	if this.PlantType=="Potatoes" then
		local name = Object.Spawn("Stack", this.Pos.x, this.Pos.y )
		Object.SetProperty(name, "Contents",this.IngredientsNr)	-- http://devwiki.introversion.co.uk/pa/index.php/ModSchema
	 	Object.SetProperty(name, "SubType",1)			
		Object.SetProperty(name, "Quantity",20)
		local velX = -1.0 + math.random() + math.random()
		local velY = -1.0 + math.random() + math.random()
		Object.ApplyVelocity(name, velX, velY)
	elseif this.PlantType=="Ingredients" then
		local name = Object.Spawn("Stack", this.Pos.x, this.Pos.y )
		Object.SetProperty(name, "Contents",this.IngredientsNr)	-- http://devwiki.introversion.co.uk/pa/index.php/ModSchema
	 	Object.SetProperty(name, "SubType",0)			
		Object.SetProperty(name, "Quantity",20)			-- ingredients/potatoes always give stack of 20
		local velX = -1.0 + math.random() + math.random()
		local velY = -1.0 + math.random() + math.random()
		Object.ApplyVelocity(name, velX, velY)
	else
		for i = 1, outNum do				-- the number of outcome is between 1 and 20
		 	local name = Object.Spawn( this.PlantType, this.Pos.x, this.Pos.y )
			local velX = -1.0 + math.random() + math.random()
			local velY = -1.0 + math.random() + math.random()
			Object.ApplyVelocity(name, velX, velY)
		end
	end
	
--	if math.random() > .5 then
--		Object.SetProperty(this,"SubType", 10)
--			else
		Object.SetProperty(this,"SubType", 2)
--	end
	if this.RemainHarvest == 0 then		-- harvest times before plant is dead and needs replacement
		Object.SetProperty(this,"IsDead", "Yes")
	else
		if this.NeedsPruning == "No" and this.IsRipe == "No" and this.IsDead == "No" then
			Object.SetProperty(this,"NeedsPruning","Yes")
		end
		if this.PlantType~="Potatoes" and this.PlantType~="Ingredients" then
			Object.SetProperty(this,"RemainHarvest", this.RemainHarvest-1)
		end
	end
	
	SetPlantTooltip()
end







function JobComplete_PlantGreenhouseSeed()
    Object.SetProperty(this,"IsEmpty", "No")
	Object.SetProperty(this,"AgeHours", 0.0)
	Object.SetProperty(this,"AgeMinutes", 0.0)
--	if math.random() > .5 then
		Object.SetProperty(this,"SubType", 1)
--			else
--		Object.SetProperty(this,"SubType", 5)
--	end
	Object.SetProperty(this,"RemainHarvest", math.random(3,6))			-- can be harvested 3-6 times before the plant is dead and a new seed must be planted

	if this.NeedsTending == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsTending", "Yes")
	end
	SetPlantTooltip()
end

function JobComplete_TendGreenhousePlant()
    Object.SetProperty(this,"NeedsTending","No")
	if this.NeedsDDT == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsDDT","Yes")
	end
	SetPlantTooltip()
end

function JobComplete_PruneGreenhousePlant()
--	if math.random() > .5 then
		Object.SetProperty(this,"SubType", 1)
--			else
--		Object.SetProperty(this,"SubType", 5)
--	end
	local name = Object.Spawn( "GardenPrunedPlant", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	Object.SetProperty(this,"NeedsPruning","No")
	if this.NeedsTending == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsTending","Yes")
	end
	SetPlantTooltip()
end

function JobComplete_WaterGreenhousePlant()
    Object.SetProperty(this,"NeedsWater","No")
	SetPlantTooltip()
end

function JobComplete_FertilizeGardenPlant()
    Object.SetProperty(this,"NeedsFerti","No")
	
	if this.NeedsDDT == "No" and this.IsRipe == "No" and this.IsDead == "No" then
		Object.SetProperty(this,"NeedsDDT","Yes")
	end
	SetPlantTooltip()
end

function JobComplete_DDTGreenhousePlant()
    Object.SetProperty(this,"NeedsDDT","No")
	SetPlantTooltip()
end

function JobComplete_RemoveStruckGreenhousePlant()
	Object.CancelJob(this,"RemoveDeadGardenPlant")
	local name = Object.Spawn( "GardenPlantStruck", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	local newSeed = Object.Spawn( "GardenPot2Remote", this.Pos.x, this.Pos.y )
	Object.SetProperty(newSeed,"SubType", 0)
	Object.SetProperty(newSeed,"PlantType", this.PlantType)
	Object.SetProperty(newSeed,"Tooltip","tooltip_PlantSeed")
	this.Delete()
end

function JobComplete_RemoveDeadGreenhousePlant()
	Object.CancelJob(this,"RemoveStruckGardenPlant")
	local name = Object.Spawn( "GardenDeadPlant", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	local newSeed = Object.Spawn( "GardenPot2Remote", this.Pos.x, this.Pos.y )
	Object.SetProperty(newSeed,"SubType", 0)
	Object.SetProperty(newSeed,"PlantType", this.PlantType)
	Object.SetProperty(newSeed,"Tooltip","tooltip_PlantSeed")
	this.Delete()
end

function JobComplete_HarvestGreenhousePlant()
	Object.SetProperty(this,"AgeHours", 0.0)
	Object.SetProperty(this,"AgeMinutes", 0.0)
	
	Object.SetProperty(this,"IsRipe","No")
	
	local outNum = math.random(10)
	if this.PlantType=="Potatoes" then
		local name = Object.Spawn("Stack", this.Pos.x, this.Pos.y )
		Object.SetProperty(name, "Contents",this.IngredientsNr)	-- http://devwiki.introversion.co.uk/pa/index.php/ModSchema
	 	Object.SetProperty(name, "SubType",1)			
		Object.SetProperty(name, "Quantity",20)
		local velX = -1.0 + math.random() + math.random()
		local velY = -1.0 + math.random() + math.random()
		Object.ApplyVelocity(name, velX, velY)
	elseif this.PlantType=="Ingredients" then
		local name = Object.Spawn("Stack", this.Pos.x, this.Pos.y )
		Object.SetProperty(name, "Contents",this.IngredientsNr)	-- http://devwiki.introversion.co.uk/pa/index.php/ModSchema
	 	Object.SetProperty(name, "SubType",0)			
		Object.SetProperty(name, "Quantity",20)			-- ingredients/potatoes always give stack of 20
		local velX = -1.0 + math.random() + math.random()
		local velY = -1.0 + math.random() + math.random()
		Object.ApplyVelocity(name, velX, velY)
	else
		for i = 1, outNum do				-- the number of outcome is between 1 and 20
		 	local name = Object.Spawn( this.PlantType, this.Pos.x, this.Pos.y )
			local velX = -1.0 + math.random() + math.random()
			local velY = -1.0 + math.random() + math.random()
			Object.ApplyVelocity(name, velX, velY)
		end
	end
	
--	if math.random() > .5 then
--		Object.SetProperty(this,"SubType", 10)
--			else
		Object.SetProperty(this,"SubType", 2)
--	end
	if this.RemainHarvest == 0 then		-- harvest times before plant is dead and needs replacement
		Object.SetProperty(this,"IsDead", "Yes")
	else
		if this.NeedsPruning == "No" and this.IsRipe == "No" and this.IsDead == "No" then
			Object.SetProperty(this,"NeedsPruning","Yes")
		end
		if this.PlantType~="Potatoes" and this.PlantType~="Ingredients" then
			Object.SetProperty(this,"RemainHarvest", this.RemainHarvest-1)
		end
	end
	
	SetPlantTooltip()
end

function SetPlantTooltip()
	if this.IsDead =="Yes" then
		this.Tooltip = "tooltip_PlantDead"
	elseif this.IsEmpty =="Yes" then
		this.Tooltip = "tooltip_PlantSeed"
	else
		this.Tooltip = { "tooltip_PlantStatus",this.PlantType,"A",this.AgeHours,"B",this.AgeMinutes,"C",HourToHarvest[this.HarvestHour],"D",this.NeedsTending,"E",this.NeedsWater,"F",this.NeedsDDT,"G",this.NeedsFerti,"H",this.NeedsPruning,"I",this.IsRipe,"J", this.RemainHarvest,"K"}
	end
end
