
local Find = Object.GetNearbyObjects
local Get = Object.GetProperty
local Set = Object.SetProperty

local DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler",
				"Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }

local ModdedEntities = { "SystemAdministrator", "ComputerNerd", "SimulationOfficeManager", "YogaMaster",
				"GraveDigger", "LotteryOfficial", "ForestryWorker", "BarberChief", "Barber",
				"CarMechanic2", "CraneOperator2", "SmartPhoneGenius", "GardenWorker",
				"GreenhouseWorker", "PlantationWorker", "Tailor", "TeslaMaticExpert", "ShadyTeslaDude"
				 }

local FiremanEntities = { "PrisonFiremanA0", "PrisonFiremanA1", "PrisonFiremanA2", "PrisonFiremanA3",
				"PrisonFiremanB0", "PrisonFiremanB1", "PrisonFiremanB2", "PrisonFiremanB3",
				"PrisonFiremanC0", "PrisonFiremanC1", "PrisonFiremanC2", "PrisonFiremanC3",
				"PrisonFiremanD0", "PrisonFiremanD1", "PrisonFiremanD2", "PrisonFiremanD3"
				 }

local ExternalEntities = {}				


local TotalDefaultEntities = #DefaultEntities
local TotalModdedEntities = #ModdedEntities
local TotalFiremanEntities = #FiremanEntities
local TotalExternalEntities = #ExternalEntities

local CurrentDefaultEntity = 1
local CurrentModdedEntity = 1
local CurrentFiremanEntity = 1
local CurrentExternalEntity = 1
local TipCurrentDefaultEntity = "Workman"
local TipCurrentModdedEntity = "SystemAdministrator"
local TipCurrentFiremanEntity = "PrisonFiremanA0"
local TipCurrentExternalEntity = "Murgh"

local MetroStations = {}
local TotalMetros = 1

local timeTot = 0
local timeToCleanTooltip = 0
local timePerCleanup = 5

local subToMetroType = { STAFF = 0, HQ = 1, DELIVERIES = 2, EXPORTS = 3, KITCHEN = 4, WORKSHOP = 5, TAZER = 6, GUARDS = 7, SNIPERS = 8, EXECUTION = 9, TOILETS = 10, CANTEEN = 11, NURSERY = 12, STAFFROOM = 13, STORAGE = 14, KENNEL = 15, ARMOURY = 16, TOWER = 17, OFFICE = 18, PLANTATION = 19, GARDEN = 20, MINSEC = 21, MEDSEC = 22, MAXSEC = 23, SUPERMAX = 24, INSANE = 25, PROTECTED = 26, DEATHROW = 27, RECEPTION = 28, CELLBLOCK = 29, SOLITARY = 30, FORESTRY = 31, FIREMAN = 32, FIREBRIGADE = 33, ACCOUNTING = 34, RECYCLING = 35, BARBER = 36, WOODSHOP = 37, FACTORY = 38, SECURITY = 39, YARD = 40, CEMETERY = 41, CHAPEL = 42, CLASSROOM = 43, EXECUTION = 44, EXIT = 45, PAROLE = 46, PRISON = 47, VISITORS = 48, MORGUE = 49, INFIRMARY = 50, LAUNDRY = 51 }

local metroGroups = { [1] = "Cell", [2] = "Logistics", [3] = "Staff", [4] = "Reform", [5] = "External" }

local nrToGroup = { Cell = 1, Logistics = 2, Staff = 3, Reform = 4, External = 5 }

local metroNames = { [1] = {
						[1] = "MINSEC",
						[2] = "MEDSEC",
						[3] = "MAXSEC",
						[4] = "SUPERMAX",
						[5] = "INSANE",
						[6] = "PROTECTED",
						[7] = "DEATHROW",
						[8] = "SOLITARY",
						[9] = "CELLBLOCK",
						[10] = "RECEPTION" },
					[2] = {
						[1] = "CANTEEN",
						[2] = "DELIVERIES",
						[3] = "EXPORTS",
						[4] = "INFIRMARY",
						[5] = "KITCHEN",
						[6] = "LAUNDRY",
						[7] = "MORGUE",
						[8] = "NURSERY",
						[9] = "RECYCLING",
						[10] = "STAFFROOM",
						[11] = "STORAGE",
						[12] = "TOILETS",
						[13] = "YARD" },
					[3] = {
						[1] = "ARMOURY",
						[2] = "EXECUTION",
						[3] = "FIREBRIGADE",
						[4] = "FIREMAN",
						[5] = "GUARDS",
						[6] = "HQ",
						[7] = "KENNEL",
						[8] = "OFFICE",
						[9] = "SECURITY",
						[10] = "SNIPERS",
						[11] = "STAFF",
						[12] = "STAFFROOM",
						[13] = "TOILETS",
						[14] = "TOWER" },
					[4] = {
						[1] = "ACCOUNTING",
						[2] = "BARBER",
						[3] = "CEMETERY",
						[4] = "CHAPEL",
						[5] = "CLASSROOM",
						[6] = "FACTORY",
						[7] = "FORESTRY",
						[8] = "GARDEN",
						[9] = "LAUNDRY",
						[10] = "OFFICE",
						[11] = "PAROLE",
						[12] = "PLANTATION",
						[13] = "TAZER",
						[14] = "VISITORS",
						[15] = "WOODSHOP",
						[16] = "WORKSHOP" },
					[5] = {
						[1] = "CEMETERY",
						[2] = "CHAPEL",
						[3] = "CLASSROOM",
						[4] = "EXECUTION",
						[5] = "EXIT",
						[6] = "PAROLE",
						[7] = "PRISON",
						[8] = "VISITORS" }
					}

local selectedGroup = 3
local selectedName = 11
local ScanHistory1Tooltip = ""
local ScanHistory2Tooltip = ""
local ScanHistory3Tooltip = ""
local ScanHistory4Tooltip = ""
local ScanHistory5Tooltip = ""

local MetroPrice = 0.01


function Create()
	Set(this,"HomeUID","Metro_"..me["id-uniqueId"])
	Set(this,"MetroType","STAFF")
	Set(this,"MetroGroup","3")
	Set(this,"MetroName","11")
	Set(this,"MetroLight","On")
	Set(this,"MetroSign","On")
	Set(this,"MetroWalls","Hide")
	Set(this,"MetroSize","Small")
	Set(this,"MetroEarnings",0)
	Set(this,"MetroScan","DefaultOnly")
	Set(this,"MetroPrisoners","NO")
	Set(this,"MetroEarnings",0)
	Set(this,"Version",2.5)
	Set(this,"MyTooltip","")
end

function FindMapEdge()
	if World.NumCellsY ~= nil and World.NumCellsX ~= nil then
		Set(this,"MapBottom",World.NumCellsY-1)
		Set(this,"MapSide",World.NumCellsX-1)
	else
		local endX=-1
		local foundEndX=false
		local endY=-1
		local foundEndY=false
		
		while foundEndY==false do
			endY=endY+1
			local myCell = World.GetCell(this.Pos.x,endY)
			if myCell.Mat==nil then
				foundEndY=true
				endY=endY-1
			end
		end
		Set(this,"MapBottom",endY)

		while foundEndX==false do
			endX=endX+1
			local myCell = World.GetCell(endX,0)
			if myCell.Mat==nil then
				foundEndX=true
				endX=endX-1
			end
		end
		Set(this,"MapSide",endX)
	end
	--print("FindMapEdge: MapBottom "..this.MapBottom)
	--print("FindMapEdge: MapSide "..this.MapSide)
end

function FindMyBeacon()
	beaconFound = false
	nearbyBeacons = Find("Metro2Beacon",10000)
	for thatBeacon, dist in pairs(nearbyBeacons) do
		MyBeacon = thatBeacon
		MyBeaconHash = thatBeacon.MetroHash
		if MyBeacon.NewMetroTotal == 0 then MyBeacon.Update = true end
		beaconFound = true
		--print("FindMyBeacon: Metro2Beacon found")
	end
	if beaconFound == false then
		FindMapEdge()
		MyBeacon = Object.Spawn("Metro2Beacon",this.MapSide-12,1)
		Set(MyBeacon,"OriginX",this.MapSide-12)
		Set(MyBeacon,"OriginY",1)
		MyBeaconHash = ""
		beaconFound = true
		--print("FindMyBeacon: Metro2Beacon spawned")
	end
end

function CacheMetroStations()
	if MyBeacon.NewMetroTotal > 0 then
		print("CacheMetroStations: started")
		TotalMetros = 1
		MetroStations = {}
		local i = 0
		local done = false
		while not done do
			i = i + 1
			if Get(MyBeacon,"Metro_"..i.."_PosX") ~= nil then
				--print("CacheMetroStations: Check station "..i)
				MetroStations[i] = {}
				MetroStations[i].HomeUID = Get(MyBeacon,"Metro_"..i.."_HomeUID")
				MetroStations[i].MetroType = Get(MyBeacon,"Metro_"..i.."_MetroType")
				MetroStations[i].MetroScan = Get(MyBeacon,"Metro_"..i.."_MetroScan")
				MetroStations[i].PosX = Get(MyBeacon,"Metro_"..i.."_PosX")
				MetroStations[i].PosY = Get(MyBeacon,"Metro_"..i.."_PosY")
				MetroStations[i].MetroPrisoners = Get(MyBeacon,"Metro_"..i.."_MetroPrisoners")
				if MetroStations[i].HomeUID ~= this.HomeUID then
					local dX1 = this.Pos.x
					local dX2 = MetroStations[i].PosX
					local dY1 = this.Pos.y
					local dY2 = MetroStations[i].PosY
					local DistanceToMetro = math.sqrt((dX2-dX1)^2+(dY2-dY1)^2)
					MetroStations[i].FromHereToThere = DistanceToMetro
				else
					MetroStations[i].FromHereToThere = 0
				end
				--print("CacheMetroStations: Found "..MetroStations[i].HomeUID.." Type: "..MetroStations[i].MetroType.." at X:"..MetroStations[i].PosX.." Y:"..MetroStations[i].PosY.." FromHereToThere = "..MetroStations[i].FromHereToThere)
				TotalMetros = i
			else
				--print("CacheMetroStations: All stations cached")
				done = true
				for s = 0,7 do	-- unload the signs and lights to save cpu cycles
					Set(this,"Slot"..s..".i",-1)
					Set(this,"Slot"..s..".u",-1)
				end
			end
		end
		MyBeaconHash = Get(MyBeacon,"MetroHash")
		Set(this,"MyTooltip",this.Tooltip)
	else
		--print("CacheMetroStations: waiting for NewMetroTotal")
		return
	end
end

function UpdateBeacon(stationRemoved)
	--print("UpdateBeacon")
	if not Exists(MyBeacon) then FindMyBeacon() end
	local i = 0
	local done = false
	while not done do
		i = i + 1
		if Get(MyBeacon,"Metro_"..i.."_HomeUID") ~= nil then
			if Get(MyBeacon,"Metro_"..i.."_HomeUID") == this.HomeUID then
				done = true
			end
		else
			done = true
		end
	end
	if stationRemoved == true then
		Set(this,"IsRemoved",true)
		MyBeacon.Delete()
		FindMapEdge()
		MyBeacon = Object.Spawn("Metro2Beacon",this.MapSide-12,1)
		Set(MyBeacon,"OriginX",this.MapSide-12)
		Set(MyBeacon,"OriginY",1)
		--print("UpdateBeacon: spawned new beacon")
	else
		Set(MyBeacon,"Metro_"..i.."_HomeUID",this.HomeUID)
		Set(MyBeacon,"Metro_"..i.."_MetroType",this.MetroType)
		Set(MyBeacon,"NewMetroTotal",0)
		Set(MyBeacon,"Update",true)
		--print("UpdateBeacon: beacon update set")
	end
end

function FindMySpawnPoint()
	if MyBeacon.NewMetroTotal > 0 then
		local spawnFound = false
		nearbySpawnPoints = Find("Metro2Location",4)
		for thatSpawnPoint, dist in pairs(nearbySpawnPoints) do
			if thatSpawnPoint.HomeUID == this.HomeUID then
				MySpawnPoint = thatSpawnPoint
				--print("FindMySpawnPoint: MySpawnPoint found")
				spawnFound = true
			end
		end
		if spawnFound == false then
			Set(MyBeacon,"NewMetroTotal",0)
			Set(MyBeacon,"Update",true)
			--print("FindMySpawnPoint: MySpawnPoint not found, updating beacon")
		end
	else
		CacheMetroStations()
	end
end

function toggleMetroTypeGroupClicked()
	selectedGroup = selectedGroup + 1
	if selectedGroup > #metroGroups then
		selectedGroup = 1
	end
	Set(this,"MetroGroup",selectedGroup)
	this.SetInterfaceCaption("toggleMetroTypeGroup", "tooltip_button_changetypegroup",metroGroups[selectedGroup],"X")
	if metroGroups[selectedGroup] == "External" then
		SetEntitiesToScan()
		Set(this,"MetroScan","ExternalOnly")
		DefaultEntities = {}
		Set(this,"MetroPrisoners","NO")
		DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
		CurrentDefaultEntity = 1
		TotalDefaultEntities = #DefaultEntities
		this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
		this.SetInterfaceCaption("toggleMetroScan", this.MetroScan)
	elseif metroGroups[selectedGroup] == "Cell" then
		Set(this,"MetroScan","DefaultOnly")
		this.SetInterfaceCaption("toggleMetroScan", this.MetroScan)
		if this.MetroPrisoners == "NO" then
			DefaultEntities = {}
			Set(this,"MetroPrisoners","YES")
			DefaultEntities = { "Prisoner", "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
			CurrentDefaultEntity = 1
			TotalDefaultEntities = #DefaultEntities
			this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
		end
	elseif metroGroups[selectedGroup] == "Staff" then
		DefaultEntities = {}
		Set(this,"MetroPrisoners","NO")
		DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
		CurrentDefaultEntity = 1
		TotalDefaultEntities = #DefaultEntities
		this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
	elseif metroGroups[selectedGroup] == "Reform" then
		Set(this,"MetroScan","Default+Mods")
		this.SetInterfaceCaption("toggleMetroScan", this.MetroScan)
		if this.MetroPrisoners == "NO" then
			DefaultEntities = {}
			Set(this,"MetroPrisoners","YES")
			DefaultEntities = { "Prisoner", "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
			CurrentDefaultEntity = 1
			TotalDefaultEntities = #DefaultEntities
			this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
		end
	end
	
	selectedName = 0
	toggleMetroTypePlusClicked()
end

function toggleMetroTypePlusClicked()
	local setMetroType = ""
	selectedName = selectedName + 1
	if selectedName > #metroNames[selectedGroup] then
		selectedName = 1
	end
	Set(this,"MetroName",selectedName)
	--print("selectedGroup: "..selectedGroup.." selectedName: "..selectedName)
	setMetroType = metroNames[selectedGroup][selectedName]
	--print("setMetroType: "..setMetroType)
	Set(this,"MetroType",setMetroType)
	
	if metroGroups[selectedGroup] == "External" then
		SetEntitiesToScan()
		if this.MetroType ~= "EXIT" then
			DefaultEntities = {}
			Set(this,"MetroPrisoners","NO")
			DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
			CurrentDefaultEntity = 1
			TotalDefaultEntities = #DefaultEntities
		else
			DefaultEntities = {}
			Set(this,"MetroPrisoners","YES")
			DefaultEntities = { "Prisoner", "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
			CurrentDefaultEntity = 1
			TotalDefaultEntities = #DefaultEntities
		end
		this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
	elseif this.MetroType == "FIREBRIGADE" or this.MetroType == "FIREMAN" then
		Set(this,"MetroScan","FireBrigade")
		DefaultEntities = {}
		Set(this,"MetroPrisoners","NO")
		DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
		CurrentDefaultEntity = 1
		TotalDefaultEntities = #DefaultEntities
		this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
		this.SetInterfaceCaption("toggleMetroScan", this.MetroScan)
	elseif this.MetroType == "EXECUTION" or this.MetroType == "GUARDS" then
		Set(this,"MetroScan","DefaultOnly")
		DefaultEntities = {}
		Set(this,"MetroPrisoners","NO")
		DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
		CurrentDefaultEntity = 1
		TotalDefaultEntities = #DefaultEntities
		this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
		this.SetInterfaceCaption("toggleMetroScan", this.MetroScan)
	end
	RemoveSigns()
	MakeSigns()
	UpdateBeacon(false)
	this.SetInterfaceCaption("CaptionMetroType", this.MetroType)
end

function toggleMetroTypeMinusClicked()
	local setMetroType = ""
	selectedName = selectedName - 1
	if selectedName < 1 then
		selectedName = #metroNames[selectedGroup]
	end
	Set(this,"MetroName",selectedName)
	--print("selectedGroup: "..selectedGroup.." selectedName: "..selectedName)
	setMetroType = metroNames[selectedGroup][selectedName]
	--print("setMetroType: "..setMetroType)
	Set(this,"MetroType",setMetroType)
	
	if metroGroups[selectedGroup] == "External" then
		SetEntitiesToScan()
		if this.MetroType ~= "EXIT" then
			DefaultEntities = {}
			Set(this,"MetroPrisoners","NO")
			DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
			CurrentDefaultEntity = 1
			TotalDefaultEntities = #DefaultEntities

		else
			DefaultEntities = {}
			Set(this,"MetroPrisoners","YES")
			DefaultEntities = { "Prisoner", "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
			CurrentDefaultEntity = 1
			TotalDefaultEntities = #DefaultEntities
		end
		this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
	elseif this.MetroType == "FIREBRIGADE" or this.MetroType == "FIREMAN" then
		Set(this,"MetroScan","FireBrigade")
		DefaultEntities = {}
		Set(this,"MetroPrisoners","NO")
		DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
		CurrentDefaultEntity = 1
		TotalDefaultEntities = #DefaultEntities
		this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
		this.SetInterfaceCaption("toggleMetroScan", this.MetroScan)
	elseif this.MetroType == "EXECUTION" or this.MetroType == "GUARDS" then
		Set(this,"MetroScan","DefaultOnly")
		DefaultEntities = {}
		Set(this,"MetroPrisoners","NO")
		DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
		CurrentDefaultEntity = 1
		TotalDefaultEntities = #DefaultEntities
		this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
		this.SetInterfaceCaption("toggleMetroScan", this.MetroScan)
	end
	RemoveSigns()
	MakeSigns()
	UpdateBeacon(false)
	this.SetInterfaceCaption("CaptionMetroType", this.MetroType)
end

function toggleMetroSizeClicked()
	RemoveObjects()
	if this.MetroWalls == "Show" then
		RemoveWalls()
	else
		RemoveSlowFloor()
	end
	if this.SubType == 0 then
		this.SubType = 1
		Set(this,"MetroSize","Dead End L")
	elseif this.SubType == 1 then
		this.SubType = 2
		Set(this,"MetroSize","Crossing S")
	elseif this.SubType == 2 then
		this.SubType = 3
		Set(this,"MetroSize","Crossing L")
	elseif this.SubType == 3 then
		this.SubType = 4
		Set(this,"MetroSize","Junction S")
	elseif this.SubType == 4 then
		this.SubType = 5
		Set(this,"MetroSize","Junction L")
	else
		this.SubType = 0
		Set(this,"MetroSize","Dead End S")
	end
	this.SetInterfaceCaption("toggleMetroSize", this.MetroSize)
	if this.MetroWalls == "Hide" then
		MakeSlowFloor()
	else
		MakeWalls()
		--MakeSlowFloor()
	end
	if this.MetroSign == "On" then
		MakeSigns()
	end
	if this.MetroLight == "On" then
		MakeLights()
	end
	UpdateBeacon(false)
end

function toggleMetroRotateClicked()
	RemoveObjects()
	if this.MetroWalls == "Show" then
		RemoveWalls()
	else
		RemoveSlowFloor()
	end
	if this.Or.x == 0 and this.Or.y == 1 then
		this.PosX = this.PosX-0.5
		this.PosY = this.PosY+2.5
		this.Or.x = -1
		this.Or.y = 0
	elseif this.Or.x == -1 and this.Or.y == 0 then
		this.PosX = this.PosX+0.5
		this.PosY = this.PosY-4.5
		this.Or.x = 0
		this.Or.y = -1
	elseif this.Or.x == 0 and this.Or.y == -1 then
		this.PosX = this.PosX+0.5
		this.PosY = this.PosY+4.5
		this.Or.x = 1
		this.Or.y = 0
	elseif this.Or.x == 1 and this.Or.y == 0 then
		this.PosX = this.PosX-0.5
		this.PosY = this.PosY-2.5
		this.Or.x = 0
		this.Or.y = 1
	end
	if this.MetroWalls == "Hide" then
		MakeSlowFloor()
	else
		MakeWalls()
		--MakeSlowFloor()
	end
	if this.MetroSign == "On" then
		MakeSigns()
	end
	if this.MetroLight == "On" then
		MakeLights()
	end
	UpdateBeacon(false)
end

function toggleMetroSignClicked()
	if this.MetroSign == "Off" then
		RemoveSigns()
		MakeSigns()
		Set(this,"MetroSign","On")
	else
		RemoveSigns()
		Set(this,"MetroSign","Off")
	end
	this.SetInterfaceCaption("toggleMetroSign", this.MetroSign)
end

function toggleMetroWallsClicked()
	if this.MetroWalls == "Hide" then
		Set(this,"MetroWalls","Show")
		RemoveWalls()
		MakeWalls()
		--MakeSlowFloor()
	else
		Set(this,"MetroWalls","Hide")
		RemoveWalls()
		MakeSlowFloor()
	end
	if this.MetroSign == "On" then
		RemoveSigns()
		MakeSigns()
	end
	if this.MetroLight == "On" then
		RemoveLights()
		MakeLights()
	end
	this.SetInterfaceCaption("toggleMetroWalls", this.MetroWalls)
end

function toggleMetroScanClicked()
	if this.MetroScan ~= "FireBrigade" then
		if metroGroups[selectedGroup] == "External" then
			if this.MetroScan == "ExternalOnly" then
				Set(this,"MetroScan","Default+Ext")
				CurrentDefaultEntity = 1
			else
				Set(this,"MetroScan","ExternalOnly")
				CurrentDefaultEntity = 1
			end
			this.SetInterfaceCaption("toggleMetroScan", this.MetroScan)
			UpdateBeacon(false)
		else
			if this.MetroScan == "DefaultOnly" then
				Set(this,"MetroScan","Default+Mods")
			elseif this.MetroScan == "Default+Mods" then
				Set(this,"MetroScan","DefaultOnly")
			end
			this.SetInterfaceCaption("toggleMetroScan", this.MetroScan)
			UpdateBeacon(false)
		end
	end
end

function toggleMetroPrisonersClicked()
	if this.MetroScan ~= "FireBrigade" then
		if this.MetroPrisoners == "NO" then
			DefaultEntities = {}
			Set(this,"MetroPrisoners","YES")
			DefaultEntities = { "Prisoner", "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
			CurrentDefaultEntity = 1
			TotalDefaultEntities = #DefaultEntities
			this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
			UpdateBeacon(false)
		else
			if this.MetroType ~= "EXIT" then
				DefaultEntities = {}
				Set(this,"MetroPrisoners","NO")
				DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
				CurrentDefaultEntity = 1
				TotalDefaultEntities = #DefaultEntities
				this.SetInterfaceCaption("toggleMetroPrisoners", this.MetroPrisoners)
				UpdateBeacon(false)
			end
		end
	end
end

function toggleMetroLightClicked()
	if this.MetroLight == "Off" then
		RemoveLights()
		MakeLights()
		Set(this,"MetroLight","On")
	else
		RemoveLights()
		Set(this,"MetroLight","Off")
	end
	this.SetInterfaceCaption("toggleMetroLight", this.MetroLight)
end

function FindMyDoor()
	nearbyDoors = Find("MetroDoor",4)
	for thatDoor, dist in pairs(nearbyDoors) do
		if thatDoor.HomeUID == this.HomeUID then
			MyMetroDoor = thatDoor
		end
	end
end

function MakeSlowFloor()
	if this.SubType == 1 or this.SubType == 3 or this.SubType == 5 then
		if this.Or.x == 0 and this.Or.y == 1 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-0.175
			if this.SubType == 1 then		-- Dead End L
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.ceil(this.Pos.y),-4,4,-3,1
				for i = Ymin+2,Ymax-1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 3 then	-- Crossing L
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 5 then	-- Junction L
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			end
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-0.33
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,-7,1
				for i = Ymin+2,Ymax-2 do	for j = Xmin+1,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 3 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			end
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY+0.75
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-1,3
				for i = Ymin+1,Ymax-2 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 3 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			end
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-0.33
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,1,-7,1
				for i = Ymin+2,Ymax-2 do	for j = Xmin+2,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 3 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			end
		end	-- rotated three times
	else
		if this.Or.x == 0 and this.Or.y == 1 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-0.175
			if this.SubType == 0 then		-- Dead End S
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+2,Ymax-1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 2 then	-- Crossing S
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 4 then	-- Junction S
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			end
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-1.33
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,-5,1
				for i = Ymin+2,Ymax-2 do	for j = Xmin+1,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 2 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			end
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY+0.75
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-1,3
				for i = Ymin+1,Ymax-2 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 2 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			end
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-1.33
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,1,-5,1
				for i = Ymin+2,Ymax-2 do	for j = Xmin+2,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 2 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			end
		end	-- rotated three times
	end
end

function RemoveSlowFloor()
	if this.SubType == 1 or this.SubType == 3 or this.SubType == 5 then
		if this.Or.x == 0 and this.Or.y == 1 then
			if this.SubType == 1 then		-- Dead End L
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.ceil(this.Pos.y),-4,4,-3,1
				for i = Ymin+2,Ymax-1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 3 then	-- Crossing L
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 5 then	-- Junction L
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,-7,1
				for i = Ymin+2,Ymax-2 do	for j = Xmin+1,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 3 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-1,3
				for i = Ymin+1,Ymax-2 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 3 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,1,-7,1
				for i = Ymin+2,Ymax-2 do	for j = Xmin+2,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 3 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated three times
	else
		if this.Or.x == 0 and this.Or.y == 1 then
			if this.SubType == 0 then		-- Dead End S
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+2,Ymax-1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 2 then	-- Crossing S
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 4 then	-- Junction S
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,-5,1
				for i = Ymin+2,Ymax-2 do	for j = Xmin+1,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 2 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-1,3
				for i = Ymin+1,Ymax-2 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 2 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,1,-5,1
				for i = Ymin+2,Ymax-2 do	for j = Xmin+2,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 2 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated three times
	end
end

function MakeExitDoor()
	if this.SubType == 1 then		-- Dead End L
		if this.Or.x == 0 and this.Or.y == 1 then
			local cell = World.GetCell(math.floor(this.Pos.x)+1,math.floor(this.Pos.y)-1)	cell.Mat = "SolacoFloor"
			MyMetroDoor = Object.Spawn("MetroDoor",this.PosX+1,this.PosY-1.5)
			Set(MyMetroDoor,"OpenDir.y",0)
			Set(MyMetroDoor,"Open",0)
			Set(MyMetroDoor,"HomeUID",this.HomeUID)
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			local cell = World.GetCell(math.floor(this.Pos.x)+1,math.floor(this.Pos.y)-3)	cell.Mat = "SolacoFloor"
			MyMetroDoor = Object.Spawn("MetroDoor",this.PosX+1.5,this.PosY-3)
			Set(MyMetroDoor,"Or.x",-1)
			Set(MyMetroDoor,"Or.y",0)
			Set(MyMetroDoor,"OpenDir.x",0)
			Set(MyMetroDoor,"OpenDir.y",-1)
			Set(MyMetroDoor,"Open",0)
			Set(MyMetroDoor,"HomeUID",this.HomeUID)
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			local cell = World.GetCell(math.floor(this.Pos.x),math.floor(this.Pos.y)+2)	cell.Mat = "SolacoFloor"
			MyMetroDoor = Object.Spawn("MetroDoor",this.PosX,this.PosY+2.5)
			Set(MyMetroDoor,"OpenDir.y",0)
			Set(MyMetroDoor,"Open",0)
			Set(MyMetroDoor,"HomeUID",this.HomeUID)
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			local cell = World.GetCell(math.floor(this.Pos.x)-2,math.floor(this.Pos.y)-3)	cell.Mat = "SolacoFloor"
			MyMetroDoor = Object.Spawn("MetroDoor",this.PosX-1.5,this.PosY-3)
			Set(MyMetroDoor,"Or.x",-1)
			Set(MyMetroDoor,"Or.y",0)
			Set(MyMetroDoor,"OpenDir.x",0)
			Set(MyMetroDoor,"OpenDir.y",-1)
			Set(MyMetroDoor,"Open",0)
			Set(MyMetroDoor,"HomeUID",this.HomeUID)
		end	-- rotated three times
	elseif this.SubType == 0 then		-- Dead End S
		if this.Or.x == 0 and this.Or.y == 1 then
			local cell = World.GetCell(math.floor(this.Pos.x)+1,math.floor(this.Pos.y)-1)	cell.Mat = "SolacoFloor"
			MyMetroDoor = Object.Spawn("MetroDoor",this.PosX+1,this.PosY-1.5)
			Set(MyMetroDoor,"OpenDir.y",0)
			Set(MyMetroDoor,"Open",0)
			Set(MyMetroDoor,"HomeUID",this.HomeUID)
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			local cell = World.GetCell(math.floor(this.Pos.x)+1,math.floor(this.Pos.y)-2)	cell.Mat = "SolacoFloor"
			MyMetroDoor = Object.Spawn("MetroDoor",this.PosX+1.5,this.PosY-3)
			Set(MyMetroDoor,"Or.x",-1)
			Set(MyMetroDoor,"Or.y",0)
			Set(MyMetroDoor,"OpenDir.x",0)
			Set(MyMetroDoor,"OpenDir.y",-1)
			Set(MyMetroDoor,"Open",0)
			Set(MyMetroDoor,"HomeUID",this.HomeUID)
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			local cell = World.GetCell(math.floor(this.Pos.x),math.floor(this.Pos.y)+2)	cell.Mat = "SolacoFloor"
			MyMetroDoor = Object.Spawn("MetroDoor",this.PosX,this.PosY+2.5)
			Set(MyMetroDoor,"OpenDir.y",0)
			Set(MyMetroDoor,"Open",0)
			Set(MyMetroDoor,"HomeUID",this.HomeUID)
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			local cell = World.GetCell(math.floor(this.Pos.x)-2,math.floor(this.Pos.y)-2)	cell.Mat = "SolacoFloor"
			MyMetroDoor = Object.Spawn("MetroDoor",this.PosX-1.5,this.PosY-3)
			Set(MyMetroDoor,"Or.x",-1)
			Set(MyMetroDoor,"Or.y",0)
			Set(MyMetroDoor,"OpenDir.x",0)
			Set(MyMetroDoor,"OpenDir.y",-1)
			Set(MyMetroDoor,"Open",0)
			Set(MyMetroDoor,"HomeUID",this.HomeUID)
		end	-- rotated three times
	end
end

function MakeWalls()
	--print("MakeWalls")
	if this.SubType == 1 or this.SubType == 3 or this.SubType == 5 then
		if this.Or.x == 0 and this.Or.y == 1 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-0.175
			if this.SubType == 1 then		-- Dead End L
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.ceil(this.Pos.y),-3,3,-2,1
				for i = Ymin,Ymin do		for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymax do		for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymax do		for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 3 then	-- Crossing L
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 5 then	-- Junction L
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			end
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-0.33
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,-7,1
				--if this.MetroWalls == "Show" then
					for i = Ymin+1,Ymax-1 do	for j = Xmin,Xmax-1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
					for i = Ymin+2,Ymax-2 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				--end
				--for i = Ymin+2,Ymax-2 do	for j = Xmin+1,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 3 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymax+1 do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"		 end	end
			end
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY+0.75
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-1,3
				--if this.MetroWalls == "Show" then
					for i = Ymin,Ymax-1 do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
					for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				--end
				--for i = Ymin+1,Ymax-2 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 3 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymax,Ymax do		for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"				 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			end
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-0.33
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,1,-7,1
				--if this.MetroWalls == "Show" then
					for i = Ymin+1,Ymax-1 do	for j = Xmin+1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
					for i = Ymin+2,Ymax-2 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				--end
				--for i = Ymin+2,Ymax-2 do	for j = Xmin+2,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 3 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymax+1 do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			end
		end	-- rotated three times
	else
		if this.Or.x == 0 and this.Or.y == 1 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-0.175
			if this.SubType == 0 then		-- Dead End S
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,-1,2
				for i = Ymin,Ymin do		for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymax do		for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymax do		for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 2 then	-- Crossing S
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 4 then	-- Junction S
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			end
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-1.33
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,-5,1
				--if this.MetroWalls == "Show" then
					for i = Ymin+1,Ymax-1 do	for j = Xmin,Xmax-1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
					for i = Ymin+2,Ymax-2 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				--end
				--for i = Ymin+2,Ymax-2 do	for j = Xmin+1,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 2 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymax+1 do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			end
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY+0.75
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-1,3
				--if this.MetroWalls == "Show" then
					for i = Ymin,Ymax-1 do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
					for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				--end
				--for i = Ymin+1,Ymax-2 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 2 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymax,Ymax do		for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			end
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY-1.33
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,1,-5,1
				--if this.MetroWalls == "Show" then
					for i = Ymin+1,Ymax-1 do	for j = Xmin+1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
					for i = Ymin+2,Ymax-2 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				--end
				--for i = Ymin+2,Ymax-2 do	for j = Xmin+2,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "MetroFloor" end	end
			elseif this.SubType == 2 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymin+1 do	for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmin,Xmin+1 do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmin,Xmin do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			elseif this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin+1,Ymin+1 do	for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax,Ymax do		for j = Xmax-1,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymax+1 do		for j = Xmin+1,Xmin+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmax-1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "YutaniWall"		 end	end
				for i = Ymin,Ymin do		for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymax+1,Ymax+1 do	for j = Xmin+2,Xmax-2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
				for i = Ymin+2,Ymax-1 do	for j = Xmax,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "SolacoFloor"	 end	end
			end
		end	-- rotated three times
	end
end

function RemoveWalls()
	--print("RemoveWalls")
	if this.SubType == 1 or this.SubType == 3 or this.SubType == 5 then
		if this.Or.x == 0 and this.Or.y == 1 then
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.ceil(this.Pos.y),-4,4,-3,1
				for i = Ymin+1,Ymax do	for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 3 or this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin,Ymax+1 do	for j = Xmin,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,-7,1
				for i = Ymin+1,Ymax-1 do	for j = Xmin,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 3 or this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin,Ymax+1 do	for j = Xmin,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-1,3
				for i = Ymin,Ymax-1 do	for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 3 or this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-4,4,-2,2
				for i = Ymin,Ymax+1 do	for j = Xmin,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			if this.SubType == 1 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,1,-7,1
				for i = Ymin+1,Ymax-1 do	for j = Xmin+1,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 3 or this.SubType == 5 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-7,0
				for i = Ymin,Ymax+1 do	for j = Xmin,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated three times
	else
		if this.Or.x == 0 and this.Or.y == 1 then
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin+1,Ymax do	for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 2 or this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin,Ymax+1 do	for j = Xmin,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- placed down
		if this.Or.x == -1 and this.Or.y == 0 then
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,-5,1
				for i = Ymin+1,Ymax-1 do	for j = Xmin,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 2 or this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin,Ymax+1 do	for j = Xmin,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated once
		if this.Or.x == 0 and this.Or.y == -1 then
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-1,3
				for i = Ymin,Ymax-1 do	for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 2 or this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,3,-2,2
				for i = Ymin,Ymax+1 do	for j = Xmin,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated twice
		if this.Or.x == 1 and this.Or.y == 0 then
			if this.SubType == 0 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,1,-5,1
				for i = Ymin+1,Ymax-1 do	for j = Xmin+1,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			elseif this.SubType == 2 or this.SubType == 4 then
				local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-3,2,-5,0
				for i = Ymin,Ymax+1 do	for j = Xmin,Xmax do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
			end
		end	-- rotated three times
	end
end

function MakeSigns()
	if this.SubType <= 1 then
		MyMetroSign1 = Object.Spawn("Metro2Sign",this.Pos.x,this.Pos.y+0.5)
		Set(MyMetroSign1,"HomeUID",this.HomeUID)
		this.Slot1.i = MyMetroSign1.Id.i
		this.Slot1.u = MyMetroSign1.Id.u
		MyMetroSign1.SubType = subToMetroType[this.MetroType]
		--print("Created MyMetroSign1")
	else
		MyMetroSign1 = Object.Spawn("Metro2Sign",this.Pos.x,this.Pos.y+0.5)
		Set(MyMetroSign1,"HomeUID",this.HomeUID)
		this.Slot1.i = MyMetroSign1.Id.i
		this.Slot1.u = MyMetroSign1.Id.u
		MyMetroSign1.SubType = subToMetroType[this.MetroType]
		--print("Created MyMetroSign1")
		
		MyMetroSign2 = Object.Spawn("Metro2Sign",this.Pos.x,this.Pos.y+0.5)
		Set(MyMetroSign2,"HomeUID",this.HomeUID)
		this.Slot3.i = MyMetroSign2.Id.i
		this.Slot3.u = MyMetroSign2.Id.u
		MyMetroSign2.SubType = subToMetroType[this.MetroType]
		--print("Created MyMetroSign2")
	
		MyMetroSign3 = Object.Spawn("Metro2Sign",this.Pos.x,this.Pos.y+0.5)
		Set(MyMetroSign3,"HomeUID",this.HomeUID)
		this.Slot5.i = MyMetroSign3.Id.i
		this.Slot5.u = MyMetroSign3.Id.u
		MyMetroSign3.SubType = subToMetroType[this.MetroType]
		--print("Created MyMetroSign3")
		
		if this.SubType == 2 or this.SubType == 3 then
			MyMetroSign4 = Object.Spawn("Metro2Sign",this.Pos.x,this.Pos.y+0.5)
			Set(MyMetroSign4,"HomeUID",this.HomeUID)
			this.Slot7.i = MyMetroSign4.Id.i
			this.Slot7.u = MyMetroSign4.Id.u
			MyMetroSign4.SubType = subToMetroType[this.MetroType]
			--print("Created MyMetroSign4")
		end
	end
end

function MakeLights()
	if this.SubType <= 1 then
		MyWallLight1 = Object.Spawn("WallLight",this.Pos.x,this.Pos.y+0.5)
		Set(MyWallLight1,"HomeUID",this.HomeUID)
		this.Slot2.i = MyWallLight1.Id.i
		this.Slot2.u = MyWallLight1.Id.u
		--print("Created MyWallLight1")
	else
		MyWallLight1 = Object.Spawn("WallLight",this.Pos.x,this.Pos.y+0.5)
		Set(MyWallLight1,"HomeUID",this.HomeUID)
		this.Slot2.i = MyWallLight1.Id.i
		this.Slot2.u = MyWallLight1.Id.u
		--print("Created MyWallLight1")
		
		MyWallLight2 = Object.Spawn("WallLight",this.Pos.x,this.Pos.y+0.5)
		Set(MyWallLight2,"HomeUID",this.HomeUID)
		this.Slot4.i = MyWallLight2.Id.i
		this.Slot4.u = MyWallLight2.Id.u
		--print("Created MyWallLight2")
	
		MyWallLight3 = Object.Spawn("WallLight",this.Pos.x,this.Pos.y+0.5)
		Set(MyWallLight3,"HomeUID",this.HomeUID)
		this.Slot6.i = MyWallLight3.Id.i
		this.Slot6.u = MyWallLight3.Id.u
		--print("Created MyWallLight3")
		
		if this.SubType == 2 or this.SubType == 3 then
			MyWallLight4 = Object.Spawn("WallLight",this.Pos.x,this.Pos.y+0.5)
			Set(MyWallLight4,"HomeUID",this.HomeUID)
			this.Slot0.i = MyWallLight4.Id.i
			this.Slot0.u = MyWallLight4.Id.u
			--print("Created MyWallLight4")
		end
	end
end

function RemoveSigns()
	local mySigns = Find(this,"Metro2Sign",7)
	for thatSign, dist in pairs(mySigns) do
		if thatSign.HomeUID == this.HomeUID then
			thatSign.Delete()
		end
	end
end

function RemoveLights()
	local myLights = Find(this,"WallLight",7)
	for thatLight, dist in pairs(myLights) do
		if thatLight.HomeUID == this.HomeUID then
			thatLight.Delete()
		end
	end
end

function RemoveObjects()
	--print("RemoveObjects")
	local Objects =  { "WallLight", "Metro2Sign", "Metro2Location", "MetroDoor" }
	for j = 1, #Objects do
		for O in next, Find(this,Objects[j],7) do
			if O.HomeUID == this.HomeUID then
				O.Delete()
			end
		end
	end
end

function toggleRemoveStationClicked()
	RemoveObjects()
	if this.MetroWalls == "Show" then
		RemoveWalls()
	end
	UpdateBeacon(true)
	this.Delete()
end

function SetEntitiesToScan()

	ExternalEntities = {}
	if this.MetroType == "CEMETERY" then
		ExternalEntities = { "SomeFriend", "SomeFriendFuneral", "SomeFriendParlour1","SomeFriendParlour2","SomeFriendParlour3","SomeFriendParlour4", "SomeFriendParlour5","SomeFriendCemetery","SomeFriendLeaving" }
	elseif this.MetroType == "CHAPEL" then
		ExternalEntities = { "SpiritualLeaderClone", "Nobody" }
	elseif this.MetroType == "CLASSROOM" then
		ExternalEntities = { "TeacherClone", "Nobody" }
	elseif this.MetroType == "EXECUTION" then
		ExternalEntities = { "ExecutionWitness", "MetroGuard" }
	elseif this.MetroType == "EXIT" then
		ExternalEntities = { "Prisoner", "Visitor", "Fireman", "Paramedic", "RiotGuard", "Soldier", "Dog", "DogHandler", "LotteryOfficial" }
	elseif this.MetroType == "PAROLE" then
		ExternalEntities = { "ParoleOfficerClone", "ParoleLawyerClone", "AppealsLawyerClone", "AppealsMagistrateClone" }
	elseif this.MetroType == "PRISON" then
		ExternalEntities = { "Visitor", "MetroGuard", "TeacherClone", "SpiritualLeaderClone", "ParoleOfficerClone", "ParoleLawyerClone", "AppealsLawyerClone", "AppealsMagistrateClone", "ExecutionWitness", "SomeFriend", "SomeFriendFuneral", "SomeFriendParlour1","SomeFriendParlour2","SomeFriendParlour3","SomeFriendParlour4", "SomeFriendParlour5","SomeFriendCemetery","SomeFriendLeaving"}
	elseif this.MetroType == "VISITORS" then
		ExternalEntities = { "Visitor", "MetroGuard" }
	end
	TotalExternalEntities = #ExternalEntities
	CurrentExternalEntity = 1
end

function Update(timePassed)
	if timePerUpdate == nil then
		if not this.Init then
			if this.PosY == nil then return end
			this.Pos.x = this.PosX
			this.Pos.y = this.PosY
			if this.MetroType == "ACOUNTING" then
				this.MetroType = "ACCOUNTING"
				this.MetroGroup = 4
				this.MetroName = 1
			end
			MakeSlowFloor()
			MakeSigns()
			MakeLights()
			this.Init = true
		end
		if this.MetroType == "ACOUNTING" then
			this.MetroType = "ACCOUNTING"
			this.MetroGroup = 4
			this.MetroName = 1
		end
		selectedGroup = this.MetroGroup
		for i = 1, #metroNames[selectedGroup] do
			if metroNames[selectedGroup][i] == this.MetroType then
				selectedName = i
				break
			end
		end
		if metroGroups[selectedGroup] == "External" then
			SetEntitiesToScan()
		end
		if this.MetroPrisoners == "YES" then
			DefaultEntities = {}
			DefaultEntities = { "Prisoner", "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
		else
			DefaultEntities = {}
			DefaultEntities = { "Workman", "Guard", "ArmedGuard", "Doctor", "Orderly", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Sniper", "Warden", "Chief", "Foreman", "Psychologist", "Psychiatrist", "Accountant", "Lawyer" }
		end
		Interface.AddComponent(this,"toggleRemoveStation", "Button", "Remove")
		Interface.AddComponent(this,"CaptionSeparatorMetro1", "Caption", "tooltip_separatorline")
		Interface.AddComponent(this,"CaptionMetro2", "Caption", "== SELECT GROUP ==")
		Interface.AddComponent(this,"toggleMetroTypeGroup", "Button", "tooltip_button_changetypegroup",metroGroups[selectedGroup],"X")
		Interface.AddComponent(this,"CaptionMetro3", "Caption", "== SELECT NAME ==")
		Interface.AddComponent(this,"toggleMetroTypeMinus", "Button", "tooltip_button_changetypeminus")
		Interface.AddComponent(this,"CaptionMetroType", "Button", this.MetroType)
		Interface.AddComponent(this,"toggleMetroTypePlus", "Button", "tooltip_button_changetypeplus")
		Interface.AddComponent(this,"CaptionMetro4", "Caption", "= SELECT PEOPLE =")
		Interface.AddComponent(this,"toggleMetroScan", "Button", this.MetroScan)
		Interface.AddComponent(this,"CaptionMetro5", "Caption", "= PRISONER AUTH =")
		Interface.AddComponent(this,"toggleMetroPrisoners", "Button", this.MetroPrisoners)
		Interface.AddComponent(this,"CaptionSeparatorMetro2", "Caption", "tooltip_separatorline")
		Interface.AddComponent(this,"CaptionMetro1", "Caption", "== METRO WALLS ==")
		Interface.AddComponent(this,"toggleMetroRotate", "Button", "Rotate")
		Interface.AddComponent(this,"toggleMetroWalls", "Button", this.MetroWalls)
		Interface.AddComponent(this,"CaptionMetro6", "Caption", "== METRO  PATH ==")
		Interface.AddComponent(this,"toggleMetroSize", "Button", "Change")
		Interface.AddComponent(this,"CaptionMetro7", "Caption", "== METRO  SIGN ==")
		Interface.AddComponent(this,"toggleMetroSign", "Button", "Change")
		Interface.AddComponent(this,"CaptionMetro8", "Caption", "== METRO LIGHT ==")
		Interface.AddComponent(this,"toggleMetroLight", "Button", "Change")
		FindMyBeacon()
		FindMySpawnPoint()
		CacheMetroStations()
		if this.MetroType == "EXIT" then
			FindMyDoor()
		end
		timePerUpdate = 0.11
	else
		timeTot = timeTot+timePassed
		if timeTot >= timePerUpdate then
			timeTot = 0
			
			if not Exists(MyBeacon) then
				FindMyBeacon()
			elseif MyBeaconHash == MyBeacon.MetroHash then
				if not Exists(MySpawnPoint) then
					FindMySpawnPoint()
				else
					
					if metroGroups[selectedGroup] == "External" then
					
						if this.MetroScan == "ExternalOnly" then
							if this.MetroPrisoners == "NO" then
								local nearbyExternalEntities = Find(MySpawnPoint,ExternalEntities[CurrentExternalEntity],2)
								if next(nearbyExternalEntities) then
									for E, dist in pairs(nearbyExternalEntities) do
										GoHome(E)
									end
								end
								nearbyExternalEntities = nil
								TipCurrentExternalEntity = ExternalEntities[CurrentExternalEntity]
								this.Tooltip = this.MyTooltip.."\n  -> Default  OFF\n  -> Modded OFF\n  -> External "..TipCurrentExternalEntity.."\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip
									
								CurrentExternalEntity = CurrentExternalEntity + 1
								if CurrentExternalEntity > TotalExternalEntities then
									CurrentExternalEntity = 1
									 -- print("")
									 -- print("External entity scan cycle COMPLETED")
									 -- print("")
								end
								
							else
								if not TickTock then
									local nearbyExternalEntities = Find(MySpawnPoint,ExternalEntities[CurrentExternalEntity],2)
									if next(nearbyExternalEntities) then
										for E, dist in pairs(nearbyExternalEntities) do
											GoHome(E)
										end
									end
									nearbyExternalEntities = nil
									TipCurrentExternalEntity = ExternalEntities[CurrentExternalEntity]
										
									CurrentExternalEntity = CurrentExternalEntity + 1
									if CurrentExternalEntity > TotalExternalEntities then
										CurrentExternalEntity = 1
										 -- print("")
										 -- print("External entity scan cycle COMPLETED")
										 -- print("")
									end
									
									TickTock = true
								else
									local nearbyDefaultEntities = Find(MySpawnPoint,DefaultEntities[CurrentDefaultEntity],2)
									if next(nearbyDefaultEntities) then
										for D, dist in pairs(nearbyDefaultEntities) do
											FindNearestMetro(D)
										end
									end
									nearbyDefaultEntities = nil
									TipCurrentDefaultEntity = DefaultEntities[CurrentDefaultEntity]
									
									CurrentDefaultEntity = CurrentDefaultEntity + 1
									if CurrentDefaultEntity > 2 then
										CurrentDefaultEntity = 1
										 -- print("")
										 -- print("Default staff scan cycle COMPLETED")
										 -- print("")
									end
									TickTock = nil
								end
								this.Tooltip = this.MyTooltip.."\n  -> Default  "..TipCurrentDefaultEntity.."\n  -> Modded OFF\n  -> External "..TipCurrentExternalEntity.."\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip
							end
							 
						elseif this.MetroScan == "Default+Ext" then
							if not TickTock then
								local nearbyDefaultEntities = Find(MySpawnPoint,DefaultEntities[CurrentDefaultEntity],2)
								if next(nearbyDefaultEntities) then
									for D, dist in pairs(nearbyDefaultEntities) do
										FindNearestMetro(D)
									end
								end
								nearbyDefaultEntities = nil
								TipCurrentDefaultEntity = DefaultEntities[CurrentDefaultEntity]
								
								CurrentDefaultEntity = CurrentDefaultEntity + 1
								if CurrentDefaultEntity > TotalDefaultEntities then
									CurrentDefaultEntity = 1
									 -- print("")
									 -- print("Default staff scan cycle COMPLETED")
									 -- print("")
								end
								
								TickTock = true
							else
								local nearbyExternalEntities = Find(MySpawnPoint,ExternalEntities[CurrentExternalEntity],2)
								if next(nearbyExternalEntities) then
									for E, dist in pairs(nearbyExternalEntities) do
										GoHome(E)
									end
								end
								nearbyExternalEntities = nil
								TipCurrentExternalEntity = ExternalEntities[CurrentExternalEntity]
									
								CurrentExternalEntity = CurrentExternalEntity + 1
								if CurrentExternalEntity > TotalExternalEntities then
									CurrentExternalEntity = 1
									 -- print("")
									 -- print("External entity scan cycle COMPLETED")
									 -- print("")
								end
									
								TickTock = nil
							end
							
							this.Tooltip = this.MyTooltip.."\n  -> Default  "..TipCurrentDefaultEntity.."\n  -> Modded OFF\n  -> External "..TipCurrentExternalEntity.."\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip
						end
						
					else
					
					
						if this.MetroScan == "DefaultOnly" then
						
							local nearbyDefaultEntities = Find(MySpawnPoint,DefaultEntities[CurrentDefaultEntity],2)
							if next(nearbyDefaultEntities) then
								for D, dist in pairs(nearbyDefaultEntities) do
									FindNearestMetro(D)
								end
							end
							nearbyDefaultEntities = nil
							TipCurrentDefaultEntity = DefaultEntities[CurrentDefaultEntity]
							this.Tooltip = this.MyTooltip.."\n  -> Default  "..TipCurrentDefaultEntity.."\n  -> Modded OFF\n  -> External OFF\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip.."\n\nTicket earnings: $"..this.MetroEarnings

							CurrentDefaultEntity = CurrentDefaultEntity + 1
							if CurrentDefaultEntity > TotalDefaultEntities then
								CurrentDefaultEntity = 1
								 -- print("")
								 -- print("Default staff scan cycle COMPLETED")
								 -- print("")
							end
							
						elseif this.MetroScan == "Default+Mods" then
						
							if not TickTock then
								local nearbyDefaultEntities = Find(MySpawnPoint,DefaultEntities[CurrentDefaultEntity],2)
								if next(nearbyDefaultEntities) then
									for D, dist in pairs(nearbyDefaultEntities) do
										FindNearestMetro(D)
									end
								end
								nearbyDefaultEntities = nil
								TipCurrentDefaultEntity = DefaultEntities[CurrentDefaultEntity]
								
								CurrentDefaultEntity = CurrentDefaultEntity + 1
								if CurrentDefaultEntity > TotalDefaultEntities then
									CurrentDefaultEntity = 1
									 -- print("")
									 -- print("Default staff scan cycle COMPLETED")
									 -- print("")
								end
								
								TickTock = true
							else
								local nearbyModdedEntities = Find(MySpawnPoint,ModdedEntities[CurrentModdedEntity],2)
								if next(nearbyModdedEntities) then
									for M, dist in pairs(nearbyModdedEntities) do
										FindNearestMetro(M)
									end
								end
								nearbyModdedEntities = nil
								TipCurrentModdedEntity = ModdedEntities[CurrentModdedEntity]
								
								CurrentModdedEntity = CurrentModdedEntity + 1
								if CurrentModdedEntity > TotalModdedEntities then
									CurrentModdedEntity = 1
									 -- print("")
									 -- print("Modded staff scan cycle COMPLETED")
									 -- print("")
								end
								TickTock = nil
							end
							
							this.Tooltip = this.MyTooltip.."\n  -> Default  "..TipCurrentDefaultEntity.."\n  -> Modded "..TipCurrentModdedEntity.."\n  -> External OFF\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip.."\n\nTicket earnings: $"..this.MetroEarnings
							
						else
						
							local nearbyFiremanEntities = Find(MySpawnPoint,FiremanEntities[CurrentFiremanEntity],2)
							if next(nearbyFiremanEntities) then
								for F, dist in pairs(nearbyFiremanEntities) do
									FindNearestMetro(F)
								end
							end
							nearbyFiremanEntities = nil
							TipCurrentFiremanEntity = FiremanEntities[CurrentFiremanEntity]
							this.Tooltip = this.MyTooltip.."\n  -> Default  OFF\n  -> Prison Fire Brigade "..TipCurrentFiremanEntity.."\n  -> External OFF\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip.."\n\nTicket earnings: $"..this.MetroEarnings
							
							CurrentFiremanEntity = CurrentFiremanEntity + 1
							if CurrentFiremanEntity > TotalFiremanEntities then
								CurrentFiremanEntity = 1
								 -- print("")
								 -- print("Fireman staff scan cycle COMPLETED")
								 -- print("")
							end
						end
					end
				end
			else
				CacheMetroStations()
			end
		end
		timeToCleanTooltip = timeToCleanTooltip + timePassed
		if timeToCleanTooltip > timePerCleanup then
			timeToCleanTooltip = 0
			ScanHistory1Tooltip = ScanHistory2Tooltip
			ScanHistory2Tooltip = ScanHistory3Tooltip
			ScanHistory3Tooltip = ScanHistory4Tooltip
			ScanHistory4Tooltip = ScanHistory5Tooltip
			ScanHistory5Tooltip = ""
			if this.MetroScan == "DefaultOnly" then
				this.Tooltip = this.MyTooltip.."\n  -> Default  "..TipCurrentDefaultEntity.."\n  -> Modded OFF\n  -> External OFF\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip.."\n\nTicket earnings: $"..this.MetroEarnings
			elseif this.MetroScan == "Default+Mods" then
				this.Tooltip = this.MyTooltip.."\n  -> Default  "..TipCurrentDefaultEntity.."\n  -> Modded "..TipCurrentModdedEntity.."\n  -> External OFF\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip.."\n\nTicket earnings: $"..this.MetroEarnings
			elseif this.MetroScan == "FireBrigade" then
				this.Tooltip = this.MyTooltip.."\n  -> Default  OFF\n  -> Prison Fire Brigade "..TipCurrentFiremanEntity.."\n  -> External OFF\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip.."\n\nTicket earnings: $"..this.MetroEarnings
			elseif this.MetroScan == "ExternalOnly" then
				if this.MetroPrisoners == "NO" then
					this.Tooltip = this.MyTooltip.."\n  -> Default  OFF\n  -> Modded OFF\n  -> External "..TipCurrentExternalEntity.."\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip.."\n\nTicket earnings: $"..this.MetroEarnings
				else
					this.Tooltip = this.MyTooltip.."\n  -> Default  "..TipCurrentDefaultEntity.."\n  -> Modded OFF\n  -> External "..TipCurrentExternalEntity.."\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip.."\n\nTicket earnings: $"..this.MetroEarnings
				end
			elseif this.MetroScan == "Default+Ext" then
				this.Tooltip = this.MyTooltip.."\n  -> Default  "..TipCurrentDefaultEntity.."\n  -> Modded OFF\n  -> External "..TipCurrentExternalEntity.."\n  -> Prisoner "..this.MetroPrisoners.."\n===============================\n"..ScanHistory1Tooltip..ScanHistory2Tooltip..ScanHistory3Tooltip..ScanHistory4Tooltip..ScanHistory5Tooltip.."\n\nTicket earnings: $"..this.MetroEarnings
			end
		end
	end
end

function GoHome(E)
	local ScanCycleTooltip = ""
	if E.Type == "Visitor" or E.Type == "MetroGuard" or E.Type == "ExecutionWitness" or E.Type == "SomeFriend" or E.Type == "SomeFriendParlour1" or E.Type == "SomeFriendParlour2" or E.Type == "SomeFriendParlour3" or E.Type == "SomeFriendParlour4" or E.Type == "SomeFriendParlour5" or E.Type == "SomeFriendFuneral" or E.Type == "SomeFriendCemetery" or E.Type == "SomeFriendLeaving" then
		if Get(E,"BeingTransported") == true or E.Dest.y >= World.NumCellsY-1 then
			if E.Type == "MetroGuard" then
				ScanCycleTooltip = "\n\n"..E.Type.." id: "..E.Id.i.."\n  -> Escorted visitor to station"
			else
				ScanCycleTooltip = "\n\n"..E.Type.." id: "..E.Id.i.."\n  -> Catched metro towards city"
			end
			E.Delete()
		else
			ScanCycleTooltip = "\n\n"..E.Type.." id: "..E.Id.i.."\n  -> Walking in station"
		end
	elseif E.Type == "Prisoner" then
		if not E.AvatarControl then 
			if E.Dest.y >= World.NumCellsY-1 then
				ScanCycleTooltip = "\n\n"..E.Type.." id: "..E.Id.i.."\n  -> Released, going home"
				E.Pos.x = E.Dest.x
				E.Pos.y = E.Dest.y
			end
		else
			ScanCycleTooltip = "\n\n"..E.Type.." id: "..E.Id.i.."\n  -> Escaped, going home"
			E.Pos.x = World.NumCellsX-1
			E.Pos.y = World.NumCellsY-1
		end
	else
		ScanCycleTooltip = "\n\n"..E.Type.." id: "..E.Id.i.."\n  -> Catched metro towards city"
		E.Delete()
	end
	--print("")
	--print("")

	if ScanHistory1Tooltip == "" then
		ScanHistory1Tooltip = ScanCycleTooltip
	elseif ScanHistory2Tooltip == "" then
		ScanHistory2Tooltip = ScanCycleTooltip
	elseif ScanHistory3Tooltip == "" then
		ScanHistory3Tooltip = ScanCycleTooltip
	elseif ScanHistory4Tooltip == "" then
		ScanHistory4Tooltip = ScanCycleTooltip
	elseif ScanHistory5Tooltip == "" then
		ScanHistory5Tooltip = ScanCycleTooltip
	else
		ScanHistory1Tooltip = ScanHistory2Tooltip
		ScanHistory2Tooltip = ScanHistory3Tooltip
		ScanHistory3Tooltip = ScanHistory4Tooltip
		ScanHistory4Tooltip = ScanHistory5Tooltip
		ScanHistory5Tooltip = ScanCycleTooltip
	end
	timeToCleanTooltip = 0
end

function FindNearestMetro(MyEntity)
	--print("FindNearestMetro: for "..MyEntity.Type.." id: "..MyEntity.Id.i.." with destination x: "..MyEntity.Dest.x.."  y: "..MyEntity.Dest.y)
	local preferredStation = 0
	local ScanCycleTooltip = ""
	
	if MyEntity.Dest.x > 0 and MyEntity.Dest.y > 0 then
		local dX1 = this.Pos.x
		local dX2 = MyEntity.Dest.x
		local dY1 = this.Pos.y
		local dY2 = MyEntity.Dest.y
		local DistanceToDestination = math.sqrt((dX2-dX1)^2+(dY2-dY1)^2)
		--print("Distance between here and destination of "..MyEntity.Type.." id: "..MyEntity.Id.i.." is "..DistanceToDestination)
		
		for j = 1,#MetroStations,1 do
			local T = MetroStations[j].MetroType
			local dX1 = MyEntity.Dest.x
			local dX2 = MetroStations[j].PosX
			local dY1 = MyEntity.Dest.y
			local dY2 = MetroStations[j].PosY
			local DistanceToMetro = math.sqrt((dX2-dX1)^2+(dY2-dY1)^2)
			--print("Dist between "..MyEntity.Type.." id: "..MyEntity.Id.i.." dest and "..j.." ("..T..") is "..DistanceToMetro)
			if MyEntity.Type ~= "Prisoner" then
				if DistanceToMetro < DistanceToDestination and MetroStations[j].MetroScan ~= "ExternalOnly" then
					DistanceToDestination = DistanceToMetro
					preferredStation = j
				end
			else
				if DistanceToMetro < DistanceToDestination and MetroStations[j].MetroPrisoners == "YES" then
					DistanceToDestination = DistanceToMetro
					preferredStation = j
				end
			end
		end
	end
	--print("preferredStation: "..preferredStation)
	if preferredStation > 0 then
		local MetroX = MetroStations[preferredStation].PosX
		local MetroY = MetroStations[preferredStation].PosY
		local TicketFrom = this.HomeUID
		local TicketTo = MetroStations[preferredStation].HomeUID
		local TicketHash = "F"..TicketFrom.."T"..TicketTo.."X"..math.floor(MyEntity.Dest.x).."Y"..math.floor(MyEntity.Dest.y)
		--print("TicketHash: "..TicketHash)
		--print(MyEntity.MetroTicketHash)
		if MyEntity.MetroTicketFrom ~= nil then	-- entity used the metro lines already
			if TicketTo == TicketFrom then		-- entity reached destination station
				if MyEntity.MetroTicketTo ~= "CheckedOut" then	-- see if person checked out already, to prevent duplicates in the tooltip
					Set(MyEntity,"MetroTicketFrom",TicketFrom)
					Set(MyEntity,"MetroTicketTo","CheckedOut")
					ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Dest x: "..math.floor(MyEntity.Dest.x).."  y: "..math.floor(MyEntity.Dest.y).."\n  -> Checked out"
					--print(MyEntity.Type.." id: "..MyEntity.Id.i.." checked out")
				else
					ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Dest x: "..math.floor(MyEntity.Dest.x).."  y: "..math.floor(MyEntity.Dest.y).."\n  -> Walking in station"
					--print(MyEntity.Type.." id: "..MyEntity.Id.i.." walking in station")
				end
				metroFound = false
			elseif MyEntity.MetroTicketFrom == TicketTo and MyEntity.MetroTicketHash == TicketHash then -- entity walking in a loop between 2 stations, this happens when distance to other station was nearer to his/her destination, but game pathfinding decides to walk the tourist route due to the prison layout
				Set(MyEntity,"MetroTicketFrom",TicketFrom)
				Set(MyEntity,"MetroTicketTo","CheckedOut")
				ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Dest x: "..math.floor(MyEntity.Dest.x).."  y: "..math.floor(MyEntity.Dest.y).."\n  -> Confused, checked out"
				--print(MyEntity.Type.." id: "..MyEntity.Id.i.." was in loop, checked out")
				metroFound = false
			elseif TicketTo ~= TicketFrom and MyEntity.MetroTicketHash ~= TicketHash then -- entity takes metro to another station 
				Set(MyEntity,"MetroTicketFrom",TicketFrom)
				Set(MyEntity,"MetroTicketTo",TicketTo)
				Set(MyEntity,"MetroTicketHash",TicketHash)
				local TicketPrice = string.format("%6.2f",MetroStations[preferredStation].FromHereToThere * MetroPrice)
				ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Dest x: "..math.floor(MyEntity.Dest.x).."  y: "..math.floor(MyEntity.Dest.y).."\n  -> To station "..preferredStation.." ("..MetroStations[preferredStation].MetroType..")\n  -> Paid $"..TicketPrice.." for ticket"
				--print("Preferred station for "..MyEntity.Type.." id: "..MyEntity.Id.i.." is "..preferredStation.." ("..MetroStations[preferredStation].MetroType.."). Paid $"..TicketPrice)
				Set(this,"MetroEarnings",string.format("%6.2f",this.MetroEarnings + TicketPrice))
				metroFound = true
			elseif MyEntity.MetroTicketHash == TicketHash then	-- do nothing, we took care of this entity already in a prior scan cycle (this script cycles through entities fast
				metroFound = false 								--  so we might see them in a next scan cycle if they couldn't move away fast enough from the metro floor)
																-- no need to update the tooltip for this person who already checked out (otherwise we get duplicates in the tooltip)
				ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Dest x: "..math.floor(MyEntity.Dest.x).."  y: "..math.floor(MyEntity.Dest.y).."\n  -> Walking in station"
				--print(MyEntity.Type.." id: "..MyEntity.Id.i.." walking in station")
			end
		elseif TicketTo == TicketFrom then	-- entity never used metro before and doesn't need metro this time
			Set(MyEntity,"MetroTicketFrom",TicketFrom)
			if MyEntity.MetroTicketTo ~= "CheckedOut" then	-- see if person checked out already, to prevent duplicates in the tooltip
				Set(MyEntity,"MetroTicketTo","CheckedOut")
				ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Dest x: "..math.floor(MyEntity.Dest.x).."  y: "..math.floor(MyEntity.Dest.y).."\n  -> Checked out"
				--print(MyEntity.Type.." id: "..MyEntity.Id.i.." checked out")
			else
				ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Dest x: "..math.floor(MyEntity.Dest.x).."  y: "..math.floor(MyEntity.Dest.y).."\n  -> Walking in station"
				--print(MyEntity.Type.." id: "..MyEntity.Id.i.." walking in station")
			end
			metroFound = false
		elseif TicketTo ~= TicketFrom then	-- entity never used metro before and takes metro to another station
			Set(MyEntity,"MetroTicketFrom",TicketFrom)
			Set(MyEntity,"MetroTicketTo",TicketTo)
			Set(MyEntity,"MetroTicketHash",TicketHash)
			local TicketPrice = string.format("%6.2f",MetroStations[preferredStation].FromHereToThere * MetroPrice)
			ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Dest x: "..math.floor(MyEntity.Dest.x).."  y: "..math.floor(MyEntity.Dest.y).."\n  -> To station "..preferredStation.." ("..MetroStations[preferredStation].MetroType..")\n  -> Paid $"..TicketPrice.." for ticket"
			--print("Preferred station for "..MyEntity.Type.." id: "..MyEntity.Id.i.." is "..preferredStation.." ("..MetroStations[preferredStation].MetroType.."). Paid $"..TicketPrice)
			Set(this,"MetroEarnings",string.format("%6.2f",this.MetroEarnings + TicketPrice))
			metroFound = true
		end
		if metroFound == true then
			MyEntity.Pos.x = MetroX
			MyEntity.Pos.y = MetroY
			MyEntity.Dest.x = 0
			MyEntity.Dest.y = 0
			MyEntity.ClearRouting()
		end
	else	-- entity reached destination station, or a random person walked through the station (and has Dest.x/y of 0,0)
		Set(MyEntity,"MetroTicketFrom",this.HomeUID) -- update entities metro ticket so its last station where he/she came out is known
		if MyEntity.MetroTicketTo ~= "CheckedOut" then	-- see if person checked out already, to prevent duplicates in the tooltip
			Set(MyEntity,"MetroTicketTo","CheckedOut")
			ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Thinking about destination\n  -> Checked out"
			--print(MyEntity.Type.." id: "..MyEntity.Id.i.." checked out")
		else
			ScanCycleTooltip = "\n\n"..MyEntity.Type.." id: "..MyEntity.Id.i.."\n  -> Has no destination\n  -> Walking in station"
			--print(MyEntity.Type.." id: "..MyEntity.Id.i.." walking in station")
		end
	end
	--print("")
	--print("")

	if ScanHistory1Tooltip == "" then
		ScanHistory1Tooltip = ScanCycleTooltip
	elseif ScanHistory2Tooltip == "" then
		ScanHistory2Tooltip = ScanCycleTooltip
	elseif ScanHistory3Tooltip == "" then
		ScanHistory3Tooltip = ScanCycleTooltip
	elseif ScanHistory4Tooltip == "" then
		ScanHistory4Tooltip = ScanCycleTooltip
	elseif ScanHistory5Tooltip == "" then
		ScanHistory5Tooltip = ScanCycleTooltip
	else
		ScanHistory1Tooltip = ScanHistory2Tooltip
		ScanHistory2Tooltip = ScanHistory3Tooltip
		ScanHistory3Tooltip = ScanHistory4Tooltip
		ScanHistory4Tooltip = ScanHistory5Tooltip
		ScanHistory5Tooltip = ScanCycleTooltip
	end
	timeToCleanTooltip = 0
	if tonumber(this.MetroEarnings) >= 100 then
		Set(this,"MetroEarnings",0)
		MyEarnings = Object.Spawn("MetroStationEarnings",this.PosX,this.PosY)
	end
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end
