
local Find = Object.GetNearbyObjects
local Get = Object.GetProperty
local Set = Object.SetProperty

local metroGroups = { [1] = "Cell", [2] = "Logistics", [3] = "Staff", [4] = "Reform", [5] = "External" }

local metroNames = { [1] = {
						[1] = "MINSEC",
						[2] = "MEDSEC",
						[3] = "MAXSEC",
						[4] = "SUPERMAX",
						[5] = "INSANE",
						[6] = "PROTECTED",
						[7] = "DEATHROW",
						[8] = "SOLITARY",
						[9] = "CELLBLOCK",
						[10] = "RECEPTION" },
					[2] = {
						[1] = "CANTEEN",
						[2] = "DELIVERIES",
						[3] = "EXPORTS",
						[4] = "KITCHEN",
						[5] = "NURSERY",
						[6] = "RECYCLING",
						[7] = "STAFFROOM",
						[8] = "STORAGE",
						[9] = "TOILETS",
						[10] = "YARD" },
					[3] = {
						[1] = "ARMOURY",
						[2] = "EXECUTION",
						[3] = "FIREBRIGADE",
						[4] = "FIREMAN",
						[5] = "GUARDS",
						[6] = "HQ",
						[7] = "KENNEL",
						[8] = "OFFICE",
						[9] = "SECURITY",
						[10] = "SNIPERS",
						[11] = "STAFF",
						[12] = "STAFFROOM",
						[13] = "TOILETS",
						[14] = "TOWER" },
					[4] = {
						[1] = "ACCOUNTING",
						[2] = "BARBER",
						[3] = "CEMETERY",
						[4] = "CHAPEL",
						[5] = "CLASSROOM",
						[6] = "FACTORY",
						[7] = "FORESTRY",
						[8] = "GARDEN",
						[9] = "OFFICE",
						[10] = "PAROLE",
						[11] = "PLANTATION",
						[12] = "TAZER",
						[13] = "VISITORS",
						[14] = "WOODSHOP",
						[15] = "WORKSHOP" },
					[5] = {
						[1] = "CEMETERY",
						[2] = "CHAPEL",
						[3] = "CLASSROOM",
						[4] = "EXECUTION",
						[5] = "EXIT",
						[6] = "PAROLE",
						[7] = "PRISON",
						[8] = "VISITORS" }
					}

local selectedGroup = 3
local selectedName = 11

function Create()
end

function RemoveObjects()
	--print("RemoveObjects")
	local Objects =  { "WallLight", "MetroSignStaff", "MetroSpawnLocation" }
	for j = 1, #Objects do
		for O in next, Find(this,Objects[j],7) do
			if O.HomeUID == this.HomeUID then
				O.Delete()
			end
		end
	end
end

function Update(timePassed)
	if timePerUpdate == nil then
		if this.MetroWalls == nil then Set(this,"MetroWalls","Show") end
		if this.MetroScan == nil then Set(this,"MetroScan","DefaultOnly") end
		if this.MetroPrisoners == nil then Set(this,"MetroPrisoners","NO") end
		if this.MetroGroup == nil then
			for i = 1, #metroGroups do
				for j = 1, #metroNames[i] do
					if metroNames[i][j] == this.MetroType then
						selectedGroup = i
						selectedName = j
						Set(this,"MetroGroup",selectedGroup)
						Set(this,"MetroName",selectedName)
						break
					end
				end
			end
		end
		selectedGroup = this.MetroGroup
		selectedName = this.MetroName
		if metroGroups[selectedGroup] == "External" then
			SetEntitiesToScan()
		end
		UpgradedMetro = Object.Spawn("Metro2",this.PosX,this.PosY)
		UpgradedMetro.Or.x = this.Or.x
		UpgradedMetro.Or.y = this.Or.y
		UpgradedMetro.SubType = this.SubType
		Set(UpgradedMetro,"HomeUID","Metro_"..UpgradedMetro.Id.u)
		Set(UpgradedMetro,"MetroType",this.MetroType)
		Set(UpgradedMetro,"MetroGroup",this.MetroGroup)
		Set(UpgradedMetro,"MetroName",this.MetroName)
		Set(UpgradedMetro,"MetroLight",this.MetroLight)
		Set(UpgradedMetro,"MetroSign",this.MetroSign)
		Set(UpgradedMetro,"MetroWalls",this.MetroWalls)
		Set(UpgradedMetro,"MetroSize",this.MetroSize)
		Set(UpgradedMetro,"MetroEarnings",0)
		Set(UpgradedMetro,"MetroScan",this.MetroScan)
		Set(UpgradedMetro,"MetroPrisoners",this.MetroPrisoners)
		Set(UpgradedMetro,"Version",2.5)
		Set(UpgradedMetro,"MyTooltip","")
		Set(UpgradedMetro,"PosX",this.PosX)
		Set(UpgradedMetro,"PosY",this.PosY)
		RemoveObjects()
		timePerUpdate = 0.5
	else
		this.Delete()
	end
end
