
local Find = Object.GetNearbyObjects

function FindMapEdge()
	if World.NumCellsX ~= nil then
		Set("MapSide",World.NumCellsX-1)
	else
		local endX=-1
		local foundEndX=false
		while foundEndX==false do
			endX=endX+1
			local myCell = World.GetCell(endX,0)
			if myCell.Mat==nil then
				foundEndX=true
				endX=endX-1
			end
		end
		Set("MapSide",endX)
	end
end

function RemoveOldStation()
	nearbyStations = Find("MetroStation",10000)
	for thatStation, dist in pairs(nearbyStations) do
		if thatStation.SubType == 2 then
			oldStation = thatStation
			RemoveWalls()
			thatStation.Delete()
		end
	end
	nearbyStations = Find("MetroStationSmall",10000)
	for thatStation, dist in pairs(nearbyStations) do
		if thatStation.SubType == 0 then
			oldStation = thatStation
			RemoveWalls()
			thatStation.Delete()
		end
	end
end

function FindMyBeacon()
	local beaconFound = false
	nearbyBeacons = Find("Metro2Beacon",10000)
	for thatBeacon, dist in pairs(nearbyBeacons) do
		MyBeacon = thatBeacon
		beaconFound = true
	end
	if beaconFound == false then
		FindMapEdge()
		MyBeacon = Object.Spawn("Metro2Beacon",this.MapSide-11,1)
	end
end

function MakeWalls()
	if newStation.Type == "MetroStationSmall" then
		local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(newStation.Pos.x), math.floor(newStation.Pos.y),-2,1,0,0
		for i = Ymin-2,Ymax+2 do	for j = Xmin-1,Xmax+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "PavingStone"	 end	end
		for i = Ymin-1,Ymax+1 do	for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "PerimeterWall"	 end	end
		for i = Ymin,Ymax+1 do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "ConcreteTiles"	 end	end
	else
		local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(newStation.Pos.x), math.floor(newStation.Pos.y),-3,2,0,0
		for i = Ymin-2,Ymax+2 do	for j = Xmin-1,Xmax+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "PavingStone"	 end	end
		for i = Ymin-1,Ymax+1 do	for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "PerimeterWall"	 end	end
		for i = Ymin,Ymax+1 do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "ConcreteTiles"	 end	end
	end
	NewWallLight = Object.Spawn("WallLight",newStation.Pos.x,newStation.Pos.y)
	Set(NewWallLight,"HomeUID",newStation.HomeUID.."_1")
end

function RemoveWalls()
	RemoveObjects()
	if oldStation.Type == "MetroStationSmall" then
		local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(oldStation.Pos.x), math.floor(oldStation.Pos.y),-2,1,0,0
		for i = Ymin-2,Ymax+2 do	for j = Xmin-1,Xmax+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
		for i = Ymin-1,Ymax+1 do	for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
		for i = Ymin,Ymax+1 do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
	else
		local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(oldStation.Pos.x), math.floor(oldStation.Pos.y),-3,2,0,0
		for i = Ymin-2,Ymax+2 do	for j = Xmin-1,Xmax+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
		for i = Ymin-1,Ymax+1 do	for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
		for i = Ymin,Ymax+1 do		for j = Xmin+1,Xmax-1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
	end
end

function RemoveObjects()
	local Objects =  { "WallLight", "MetroDoor" }
	for j = 1, #Objects do
		for O in next, Find(oldStation,Objects[j],3) do
			if O.HomeUID == oldStation.HomeUID.."_1" or O.HomeUID == oldStation.HomeUID.."_2" then
				O.Delete()
			end
		end
	end
end

function Create()
	local PosX = math.floor(this.Pos.x+0.5)
	local PosY = math.floor(this.Pos.y-0.5)
	RemoveOldStation()
	newStation = Object.Spawn("MetroStationSmall",PosX,PosY)
	SetOn(newStation,"HomeUID","Metro_"..newStation.Id.u)
	SetOn(newStation,"SubType",0)
	SetOn(newStation,"Version",2.0)
	MakeWalls()
	FindMyBeacon()
	SetOn(MyBeacon,"Update",true)
end

function Update()
	this.Delete()
end

-------------------------------------------------------------------------------------------
-- Helper Functions
------------------------------------------------------------------------------------------- 
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end