
local Find = Object.GetNearbyObjects
local timeTot = 0
local entities = {}

function Create()
end

function UpgradeOlderMetroStation()
	if this.Version == nil and not this.UpgradeCompleted then
		Set("HomeUID","Metro_"..this.Id.u)
		nearbyLights = Find("Light",2)
		for thatLight, dist in pairs(nearbyLights) do
			thatLight.Delete()
		end
		NewWallLight = Object.Spawn("WallLight",this.Pos.x,this.Pos.y)
		SetOn(NewWallLight,"HomeUID",this.HomeUID.."_1")
		
		nearbyDoors = Find("MetroDoor",2)
		for thatDoor, dist in pairs(nearbyDoors) do
			if thatDoor.OpenDir.x == 1 then
				SetOn(thatDoor,"HomeUID",this.HomeUID.."_1")
				rightDoor = thatDoor
			else
				SetOn(thatDoor,"HomeUID",this.HomeUID.."_2")
				leftDoor = thatDoor
			end
		end
		Set("Version",2.5)
		Set("UpgradeCompleted",true)
	end
end

function RemoveWalls()
	RemoveObjects()
	if this.SubType > 2 then
		local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-1,1,0,0
		for i = Ymin-2,Ymax+2 do	for j = Xmin-2,Xmax+2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
		for i = Ymin-1,Ymax+1 do	for j = Xmin-1,Xmax+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
		for i = Ymin,Ymax+1 do		for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
	else
		local x,y,Xmin,Xmax,Ymin,Ymax = math.floor(this.Pos.x), math.floor(this.Pos.y),-2,2,0,0
		for i = Ymin-2,Ymax+2 do	for j = Xmin-2,Xmax+2 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
		for i = Ymin-1,Ymax+1 do	for j = Xmin-1,Xmax+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
		for i = Ymin,Ymax+1 do		for j = Xmin,Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = "Dirt" end	end
	end
end

function RemoveObjects()
	local Objects =  { "WallLight", "MetroDoor" }
	for j = 1, #Objects do
		for O in next, Find(this,Objects[j],3) do
			if O.HomeUID == this.HomeUID.."_1" or O.HomeUID == this.HomeUID.."_2" then
				O.Delete()
			end
		end
	end
end

function toggleRemoveStationClicked()
	RemoveWalls()
	Set("IsRemoved",true)
	if MyBeacon == nil then FindMyBeacon() end
	local subToMetroType = { [0] = "PAROLE", [1] = "CHAPEL", [2] = "CLASSROOM", [3] = "VISITOR", [4] = "EXECUTION", [5] = "PRISON", [6] = "CEMETERY", [7] = "EXIT" }
	SetOn(MyBeacon,subToMetroType[this.SubType].."stationPosX",0)
	SetOn(MyBeacon,subToMetroType[this.SubType].."stationPosY",0)
	SetOn(MyBeacon,subToMetroType[this.SubType].."stationID","None")
	SetOn(MyBeacon,"Update",true)
	this.Delete()
end

function FindMyDoors()
	nearbyDoors = Find("MetroDoor",2)
	for thatDoor, dist in pairs(nearbyDoors) do
		if thatDoor.OpenDir.x == 1 then
			rightDoor = thatDoor
		else
			leftDoor = thatDoor
		end
	end
end

function FindMapEdge()
	if World.NumCellsY ~= nil and World.NumCellsX ~= nil then
		Set("MapBottom",World.NumCellsY-1)
		Set("MapSide",World.NumCellsX-1)
	else
		local endX=-1
		local foundEndX=false
		local endY=-1
		local foundEndY=false
		
		while foundEndY==false do
			endY=endY+1
			local myCell = World.GetCell(this.Pos.x,endY)
			if myCell.Mat==nil then
				foundEndY=true
				endY=endY-1
			end
		end
		Set("MapBottom",endY)

		while foundEndX==false do
			endX=endX+1
			local myCell = World.GetCell(endX,0)
			if myCell.Mat==nil then
				foundEndX=true
				endX=endX-1
			end
		end
		Set("MapSide",endX)
	end
end

function FindMyBeacon()
	local beaconFound = false
	nearbyBeacons = Find("Metro2Beacon",10000)
	for thatBeacon, dist in pairs(nearbyBeacons) do
		MyBeacon = thatBeacon
		beaconFound = true
	end
	if beaconFound == false then
		FindMapEdge()
		MyBeacon = Object.Spawn("Metro2Beacon",this.MapSide-11,1)
	end
end

function toggleBeaconClicked()
	if MyBeacon == nil then FindMyBeacon() end
	if MyBeacon.SubType == 0 then
		MyBeacon.SubType = 1
		this.SetInterfaceCaption("toggleBeacon", "Hidden")
	else
		MyBeacon.SubType = 0
		this.SetInterfaceCaption("toggleBeacon", "Visible")
	end
end

function SetEntitiesToScan()
	entities = {}
	local subToMetroType = { [0] = "PAROLE", [1] = "CHAPEL", [2] = "CLASSROOM", [3] = "VISITORS", [4] = "EXECUTION", [5] = "PRISON", [6] = "CEMETERY", [7] = "EXIT" }
	if subToMetroType[this.SubType] == "CEMETERY" then
		entities = { "SomeFriend", "SomeFriendFuneral", "SomeFriendParlour1","SomeFriendParlour2","SomeFriendParlour3","SomeFriendParlour4", "SomeFriendParlour5","SomeFriendCemetery","SomeFriendLeaving" }
	elseif subToMetroType[this.SubType] == "CHAPEL" then
		entities = { "SpiritualLeaderClone" }
	elseif subToMetroType[this.SubType] == "CLASSROOM" then
		entities = { "TeacherClone" }
	elseif subToMetroType[this.SubType] == "EXECUTION" then
		entities = { "ExecutionWitness", "MetroGuard" }
	elseif subToMetroType[this.SubType] == "EXIT" then
		entities = { "Prisoner", "Visitor", "Fireman", "Paramedic", "RiotGuard", "Soldier", "Dog", "DogHandler", "LotteryOfficial" }
	elseif subToMetroType[this.SubType] == "PAROLE" then
		entities = { "ParoleOfficerClone", "ParoleLawyerClone", "AppealsLawyerClone", "AppealsMagistrateClone" }
	elseif subToMetroType[this.SubType] == "PRISON" then
		entities = { "Visitor", "MetroGuard", "TeacherClone", "SpiritualLeaderClone", "ParoleOfficerClone", "ParoleLawyerClone", "AppealsLawyerClone", "AppealsMagistrateClone", "ExecutionWitness", "SomeFriend", "SomeFriendFuneral", "SomeFriendParlour1","SomeFriendParlour2","SomeFriendParlour3","SomeFriendParlour4", "SomeFriendParlour5","SomeFriendCemetery","SomeFriendLeaving"}
	elseif subToMetroType[this.SubType] == "VISITORS" then
		entities = { "Visitor", "MetroGuard" }
	end
end

function Update(timePassed)
	if timePerUpdate == nil then
		UpgradeOlderMetroStation()
		if this.SubType == 7 then
			FindMyDoors()
		end
		Interface.AddComponent(this,"toggleRemoveStation", "Button", "Remove")
		Interface.AddComponent(this,"CaptionSeparatorMetro", "Caption", "tooltip_separatorline")
		Interface.AddComponent(this,"CaptionMetro", "Caption", "= METRO BEACON =")
		Interface.AddComponent(this,"toggleBeacon", "Button", "Toggle")
		SetEntitiesToScan()
		timePerUpdate = 2+math.random() / World.TimeWarpFactor
	else
		timeTot = timeTot+timePassed
		if timeTot >= timePerUpdate then
			timeTot = 0
			
			if not Exists(MyBeacon) then FindMyBeacon() end
			
			for j = 1, #entities do
				nearbyEntities =  Find(this,entities[j],3)
				if next(nearbyEntities) then
					for E, dist in pairs(nearbyEntities) do
						if E.Type == "Visitor" or E.Type == "MetroGuard" or E.Type == "ExecutionWitness" or E.Type == "SomeFriend" or E.Type == "SomeFriendParlour1" or E.Type == "SomeFriendParlour2" or E.Type == "SomeFriendParlour3" or E.Type == "SomeFriendParlour4" or E.Type == "SomeFriendParlour5" or E.Type == "SomeFriendFuneral" or E.Type == "SomeFriendCemetery" or E.Type == "SomeFriendLeaving" then
							if GetFrom(E,"BeingTransported") == true or E.Dest.y >= World.NumCellsY-1 then
								E.Delete()
							end
						elseif E.Type == "Prisoner" then
							if not E.AvatarControl then
								E.Pos.x = E.Dest.x
								E.Pos.y = E.Dest.y
							else
								E.Pos.x = World.NumCellsX-1
								E.Pos.y = World.NumCellsY-1
							end
						else
							E.Delete()
						end
					end
				end
				nearbyEntities = nil
			end
			
			if this.SubType == 7 then
				if Exists(leftDoor) then leftDoor.Open = 0 end
				if Exists(rightDoor) then rightDoor.Open = 0 end
			end
		end
	end
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end

-------------------------------------------------------------------------------------------
-- Helper Functions
------------------------------------------------------------------------------------------- 
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end
-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
    return Object;
end
