
local timeTot = 0

local Animation = { [1] = 1, [2] = 2, [3] = 3, [4] = 4, [5] = 5 }
local Frame = 1
local PaperWorkAdminNr = 1
local BoringPaperWorkNr = 1

local Find = Object.GetNearbyObjects
local Get = Object.GetProperty
local Set = Object.SetProperty

local timeOutPrinterJam = 45

function Create()
	Set(this,"PaperTray",0)
	Set(this,"PrintQueue",0)
	Set(this,"JobSize",0)
	Set(this,"PrinterStatus","Not Connected")
	Set(this,"PrintJobRequest",false)
	Set(this,"PrintDocType0","None")
	Set(this,"PrinterActive",false)
	Set(this,"PaperJam",false)
	Set(this,"FrustratingJam",false)
	Set(this,"QueueError",false)
	Set(this,"TimeWarp",1)
	Set(this,"GatewayID",0)
	FirstInstall()
	UpdateServers()
end

function UpdateServers()
	local nearbyServers = Find(this,"Server",10000)
	if next(nearbyServers) then
		for thatServer,dist in pairs(nearbyServers) do
			Set(thatServer,"UpdateClients",true)
		end
	end
end

function IsGatewayOrSwitch()
	if tonumber(this.TriggeredBy.i) > -1 and tonumber(this.TriggeredBy.i) == tonumber(this.GatewayID) then
		return true
	else
		--local ModuleTypes = { "NetworkSwitch", "LogicCircuit" }
		local ModuleTypes = { "LogicCircuit" }
		MyModule = nil
		for _, ModuleType in ipairs(ModuleTypes) do
			local Modules = Find(this,ModuleType,10000)
			for thatModule, _ in next, Modules do
				if thatModule.Id.i == tonumber(this.TriggeredBy.i) and thatModule.AvailableConnections ~= nil and tonumber(thatModule.AvailableConnections) > 0 then
					MyModule = thatModule
					Set(this,"GatewayID",this.TriggeredBy.i)
					break
				end
			end
			Modules = nil
		end
		if MyModule == nil then
			Set(this,"GatewayID",0)
			return false
		else
			return true
		end
	end
end

function FirstInstall()
	FindStackNumbers()
end

function FindStackNumbers()
	local newStack = Object.Spawn("Stack", this.Pos.x, this.Pos.y)
	for i = 1,2000 do
		Set(newStack,"Quantity",2)
		Set(newStack,"Contents",i)
		if newStack.Contents == "PiledUpBoringPaperWork" then
			BoringPaperWorkNr = i
		end
		if newStack.Contents == "PiledUpPaperWorkAdmin" then
			PaperWorkAdminNr = i
		end
		if BoringPaperWorkNr > 1 and PaperWorkAdminNr > 1 then
			newStack.Delete()
			break
		end
	end
end

function FindMyStack()
	MyStacks = Find(this,"Stack",2)
	if next(MyStacks) then
		for thatStack, dist in pairs(MyStacks) do
			if thatStack.Id.i == this.Slot0.i then
				MyPrintedPaper = thatStack
			end
		end
	end
end

function AnimatePrinter()
	if this.PaperJam == false then
		this.SubType = this.DefaultSubType + Animation[Frame]
		Frame = Frame + 1
		if Frame > #Animation then
			Frame = 1
		end
	else
		if this.DefaultSubType == 0 then
			if this.SubType == 6 then this.SubType = 7 else this.SubType = 6 end
		elseif this.DefaultSubType == 8 then
			if this.SubType == 14 then this.SubType = 15 else this.SubType = 14 end
		elseif this.DefaultSubType == 16 then
			if this.SubType == 22 then this.SubType = 23 else this.SubType = 22 end
		end
	end
	
	if this.PaperTray == 0 or this.Toner == 0 or this.DrumKit == 0 then
		if this.DefaultSubType == 0 then
			if this.SubType == 6 then this.SubType = 7 else this.SubType = 6 end
		elseif this.DefaultSubType == 8 then
			if this.SubType == 14 then this.SubType = 15 else this.SubType = 14 end
		elseif this.DefaultSubType == 16 then
			if this.SubType == 22 then this.SubType = 23 else this.SubType = 22 end
		end
	end
end

function PaperIsJammed()
	local rndJam = math.random(1,100)
	if rndJam <= 2 then
		Set(this,"PaperJam",true)
		if rndJam == 1 then
			Set(this,"FrustratingJam",true)
		else
			Set(this,"FrustratingJam",false)
			timeOutPrinterJam = 45
		end
		return true
	else
		return false
	end
end

function Exists(theObject)
	if theObject == nil or theObject.SubType == nil then
		return false
	else
		return true
	end
end

function PrinterStatusOK()
	local OK = true
	if this.PaperJam == true then Set(this,"PrinterStatus", "Paper jam"); OK = false
	elseif this.PaperTray <= 2 then Set(this,"PaperTray",0); Set(this,"PrinterStatus","Out of paper"); OK = false
	elseif this.DrumKit <= 1 then Set(this,"DrumKit",0); Set(this,"PrinterStatus","Replace drum kit"); OK = false
	elseif this.Toner <= 1 then Set(this,"Toner",0); Set(this,"PrinterStatus","Replace toner"); OK = false
	elseif Get(this,"PrintDocType"..this.PrintQueue) == nil or Get(this,"PrintDocType"..this.PrintQueue) == "None" then Set(this,"PrinterStatus","Print Queue error"); Set(this,"QueueError",true); OK = false
	end
	return OK
end

function PrintUselessData()
	if not Exists(MyPrintedPaper) then
		if PaperIsJammed() == false then
			timePerUpdate = 0.1 / World.TimeWarpFactor
			MyPrintedPaper = Object.Spawn("Stack", this.Pos.x, this.Pos.y)
			Set(MyPrintedPaper,"Quantity",1)
			if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpBoringPaperWork" then
				Set(MyPrintedPaper,"Contents",BoringPaperWorkNr)
			elseif Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
				Set(MyPrintedPaper,"Contents",PaperWorkAdminNr)
			end
			MyPrintedPaper.CarrierId.i = this.Id.i
			MyPrintedPaper.CarrierId.u = this.Id.u
			MyPrintedPaper.Loaded = true
			this.Slot0.i = MyPrintedPaper.Id.i
			this.Slot0.u = MyPrintedPaper.Id.u
			Set(this,"JobSize",math.random(3,30))
		end
	else
		if MyPrintedPaper.Quantity < this.JobSize then
			timePerUpdate = 0.1 / World.TimeWarpFactor
			Set(MyPrintedPaper,"Quantity",MyPrintedPaper.Quantity + 1)
			Set(this,"PaperTray",this.PaperTray - 1)
			Set(this,"Toner",this.Toner - 1)
			Set(this,"DrumKit",this.DrumKit - 1)
			Set(this,"PrinterStatus","Printing page "..MyPrintedPaper.Quantity.."/"..this.JobSize)
		elseif MyPrintedPaper.Quantity >= this.JobSize then
			this.SubType = this.DefaultSubType + 1
			this.Slot0.i = -1
			this.Slot0.u = -1
			MyPrintedPaper.CarrierId.i = -1
			MyPrintedPaper.CarrierId.u = -1
			MyPrintedPaper.Loaded = false
			Set(this,"JobSize",0)
			Set(this,"PrinterActive",false)
			Set(this,"PrintJobRequest",false)
			Set(this,"PrintDocType"..this.PrintQueue,nil)
			Set(this,"PrinterStatus","Idle")
			Set(this,"PrintQueue",this.PrintQueue - 1)
			if this.PrintQueue <= 0 then this.PrintQueue = 0 end
			MyPrintedPaper = nil
		end
	end
end

function Update( timePassed )
	if timePerUpdate == nil then
		if Get(this,"PrintDocType"..this.PrintQueue) == nil then Set(this,"PrintDocType"..this.PrintQueue,"None") end
		FindStackNumbers()
		FindMyStack()
		timePerUpdate = 1 / World.TimeWarpFactor
	end
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		timePerUpdate = 1 / World.TimeWarpFactor
		
		if tonumber(this.Triggered) >= 4 and IsGatewayOrSwitch() == true then
			if this.PrinterActive == true then
				AnimatePrinter()
				if PrinterStatusOK() == true then
					PrintUselessData()
				elseif this.PaperJam == true then
					if this.FrustratingJam == true then
						if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
							Object.CreateJob(this,"FixFrustratingPaperJamAdmin")
						else
							Object.CreateJob(this,"FixFrustratingPaperJam")
						end
					else
						timeOutPrinterJam = timeOutPrinterJam - 1
						if timeOutPrinterJam <= 0 then	-- make this a frustrating jam so a free SysAdmin can come fix it if nobody fixed it within 45 minutes
							if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
								Object.CreateJob(this,"FixFrustratingPaperJamAdmin")
							else
								Object.CreateJob(this,"FixFrustratingPaperJam")
							end
						else
							if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
								Object.CreateJob(this,"FixPaperJamAdmin")
							else
								Object.CreateJob(this,"FixPaperJam")
							end
						end
					end
				elseif this.QueueError == true then
					Object.CreateJob(this,"ResetPrinter")
				end
			else
				this.SubType = this.DefaultSubType + 1
				if this.PrintJobRequest == true or this.PrintQueue > 0 then
					Set(this,"PrinterActive",true)
					Set(this,"PrinterStatus","Incoming print job")
				else
					Set(this,"PrinterStatus","Idle")
				end
			end
		else
			this.SubType = this.DefaultSubType
			Set(this,"PrinterActive",false)
			Set(this,"PrinterStatus","Not connected to Gateway or Server is down")
		end
		
		
		if this.PaperTray == 0 then
			if this.DefaultSubType == 0 then
				
				if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
					Object.CreateJob(this,"LargePrinterPaperAdmin")
				else
					Object.CreateJob(this,"LargePrinterPaper")
				end
			elseif this.DefaultSubType == 8 then
				
				if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
					Object.CreateJob(this,"SmallPrinterPaperAdmin")
				else
					Object.CreateJob(this,"SmallPrinterPaper")
				end
			elseif this.DefaultSubType == 16 then
				
				if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
					Object.CreateJob(this,"TinyPrinterPaperAdmin")
				else
					Object.CreateJob(this,"TinyPrinterPaper")
				end
			end
		end
		if this.Toner == 0 then
			if this.DefaultSubType == 0 then
				
				if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
					Object.CreateJob(this,"ReplaceLargeTonerAdmin")
				else
					Object.CreateJob(this,"ReplaceLargeToner")
				end
			elseif this.DefaultSubType == 8 then
				
				if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
					Object.CreateJob(this,"ReplaceSmallTonerAdmin")
				else
					Object.CreateJob(this,"ReplaceSmallToner")
				end
			elseif this.DefaultSubType == 16 then
				
				if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
					Object.CreateJob(this,"ReplaceTinyTonerAdmin")
				else
					Object.CreateJob(this,"ReplaceTinyToner")
				end
			end
		end
		if this.DrumKit == 0 then
			if this.DefaultSubType == 0 then
				
				if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
					Object.CreateJob(this,"ReplaceLargeDrumkitAdmin")
				else
					Object.CreateJob(this,"ReplaceLargeDrumkit")
				end
			elseif this.DefaultSubType == 8 then
				
				if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
					Object.CreateJob(this,"ReplaceSmallDrumkitAdmin")
				else
					Object.CreateJob(this,"ReplaceSmallDrumkit")
				end
			elseif this.DefaultSubType == 16 then
				
				if Get(this,"PrintDocType"..this.PrintQueue) == "PiledUpPaperWorkAdmin" then
					Object.CreateJob(this,"ReplaceTinyDrumkitAdmin")
				else
					Object.CreateJob(this,"ReplaceTinyDrumkit")
				end
			end
		end
		
		local docType = Get(this,"PrintDocType"..this.PrintQueue)
		this.Tooltip = { "tooltip_NetworkPrinter",this.Id.i,"A",this.PrinterStatus,"B",this.PrintQueue,"C",docType,"D",this.PaperTray,"E",this.Toner,"F",this.DrumKit,"G",this.TriggeredBy.i,"H" }
	end
end

function MakeUserMad()
	local myUser = Find(this,"Prisoner",1)
	if next(myUser) then
		for thatUser, dist in pairs(myUser) do
			local rndChance = math.random()
			if rndChance >= 0.8 then
				thatUser.Misbehavior = 3
			end
			break
		end
	end
end

function JobComplete_ResetPrinter()
	Set(this,"PrintQueue",0)
	Set(this,"JobSize",0)
	Set(this,"PrintJobRequest",false)
	Set(this,"PrinterActive",false)
	Set(this,"PaperJam",false)
	Set(this,"FrustratingJam",false)
	Set(this,"QueueError",false)
	Set(this,"PrintDocType0","None")
	this.SubType = this.DefaultSubType + 1
end

function JobComplete_TinyPrinterPaper()
	Set(this,"PaperTray",250)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"TinyPrinterPaper")
	this.SubType = this.DefaultSubType + 1
end

function JobComplete_SmallPrinterPaper()
	Set(this,"PaperTray",500)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"SmallPrinterPaper")
	this.SubType = this.DefaultSubType + 1
end

function JobComplete_LargePrinterPaper()
	Set(this,"PaperTray",1500)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"LargePrinterPaper")
	this.SubType = this.DefaultSubType + 1
end

function JobComplete_ReplaceTinyToner()
	Set(this,"Toner",2500)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceTinyToner")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceSmallToner()
	Set(this,"Toner",5000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceSmallToner")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceLargeToner()
	Set(this,"Toner",10000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceLargeToner")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceTinyDrumkit()
	Set(this,"DrumKit",65000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceTinyDrumkit")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceSmallDrumkit()
	Set(this,"DrumKit",125000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceSmallDrumkit")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceLargeDrumkit()
	Set(this,"DrumKit",250000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceLargeDrumkit")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_FixPaperJam()
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	this.SubType = this.DefaultSubType + 1
	Object.CancelJob(this,"FixFrustratingPaperJam")
	Object.CancelJob(this,"FixPaperJam")
end

function JobComplete_FixFrustratingPaperJam()
	local rndFixed = math.random(1)
	if rndFixed >= 0.5 then
		Set(this,"PaperJam",false)
		Set(this,"FrustratingJam",false)
		Set(this,"PrinterActive",false)
		this.SubType = this.DefaultSubType + 1
		Object.CancelJob(this,"FixFrustratingPaperJam")
		Object.CancelJob(this,"FixPaperJam")
	else
		MakeUserMad()
	end
end


function JobComplete_TinyPrinterPaperAdmin()
	Set(this,"PaperTray",250)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"TinyPrinterPaperAdmin")
	this.SubType = this.DefaultSubType + 1
end

function JobComplete_SmallPrinterPaperAdmin()
	Set(this,"PaperTray",500)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"SmallPrinterPaperAdmin")
	this.SubType = this.DefaultSubType + 1
end

function JobComplete_LargePrinterPaperAdmin()
	Set(this,"PaperTray",1500)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"LargePrinterPaperAdmin")
	this.SubType = this.DefaultSubType + 1
end

function JobComplete_ReplaceTinyTonerAdmin()
	Set(this,"Toner",2500)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceTinyTonerAdmin")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceSmallTonerAdmin()
	Set(this,"Toner",5000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceSmallTonerAdmin")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceLargeTonerAdmin()
	Set(this,"Toner",10000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceLargeTonerAdmin")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceTinyDrumkitAdmin()
	Set(this,"DrumKit",65000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceTinyDrumkitAdmin")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceSmallDrumkitAdmin()
	Set(this,"DrumKit",125000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceSmallDrumkitAdmin")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_ReplaceLargeDrumkitAdmin()
	Set(this,"DrumKit",250000)
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	Object.CancelJob(this,"ReplaceLargeDrumkitAdmin")
	this.SubType = this.DefaultSubType + 1
	newRubbish = Object.Spawn("Garbage",this.Pos.x,this.Pos.y+1)
end

function JobComplete_FixPaperJamAdmin()
	Set(this,"PaperJam",false)
	Set(this,"PrinterActive",false)
	this.SubType = this.DefaultSubType + 1
	Object.CancelJob(this,"FixFrustratingPaperJamAdmin")
	Object.CancelJob(this,"FixPaperJamAdmin")
end

function JobComplete_FixFrustratingPaperJamAdmin()
	local rndFixed = math.random(1)
	if rndFixed >= 0.5 then
		Set(this,"PaperJam",false)
		Set(this,"FrustratingJam",false)
		Set(this,"PrinterActive",false)
		this.SubType = this.DefaultSubType + 1
		Object.CancelJob(this,"FixFrustratingPaperJamAdmin")
		Object.CancelJob(this,"FixPaperJamAdmin")
	--else
	--	MakeUserMad()
	end
end
