
local timeInit = 0
local initTimer = math.random()	-- only used when object is placed down.
								-- this will prevent a dozen objects being placed down at the same time from starting to calculate
								-- the TimeWarp all at the same moment, give your potato a break and spread the cpu load a bit :)
local Now = 0
local StartingMinute = 0
local EndingMinute = 0

local myMapSize = "UNKNOWN"
local mySlowTime = "UNKNOWN"

local myTimeWarpFactor = 0
local timeWarpFound = false

local timeTot = 0

local nearbyClassroomClients = {}
local nearbyFreeTimeClients = {}
local nearbyWorkClients = {}
local nearbyAdminClients = {}
local nearbySwitches = {}
local nearbyCircuits = {}
local nearbyStorages = {}
local nearbyNetworkPrinters = {}
local nearbyAdminNetworkPrinters = {}

local clientTot = 0
local clientUpdate = 2.5
local clientsToUpdate = 0

local MaxClients = 0
local CrossLinkedSwitches = 0
local ServerConnections = 0
local Uploads = 0

local Find = Object.GetNearbyObjects
local Get = Object.GetProperty
local Set = Object.SetProperty

function Create()
	Init()
	UpdateServers()
end

function UpdateServers()
	local nearbyServers = Find(this,"Server",10000)
	if next(nearbyServers) then
		for thatServer,dist in pairs(nearbyServers) do
			Set(thatServer,"UpdateClients",true)
		end
	end
end

function Init()
	Set(this,"HomeUID",me["id-uniqueId"])
	Set(this,"ServerBroken",false)
	Set(this,"ServerPower","ON")
	Set(this,"ServerStatus","NO POWER")
	Set(this,"ServerClients",0)
	Set(this,"UpdateClients",true)
	Set(this,"ServerFailures",0)
	Set(this,"AntivirusInstalled","None")
	Set(this,"ModuleType","None")
	Set(this,"ModuleStatus","Not installed")
	Set(this,"ModuleGateway","None")
	Set(this,"ModuleStorage",0)
	Set(this,"ModuleDataStream",0)
	
	-- MyTimer = Object.Spawn("DoorTimer",this.Pos.x,this.Pos.y)				-- a doortimer is used to check if electric cable is installed
	-- Set(MyTimer,"HomeUID",this.HomeUID)
	-- this.Slot0.i = MyTimer.Id.i
	-- this.Slot0.u = MyTimer.Id.u
	-- MyTimer.CarrierId.i = this.Id.i
	-- MyTimer.CarrierId.u = this.Id.u
	-- MyTimer.Loaded = true
	-- MyTimer.Hidden = true														-- hide doortimer since it's not needed to see this object
	
	this.Tooltip = "tooltip_Init_TimeWarpA"
	this.HasCustomReport = true		-- comment out to get the old buttons
end

-- Find stuff

function FindMyTimer()
	MyTimers = Find(this,"DoorTimer",3)
	if next(MyTimers) and tonumber(this.Slot0.i) > -1 then
		for thatTimer, dist in pairs(MyTimers) do
			if thatTimer.Id.i == this.Slot0.i then
				MyTimer = thatTimer
				break
			end
		end
	end
	if MyTimer == nil then
		-- RemoveServer()
		MyTimer = Object.Spawn("DoorTimer",this.Pos.x,this.Pos.y)				-- a doortimer is used to check if electric cable is installed
		Set(MyTimer,"HomeUID",this.HomeUID)
		this.Slot0.i = MyTimer.Id.i
		this.Slot0.u = MyTimer.Id.u
		MyTimer.CarrierId.i = this.Id.i
		MyTimer.CarrierId.u = this.Id.u
		MyTimer.Loaded = true
		MyTimer.Hidden = true														-- hide doortimer since it's not needed to see this object
		
	end
end

function FindMyPowerSwitch()
	MyPowerSwitches = Find(this,"PowerSwitch",3)
	if next(MyPowerSwitches) and tonumber(this.Slot1.i) > -1 then
		for thatSwitch, dist in pairs(MyPowerSwitches) do
			if thatSwitch.Id.i == this.Slot1.i then
				MyPowerSwitch = thatSwitch
				break
			end
		end
	end
	if MyPowerSwitch == nil then
		-- RemoveServer()
		MyPowerSwitch = Object.Spawn("PowerSwitch",this.Pos.x,this.Pos.y)		-- power switch to turn server on/off
		Set(MyPowerSwitch,"HomeUID",this.HomeUID)
		this.Slot1.i = MyPowerSwitch.Id.i
		this.Slot1.u = MyPowerSwitch.Id.u
		MyPowerSwitch.CarrierId.i = this.Id.i
		MyPowerSwitch.CarrierId.u = this.Id.u
		MyPowerSwitch.Loaded = true
		MyPowerSwitch.Switch = false												-- turn power switch off by default
		MyPowerSwitch.Tooltip = "tooltip_DeleteServer"
	end
end

function FindMyModule()
	local ModuleTypes = { "NetworkSwitch", "NetworkStorage", "LogicCircuit" }
	for _, ModuleType in ipairs(ModuleTypes) do
		local Modules = Find(this,ModuleType,3)
		for thatModule, _ in next, Modules do
			if thatModule.Id.i == this.Slot2.i then
				MyModule = thatModule
				break
			end
		end
	end
	if MyModule == nil then
		Interface.AddComponent(this,"shutdownServer", "Button", "tooltip_button_ServerShutdown",this.ServerShutdown,"X")
		Interface.AddComponent(this,"installNetworkSwitch", "Button", "tooltip_button_InstallSwitch")
		Interface.AddComponent(this,"installNetworkStorage", "Button", "tooltip_button_InstallStorage")
		Interface.AddComponent(this,"installNetworkLogicCircuit", "Button", "tooltip_button_InstallLogicCircuit")
	else
		Interface.AddComponent(this,"shutdownServer", "Button", "tooltip_button_ServerShutdown",this.ServerShutdown,"X")
		Interface.AddComponent(this,"removeServerModule", "Button", "tooltip_button_RemoveModule")
		if this.AntivirusInstalled == "None" then
			Interface.AddComponent(this,"installAntivirus", "Button", "tooltip_button_InstallAntivirus")
		end
	end
end

function FindNearestPrinter(theClient,ModuleLink)
	print("FindNearestPrinter to "..theClient.Id.i)
	local CurrentDist = 100
	nearbyPrinterToClient = Find(theClient,"NetworkPrinter",100)
	if next(nearbyPrinterToClient) then
		for thatnearbyPrinter, dist in pairs(nearbyPrinterToClient) do
			if dist <= CurrentDist and thatnearbyPrinter.TriggeredBy.i == ModuleLink then
				NearestNetworkPrinter = thatnearbyPrinter
				CurrentDist = dist
				print("Printer "..NearestNetworkPrinter.Id.i.." is valid candidate")
			end
		end
		if Exists(NearestNetworkPrinter) then
			print("Assigned printer "..NearestNetworkPrinter.Id.i.." to client "..theClient.Id.i)
			Set(theClient,"PrinterID",NearestNetworkPrinter.Id.i)
		end
		NearestNetworkPrinter = nil
	end
	nearbyPrinterToClient = nil
end

function PrintToNearestPrinter(theClient)
	local PrintJobIssued = false
	for thatNetworkPrinter, dist in pairs(nearbyNetworkPrinters) do
		if Exists(thatNetworkPrinter) and thatNetworkPrinter.Id.i == theClient.PrinterID and thatNetworkPrinter.PrintQueue < 25 then
			print("Printer "..thatNetworkPrinter.Id.i.." got job request from client "..theClient.Id.i)
			Set(thatNetworkPrinter,"PrintQueue",thatNetworkPrinter.PrintQueue + 1)
			Set(thatNetworkPrinter,"PrintDocType"..thatNetworkPrinter.PrintQueue,theClient.PrintDocType)
			Set(thatNetworkPrinter,"PrintJobRequest",true)
			Set(theClient,"PrintJobRequest",false)
			PrintJobIssued = true
		end
	end
	if PrintJobIssued == false then
		print("Client printerID reset")
		Set(theClient,"PrinterID",nil)
	end
end

function Exists(theObject)
	if theObject == nil or theObject.SubType == nil then
		return false
	else
		return true
	end
end

function FindActiveClients()
	local VirusOnNetwork = false
	ServerConnections = 0
	CrossLinkedSwitches = 0
	ConnectedStorages = 0
	Uploads = 0
	local ModuleLink = 0
	if Exists(MyModule) and MyModule.ModuleBroken == false then ModuleLink = MyModule.Id.i end
	if next(nearbyFreeTimeClients) then
		for thatFreeTimeClient, dist in pairs(nearbyFreeTimeClients) do
			if Exists(thatFreeTimeClient) and thatFreeTimeClient.TriggeredBy.i == ModuleLink then
				Set(thatFreeTimeClient,"TimeWarp",this.TimeWarp)
				ServerConnections = ServerConnections + 1
				if thatFreeTimeClient.HasVirus == true and this.AntivirusInstalled ~= "Yes" then
					VirusOnNetwork = true
				end
				if VirusOnNetwork == true then
					local rndChance1 = math.random(0,100)
					if rndChance1 == 11 then
						Set(thatFreeTimeClient,"HasVirus",true)
					end
				end
			end
		end
	end
	if next(nearbyClassroomClients) then
		for thatClassroomClient, dist in pairs(nearbyClassroomClients) do
			if Exists(thatClassroomClient) and thatClassroomClient.TriggeredBy.i == ModuleLink then
				Set(thatClassroomClient,"TimeWarp",this.TimeWarp)
				ServerConnections = ServerConnections + 1
			end
		end
	end
	if next(nearbyNetworkPrinters) then
		for thatNetworkPrinter, dist in pairs(nearbyNetworkPrinters) do
			if Exists(thatNetworkPrinter) and thatNetworkPrinter.TriggeredBy.i == ModuleLink then
				Set(thatNetworkPrinter,"TimeWarp",this.TimeWarp)
				ServerConnections = ServerConnections + 1
			end
		end
	end
	if next(nearbyWorkClients) then
		for thatWorkClient, dist in pairs(nearbyWorkClients) do
			if Exists(thatWorkClient) and thatWorkClient.TriggeredBy.i == ModuleLink then
				ServerConnections = ServerConnections + 1
				Set(thatWorkClient,"TimeWarp",this.TimeWarp)
				if thatWorkClient.PrintJobRequest == true then
					if thatWorkClient.PrinterID == nil then
						FindNearestPrinter(thatWorkClient,ModuleLink)
					else
						if next(nearbyNetworkPrinters) then
							PrintToNearestPrinter(thatWorkClient)
						else
							Set(thatWorkClient,"PrinterID",nil)
						end
					end
				elseif thatWorkClient.Uploading == true then
					Uploads = Uploads + 1
				end
			end
		end
	end
	if next(nearbyAdminClients) then
		for thatAdminClient, dist in pairs(nearbyAdminClients) do
			if Exists(thatAdminClient) and thatAdminClient.TriggeredBy.i == ModuleLink then
				ServerConnections = ServerConnections + 1
				Set(thatAdminClient,"TimeWarp",this.TimeWarp)
				if thatAdminClient.PrintJobRequest == true then
					if thatAdminClient.PrinterID == nil then
						FindNearestPrinter(thatAdminClient,ModuleLink)
					else
						if next(nearbyNetworkPrinters) then
							PrintToNearestPrinter(thatAdminClient)
						else
							Set(thatAdminClient,"PrinterID",nil)
						end
					end
				elseif thatAdminClient.Uploading == true then
					Uploads = Uploads + 1
				end
			end
		end
	end
	if next(nearbySwitches) then
		for thatSwitch, dist in pairs(nearbySwitches) do
			if Exists(thatSwitch) and ((thatSwitch.TriggeredBy.i == ModuleLink or thatSwitch.HomeUID == this.HomeUID) and (thatSwitch.ModuleStatus == "UP" or thatSwitch.ModuleStatus == "CrossLinked")) then
				ServerConnections = ServerConnections + 1
				if this.ModuleType == "Network Gateway" and (thatSwitch.ModuleStatus == "UP" or thatSwitch.ModuleStatus == "CrossLinked") then
					CrossLinkedSwitches = CrossLinkedSwitches + 1
				end
			end
		end
	end
	if next(nearbyCircuits) then
		for thatCircuit, dist in pairs(nearbyCircuits) do
			if Exists(thatCircuit) and thatCircuit.HomeUID == this.HomeUID and this.ServerStatus == "UP" then
				thatCircuit.Uploads = Uploads
				ServerConnections = ServerConnections + 1
			end
			if this.ModuleType == "Network Switch" and (this.ModuleStatus == "UP" or this.ModuleStatus == "CrossLinked") and MyModule.TriggeredBy.i == thatCircuit.Id.i then
				ServerConnections = ServerConnections + 22
				this.ModuleStatus = "CrossLinked"
				MyModule.ModuleStatus = "CrossLinked"
			end
		end
	end
	if next(nearbyStorages) then
		for thatStorage, dist in pairs(nearbyStorages) do
			if Exists(thatStorage) and (thatStorage.TriggeredBy.i == ModuleLink or thatStorage.HomeUID == this.HomeUID) and thatStorage.ModuleStatus == "UP" then
				ServerConnections = ServerConnections + 1
				ConnectedStorages = ConnectedStorages + 1
			end
		end
		for thatStorage, dist in pairs(nearbyStorages) do
			if Exists(thatStorage) and (this.ModuleType == "Network Gateway" or this.ModuleType == "Network Switch") and thatStorage.TriggeredBy.i == ModuleLink then
				if Uploads > 0 and ConnectedStorages > 0 then
					if thatStorage.ModuleBroken == false then
						thatStorage.DataStream = Uploads / ConnectedStorages
					end
				elseif Uploads == 0 then
					thatStorage.DataStream = 0
				end
			end
		end
	end
	if this.ModuleType == "Network Gateway" and this.ModuleStatus == "UP" and MyModule.Result == false then
		Set(this,"ServerClients",0)
	else
		Set(this,"ServerClients",ServerConnections)
	end
end

-- Buttons

function installNetworkSwitchClicked()
	if tonumber(this.Slot2.i) == -1 then
		Object.CreateJob(this,"InstallNetworkSwitch")
		Set(this,"ModuleType","Network Switch")
		Set(this,"ModuleStatus","Getting installed...")
		Interface.RemoveComponent(this,"installNetworkSwitch", "Button", "tooltip_button_InstallSwitch")
		Interface.RemoveComponent(this,"installNetworkStorage", "Button", "tooltip_button_InstallStorage")
		Interface.RemoveComponent(this,"installNetworkLogicCircuit", "Button", "tooltip_button_InstallLogicCircuit")
		Object.CancelJob(this,"InstallNetworkStorage")
		Object.CancelJob(this,"InstallNetworkLogicCircuit")
		Interface.AddComponent(this,"cancelModuleInstallation", "Button", "tooltip_button_CancelInstall")
	end
end

function installNetworkStorageClicked()
	if tonumber(this.Slot2.i) == -1 then
		Object.CreateJob(this,"InstallNetworkStorage")
		Set(this,"ModuleType","Network Storage")
		Set(this,"ModuleStatus","Getting installed...")
		Interface.RemoveComponent(this,"installNetworkSwitch", "Button", "tooltip_button_InstallSwitch")
		Interface.RemoveComponent(this,"installNetworkStorage", "Button", "tooltip_button_InstallStorage")
		Interface.RemoveComponent(this,"installNetworkLogicCircuit", "Button", "tooltip_button_InstallLogicCircuit")
		Object.CancelJob(this,"InstallNetworkSwitch")
		Object.CancelJob(this,"InstallNetworkLogicCircuit")
		Interface.AddComponent(this,"cancelModuleInstallation", "Button", "tooltip_button_CancelInstall")
	end
end

function installNetworkLogicCircuitClicked()
	if tonumber(this.Slot2.i) == -1 then
		Object.CreateJob(this,"InstallNetworkLogicCircuit")
		Set(this,"ModuleType","Network Gateway")
		Set(this,"ModuleStatus","Getting installed...")
		Interface.RemoveComponent(this,"installNetworkSwitch", "Button", "tooltip_button_InstallSwitch")
		Interface.RemoveComponent(this,"installNetworkStorage", "Button", "tooltip_button_InstallStorage")
		Interface.RemoveComponent(this,"installNetworkLogicCircuit", "Button", "tooltip_button_InstallLogicCircuit")
		Object.CancelJob(this,"InstallNetworkSwitch")
		Object.CancelJob(this,"InstallNetworkStorage")
		Interface.AddComponent(this,"cancelModuleInstallation", "Button", "tooltip_button_CancelInstall")
	end
end

function cancelModuleInstallationClicked()
	if tonumber(this.Slot2.i) == -1 then
		Interface.RemoveComponent(this,"cancelModuleInstallation", "Button", "tooltip_button_CancelInstall")
		Interface.AddComponent(this,"installNetworkSwitch", "Button", "tooltip_button_InstallSwitch")
		Interface.AddComponent(this,"installNetworkStorage", "Button", "tooltip_button_InstallStorage")
		Interface.AddComponent(this,"installNetworkLogicCircuit", "Button", "tooltip_button_InstallLogicCircuit")
		Object.CancelJob(this,"InstallNetworkSwitch")
		Object.CancelJob(this,"InstallNetworkStorage")
		Object.CancelJob(this,"InstallNetworkLogicCircuit")
		Set(this,"ModuleType","None")
		Set(this,"ModuleStatus","Not installed")
	end
end

function installAntivirusClicked()
	Object.CreateJob(this,"InstallAntivirus")
end

function removeServerModuleClicked()
	Interface.AddComponent(this,"cancelRemoveServerModule", "Button", "tooltip_button_CancelRemoval")
	Set(this,"ModuleStatus","Getting removed...")
	Set(MyModule,"ModuleStatus","Getting removed...")
	--	MyModule = nil
	Object.CreateJob(this,"RemoveModule")
end

function cancelRemoveServerModuleClicked()
	if tonumber(this.Slot2.i) >= -1 then
		Interface.RemoveComponent(this,"cancelRemoveServerModule", "Button", "tooltip_button_CancelRemoval")
		Interface.AddComponent(this,"removeServerModule", "Button", "tooltip_button_RemoveModule")
		Set(this,"ModuleStatus","UP")
		Set(MyModule,"ModuleStatus","UP")
		Object.CancelJob(this,"RemoveModule")
	end
end

function shutdownServerClicked()
	if this.ServerPower == "OFF" then Set(this,"ServerPower","ON") else Set(this,"ServerPower","OFF") end
	this.SetInterfaceCaption("shutdownServer", "tooltip_button_ServerShutdown",this.ServerPower,"X")
end
	
-- Update

function Update( timePassed )
	if this.TimeWarp == nil then
		if World.TimeWarpFactor ~= nil then
			Set(this,"TimeWarp",World.TimeWarpFactor)
			-- MyPowerSwitch = Object.Spawn("PowerSwitch",this.Pos.x,this.Pos.y)		-- power switch to turn server on/off
			-- Set(MyPowerSwitch,"HomeUID",this.HomeUID)
			-- this.Slot1.i = MyPowerSwitch.Id.i
			-- this.Slot1.u = MyPowerSwitch.Id.u
			-- MyPowerSwitch.CarrierId.i = this.Id.i
			-- MyPowerSwitch.CarrierId.u = this.Id.u
			-- MyPowerSwitch.Loaded = true
			-- MyPowerSwitch.Switch = false												-- turn power switch off by default
			-- MyPowerSwitch.Tooltip = "tooltip_DeleteServer"
			this.Tooltip = "tooltip_ReadyForAction"
		else
			CalculateTimeWarpFactor(timePassed)
		end
		return
	elseif timePerUpdate == nil then
		if this.ServerPower == nil then Set(this,"ServerPower","ON") end
		if Interface.SetReportTabs ~= nil then
			Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
		end
		FindMyTimer()
		FindMyPowerSwitch()
		FindMyModule()
		nearbyClassroomClients = Find(this,"ClassroomPC",10000)
		nearbyFreeTimeClients = Find(this,"FreeTimePC",10000)
		nearbyWorkClients = Find(this,"WorkPC",10000)
		nearbyAdminClients = Find(this,"AdminPC",10000)
		nearbySwitches = Find(this,"NetworkSwitch",10000)
		nearbyCircuits = Find(this,"LogicCircuit",10000)
		nearbyStorages = Find(this,"NetworkStorage",10000)
		nearbyNetworkPrinters = Find(this,"NetworkPrinter",10000)
		nearbyAdminNetworkPrinters = Find(this,"NetworkPrinterAdmin",10000)
		if World.TimeWarpFactor ~= nil then
			myTimeWarpFactor = World.TimeWarpFactor
		else
			myTimeWarpFactor = Get(this,"TimeWarp")
		end
		timePerUpdate = (0.25+math.random()+math.random()) / myTimeWarpFactor
		timePerClientCheck = (1+math.random()+math.random()) / myTimeWarpFactor
	end
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		--timePerUpdate = 0.25 / myTimeWarpFactor
		
		if this.ServerStatus == "NEEDS MAINTENANCE" then Object.CreateJob(this,"ServerMaintenance")
		elseif this.ServerStatus == "NEEDS REPAIR" then Object.CreateJob(this,"RepairServer") end
		
		if MyPowerSwitch.Switch == nil or MyTimer.Powered == nil then RemoveServer() end	-- if one of these objects was dismantled, get rid of the rest
		
		if MyTimer.Powered == false and MyPowerSwitch.Switch == true then MyPowerSwitch.Switch = false end	-- if the DoorTimer has no power, turn off the PowerSwitch
		if MyTimer.Powered == true and MyPowerSwitch.Switch == false and this.ServerPower == "ON" then MyPowerSwitch.Switch = true end -- if the DoorTimer gets power again after a remotely timed PowerSwitch/DoorTimer combination cut the power to the servers, and the server was not shut down manually, then bring it back up
		if MyTimer.Powered == true and MyPowerSwitch.Switch == true and this.ServerPower == "OFF" then MyPowerSwitch.Switch = false end -- if the DoorTimer has power and the PowerSwitch is still on, then turn it off if user requested a Server ShutDown
		
		if MyModule ~= nil then		-- copy status of installed module
			if MyModule.SubType ~= nil then
				Set(this,"ModuleStatus",MyModule.ModuleStatus)
				if this.ModuleType == "Network Gateway" then
					if MyModule.TriggeredBy.i ~= MyModule.Id.i then
						Set(this,"ModuleGateway",MyModule.TriggeredBy.i)
					else
						Set(this,"ModuleGateway",MyModule.Id.i)
					end
					if MyModule.Result == true and CrossLinkedSwitches > 0 then
						MaxClients = 22 * CrossLinkedSwitches + 24
					elseif MyModule.Result == true then
						MaxClients = 24
					elseif MyModule.Result == false then
						MaxClients = 0
					end
				elseif this.ModuleType == "Network Switch" then
					if MyModule.TriggeredBy.i > -1 then
						Set(this,"ModuleGateway",MyModule.TriggeredBy.i)
					else
						Set(this,"ModuleGateway",MyModule.Id.i)
					end
					MaxClients = 24
				elseif this.ModuleType == "Network Storage" then
					if MyModule.TriggeredBy.i > -1 then
						Set(this,"ModuleGateway",MyModule.TriggeredBy.i)
					else
						Set(this,"ModuleGateway",MyModule.Id.i)
					end
					Set(this,"ModuleStorage",string.sub(tostring(MyModule.DataStored),0,4))
					Set(this,"ModuleDataStream",MyModule.DataStream)
					MaxClients = 1
				end
				if MyModule.ModuleBroken == true then
					MyPowerSwitch.Switch = false
					MaxClients = 0
					Set(this,"ModuleGateway","Off-line")
					Set(MyModule,"Triggered",0)
					Set(MyModule,"TriggeredBy.i",-1)
					Set(MyModule,"TriggeredBy.u",-1)
				end
				if Exists(MyModule) then Set(MyModule,"AvailableConnections",MaxClients) end
			else
				MaxClients = 0
				Set(this,"ModuleType","None")	-- module was removed by player, show buttons to install new one
				Set(this,"ModuleStatus","Not installed")
				Set(this,"ModuleGateway","None")
				MyModule = nil
				if this.AntivirusInstalled == "None" then
					Interface.RemoveComponent(this,"installAntivirus", "Button", "tooltip_button_InstallAntivirus")
				end
				if this.AntivirusInstalled == true then this.AntivirusInstalled = "None" end
				Interface.AddComponent(this,"installNetworkSwitch", "Button", "tooltip_button_InstallSwitch")
				Interface.AddComponent(this,"installNetworkStorage", "Button", "tooltip_button_InstallStorage")
				Interface.AddComponent(this,"installNetworkLogicCircuit", "Button", "tooltip_button_InstallLogicCircuit")
				Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
			end
		else
			MaxClients = 0
			Set(this,"ServerClients",0)
			Set(this,"ModuleGateway","None")
			if this.ModuleStatus == "Getting installed..." then
				if this.ModuleType == "Network Switch" then Object.CreateJob(this,"InstallNetworkSwitch")
					elseif this.ModuleType == "Network Storage" then Object.CreateJob(this,"InstallNetworkStorage")
					elseif this.ModuleType == "Network Gateway" then Object.CreateJob(this,"InstallNetworkLogicCircuit")
				end
			elseif this.ModuleStatus == "Getting removed..." then
				Object.CreateJob(this,"RemoveModule")
			end
		end
		
		
		if MyTimer.Powered == true then		-- if the DoorTimer has juice, then the Server may operate
			
			if MyPowerSwitch.Switch == true then	-- if the Server is powered on
			
				if this.ServerBroken == false then
					if this.ModuleType ~= "Network Gateway" then
						local rndSub1 = math.random()
						local rndSub2 = math.random()
						if rndSub1 <= 0.99 then this.SubType = 4 end
						if rndSub1 <= 0.66 then this.SubType = 3 end
						if rndSub1 <= 0.33 then this.SubType = 2 end
						if rndSub1 <= 0.01 and rndSub2 <= 0.01 then
							Set(this,"ServerBroken",true)
							Set(this,"ServerFailures",this.ServerFailures+1)
							Set(this,"ServerClients",0)
							if Exists(MyModule) then Set(MyModule,"AvailableConnections",0) end
						else
							this.ServerStatus = "UP"
						end
					elseif this.ModuleStatus == "UP" then
						local rndSub1 = math.random()
						local rndSub2 = math.random()
						if rndSub1 <= 0.99 then this.SubType = 9 end
						if rndSub1 <= 0.66 then this.SubType = 8 end
						if rndSub1 <= 0.33 then this.SubType = 7 end
						if rndSub1 <= 0.01 and rndSub2 <= 0.01 then
							Set(this,"ServerBroken",true)
							Set(this,"ServerFailures",this.ServerFailures+1)
							Set(this,"ServerClients",0)
							MaxClients = MaxClients - 24
							if MaxClients < 0 then MaxClients = 0 end
							if Exists(MyModule) then Set(MyModule,"AvailableConnections",MaxClients) end
						else
							this.ServerStatus = "UP"
						end
						if MyModule.Result == false then
							local rndSub1 = math.random()
							local rndSub2 = math.random()
							if rndSub1 <= 0.99 then this.SubType = 12 end
							if rndSub1 <= 0.66 then this.SubType = 11 end
							if rndSub1 <= 0.33 then this.SubType = 10 end
						--	this.SubType = 6
						end
					end
					if this.ModuleType == "None" then
						this.SubType = 1
					end
				else
					MyPowerSwitch.Switch = false
					Set(this,"ServerClients",0)
					if Exists(MyModule) then Set(MyModule,"AvailableConnections",0) end
					if this.ModuleType == "Network Gateway" and this.ModuleStatus == "UP" then
						local rndSub1 = math.random()
						local rndSub2 = math.random()
						if MyModule.Result == false then
							this.SubType = 6
						else
							if rndSub1 <= 0.99 then this.SubType = 15 end
							if rndSub1 <= 0.66 then this.SubType = 14 end
							if rndSub1 <= 0.33 then this.SubType = 13 end
						end
					else
						this.SubType = 1
					end
					if this.ServerFailures >= 25 then
						this.ServerStatus = "NEEDS MAINTENANCE"
					else
						this.ServerStatus = "NEEDS REPAIR"
					end
				end
				
			else
				if this.ModuleType == "Network Gateway" and this.ModuleStatus == "UP" then 
					if MaxClients > 0 then MaxClients = MaxClients - 24 end
					if MaxClients < 0 then MaxClients = 0 end
					local rndSub1 = math.random()
					local rndSub2 = math.random()
					if MyModule.Result == false then
						this.SubType = 6
					else
						if rndSub1 <= 0.99 then this.SubType = 15 end
						if rndSub1 <= 0.66 then this.SubType = 14 end
						if rndSub1 <= 0.33 then this.SubType = 13 end
					end
					--this.SubType = 6
				else
					this.SubType = 1
				end
				Set(this,"ServerClients",0)
				if Exists(MyModule) then Set(MyModule,"AvailableConnections",0) end
				if this.ServerStatus == "UP" then this.ServerStatus = "DOWN"
				elseif this.ServerStatus == "NO POWER" then this.ServerStatus = "DOWN" end
			--	elseif this.ServerStatus == "NEEDS MAINTENANCE" then Object.CreateJob(this,"ServerMaintenance")
			--	elseif this.ServerStatus == "NEEDS REPAIR" then Object.CreateJob(this,"RepairServer") end
			end
		else
			if this.ModuleType == "Network Gateway" and this.ModuleStatus == "UP" then this.SubType = 5 else this.SubType = 0 end
			Set(this,"ServerClients",0)
			if Exists(MyModule) then Set(MyModule,"AvailableConnections",0) end
			this.ServerStatus = "NO POWER"
		end
		
		FindActiveClients()
		if this.ServerClients > MaxClients and MyPowerSwitch.Switch == true then
			MyPowerSwitch.Switch = false
			this.ServerStatus = "TOO MANY CLIENTS"
		elseif this.ServerClients <= MaxClients and MyPowerSwitch.Switch == false and this.ServerStatus == "TOO MANY CLIENTS" and MyTimer.Powered == true then
			MyPowerSwitch.Switch = true
			this.ServerStatus = "UP"
		end
		
		if this.ModuleType == "Network Storage" then
			this.Tooltip = {"tooltip_ServerStorage",this.ServerStatus,"A",this.ServerFailures,"B",this.ModuleType,"C",this.ModuleGateway,"D",this.ModuleStatus,"E",this.ModuleStorage,"F",this.ModuleDataStream,"G",this.AntivirusInstalled,"H"}
			
			if Exists(MyModule) then
				MyModule.Tooltip = {"tooltip_ServerStorage",this.ServerStatus,"A",this.ServerFailures,"B",this.ModuleType,"C",this.ModuleGateway,"D",this.ModuleStatus,"E",this.ModuleStorage,"F",this.ModuleDataStream,"G",this.AntivirusInstalled,"H"}
			end
		elseif this.ModuleType == "Network Gateway" then
			this.Tooltip = {"tooltip_ServerGateway",this.ModuleGateway,"A",this.ServerStatus,"B",this.ServerFailures,"C",this.ModuleType,"D",this.ModuleGateway,"E",this.ModuleStatus,"F",this.ServerClients,"G",MaxClients,"H",this.AntivirusInstalled,"I"}
			
			if Exists(MyModule) then
				MyModule.Tooltip = {"tooltip_ServerGateway",this.ModuleGateway,"A",this.ServerStatus,"B",this.ServerFailures,"C",this.ModuleType,"D",this.ModuleGateway,"E",this.ModuleStatus,"F",this.ServerClients,"G",MaxClients,"H",this.AntivirusInstalled,"I"}
			end
		else
			this.Tooltip = {"tooltip_Server",this.ServerStatus,"A",this.ServerFailures,"B",this.ModuleType,"C",this.ModuleGateway,"D",this.ModuleStatus,"E",this.ServerClients,"F",MaxClients,"G",this.AntivirusInstalled,"H"}
			
			if Exists(MyModule) then
				MyModule.Tooltip = {"tooltip_Server",this.ServerStatus,"A",this.ServerFailures,"B",this.ModuleType,"C",this.ModuleGateway,"D",this.ModuleStatus,"E",this.ServerClients,"F",MaxClients,"G",this.AntivirusInstalled,"H"}
			end
		end
	end
	
	clientTot = clientTot + timePassed
	if clientTot > clientUpdate then
		clientTot = 0
		
		if this.UpdateClients == true then
			nearbyClassroomClients = Find(this,"ClassroomPC",10000)
			nearbyFreeTimeClients = Find(this,"FreeTimePC",10000)
			nearbyWorkClients = Find(this,"WorkPC",10000)
			nearbyAdminClients = Find(this,"AdminPC",10000)
			nearbySwitches = Find(this,"NetworkSwitch",10000)
			nearbyCircuits = Find(this,"LogicCircuit",10000)
			nearbyStorages = Find(this,"NetworkStorage",10000)
			nearbyNetworkPrinters = Find(this,"NetworkPrinter",10000)
			Set(this,"UpdateClients",false)
		end
	end
end

function InstallServerModule(theObject,theType)
	MyModule = Object.Spawn(theObject,this.Pos.x,this.Pos.y)
	Set(MyModule,"HomeUID",this.HomeUID)
	Set(MyModule,"TimeWarp",this.TimeWarp)
	Set(MyModule,"ModuleStatus","UP")
	Set(MyModule,"ModuleBroken",false)
	Set(MyModule,"Tooltip","Module ID: "..MyModule.Id.i)
	
	this.Slot2.i = MyModule.Id.i
	this.Slot2.u = MyModule.Id.u
	MyModule.CarrierId.i = this.Slot2.i
	MyModule.CarrierId.u = this.Slot2.u
	MyModule.Loaded = true
	
	Set(this,"ModuleType",theType)
	Set(this,"ModuleStatus","UP")
	
	Interface.RemoveComponent(this,"cancelModuleInstallation", "Button", "tooltip_button_CancelInstall")
	Interface.AddComponent(this,"removeServerModule", "Button", "tooltip_button_RemoveModule")
	if this.AntivirusInstalled == "None" then
		Interface.AddComponent(this,"installAntivirus", "Button", "tooltip_button_InstallAntivirus")
	end
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

--Jobs

function JobComplete_InstallNetworkSwitch()
	InstallServerModule("NetworkSwitch","Network Switch")
	UpdateServers()
end

function JobComplete_InstallNetworkStorage()
	InstallServerModule("NetworkStorage","Network Storage")
	UpdateServers()
end

function JobComplete_InstallNetworkLogicCircuit()
	InstallServerModule("LogicCircuit","Network Gateway")
	UpdateServers()
	this.SubType = 5
end

function JobComplete_InstallAntivirus()
	Set(this,"AntivirusInstalled","Yes")
	Interface.RemoveComponent(this,"installAntivirus", "Button", "tooltip_button_InstallAntivirus")
	Object.CancelJob(this,"InstallAntivirus")
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

function JobComplete_RepairServer()
	if MyPowerSwitch == nil then FindMyPowerSwitch() end
	Set(this,"ServerBroken",false)
	Object.CancelJob(this,"RepairServer")
	MyPowerSwitch.Switch = true
	timeTot = timePerUpdate
end

function JobComplete_ServerMaintenance()
	if MyPowerSwitch == nil then FindMyPowerSwitch() end
	Set(this,"ServerBroken",false)
	Set(this,"ServerFailures",0)
	Object.CancelJob(this,"ServerMaintenance")
	MyPowerSwitch.Switch = true
	timeTot = timePerUpdate
end

function JobComplete_RemoveModule()
	if MyPowerSwitch == nil then FindMyPowerSwitch() end
	if MyTimer == nil then FindMyTimer() end
	RemoveServerModule()
	Object.CancelJob(this,"RemoveModule")
	UpdateServers()
	timeTot = timePerUpdate
end

-- remove stuff

function RemoveServerModule()
	local Obj = {"NetworkSwitch", "NetworkStorage", "LogicCircuit"}
	for _, Type in ipairs( Obj ) do
		local Objs = this.GetNearbyObjects( Type, 3 )
		for thatItem, _ in next, Objs do
			if thatItem.HomeUID == this.HomeUID then
				thatItem.CarrierId.i = -1
				thatItem.CarrierId.u = -1
				thatItem.Loaded = false
				this.Slot2.i = -1
				this.Slot2.u = -1
				thatItem.Delete()
			end
		end
	end
	MyModule = nil
	Set(this,"ModuleType","None")
	Set(this,"ModuleStatus","Not installed")
	Set(this,"ServerClients",0)
	Set(this,"HomeUID",this.Id.u)
	Interface.RemoveComponent(this,"cancelRemoveServerModule", "Button", "tooltip_button_CancelRemoval")
	if this.AntivirusInstalled == "None" then
		Interface.RemoveComponent(this,"installAntivirus", "Button", "tooltip_button_InstallAntivirus")
	end
	if this.AntivirusInstalled == "Yes" then Set(this,"AntivirusInstalled","None") end
	Interface.AddComponent(this,"installNetworkSwitch", "Button", "tooltip_button_InstallSwitch")
	Interface.AddComponent(this,"installNetworkStorage", "Button", "tooltip_button_InstallStorage")
	Interface.AddComponent(this,"installNetworkLogicCircuit", "Button", "tooltip_button_InstallLogicCircuit")
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
	local remains = Object.Spawn("Garbage",this.Pos.x-0.75,this.Pos.y+0.5)
end

function RemoveServer()
	local Obj = {"DoorTimer", "PowerSwitch", "NetworkSwitch", "NetworkStorage", "LogicCircuit"}
	for _, Type in ipairs( Obj ) do
		local Objs = this.GetNearbyObjects( Type, 3 )
		for thatItem, _ in next, Objs do
			if thatItem.HomeUID == this.HomeUID then
				thatItem.Delete()
			end
		end
	end
	this.Delete()
	return
end

function CalculateTimeWarpFactor(timePassed)
	if timeInit > initTimer then
	
		if timePerUpdate == nil then
			Now = math.floor(math.mod(World.TimeIndex,60))
			if not StartCountdown then
				if Now ~= StartingMinute then
				--	this.SubType = 1
					StartingMinute = Now
					if Now < 59 then
						EndingMinute = Now + 1				-- calculate TimeWarp within the next minute
						StartCountdown = true
					else
						return				-- wait another minute if object is placed 1 minute before next whole hour
					end
				end
			else
				timeTot=timeTot+timePassed
				this.Tooltip = {"tooltip_Init_TimeWarpB",StartingMinute,"A",EndingMinute,"B",Now,"C",timeTot,"D" }	-- show stopwatch
				if Now >= StartingMinute+1 then
					if timeTot >= 5.4 then			-- the result should be around 8 (1/8) for large map with slow time enabled, compare with 5.4 to compensate for lag
						myTimeWarpFactor = 0.125
					--	this.SubType = 2
						myMapSize = "LARGE"
						mySlowTime = "YES"
						timeWarpFound = true
					elseif timeTot >= 4.1 then		-- the result should be around 5.33 (3/16) for medium map with slow time enabled
						myTimeWarpFactor = 0.1875
					--	this.SubType = 3
						myMapSize = "MEDIUM"
						mySlowTime = "YES"
						timeWarpFound = true
					elseif timeTot >= 2.1 then		-- the result should be around 4 (1/4) for small map with slow time enabled
						myTimeWarpFactor = 0.25
					--	this.SubType = 4
						myMapSize = "SMALL"
						mySlowTime = "YES"
						timeWarpFound = true
					elseif timeTot >= 1.4 then		-- the result should be around 2 (1/2) for large map
						myTimeWarpFactor = 0.5
					--	this.SubType = 5
						myMapSize = "LARGE"
						mySlowTime = "NO"
						timeWarpFound = true
					elseif timeTot >= 1.1 then		-- the result should be around 1.33 (3/4) for medium map
						myTimeWarpFactor = 0.75
					--	this.SubType = 6
						myMapSize = "MEDIUM"
						mySlowTime = "NO"
						timeWarpFound = true
					else							-- the result should be around 1 (1) for small map
						myTimeWarpFactor = 1
					--	this.SubType = 7
						myMapSize = "SMALL"
						mySlowTime = "NO"
						timeWarpFound = true
					end
					
					-- Instead of using the hard coded TimeWarp values (found in de saved game and mentioned above),
					-- you could also calculate your own by dividing 1 minute by the time it took to get to that minute.
					-- The result will be approximately the hard coded TimeWarp value, but can be different for each object you place,
					-- depending on how busy the game is, this is should not be used by default:
					
					--timeWarpFound = false					-- enable to see this calculation result in action
					--if timeWarpFound == false then myTimeWarpFactor = 1 / timeTot end
					
					this.Tooltip = {"tooltip_Init_TimeWarpC",StartingMinute,"A",EndingMinute,"B",Now,"C",timeTot,"D",myMapSize,"E",myTimeWarpFactor,"F",mySlowTime,"G" }	-- show results
					
					-- set the timePerUpdate here so we get out of this function
					timePerUpdate = 1 / myTimeWarpFactor	-- will show the results for 3 game minutes
				end
			end
		else		-- calculation completed, so save the results
			timeTot = timeTot+timePassed
			if timeTot > timePerUpdate then
			--	this.SubType = 0						-- change sprite back to normal
				Set(this,"TimeWarp",myTimeWarpFactor)	-- this tells function Update() to proceed
				MyPowerSwitch = Object.Spawn("PowerSwitch",this.Pos.x,this.Pos.y)		-- power switch to turn server on/off
				Set(MyPowerSwitch,"HomeUID",this.HomeUID)
				this.Slot1.i = MyPowerSwitch.Id.i
				this.Slot1.u = MyPowerSwitch.Id.u
				MyPowerSwitch.CarrierId.i = this.Id.i
				MyPowerSwitch.CarrierId.u = this.Id.u
				MyPowerSwitch.Loaded = true
				MyPowerSwitch.Switch = false												-- turn power switch off by default
				MyPowerSwitch.Tooltip = "tooltip_DeleteServer"
				this.Tooltip = "tooltip_ReadyForAction"
				timePerUpdate = nil				-- reset to nil so function Update() can proceed with normal activity
			end
		end
	else
		timeInit = timeInit+timePassed
		StartingMinute = math.floor(math.mod(World.TimeIndex,60))
	end
end

-- Custom Reports window

function SetTabNames()
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

function PopulateReport( tabIndex )
	tabIndex = tonumber( tabIndex)
    local w, h = Interface.GetReportWindowSize()
	if w == nil	or h == nil then return end
	
    w = w - 20  -- Top level canvas scrollbar
    
    local rowHeight = math.min(w, h) / 25.0
    local rowGap = rowHeight * 2
    local y = 0
    
    -- Title
    Interface.AddReportComponent( 
        {
            Type = "Title", 
            Caption = "reportTitle_ServerConfiguration"
        }
    )
			
    if tabIndex == 1 then
		
		if this.TimeWarp == nil then
			
			Interface.AddReportComponent( 
				{
					Type = "Caption", 
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 1.25, 
					Caption = "reportTooltip_CaptionServerTimeWarp",
					Centred = true
				}
			)
			y = y + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "Image", 
					Name = "ImgOverview", 
					X = (w / 2) - (w / 4),
					Y = y, 
					W = w / 2, 
					H = w / 2, 
					File = "Report/report_ServerOverview.png", 
					Colour = "White"
				}
			)
			y = y + ( w / 2 ) - rowHeight + rowGap
			
			Interface.AddReportComponent( 
				{
					Type = "MultiLineText",
					Name = "TimeWarp",
					X = 0, 
					Y = y, 
					W = w, 
					H = rowHeight * 15, 
					LineSize = rowHeight, 
					Caption = "reportTooltip_ServerTimeWarp"
				}
			)
		else
			if this.ModuleStatus == "Not installed" then
				Interface.AddReportComponent( 
					{
						Type = "Caption", 
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 1.25, 
						Caption = "reportTooltip_CaptionServerOverview",
						Centred = true
					}
				)
				y = y + rowGap
					
				Interface.AddReportComponent( 
					{
						Type = "Image", 
						Name = "ImgOverview", 
						X = (w / 2) - (w / 4),
						Y = y, 
						W = w / 2, 
						H = w / 2, 
						File = "Report/report_ServerOverview.png", 
						Colour = "White"
					}
				)
				y = y + ( w / 2 ) - rowHeight + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "MultiLineText", 
						Name = "Overview",
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 4, 
						LineSize = rowHeight, 
						Caption = "reportTooltip_ServerOverview"
					}
				)
				y = y + rowHeight * 1.5 + rowGap
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "InstallSwitchModule",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight * 1.5, 
						LineSize = rowHeight, 
						Caption = "reportButton_InstallSwitchModule"
					}
				)
				y = y + rowHeight + rowGap
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "InstallGatewayModule",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight * 1.5, 
						LineSize = rowHeight, 
						Caption = "reportButton_InstallGatewayModule"
					}
				)
				y = y + rowHeight + rowGap
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "InstallStorageModule",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight * 1.5, 
						LineSize = rowHeight, 
						Caption = "reportButton_InstallStorageModule"
					}
				)
			elseif this.ModuleStatus == "Getting installed..." then
				Interface.AddReportComponent( 
					{
						Type = "Caption", 
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 1.25, 
						Caption = "reportTooltip_CaptionServerOverview",
						Centred = true
					}
				)
				y = y + rowGap
					
				Interface.AddReportComponent( 
					{
						Type = "Image", 
						Name = "ImgOverview", 
						X = (w / 2) - (w / 4),
						Y = y, 
						W = w / 2, 
						H = w / 2, 
						File = "Report/report_ServerOverview.png", 
						Colour = "White"
					}
				)
				y = y + ( w / 2 ) - rowHeight + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "MultiLineText", 
						Name = "Overview",
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 4, 
						LineSize = rowHeight, 
						Caption = "reportTooltip_ServerOverview"
					}
				)
				y = y + rowHeight * 1.5 + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "CancelInstallModule",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight * 1.5, 
						LineSize = rowHeight, 
						Caption = "reportButton_CancelInstallModule"
					}
				)
			elseif this.ModuleStatus == "Getting removed..." then
				Interface.AddReportComponent( 
					{
						Type = "Caption", 
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 1.25, 
						Caption = "reportTooltip_CaptionServerOverview",
						Centred = true
					}
				)
				y = y + rowGap
					
				Interface.AddReportComponent( 
					{
						Type = "Image", 
						Name = "ImgOverview", 
						X = (w / 2) - (w / 4),
						Y = y, 
						W = w / 2, 
						H = w / 2, 
						File = "Report/report_ServerOverview.png", 
						Colour = "White"
					}
				)
				y = y + ( w / 2 ) - rowHeight + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "MultiLineText", 
						Name = "Overview",
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 4, 
						LineSize = rowHeight, 
						Caption = "reportTooltip_ServerOverview"
					}
				)
				y = y + rowHeight * 1.5 + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "CancelRemoveServerModule",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight * 1.5, 
						LineSize = rowHeight, 
						Caption = "reportButton_CancelRemoveModule"
					}
				)
			elseif this.ModuleType ~= "None" then
				Interface.AddReportComponent( 
					{
						Type = "Caption", 
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 1.25, 
						Caption = "reportTooltip_CaptionServerOverview",
						Centred = true
					}
				)
				y = y + rowGap
					
				Interface.AddReportComponent( 
					{
						Type = "Image", 
						Name = "ImgOverview", 
						X = (w / 2) - (w / 4),
						Y = y, 
						W = w / 2, 
						H = w / 2, 
						File = "Report/report_ServerOverview.png", 
						Colour = "White"
					}
				)
				y = y + ( w / 2 ) - rowHeight + rowGap
				
				Interface.AddReportComponent( 
					{
						Type = "MultiLineText", 
						Name = "Overview",
						X = 0, 
						Y = y, 
						W = w, 
						H = rowHeight * 4, 
						LineSize = rowHeight, 
						Caption = "reportTooltip_ServerOverview"
					}
				)
				y = y + rowHeight * 1.5 + rowGap
			
				if this.ServerPower == "ON" then
					Interface.AddReportComponent( 
						{
							Type = "Button", 
							Name = "ShutdownTheServer",
							X = w / 4, 
							Y = y, 
							W = w / 2, 
							H = rowHeight * 1.5, 
							LineSize = rowHeight, 
							Caption = "reportButton_ShutdownTheServer"
						}
					)
				else
					Interface.AddReportComponent( 
						{
							Type = "Button", 
							Name = "BringUpTheServer",
							X = w / 4, 
							Y = y, 
							W = w / 2, 
							H = rowHeight * 1.5, 
							LineSize = rowHeight, 
							Caption = "reportButton_BringUpTheServer"
						}
					)
				end
				y = y + rowHeight * 1.5 + rowGap
			
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "RemoveServerModule",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight * 1.5, 
						LineSize = rowHeight, 
						Caption = "reportButton_RemoveServerModule"
					}
				)
				if this.AntivirusInstalled == "None" then
				y = y + rowHeight * 1.5 + rowGap
			
				Interface.AddReportComponent( 
					{
						Type = "Button", 
						Name = "InstallAntivirus",
						X = w / 4, 
						Y = y, 
						W = w / 2, 
						H = rowHeight * 1.5, 
						LineSize = rowHeight, 
						Caption = "reportButton_InstallAntivirus"
					}
				)
				end
			end
		end
    end
	
    if tabIndex == 2 then
		Interface.AddReportComponent(
			{
				Type = "Caption", 
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 1.25, 
				Caption = "reportTooltip_CaptionPowerCableTips",
				Centred = true
			}
		)
		y = y + rowGap
		
		Interface.AddReportComponent(
			{
				Type = "MultiLineText", 
				Name = "PowerCableTips",
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 19, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_PowerCableTips"
			}
		)
		y = y + (rowHeight * 17) + rowGap
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgPowerCable", 
				X = 0,
				Y = y, 
				W = w / 2, 
				H = w / 2, 
				File = "Report/report_PowerCables.png", 
				Colour = "White"
			}
		)
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgDoorTimer", 
				X = (w / 2),
				Y = y, 
				W = w / 2, 
				H = w / 2, 
				File = "Report/report_DoorTimer.png", 
				Colour = "White"
			}
		)
	end
	
    if tabIndex == 3 then
		Interface.AddReportComponent(
			{
				Type = "Caption", 
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 1.25, 
				Caption = "reportTooltip_CaptionServerModuleTips",
				Centred = true
			}
		)
		y = y + rowGap
		
		Interface.AddReportComponent(
			{
				Type = "MultiLineText", 
				Name = "ServerModuleTips",
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 2, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_ServerModuleTips"
			}
		)
		y = y + (rowHeight * 2) + rowGap
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgModuleGateway", 
				X = 0,
				Y = y, 
				W = w / 3, 
				H = w / 3, 
				File = "Report/report_NetworkGateway.png", 
				Colour = "White"
			}
		)
		
		Interface.AddReportComponent(
			{
				Type = "MultiLineText", 
				Name = "ServerModuleGatewayTips",
				X =  w / 3, 
				Y = y, 
				W =  (w / 3)+(w / 3), 
				H = rowHeight * 9, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_ServerModuleGatewayTips"
			}
		)
		y = y + (rowHeight * 7) + rowGap
		Interface.AddReportComponent(
			{
				Type = "MultiLineText", 
				Name = "ServerModuleSwitchTips",
				X =  0, 
				Y = y, 
				W =  (w / 3)+(w / 3), 
				H = rowHeight * 9, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_ServerModuleSwitchTips"
			}
		)
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgModuleSwitch",
				X = (w / 3)+(w / 3),
				Y = y, 
				W = w / 3, 
				H = w / 3, 
				File = "Report/report_NetworkSwitch.png", 
				Colour = "White"
			}
		)
		y = y + (rowHeight * 7) + rowGap
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgModuleStorage", 
				X = 0,
				Y = y, 
				W = w / 3, 
				H = w / 3, 
				File = "Report/report_NetworkStorage.png", 
				Colour = "White"
			}
		)
		Interface.AddReportComponent(
			{
				Type = "MultiLineText", 
				Name = "ServerModuleStorageTips",
				X =  w / 3, 
				Y = y, 
				W =  (w / 3)+(w / 3), 
				H = rowHeight * 9, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_ServerModuleStorageTips"
			}
		)
    end
	
    if tabIndex == 4 then
		Interface.AddReportComponent( 
			{
				Type = "Caption", 
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 1.25, 
				Caption = "reportTooltip_CaptionNetworkClientTips",
				Centred = true
			}
		)
		y = y + rowGap
		
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgWiringA", 
				X = (w / 3) / 2,
				Y = y, 
				W = (w * 0.75), 
				H = (w * 0.75), 
				File = "Report/report_Wiring1.png", 
				Colour = "White"
			}
		)
		y = y + (w * 0.75) + (rowGap / 2)
		
		Interface.AddReportComponent( 
			{
				Type = "MultiLineText", 
				Name = "NetworkClientTips",
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 10, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_NetworkClientTips"
			}
		)
	end
    if tabIndex == 5 then
		Interface.AddReportComponent( 
			{
				Type = "Caption", 
				X = 0, 
				Y = y, 
				W = w, 
				H = rowHeight * 1.25, 
				Caption = "reportTooltip_CaptionNetworkWiringTips",
				Centred = true
			}
		)
		y = y + rowGap
		
		Interface.AddReportComponent( 
			{
				Type = "Image", 
				Name = "ImgWiringB", 
				X = (w / 3) / 2,
				Y = y, 
				W = (w * 0.75), 
				H = (w * 0.75), 
				File = "Report/report_Wiring2.png", 
				Colour = "White"
			}
		)
		y = y + (w * 0.75) + (rowGap / 2)
		
		Interface.AddReportComponent( 
			{
				Type = "MultiLineText", 
				Name = "NetworkWiringTipsA",
				X = 0, 
				Y = y, 
				W = (w / 2), 
				H = rowHeight * 9, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_NetworkWiringTipsA"
			}
		)
		
		Interface.AddReportComponent( 
			{
				Type = "MultiLineText", 
				Name = "NetworkWiringTipsB",
				X = (w / 2), 
				Y = y, 
				W = (w / 2), 
				H = rowHeight * 9, 
				LineSize = rowHeight, 
				Caption = "reportTooltip_NetworkWiringTipsB"
			}
		)
	end
end

function ButtonPressed_InstallSwitchModule()
	installNetworkSwitchClicked()
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

function ButtonPressed_InstallAntivirus()
	installAntivirusClicked()
	Set(this,"AntivirusInstalled","Pending...")
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

function ButtonPressed_InstallGatewayModule()
	installNetworkLogicCircuitClicked()
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

function ButtonPressed_InstallStorageModule()
	installNetworkStorageClicked()
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

function ButtonPressed_CancelInstallModule()
	cancelModuleInstallationClicked()
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end
		
function ButtonPressed_ShutdownTheServer()
	shutdownServerClicked()
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

function ButtonPressed_BringUpTheServer()
	shutdownServerClicked()
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

function ButtonPressed_RemoveServerModule()
	removeServerModuleClicked()
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end

function ButtonPressed_CancelRemoveServerModule()
	cancelRemoveServerModuleClicked()
	Interface.SetReportTabs( "reportTab_ServerTab1","reportTab_ServerTab2","reportTab_ServerTab3","reportTab_ServerTab4","reportTab_ServerTab5")
end
