
local Find = Object.GetNearbyObjects

function FindMyBeacon()
	beaconFound = false
	nearbyBeacons = Find("Metro2Beacon",2)
	for thatBeacon, dist in pairs(nearbyBeacons) do
		MyBeacon = thatBeacon
		this.OriginX = thatBeacon.Pos.x
		this.OriginY = thatBeacon.Pos.y
		beaconFound = true
		print("Found beacon at distance: "..dist)
	end
	if beaconFound == false then
		nearbyBeacons = Find("Metro2Beacon",10000)
		for thatBeacon, dist in pairs(nearbyBeacons) do
			MyBeacon = thatBeacon
			if thatBeacon.Pos.x ~= this.OriginX then
				thatBeacon.Pos.x = this.OriginX
				thatBeacon.OriginX = this.Pos.x
				this.OriginX = thatBeacon.Pos.x
				this.OriginY = thatBeacon.Pos.y
			end
			beaconFound = true
			print("Found beacon at distance: "..dist)
		end
	end
end

function FindNearestMetro(fromX,fromY)
	if not Exists(MyBeacon) then FindMyBeacon() end
	metroFound = false
	local currDist = 999999
	if beaconFound == true then
		if GetFrom(MyBeacon,"CLASSROOMstationID") ~= "None" then
			local dX1 = fromX
			local dX2 = GetFrom(MyBeacon,"CLASSROOMstationPosX")
			local dY1 = fromY
			local dY2 = GetFrom(MyBeacon,"CLASSROOMstationPosY")
			local DistanceToMetro = math.sqrt((dX2-dX1)^2+(dY2-dY1)^2)
			print("Distance between my destination and old CLASSROOM station is "..DistanceToMetro)
			if DistanceToMetro <= currDist then
				currDist = DistanceToMetro
				Set("MetroX",GetFrom(MyBeacon,"CLASSROOMstationPosX"))
				Set("MetroY",GetFrom(MyBeacon,"CLASSROOMstationPosY"))
				metroFound = true
				print("Preferred station is old CLASSROOM station")
			end
		elseif GetFrom(MyBeacon,"PRISONstationID") ~= "None" then
			local dX1 = fromX
			local dX2 = GetFrom(MyBeacon,"PRISONstationPosX")
			local dY1 = fromY
			local dY2 = GetFrom(MyBeacon,"PRISONstationPosY")
			local DistanceToMetro = math.sqrt((dX2-dX1)^2+(dY2-dY1)^2)
			print("Distance between my destination and old PRISON station is "..DistanceToMetro)
			if DistanceToMetro <= currDist then
				currDist = DistanceToMetro
				Set("MetroX",GetFrom(MyBeacon,"PRISONstationPosX"))
				Set("MetroY",GetFrom(MyBeacon,"PRISONstationPosY"))
				metroFound = true
				print("Preferred station is old PRISON station")
			end
		end
		
		if GetFrom(MyBeacon,"Metro_1_PosX") ~= nil then	-- for new metro stations
			local i = 1
			local done = false
			local preferredStation = 0
			while not done do
				if GetFrom(MyBeacon,"Metro_"..i.."_PosX") ~= nil then
					local T = GetFrom(MyBeacon,"Metro_"..i.."_MetroType")
					local S = GetFrom(MyBeacon,"Metro_"..i.."_MetroScan")
					if T == "CLASSROOM" or T == "PRISON" then
						local dX1 = fromX
						local dX2 = GetFrom(MyBeacon,"Metro_"..i.."_PosX")
						local dY1 = fromY
						local dY2 = GetFrom(MyBeacon,"Metro_"..i.."_PosY")
						local DistanceToMetro = math.sqrt((dX2-dX1)^2+(dY2-dY1)^2)
						print("Distance between my destination and new station "..i.." ("..T..") is "..DistanceToMetro)
						if DistanceToMetro <= currDist and (S == "ExternalOnly" or S == "Default+Ext") then
							currDist = DistanceToMetro
							preferredStation = i
						end
					end
					i = i + 1
				else
					done = true
				end
			end
			if preferredStation > 0 then
				print("Preferred station is "..preferredStation)
				Set("MetroX",GetFrom(MyBeacon,"Metro_"..preferredStation.."_PosX"))
				Set("MetroY",GetFrom(MyBeacon,"Metro_"..preferredStation.."_PosY"))
				metroFound = true
			end
		end
		Set("MapBottom",GetFrom(MyBeacon,"MapBottom"))
	end
end

function Create()
	Set("OriginX",this.Pos.x)
	Set("OriginY",this.Pos.y+1)
	FindMyBeacon()
	this.Loaded = true
	this.Hidden = true
	this.Tooltip = "\nWaiting to receive my destination.\nThis might take some time, please be patient..."
	print("Waiting to receive my destination.")
	print("This might take some time, please be patient...")
end

function Update(timePassed)
	if not this.Init then
		if this.Dest.x == 0 then return end	-- wait until entity knows its destination
		print("--> Destination x: "..this.Dest.x.."  y: "..this.Dest.y)
		Set("DestinationX",this.Dest.x)	-- save destination
		Set("DestinationY",this.Dest.y)
		FindNearestMetro(this.DestinationX,this.DestinationY)
		if metroFound == true then	-- teleport to metrostation
			Set("Pos.x",this.MetroX)
			Set("Pos.y",this.MetroY)
			this.ClearRouting()
			Set("Dest.x",this.DestinationX)	-- restore destination after entity teleported to the metro station
			Set("Dest.y",this.DestinationY)
		else
			print("No metro station found.")
		end
		this.Tooltip = ""
		this.Hidden = false
		this.Loaded = false
		this.Init = true
	end
	if this.MapBottom ~= nil then
		if this.Dest.y >= World.NumCellsY-1 then
			Set("CurrentX",this.Pos.x)
			Set("CurrentY",this.Pos.y)
			FindNearestMetro(this.CurrentX,this.CurrentY)
			if metroFound == true then	-- clone walks back to the metrostation
				newTeacherClone = Object.Spawn("TeacherClone",this.Pos.x,this.Pos.y)
				newTeacherClone.SubType = this.SubType
				newTeacherClone.Dest.x = this.MetroX
				newTeacherClone.Dest.y = this.MetroY
				newTeacherClone.NavigateTo(this.MetroX,this.MetroY)
			end
			this.Delete()
		end
	end
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end

-------------------------------------------------------------------------------------------
-- Helper Functions
------------------------------------------------------------------------------------------- 
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end--]]


-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
    return Object
end