
local timeTot = 0
local timeVal = 0

local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local TreeTypes = { "Tree", "SpookyTree", "SnowyConiferTree", "CactusTree", "SakuraTree", "PalmTree", "Bush" }

local FoodStack		= { "Ingredients", "FoodTray", "StaffFoodBoxed", "Cooker", "Fridge", "Sink", "ServingTable", "Sprinkler"
					}
					
local LaundryStack	= { "PrisonerUniform", "VendingStackPrisonerUniform",
						"LaundryMachine", "IroningBoard", "LaundryBasket", "IroningBoardShort"
					}
					
local VendingStack	= { "ShopGoods", "LibraryBookUnsorted",
						"PaperCup", "WaterBottle", "VendingCoffee", "VendingFruit", "VendingWater", "VendingSnack", "VendingSandwich",
						"VendingStackFruit", "VendingStackSandwich", "VendingStackBurger", "VendingStackWater",
						"VendingStackSnack", "VendingStackCoffee", "VendingStackSoup", "VendingStackShop",
						"VendingStackNews", "VendingStackMedicine", "VendingStackOrangeJuice", "VendingStackWaterCooler",
						"VendingLotteryTicket", "VendingStackLottery"
					}
					
local ForestStack	= { "StackTrees", "ForestryTreeSaplingPlanted" }
					
local Workshop1Stack = { "SheetMetal", "Wood", "WorkshopSaw", "WorkshopPress", "CarpenterTable"
					}

local Workshop2Stack = { "CottonSeeds", "CottonSeed", "Compost", "ClothSpool"
					}

local Workshop3Stack = { "DirtyMoney"
					}
					
local Workshop4Stack = { "SheetAluminium"
					}

local Workshop5Stack = { "ServerParts", "PrinterPaperSmall", "PrinterPaperLarge", "PrinterTonerSmall",
						"PrinterTonerLarge", "PrinterDrumkitSmall", "PrinterDrumkitLarge"
					}

local BuildingStack = { "Brick", "Concrete", "Metal", "Steel",
						"ElectricalCable", "PipeLarge", "PipeSmall", "PipeHotWater",
						"PowerStation", "Capacitor", "WaterPumpStation", "WaterBoiler"
					}

local FloorStack	= { "FloorMaterial", "GrassTurf" }

-- A table holding all the tables above
local StackTypes = { FoodStack, LaundryStack, VendingStack, ForestStack, Workshop1Stack, Workshop2Stack, Workshop3Stack, Workshop4Stack, Workshop5Stack, BuildingStack, FloorStack }

-- StackDest is also the priority order to deliver
local StackDest  = { [1] = "Food",[2] = "Laundry",[3] = "Vending", [4] = "Forest", [5] = "Workshop1", [6] = "Workshop2", [7] = "Workshop3", [8] = "Workshop4", [9] = "Workshop5",[10] = "Building", [11] = "Floor",  [12] = "Other" }

-- Will become a table with all sorted items incoming at the Traffic Terminal room and waiting to be delivered
local StackInQueue = {  Food = {},
						Laundry = {},
						Vending = {},
						Forest = {},
						Workshop1 = {},
						Workshop2 = {},
						Workshop3 = {},
						Workshop4 = {},
						Workshop5 = {},
						Building = {},
						Floor = {},
						Other = {}
					}
local TotalQueuedStack = 0
local CleanUpCounter = 0

-- coordinates used to store items placed in an X-shape on a certain floor tile (instead of putting everything just on top of each other)
local StackSpotsCounter = 0
local StackSpots = { [1] = { X = -0.05, Y = -0.05 },
					 [2] = { X = -0.10, Y = -0.10 },
					 [3] = { X = -0.15, Y = -0.15 },
					 [4] = { X = -0.20, Y = -0.20 },
					 [5] = { X = 0.05, Y = 0.05 },
					 [6] = { X = 0.10, Y = 0.10 },
					 [7] = { X = 0.15, Y = 0.15 },
					 [8] = { X = 0.20, Y = 0.20 },
					 [9] = { X = 0.05, Y = -0.05 },
					 [10] = { X = 0.10, Y = -0.10 },
					 [11] = { X = 0.15, Y = -0.15 },
					 [12] = { X = 0.20, Y = -0.20 },
					 [13] = { X = -0.05, Y = 0.05 },
					 [14] = { X = -0.10, Y = 0.10 },
					 [15] = { X = -0.15, Y = 0.15 },
					 [16] = { X = -0.20, Y = 0.20 },
					}

-- A table holding all PrisonerStackHolders to deliver
local HoldersInQueue = {	MinSec = {},
							Normal = {},
							MaxSec = {},
							Protected = {},
							SuperMax = {},
							DeathRow = {},
							Insane = {}
						}

local PrisonerDest  = { [1] = "MinSec",[2] = "Normal",[3] = "MaxSec", [4] = "Protected", [5] = "SuperMax", [6] = "DeathRow", [7] = "Insane" }

-- A table holding all prisoners at the TrafficTerminal
local PrisonersInQueue = {	MinSec = {},
							Normal = {},
							MaxSec = {},
							Protected = {},
							SuperMax = {},
							DeathRow = {},
							Insane = {}
						}
						
local TotalQueuedPrisoners = 0

local HolderXY = { [1] = { X = 2,Y = 2 }, [2] = { X = 3,Y = 2 }, [3] = { X = 4,Y = 2 }, [4] = { X = 5,Y = 2 }, [5] = { X = 6, Y = 2 }, [6] = { X = 7 ,Y = 2 }, 
				   [7] = { X = 2,Y = 6 }, [8] = { X = 3,Y = 6 }, [9] = { X = 4,Y = 6 },[10] = { X = 5,Y = 6 },[11] = { X = 6, Y = 6 },[12] = { X = 7,Y = 6 }
				}	-- X/Y spots of the QueuedStackAreaTop and QueuedStackAreaBottom rows where sorted stack is kept until it gets delivered

local CurX = 1
local CurY = 1
local AllQuantity = 0

-- Will become a table with all cargo stations / helipads on the map
local Traffic = {}

function Create()
	World.CheatsEnabled=true
	World.ImmediateMaterials = true	-- no supply trucks will spawn, everything goes directly to the traffic terminal
end

function Update(timePassed)
	if timePerUpdate == nil then
		if not this.InitDone then
			DoOnce()
		end
	-------------------------------------------------------------------------------------------
		Interface.AddComponent(this,"DeleteTerminal", "Button", "tooltip_TrafficTerminal_Button_DeleteTerminal")
		Interface.AddComponent(this,"toggleAnimateChinook", "Button", "tooltip_TrafficTerminal_Button_AnimateChinook",this.AnimateChinook,"X")
		Interface.AddComponent(this,"TT_CaptionSeparatorLine", "Caption", "tooltip_TrafficTerminal_separatorline")
		Interface.AddComponent(this,"toggleDeliveryMethod", "Button", "tooltip_TrafficTerminal_DeliveryMethod",this.DeliveryMethod,"X")
		Interface.AddComponent(this,"toggleIntakeMethod", "Button", "tooltip_TrafficTerminal_IntakeMethod",this.IntakeMethod,"X")
		Interface.AddComponent(this,"RemoveStack", "Button", "tooltip_TrafficTerminal_Button_DeleteStack")
		AddSnitchButtons()
		FindMyStackTransferrer()			-- the thing at the top of the default road where supplytrucks spawn
		FindMyDisplays()					-- my display panels
		FindQueuedStackAreas()				-- the areas above and below the terminal where sorted stack is stored for delivery
		FindCargoStations()					-- all stations and helipads on the map
		FindKnownPrisoners()				-- rebuild the PrisonersInQueue tables with prisoners hidden below the terminal
		if not OtherTerminalDeleted then	-- rebuild the StackInQueue tables with what was sorted already after loading a game
			CurX,CurY,Forced = 2,2,true		-- orders CollectStack to put MyChecker at the Food tile of QueuedStackAreaTop
		end
		timePerUpdate = 0.15
	end
	
	if this.UpdateTraffic == true then
		FindCargoStations()
		timeTot = timePerUpdate
		return
	end
	
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		
		TransferStack()
		CollectStack(this.Pos.x,this.Pos.y)
		
		ResetPrisonerNeeds()		
		
	end
end

function ValidateExistingStations()			-- check if existing cargo stations / helipads are still on the map
	local AllOK = true
	for E = 1, #Traffic do
		if Traffic[E] == nil or not Exists(Traffic[E].CargoStation) then
			AllOK = false					-- something got removed by the player
			break
		end
	end
	if AllOK == false then
		FindCargoStations()					-- build a new table of existing stations
	end
end




	-------------------------------------------------------------------------------------------
	-- Cargo related
	-------------------------------------------------------------------------------------------


function InStackGroup(theContent,theGroup)	-- compares an item agains the given group to see if the content matches
	for _, typ in pairs(theGroup) do
		if theContent == typ then
			return true
		end
	end
	return false
end


	-------------------------------------------------------------------------------------------
	-- Transfers stack from the default road spot where supply trucks spawn and leave it behind
	-------------------------------------------------------------------------------------------
function TransferStack()
	if not Exists(MyStackTransferrer) then FindMyStackTransferrer() end
	MyStackTransferrer.Pos.y = 2
	if MyStackTransferrer.NewLoadAvailable == true then	-- set by supply trucks before they delete themselves
		local IncomingStuffToFind = { "Stack", "Box", "MailSatchel" }
		for S, typ in pairs(IncomingStuffToFind) do
			local incomingObjects = Find(MyStackTransferrer,typ,2)
			if next(incomingObjects) then
				local A = 0
				for thatItem, distance in pairs(incomingObjects) do
					if thatItem.Type ~= "MailSatchel" then
						Set(thatItem,"CarrierId.i",-1)
						Set(thatItem,"CarrierId.u",-1)
						Set(thatItem,"Loaded",false)
						local X = this.Pos.x-3+A	-- put the stuff on a random floor row at the terminal room
						local Y = this.Pos.y
						if math.random() > 0.90 then X = this.Pos.x-3+A; Y = this.Pos.y-3
						elseif math.random() > 0.70 then X = this.Pos.x-3+A; Y = this.Pos.y-1
						elseif math.random() > 0.50 then X = this.Pos.x-3+A; Y = this.Pos.y
						elseif math.random() > 0.30 then X = this.Pos.x+4-A; Y = this.Pos.y+1
						elseif math.random() > 0.20 then X = this.Pos.x+4-A; Y = this.Pos.y
						else X = this.Pos.x+4-A; Y = this.Pos.y-1
						end
						Set(thatItem,"Pos.x",X)
						Set(thatItem,"Pos.y",Y)
						Object.ApplyVelocity(thatItem,-0.5+math.random(),-0.5+math.random(),false)
						Set(thatItem,"Tooltip","Transferred by Traffic Terminal\nID: "..thatItem.Id.i)
						print(thatItem.Type.." ID: "..thatItem.Id.i.." Transferred by Traffic Terminal")
						A = A + 1
						if A > 7 then A = 0 end
					else
						Set(thatItem,"CarrierId.i",-1)
						Set(thatItem,"CarrierId.u",-1)
						Set(thatItem,"Loaded",false)
						Set(thatItem,"Pos.x",this.Pos.x-3+math.random(1,8))
						Set(thatItem,"Pos.y",this.Pos.y+3)
						Object.ApplyVelocity(thatItem,-0.5+math.random(),-0.5+math.random(),false)
						Set(thatItem,"Tooltip","Transferred by Traffic Terminal\nID: "..thatItem.Id.i)
						print(thatItem.Type.." ID: "..thatItem.Id.i.." Transferred by Traffic Terminal")
						A = A + 1
						if A > 7 then A = 0 end
					end
				end
			end
			incomingObjects = nil
		end
		MyStackTransferrer.NewLoadAvailable = nil
	end
	if MyStackTransferrer.NewIntakeAvailable == true then	-- set by prisoner buses before they delete themselves
		AddNewPrisoners()
		MyStackTransferrer.NewIntakeAvailable = nil
	end
end


	-------------------------------------------------------------------------------------------
	-- Walks from top left to bottom right of the terminal floor to consolidate stack onto several stack holders; checks 1 spot per Update() cycle
	-------------------------------------------------------------------------------------------
function CollectStack(PosX,PosY)
	local X = PosX-4
	local Y = PosY-4
	
	if not Exists(MyChecker) then
		FindMyChecker(PosX,PosY)
	end
	
	MyChecker.Pos.x, MyChecker.Pos.y = X+CurX,Y+CurY
	local StuffToFind = { "Stack", "Box" }
	for S, typ in pairs(StuffToFind) do
		local nearbyObjects = Find(MyChecker,typ,0.79)
		for thatItem, distance in pairs(nearbyObjects) do
			local SortedTo = ""
			if thatItem.Sorted == nil then
				print("CollectStack X:"..CurX.." Y:"..CurY.." -->> Processing new item: "..thatItem.Contents.." ID: "..thatItem.Id.i)
				local done = false
				for T = 1,11 do
					if InStackGroup(thatItem.Contents,StackTypes[T]) == true then	-- item belongs to one of the predefined stack types
						SortedTo = T
						done = true
						break
					end
				end
				if done == false then												-- item goes to Other stackholder
					SortedTo = 12
				end
			else
				print("CollectStack X:"..CurX.." Y:"..CurY.." -->> Processing known item: "..thatItem.Contains.." ID: "..thatItem.Id.i)
				SortedTo = thatItem.Sorted
			end
			
			local ForDestination = StackDest[SortedTo]
			table.insert( StackInQueue[ForDestination], thatItem )		-- add the item at the end of the specific StackInQueue table
			local num = #StackInQueue[ForDestination]					-- find out the total number of records of this table so whe know where the item is
			Set(StackInQueue[ForDestination][ num ],"Sorted",SortedTo)	-- add some more properties to the item
			Set(StackInQueue[ForDestination][ num ],"Contains",thatItem.Contents) -- (this is the same as writing thatItem.Contains = thatItem.Contents)
			Set(StackInQueue[ForDestination][ num ],"Tooltip","ID: "..thatItem.Id.i.."\nSorted by Traffic Terminal\nSorted to: "..StackDest[thatItem.Sorted].."\nContains: "..thatItem.Contains)
			print("CollectStack X:"..CurX.." Y:"..CurY.." -->> Sorted "..StackInQueue[ForDestination][ num ].Contains.." to "..StackDest[StackInQueue[ForDestination][ num ].Sorted])
			print("StackInQueue "..ForDestination.." has "..num.." records")
			StackSpotsCounter = StackSpotsCounter + 1	-- puts stuff on the specific tiles at QueuedStackAreas, laying items on top of each other in an X shape
			Set(StackInQueue[ForDestination][ num ],"Pos.x",X+HolderXY[thatItem.Sorted].X + StackSpots[StackSpotsCounter].X)
			Set(StackInQueue[ForDestination][ num ],"Pos.y",Y+HolderXY[thatItem.Sorted].Y + StackSpots[StackSpotsCounter].Y)
			if StackSpotsCounter >= 16 then StackSpotsCounter = 0 end	-- there are 16 spots for drawing an X on the floor tile
		end
		nearbyObjects = nil
	end
	local newMail = Find(MyChecker,"MailSatchel",0.79)							-- check mail seperately
	if next(newMail) then
		for thatMail, distance in pairs(newMail) do
			if thatMail.Sorted == nil then
				print("CollectStack X:"..CurX.." Y:"..CurY.." Processing new MailSatchel ID: "..thatMail.Id.i)
				SortedTo = 12
			else
				print("CollectStack X:"..CurX.." Y:"..CurY.." Processing known MailSatchel ID: "..thatMail.Id.i)
				SortedTo = thatMail.Sorted
			end
			local ForDestination = StackDest[SortedTo]
			table.insert( StackInQueue[ForDestination], thatMail )
			local num = #StackInQueue[ForDestination]
			Set(StackInQueue[ForDestination][ num ],"Sorted",SortedTo)
			Set(StackInQueue[ForDestination][ num ],"Contains","MailSatchel")
			Set(StackInQueue[ForDestination][ num ],"Tooltip","ID: "..thatMail.Id.i.."\nSorted by Traffic Terminal\nSorted to: "..StackDest[thatMail.Sorted].."\nContains: "..thatMail.Contains)

			StackSpotsCounter = StackSpotsCounter + 1
			Set(StackInQueue[ForDestination][ num ],"Pos.x",X+HolderXY[thatMail.Sorted].X + StackSpots[StackSpotsCounter].X)
			Set(StackInQueue[ForDestination][ num ],"Pos.y",Y+HolderXY[thatMail.Sorted].Y + StackSpots[StackSpotsCounter].Y)
			if StackSpotsCounter >= 16 then StackSpotsCounter = 0 end
		end
	end
	newMail = nil
	
	if CurX == 7 and CurY == 6 then
		local GrantCheckerToFind = { "GrantCheckerTerminal","GrantCheckerDeliveries","GrantCheckerExports","GrantCheckerGarbage", "GrantCheckerIntake","GrantCheckerEmergency" }
		for S, typ in pairs(GrantCheckerToFind) do
			local nearbyObjects = Find(MyChecker,typ,0.79)
			for thatGrant, distance in pairs(nearbyObjects) do
				if thatGrant.Sorted == nil then
					print("CollectStack X:"..CurX.." Y:"..CurY.." Processing new "..typ.." ID: "..thatGrant.Id.i)
					SortedTo = 12
				else
					print("CollectStack X:"..CurX.." Y:"..CurY.." Processing known "..typ.." ID: "..thatGrant.Id.i)
					SortedTo = thatGrant.Sorted
				end
				local ForDestination = StackDest[SortedTo]
				table.insert( StackInQueue[ForDestination], thatGrant )
				local num = #StackInQueue[ForDestination]
				Set(StackInQueue[ForDestination][ num ],"Sorted",SortedTo)
				Set(StackInQueue[ForDestination][ num ],"Contains",typ)
				Set(StackInQueue[ForDestination][ num ],"Tooltip","ID: "..thatGrant.Id.i.."\nSorted by Traffic Terminal\nSorted to: "..StackDest[thatGrant.Sorted].."\nContains: "..typ)

				StackSpotsCounter = StackSpotsCounter + 1
				Set(StackInQueue[ForDestination][ num ],"Pos.x",X+HolderXY[thatGrant.Sorted].X + StackSpots[StackSpotsCounter].X)
				Set(StackInQueue[ForDestination][ num ],"Pos.y",Y+HolderXY[thatGrant.Sorted].Y + StackSpots[StackSpotsCounter].Y)
				if StackSpotsCounter >= 16 then StackSpotsCounter = 0 end
			end
		end
	end
	
	TotalQueuedStack = 0
	for T = 1,12 do
		TotalQueuedStack = TotalQueuedStack + #StackInQueue[StackDest[T]]
	end
	
	this.Tooltip = { "tooltip_TrafficTerminal",this.DeliveryMethod,"X",this.IntakeMethod,"Y",TotalQueuedStack,"A",TotalQueuedPrisoners,"B",
	#PrisonersInQueue[PrisonerDest[1]],"C",
	#PrisonersInQueue[PrisonerDest[2]],"D",
	#PrisonersInQueue[PrisonerDest[3]],"E",
	#PrisonersInQueue[PrisonerDest[4]],"F",
	#PrisonersInQueue[PrisonerDest[5]],"G",
	#PrisonersInQueue[PrisonerDest[6]],"H",
	#PrisonersInQueue[PrisonerDest[7]],"I" }
	
	QueuedStackAreaTop.Tooltip = { "tooltip_StackInQueueTop_Totals",
	#StackInQueue[StackDest[1]],"A",
	#StackInQueue[StackDest[2]],"B",
	#StackInQueue[StackDest[3]],"C",
	#StackInQueue[StackDest[4]],"D",
	#StackInQueue[StackDest[5]],"E",
	#StackInQueue[StackDest[6]],"F" }
	
	QueuedStackAreaBottom.Tooltip = { "tooltip_StackInQueueBottom_Totals",
	#StackInQueue[StackDest[7]],"A",
	#StackInQueue[StackDest[8]],"B",
	#StackInQueue[StackDest[9]],"C",
	#StackInQueue[StackDest[10]],"D",
	#StackInQueue[StackDest[11]],"E",
	#StackInQueue[StackDest[12]],"F" }

	
	if this.DeliveryMethod == "SUSPEND" then
		if TotalQueuedStack > 0 then
			DisplayCargoL.SubType = 4
		else
			DisplayCargoL.SubType = 0
		end
		DisplayCargoR.SubType = 0
	else
		if TotalQueuedStack > 0 then
			DisplayCargoL.SubType = 3
		else
			DisplayCargoL.SubType = 2
		end
		DisplayCargoR.SubType = 1
	end
	
	CurX = CurX + 1							-- prepare for the next Update() cycle
	if CurX > 8 then						-- if MyChecker reaches the right wall then check if existing stations are still on the map
		ValidateExistingStations()
		
		CurY = CurY + 1						-- set the checker on the next row
		CurX = 1							-- at the left wall side
	end
	
	if not Forced then
		if CurY == 2 or CurY == 6 then		-- second and sixth row are for sorted stuff waiting to be delivered, these are walls where no other stack spawns
			if CurX == 2 then CurX = 8 end	-- jump over these walls
		end
	else
		if CurY == 2 and CurX > 7 then CurX,CurY = 2,6	-- CollectStack was executed by DeleteOtherTerminals(), or the game was loaded so we need to rebuild the StackInQueue
		elseif CurY == 6 and CurX > 7 then CurX,CurY,Forced = 1,1,nil end	-- in order to find previously sorted stuff on the walls
	end
	
	if CurY > 7 then						-- stacker reached the bottom row of the terminal area
		CurX = 1							-- place the checker at top left corner
		CurY = 1
		CycleDone = true					-- the room cycle has completed, Forced is no longer needed, start collecting new items as usual
		Forced = nil		
		CleanUpCounter = CleanUpCounter + 1	-- sometimes items stay on the floor after being loaded on a truck. No idea why, so this timer triggers a Forced scan

		if this.DeliveryMethod == "AUTO" then
			if TotalQueuedStack > 0 and StationOrPadFound == true then
				AutoSpawn("Cargo")			-- spawns trucks or chinooks
			elseif TotalQueuedStack == 0 and CleanUpCounter >= 2 then	-- if the terminal thinks there is no more stuff in queue, do a Forced scan to find leftovers
				CleanUpCounter,CurX,CurY,Forced = 0,2,2,true
				if TotalQueuedPrisoners == 0 then FindKnownPrisoners() end
			end
		end
	end
end


	-------------------------------------------------------------------------------------------
	-- Used when the delivery mode is set to AUTO
	-------------------------------------------------------------------------------------------
function AutoSpawn(theType)
	print("AutoSpawn")
	if theType == "Intake" then
		for A = 1, #Traffic do
			if TotalQueuedPrisoners > 0 and Exists(Traffic[A].CargoStation) and CompareIntake(Traffic[A].CargoStation) == true then
				Traffic[A].CargoStation.VehicleSpawned = "yes"
				if Traffic[A].CargoStation.Type == "CargoStopSign" then
					PrepareIntakeTruck(Traffic[A].CargoStation)
				else
					PrepareIntakeChinook(Traffic[A].CargoStation)
				end
				DisplayIntake.SubType = 2
				--break
			end
		end
	elseif theType == "Cargo" then
		for A = 1, #Traffic do
			if TotalQueuedStack > 0 and Exists(Traffic[A].CargoStation) and CompareCargo(Traffic[A].CargoStation) == true then
				Traffic[A].CargoStation.VehicleSpawned = "yes"
				if Traffic[A].CargoStation.Type == "CargoStopSign" then
					PrepareCargoTruck(Traffic[A].CargoStation)
				else
					PrepareCargoChinook(Traffic[A].CargoStation)
				end
				DisplayCargoR.SubType = 2
				--break
			end
		end
	end
end


	-------------------------------------------------------------------------------------------
	-- Check if the available cargo matches the cargo which the specified helipad accepts
	-------------------------------------------------------------------------------------------
function CompareCargo(theStation)
	local outcome = false
	print("AutoSpawn -->> Check Station: "..theStation.Number.." InUse: "..theStation.InUse.."  TrafficEnabled: "..theStation.TrafficEnabled.."  CargoType: "..theStation.CargoType.."  VehicleSpawned: "..theStation.VehicleSpawned)
	if theStation.CargoType == "Deliveries" and theStation.InUse == "no" and theStation.TrafficEnabled == "yes" and theStation.VehicleSpawned == "no" then
		for C = 1,12 do
			if #StackInQueue[StackDest[C]] > 0 then
				print("AutoSpawn -->> Station "..theStation.Number.." accepts "..StackDest[C].." delivery: "..Get(theStation,StackDest[C].."Delivery"))
				print("AutoSpawn -->> Available boxes/stack for "..StackDest[C].." is "..#StackInQueue[StackDest[C]])
				if Get(theStation,StackDest[C].."Delivery") == "yes" then
					outcome = true
				end
			end
		end
	end
	return outcome
end


function PrepareCargoTruck(theStation)
	print("--- PrepareCargoTruck for Station "..theStation.Number)
	Set(theStation,"BuildingQuantity",0)
	Set(theStation,"FloorsQuantity",0)
	Set(theStation,"LaundryQuantity",0)
	Set(theStation,"FoodQuantity",0)
	Set(theStation,"ForestQuantity",0)
	Set(theStation,"VendingQuantity",0)
	Set(theStation,"Workshop1Quantity",0)
	Set(theStation,"Workshop2Quantity",0)
	Set(theStation,"Workshop3Quantity",0)
	Set(theStation,"Workshop4Quantity",0)
	Set(theStation,"Workshop5Quantity",0)
	Set(theStation,"OtherQuantity",0)
	Set(theStation,"AllQuantity",0)
	AllQuantity = 0
	local newCargoTruck = Object.Spawn("CargoStationTruck",theStation.RoadX,math.random(5,6) + (math.random(10,99) / 100) + (math.random(10,99) / 100))
	Set(newCargoTruck,"HomeUID","CargoTruck_"..newCargoTruck.Id.u)
	Set(newCargoTruck,"TruckID",newCargoTruck.Id.u)
	Set(newCargoTruck,"Tail",6.5)
	Set(newCargoTruck,"Head",1.5)
	Set(newCargoTruck,"RoadX",theStation.RoadX)
	Set(newCargoTruck,"MyType","Cargo")
	Set(newCargoTruck,"SkinType","Deliveries")
	Set(newCargoTruck,"CargoStationID",theStation.CargoStationID)
	Set(newCargoTruck,"TruckY",2)
	
	local newTruckSkin = Object.Spawn("DeliveriesTruckSkin",theStation.RoadX,newCargoTruck.Pos.y)
	newTruckSkin.SubType = this.SubType_DeliveriesStationTruck	-- a skin with a higher renderdepth than the prisoners to cover the contents of the CargoStationTruck
	Set(newTruckSkin,"HomeUID",newCargoTruck.HomeUID)
	Set(newTruckSkin,"Slot0.i",newCargoTruck.Id.i)
	Set(newTruckSkin,"Slot0.u",newCargoTruck.Id.u)
	Set(newCargoTruck,"CarrierId.i",newTruckSkin.Id.i)
	Set(newCargoTruck,"CarrierId.u",newTruckSkin.Id.u)
	Set(newCargoTruck,"Loaded",true)
	newTruckSkin.Tooltip = { "tooltip_CargoStationTruck_TruckSkin",this.HomeUID,"H" }

	local newHL = Object.Spawn("WallLight",newTruckSkin.Pos.x,newTruckSkin.Pos.y)
	Set(newHL,"HomeUID",newCargoTruck.HomeUID)
	Set(newTruckSkin,"Slot1.i",newHL.Id.i)
	Set(newTruckSkin,"Slot1.u",newHL.Id.u)
	Set(newHL,"CarrierId.i",newTruckSkin.Id.i)
	Set(newHL,"CarrierId.u",newTruckSkin.Id.u)
	Set(newHL,"Loaded",true)
	local newHR = Object.Spawn("WallLight",newTruckSkin.Pos.x,newTruckSkin.Pos.y)
	Set(newHR,"HomeUID",newCargoTruck.HomeUID)
	Set(newTruckSkin,"Slot2.i",newHR.Id.i)
	Set(newTruckSkin,"Slot2.u",newHR.Id.u)
	Set(newHR,"CarrierId.i",newTruckSkin.Id.i)
	Set(newHR,"CarrierId.u",newTruckSkin.Id.u)
	Set(newHR,"Loaded",true)
	
	newTruckBay = Object.Spawn("CargoTruckBay",theStation.RoadX,1.5)
	Set(newTruckBay,"HomeUID",newCargoTruck.HomeUID)
	Set(newTruckBay,"CargoStationID",theStation.CargoStationID)
	Set(newTruckBay,"TruckBayNr",1)
	Set(newTruckBay,"CargoAmount",0)
	for i = 0,7 do
		Set(newTruckBay,"CargoLoad"..i,0)
	end
	
	LoadCargoByType(theStation,newTruckBay,1)
	newTruckBay.Tooltip = { "tooltip_Bay",newTruckBay.HomeUID,"H",newTruckBay.CargoStationID,"I",newTruckBay.TruckBayNr,"N",newTruckBay.CargoAmount,"A" }
	Set(newCargoTruck,"TotalCargoAmount",newTruckBay.CargoAmount)
	
	newTruckBay = Object.Spawn("CargoTruckBay",theStation.RoadX,1.5)
	Set(newTruckBay,"HomeUID",newCargoTruck.HomeUID)
	Set(newTruckBay,"CargoStationID",theStation.CargoStationID)
	Set(newTruckBay,"TruckBayNr",2)
	Set(newTruckBay,"CargoAmount",0)
	for i = 0,7 do
		Set(newTruckBay,"CargoLoad"..i,0)
	end
	
	if TotalQueuedStack > 0 then	-- try to load a second truckbay with more sorted stuff, so the total amount can be 16 boxes per truck
		LoadCargoByType(theStation,newTruckBay,2)
		newTruckBay.Tooltip = { "tooltip_Bay",newTruckBay.HomeUID,"H",newTruckBay.CargoStationID,"I",newTruckBay.TruckBayNr,"N",newTruckBay.CargoAmount,"A" }
		Set(newCargoTruck,"TotalCargoAmount",newCargoTruck.TotalCargoAmount + newTruckBay.CargoAmount)
	end								-- if no additional sorted crago was accepted by this station, then the second bay will stay empty, no problem

	if Get(newTruckBay,"CargoAmount") == 0 then newTruckBay.Delete() end
	
	Set(newCargoTruck,"Number",theStation.Number)
	
	Set(theStation,"AllQuantity",AllQuantity)
	Set(theStation,"InUse","yes")
	Set(theStation,"Status","ON ROUTE")
	theStation.Tooltip = { "tooltip_CargoStopSign_DeliveriesArriving",theStation.HomeUID,"X",theStation.CargoStationID,"Y",theStation.Number,"Z",theStation.AllQuantity,"T",theStation.FoodQuantity,"A",theStation.LaundryQuantity,"B",theStation.VendingQuantity,"C",theStation.ForestQuantity,"D",theStation.Workshop1Quantity,"E",theStation.Workshop2Quantity,"F",theStation.Workshop3Quantity,"G",theStation.Workshop4Quantity,"H",theStation.Workshop5Quantity,"I",theStation.BuildingQuantity,"J",theStation.FloorsQuantity,"K",theStation.OtherQuantity,"L" }

	local nearbyObject = Find(theStation,"CargoStationControl",8)
	if next(nearbyObject) then
		for thatControl, distance in pairs(nearbyObject) do
			if thatControl.MarkerUID == theStation.MarkerUID and thatControl.HomeUID == theStation.HomeUID then
				Set(thatControl,"SubType",7)
				break
			end
		end
	end
	nearbyObject = nil
	newCargoTruck = nil
	newTruckBay = nil
	print("--- PrepareCargoTruck --> ITEMS ON ROUTE TO CARGO STATION "..theStation.Number.." ---")
end

function PrepareCargoChinook(thePad)
	print("--- PrepareCargoChinook for Helipad "..thePad.Number)
	Set(thePad,"BuildingQuantity",0)
	Set(thePad,"FloorsQuantity",0)
	Set(thePad,"LaundryQuantity",0)
	Set(thePad,"FoodQuantity",0)
	Set(thePad,"ForestQuantity",0)
	Set(thePad,"VendingQuantity",0)
	Set(thePad,"Workshop1Quantity",0)
	Set(thePad,"Workshop2Quantity",0)
	Set(thePad,"Workshop3Quantity",0)
	Set(thePad,"Workshop4Quantity",0)
	Set(thePad,"Workshop5Quantity",0)
	Set(thePad,"OtherQuantity",0)
	Set(thePad,"AllQuantity",0)
	AllQuantity = 0
	local newChinook = Object.Spawn("Chinook2",4,thePad.Pos.y-5)
	Set(newChinook,"HomeUID","CargoChinook_"..string.sub(newChinook.Id.u,-2))
	Set(newChinook,"MyType","Cargo")
	if Get(this,"AnimateChinook") == "yes" then
		local ChinookLightBack = Object.Spawn("StatusLight",newChinook.Pos.x-2.9,newChinook.Pos.y-1)
		Set(ChinookLightBack,"HomeUID",newChinook.HomeUID)
		Set(ChinookLightBack,"Spot","Back")
		Set(ChinookLightBack,"Or.x",0)
		Set(ChinookLightBack,"Or.y",-1)
		Set(newChinook,"Slot0.i",ChinookLightBack.Id.i)
		Set(newChinook,"Slot0.u",ChinookLightBack.Id.u)
		Set(ChinookLightBack,"Loaded",true)
		
		local ChinookLightFront = Object.Spawn("StatusLight",newChinook.Pos.x+5.85,newChinook.Pos.y-1)
		Set(ChinookLightFront,"HomeUID",newChinook.HomeUID)
		Set(ChinookLightFront,"Spot","Front")
		Set(ChinookLightFront,"Or.x",0)
		Set(ChinookLightFront,"Or.y",-1)
		Set(newChinook,"Slot1.i",ChinookLightFront.Id.i)
		Set(newChinook,"Slot1.u",ChinookLightFront.Id.u)
		Set(ChinookLightFront,"Loaded",true)
		
	end
	
	newChinookHook = Object.Spawn("CargoChinookHook",newChinook.Pos.x+2.1,newChinook.Pos.y-2.7)
	Set(newChinookHook,"HomeUID",newChinook.HomeUID)
	Set(newChinookHook,"HeliPadID",thePad.HomeUID)
	Set(newChinookHook,"HookNr",1)
	Set(newChinookHook,"CargoAmount",0)
	for i = 0,7 do
		Set(newChinookHook,"CargoLoad"..i,0)
	end
	
	LoadCargoByType(thePad,newChinookHook,1)
	newChinookHook.Tooltip = { "tooltip_ChinookHook",newChinookHook.HomeUID,"H",newChinookHook.HeliPadID,"I",newChinookHook.HookNr,"N",newChinookHook.CargoAmount,"A" }
	Set(newChinook,"TotalCargoAmount",newChinookHook.CargoAmount)
	
	Set(newChinook,"Slot2.i",newChinookHook.Id.i)
	Set(newChinook,"Slot2.u",newChinookHook.Id.u)
	Set(newChinookHook,"Loaded",true)
	
	newChinookHook = Object.Spawn("CargoChinookHook",newChinook.Pos.x+2.1,newChinook.Pos.y-2.7)
	Set(newChinookHook,"HomeUID",newChinook.HomeUID)
	Set(newChinookHook,"HeliPadID",thePad.HomeUID)
	Set(newChinookHook,"HookNr",2)
	Set(newChinookHook,"CargoAmount",0)
	for i = 0,7 do
		Set(newChinookHook,"CargoLoad"..i,0)
	end
	
	if TotalQueuedStack > 0 then	-- load a second hook, so the total amount can be 16 boxes per chinook
		LoadCargoByType(thePad,newChinookHook,2)
		newChinookHook.Tooltip = { "tooltip_ChinookHook",newChinookHook.HomeUID,"H",newChinookHook.HeliPadID,"I",newChinookHook.HookNr,"N",newChinookHook.CargoAmount,"A" }
		Set(newChinook,"TotalCargoAmount",newChinook.TotalCargoAmount + newChinookHook.CargoAmount)
	end
	
	Set(newChinook,"Slot3.i",newChinookHook.Id.i)
	Set(newChinook,"Slot3.u",newChinookHook.Id.u)
	Set(newChinookHook,"Loaded",true)
	
	Set(thePad,"AllQuantity",AllQuantity)
	
	Set(newChinook,"PadX",thePad.Pos.x-0.5+math.random())
	Set(newChinook,"PadY",thePad.Pos.y-5+math.random())
	Set(newChinook,"HeliPadID",thePad.HomeUID)
	Set(newChinook,"EdgeX",World.NumCellsX - 6)
	Set(newChinook,"EdgeY",newChinook.PadY)
	Set(newChinook,"AnimateChinook",Get(this,"AnimateChinook"))
	Set(newChinook,"VehicleState","ToHelipad")
	Set(newChinook,"Number",thePad.Number)
	newChinook.Tooltip = { "tooltip_Chinook2_Status",newChinook.HomeUID,"X",newChinook.VehicleState,"Y" }
   
	Set(thePad,"InUse","yes")
	Set(thePad,"Status","ON ROUTE")
	thePad.Tooltip = { "tooltip_CargoHelipad_DeliveriesArriving",thePad.HomeUID,"Y",thePad.Number,"Z",thePad.AllQuantity,"T",thePad.FoodQuantity,"A",thePad.LaundryQuantity,"B",thePad.VendingQuantity,"C",thePad.ForestQuantity,"D",thePad.Workshop1Quantity,"E",thePad.Workshop2Quantity,"F",thePad.Workshop3Quantity,"G",thePad.Workshop4Quantity,"H",thePad.Workshop5Quantity,"I",thePad.BuildingQuantity,"J",thePad.FloorsQuantity,"K",thePad.OtherQuantity,"L" }
	newChinookHook = nil
	print("--- PrepareCargoChinook --> ITEMS ON ROUTE TO HELIPAD "..thePad.Number.." ---")
end


	-------------------------------------------------------------------------------------------
	-- Load stack onto the CargoTruck/Chinook according to what the CargoStation/Helipad will accept
	-------------------------------------------------------------------------------------------
function LoadCargoByType(theStation,theBay,theNumber)
	print("--- LoadCargoByType -->> Fill "..theBay.Type.." number "..theNumber)
	
	local theAmount = 0
	for C = 1,12 do
		local DeliverTo = StackDest[C]
		if #StackInQueue[DeliverTo] > 0 then	-- if the total number of records from the specific StackInQueue table holds items
			print("Available: "..#StackInQueue[DeliverTo])
			if Get(theStation,DeliverTo.."Delivery") == "yes" then
				for D = theAmount,7 do
					local foundQ = false
					local LQ = 0
					for Q = 1,#StackInQueue[DeliverTo] do
						if Exists(StackInQueue[DeliverTo][Q]) then
							foundQ = true
							LQ = Q
							break
						else
							table.remove(StackInQueue[DeliverTo],Q)	-- item got teleported already, remove this record item from the StackInQueue table
						end
					end
					if foundQ == true and Exists(StackInQueue[DeliverTo][LQ]) then	-- first in/first out, so the first item from specific StackInQueue table C is delivered
						print("Loading item ID "..StackInQueue[DeliverTo][LQ].Id.i.." in "..theBay.Type.." Slot "..D)
						Set(theBay,"Slot"..D..".i",StackInQueue[DeliverTo][LQ].Id.i)
						Set(theBay,"Slot"..D..".u",StackInQueue[DeliverTo][LQ].Id.u)
						Set(StackInQueue[DeliverTo][LQ],"CarrierId.i",theBay.Id.i)
						Set(StackInQueue[DeliverTo][LQ],"CarrierId.u",theBay.Id.u)
						Set(StackInQueue[DeliverTo][LQ],"Loaded",true)
						Set(theBay,"CargoLoad"..D,theStation.CargoStationID)
						Set(theStation,StackDest[C].."Quantity",Get(theStation,StackDest[C].."Quantity") + 1)
						table.remove(StackInQueue[DeliverTo],LQ)	-- remove this record item from the StackInQueue table
						theAmount = theAmount + 1
						AllQuantity = AllQuantity + 1
					end
				end
				--Set(theBay,"CargoAmount",theAmount)
			end
		end
		--AllQuantity = AllQuantity + Get(theStation,StackDest[C].."Quantity")
	end
	Set(theBay,"CargoAmount",theAmount)
	print("CargoAmount on bay: "..theBay.CargoAmount)
	
	
	TotalQueuedStack = 0
	for T = 1,12 do
		TotalQueuedStack = TotalQueuedStack + #StackInQueue[StackDest[T]]
	end
	
	this.Tooltip = { "tooltip_TrafficTerminal",this.DeliveryMethod,"X",this.IntakeMethod,"Y",TotalQueuedStack,"A",TotalQueuedPrisoners,"B",
	#PrisonersInQueue[PrisonerDest[1]],"C",
	#PrisonersInQueue[PrisonerDest[2]],"D",
	#PrisonersInQueue[PrisonerDest[3]],"E",
	#PrisonersInQueue[PrisonerDest[4]],"F",
	#PrisonersInQueue[PrisonerDest[5]],"G",
	#PrisonersInQueue[PrisonerDest[6]],"H",
	#PrisonersInQueue[PrisonerDest[7]],"I" }
	
	QueuedStackAreaTop.Tooltip = { "tooltip_StackInQueueTop_Totals",
	#StackInQueue[StackDest[1]],"A",
	#StackInQueue[StackDest[2]],"B",
	#StackInQueue[StackDest[3]],"C",
	#StackInQueue[StackDest[4]],"D",
	#StackInQueue[StackDest[5]],"E",
	#StackInQueue[StackDest[6]],"F" }
	
	QueuedStackAreaBottom.Tooltip = { "tooltip_StackInQueueBottom_Totals",
	#StackInQueue[StackDest[7]],"A",
	#StackInQueue[StackDest[8]],"B",
	#StackInQueue[StackDest[9]],"C",
	#StackInQueue[StackDest[10]],"D",
	#StackInQueue[StackDest[11]],"E",
	#StackInQueue[StackDest[12]],"F" }
	
	DisplayCargoR.SubType = 2
end



	-------------------------------------------------------------------------------------------
	-- Intake related
	-------------------------------------------------------------------------------------------
	
	
function PrepareIntakeTruck(theStation)
	print("--- PrepareIntakeTruck for Station "..theStation.Number)
	Set(theStation,"MinSecQuantity",0)
	Set(theStation,"NormalQuantity",0)
	Set(theStation,"MaxSecQuantity",0)
	Set(theStation,"SuperMaxQuantity",0)
	Set(theStation,"ProtectedQuantity",0)
	Set(theStation,"DeathRowQuantity",0)
	Set(theStation,"InsaneQuantity",0)
	Set(theStation,"PrisQuantity",0)
	PrisQuantity = 0
	local newIntakeTruck = Object.Spawn("CargoStationTruck",theStation.RoadX,math.random(5,6) + (math.random(10,99) / 100) + (math.random(10,99) / 100))
	Set(newIntakeTruck,"HomeUID","IntakeTruck_"..newIntakeTruck.Id.u)
	Set(newIntakeTruck,"TruckID",newIntakeTruck.Id.u)
	Set(newIntakeTruck,"Tail",4)
	Set(newIntakeTruck,"Head",1.25)
	Set(newIntakeTruck,"RoadX",theStation.RoadX)
	Set(newIntakeTruck,"MyType","Intake")
	Set(newIntakeTruck,"SkinType","Intake")
	Set(newIntakeTruck,"TruckY",0.25)
	Set(newIntakeTruck,"CargoStationID",theStation.CargoStationID)
	
	local newTruckSkin = Object.Spawn("IntakeTruckSkin",theStation.RoadX,newIntakeTruck.Pos.y)
	newTruckSkin.SubType = this.SubType_IntakeStationTruck	-- a skin with a higher renderdepth than the prisoners to cover the contents of the CargoStationTruck
	Set(newTruckSkin,"HomeUID",newIntakeTruck.HomeUID)
	Set(newTruckSkin,"Slot0.i",newIntakeTruck.Id.i)
	Set(newTruckSkin,"Slot0.u",newIntakeTruck.Id.u)
	Set(newIntakeTruck,"CarrierId.i",newTruckSkin.Id.i)
	Set(newIntakeTruck,"CarrierId.u",newTruckSkin.Id.u)
	Set(newIntakeTruck,"Loaded",true)
	newIntakeTruck.Tooltip = { "tooltip_CargoStationTruck_TruckSkin",this.HomeUID,"H" }
	
	local newHL = Object.Spawn("WallLight",newTruckSkin.Pos.x,newTruckSkin.Pos.y)
	Set(newTruckSkin,"Slot1.i",newHL.Id.i)
	Set(newTruckSkin,"Slot1.u",newHL.Id.u)
	Set(newHL,"CarrierId.i",newTruckSkin.Id.i)
	Set(newHL,"CarrierId.u",newTruckSkin.Id.u)
	Set(newHL,"Loaded",true)
	Set(newHL,"HomeUID",newIntakeTruck.HomeUID)
	local newHR = Object.Spawn("WallLight",newTruckSkin.Pos.x,newTruckSkin.Pos.y)
	Set(newTruckSkin,"Slot2.i",newHR.Id.i)
	Set(newTruckSkin,"Slot2.u",newHR.Id.u)
	Set(newHR,"CarrierId.i",newTruckSkin.Id.i)
	Set(newHR,"CarrierId.u",newTruckSkin.Id.u)
	Set(newHR,"Loaded",true)
	Set(newHR,"HomeUID",newIntakeTruck.HomeUID)
	
	newTruckBay = Object.Spawn("IntakeTruckBay",theStation.RoadX,1.25)
	Set(newTruckBay,"HomeUID",newIntakeTruck.HomeUID)
	Set(newTruckBay,"CargoStationID",theStation.CargoStationID)
	Set(newTruckBay,"TruckBayNr",1)
	Set(newTruckBay,"CargoAmount",0)
	for i = 0,7 do
		Set(newTruckBay,"CargoLoad"..i,0)
	end
	
	LoadIntakeBySecLevel(theStation,newTruckBay,1)
	newTruckBay.Tooltip = { "tooltip_BayIntake",newTruckBay.HomeUID,"H",newTruckBay.CargoStationID,"I",newTruckBay.TruckBayNr,"N",newTruckBay.CargoAmount,"A" }
	Set(newIntakeTruck,"TotalCargoAmount",newTruckBay.CargoAmount)
	
	newTruckBay = Object.Spawn("IntakeTruckBay",theStation.RoadX,1.25)
	Set(newTruckBay,"HomeUID",newIntakeTruck.HomeUID)
	Set(newTruckBay,"Tooltip","\nVehicle ID: "..newTruckBay.HomeUID.." Bay 2")
	Set(newTruckBay,"CargoStationID",theStation.CargoStationID)
	Set(newTruckBay,"TruckBayNr",2)
	Set(newTruckBay,"CargoAmount",0)
	for i = 0,7 do
		Set(newTruckBay,"CargoLoad"..i,0)
	end
	
	if TotalQueuedPrisoners > 0 then	-- load a second truckbay, so the total amount can be 16 prisoners per truck
		LoadIntakeBySecLevel(theStation,newTruckBay,2)
		newTruckBay.Tooltip = { "tooltip_BayIntake",newTruckBay.HomeUID,"H",newTruckBay.CargoStationID,"I",newTruckBay.TruckBayNr,"N",newTruckBay.CargoAmount,"A" }
		Set(newIntakeTruck,"TotalCargoAmount",newIntakeTruck.TotalCargoAmount + newTruckBay.CargoAmount)
	end
	
	Set(newIntakeTruck,"Number",theStation.Number)
	Set(theStation,"PrisQuantity",PrisQuantity)
	Set(theStation,"InUse","yes")
	Set(theStation,"Status","ON ROUTE")
	theStation.Tooltip = { "tooltip_CargoStopSign_PrisonersArriving",theStation.HomeUID,"Y",theStation.Number,"Z",theStation.PrisQuantity,"T",theStation.MinSecQuantity,"A",theStation.NormalQuantity,"B",theStation.MaxSecQuantity,"C",theStation.ProtectedQuantity,"D",theStation.SuperMaxQuantity,"E",theStation.DeathRowQuantity,"F",theStation.InsaneQuantity,"G" }

	local nearbyObject = Find(theStation,"CargoStationControl",8)
	if next(nearbyObject) then
		for thatControl, distance in pairs(nearbyObject) do
			if thatControl.MarkerUID == theStation.MarkerUID and thatControl.HomeUID == theStation.HomeUID then
				Set(thatControl,"SubType",17)
				break
			end
		end
	end
	nearbyObject = nil
	newIntakeTruck = nil
	newTruckBay = nil
end

function PrepareIntakeChinook(thePad)
	print("--- PrepareIntakeChinook for Helipad "..thePad.Number)
	Set(thePad,"MinSecQuantity",0)
	Set(thePad,"NormalQuantity",0)
	Set(thePad,"MaxSecQuantity",0)
	Set(thePad,"SuperMaxQuantity",0)
	Set(thePad,"ProtectedQuantity",0)
	Set(thePad,"DeathRowQuantity",0)
	Set(thePad,"InsaneQuantity",0)
	Set(thePad,"PrisQuantity",0)
	PrisQuantity = 0
	local newChinook = Object.Spawn("Chinook2",4,thePad.Pos.y-5)
	local insideChinook = Object.Spawn("IntakeChinookInside",4,thePad.Pos.y-5)
	Set(newChinook,"HomeUID","IntakeChinook_"..string.sub(newChinook.Id.u,-2))
	Set(newChinook,"MyType","Intake")
	Set(insideChinook,"HomeUID",newChinook.HomeUID)
	Set(insideChinook,"Slot0.i",newChinook.Id.i)
	Set(insideChinook,"Slot0.u",newChinook.Id.u)
	Set(newChinook,"Loaded",true)
	if Get(this,"AnimateChinook") == "yes" then
		local ChinookLightBack = Object.Spawn("StatusLight",newChinook.Pos.x-2.9,newChinook.Pos.y-1)
		Set(ChinookLightBack,"HomeUID",newChinook.HomeUID)
		Set(ChinookLightBack,"Spot","Back")
		Set(ChinookLightBack,"Or.x",0)
		Set(ChinookLightBack,"Or.y",-1)
		Set(insideChinook,"Slot1.i",ChinookLightBack.Id.i)
		Set(insideChinook,"Slot1.u",ChinookLightBack.Id.u)
		Set(ChinookLightBack,"Loaded",true)
		
		local ChinookLightFront = Object.Spawn("StatusLight",newChinook.Pos.x+5.85,newChinook.Pos.y-1)
		Set(ChinookLightFront,"HomeUID",newChinook.HomeUID)
		Set(ChinookLightFront,"Spot","Front")
		Set(ChinookLightFront,"Or.x",0)
		Set(ChinookLightFront,"Or.y",-1)
		Set(insideChinook,"Slot2.i",ChinookLightFront.Id.i)
		Set(insideChinook,"Slot2.u",ChinookLightFront.Id.u)
		Set(ChinookLightFront,"Loaded",true)
	end
	
	ChinookHook = Object.Spawn("IntakeChinookHook",newChinook.Pos.x+2.1,newChinook.Pos.y-2.7)
	Set(ChinookHook,"HomeUID",newChinook.HomeUID)
	Set(ChinookHook,"Tooltip","\nVehicle ID: "..ChinookHook.HomeUID.." Bay 1")
	Set(ChinookHook,"HookNr",1)
	Set(ChinookHook,"CargoAmount",0)
	for i = 0,7 do
		Set(ChinookHook,"CargoLoad"..i,0)
	end
	
	LoadIntakeBySecLevel(thePad,ChinookHook,1)
	Set(newChinook,"TotalCargoAmount",ChinookHook.CargoAmount)
	
	Set(insideChinook,"Slot4.i",ChinookHook.Id.i)
	Set(insideChinook,"Slot4.u",ChinookHook.Id.u)
	Set(ChinookHook,"Loaded",true)
	
	ChinookHook = Object.Spawn("IntakeChinookHook",newChinook.Pos.x+2.1,newChinook.Pos.y-2.7)
	Set(ChinookHook,"HomeUID",newChinook.HomeUID)
	Set(ChinookHook,"Tooltip","\nVehicle ID: "..ChinookHook.HomeUID.." Bay 2")
	Set(ChinookHook,"HookNr",2)
	Set(ChinookHook,"CargoAmount",0)
	for i = 0,7 do
		Set(ChinookHook,"CargoLoad"..i,0)
	end
	
	if TotalQueuedPrisoners > 0 then	-- load a second hook, so the total amount can be 16 prisoners per chinook
		LoadIntakeBySecLevel(thePad,ChinookHook,2)
		Set(newChinook,"TotalCargoAmount",newChinook.TotalCargoAmount + ChinookHook.CargoAmount)
	end
	
	Set(insideChinook,"Slot5.i",ChinookHook.Id.i)
	Set(insideChinook,"Slot5.u",ChinookHook.Id.u)
	Set(ChinookHook,"Loaded",true)
	
	Set(thePad,"PrisQuantity",PrisQuantity)
	
	Set(newChinook,"PadX",thePad.Pos.x-0.5+math.random())
	Set(newChinook,"PadY",thePad.Pos.y-5+math.random())
	Set(newChinook,"HeliPadID",thePad.HomeUID)
	Set(newChinook,"FuelLevel",0)
	Set(newChinook,"EdgeX",World.NumCellsX - 6)
	Set(newChinook,"EdgeY",newChinook.PadY)
	Set(newChinook,"AnimateChinook",Get(this,"AnimateChinook"))
	Set(newChinook,"VehicleState","ToHelipad")
	Set(newChinook,"Number",thePad.Number)
	newChinook.Tooltip = { "tooltip_Chinook2_Status",newChinook.HomeUID,"X",newChinook.VehicleState,"Y" }
   
	Set(thePad,"InUse","yes")
	Set(thePad,"Status","ON ROUTE")
	thePad.Tooltip = { "tooltip_CargoHelipad_PrisonersArriving",thePad.HomeUID,"Y",thePad.Number,"Z",thePad.PrisQuantity,"T",thePad.MinSecQuantity,"A",thePad.NormalQuantity,"B",thePad.MaxSecQuantity,"C",thePad.ProtectedQuantity,"D",thePad.SuperMaxQuantity,"E",thePad.DeathRowQuantity,"F",thePad.InsaneQuantity,"G" }
	ChinookHook = nil
end


	-------------------------------------------------------------------------------------------
	-- Check if available prisoners match the seclevel which the specified helipad accepts
	-------------------------------------------------------------------------------------------
function CompareIntake(theStation)
	local outcome = false
	print("AutoSpawn -->> Check Station: "..theStation.Number.." InUse: "..theStation.InUse.."  TrafficEnabled: "..theStation.TrafficEnabled.."  CargoType: "..theStation.CargoType.."  VehicleSpawned: "..theStation.VehicleSpawned)
	if theStation.CargoType == "Intake" and theStation.InUse == "no" and theStation.TrafficEnabled == "yes" and theStation.VehicleSpawned == "no" then
		for C = 1,7 do
			if #PrisonersInQueue[PrisonerDest[C]] > 0 then
				print("AutoSpawn -->> Station "..theStation.Number.." accepts: "..theStation.SecLevel.." prisoners")
				print("AutoSpawn -->> Available prisoners for "..PrisonerDest[C].." is "..#PrisonersInQueue[PrisonerDest[C]])
				if Get(theStation,"SecLevel") == "ALL" or Get(theStation,"SecLevel") == PrisonerDest[C] then
					outcome = true
				end
			end
		end
	end
	return outcome
end

	-------------------------------------------------------------------------------------------
	-- Load prisoners onto the IntakeTruck/chinook according to what the IntakeStation will accept
	-------------------------------------------------------------------------------------------
function LoadIntakeBySecLevel(theStation,theBay,theNumber)
	print("LoadIntakeBySecLevel -->> Fill "..theBay.Type.." number "..theNumber)
	
	local theAmount = 0
	for C = 1,7 do
		local Category = PrisonerDest[C]
		if #PrisonersInQueue[Category] > 0 then	-- if the total number of records from the specific PrisonersInQueue table holds items
			print("LoadIntakeBySecLevel -->> Available: "..#PrisonersInQueue[Category].." "..Category.." Prisoners")
			print("LoadIntakeBySecLevel -->> Available: "..#HoldersInQueue[Category].." "..Category.." HoldersInQueue")
			if Get(theStation,"SecLevel") == "ALL" or Get(theStation,"SecLevel") == Category then
				for D = theAmount,7 do
					if Exists(HoldersInQueue[Category][1]) then	-- first in/first out, so the first prisoner from specific HoldersInQueue table C is delivered
						print("LoadIntakeBySecLevel -->> Loading prisoner ID "..HoldersInQueue[Category][1].Id.i.." in "..theBay.Type.." Slot "..D)
						Set(theBay,"Slot"..D..".i",HoldersInQueue[Category][1].Id.i)
						Set(theBay,"Slot"..D..".u",HoldersInQueue[Category][1].Id.u)
						Set(HoldersInQueue[Category][1],"CarrierId.i",theBay.Id.i)
						Set(HoldersInQueue[Category][1],"CarrierId.u",theBay.Id.u)
						Set(HoldersInQueue[Category][1],"Loaded",true)
						if theStation.Type == "CargoHelipad" then
							Set(HoldersInQueue[Category][1],"HelipadID",theStation.Id.u)
							Set(theBay,"CargoLoad"..D,theStation.Id.u)
						else
							Set(HoldersInQueue[Category][1],"CargoStationID",theStation.CargoStationID)
							Set(theBay,"CargoLoad"..D,theStation.CargoStationID)
						end
						Set(theStation,Category.."Quantity",Get(theStation,Category.."Quantity") + 1)
						table.remove(HoldersInQueue[Category],1)	-- remove this record item from the HoldersInQueue table
						table.remove(PrisonersInQueue[Category],1)	-- remove this record item from the PrisonersInQueue table
						theAmount = theAmount + 1
						PrisQuantity = PrisQuantity + 1
					end
				end
				Set(theBay,"CargoAmount",theAmount)
			end
		end
		--PrisQuantity = PrisQuantity + Get(theStation,PrisonerDest[C].."Quantity")
	end
	UpdatePrisonerDisplays()
end



	-------------------------------------------------------------------------------------------
	-- Find stuff
	-------------------------------------------------------------------------------------------
function FindMyStackTransferrer()
	print("FindMyStackTransferrer")
    local Transferrers = Find(this,"StackTransferrer",10000)
	local transferFound = false
	if next(Transferrers) then
		for thatTransferrer, distance in pairs(Transferrers) do
			MyStackTransferrer=thatTransferrer
			Set(MyStackTransferrer,"HomeUID",this.HomeUID)
			print("StackTransferrer found at "..distance)
			transferFound = true
		end
	end
	Transferrers=nil
	if transferFound == false then
		MyStackTransferrer = Object.Spawn("StackTransferrer",World.OriginW+World.OriginX-10,2)
		-- MyStackTransferrer = Object.Spawn("StackTransferrer",World.OriginW-10,1)
		Set(MyStackTransferrer,"HomeUID",this.HomeUID)
		Set(MyStackTransferrer,"Tooltip","tooltip_StackTransferrer")
		print("StackTransferrer spawned")
	end
end

function FindMyDisplays()
	print("FindMyDisplays")
	local LeftIntakeDisplays = Find(this,"TrafficTerminalIntakeDisplayLeft",4)
	local RightIntakeDisplays = Find(this,"TrafficTerminalIntakeDisplayRight",4)
	local LeftCargoDisplays = Find(this,"TrafficTerminalCargoDisplayLeft",4)
	local RightCargoDisplays = Find(this,"TrafficTerminalCargoDisplayRight",4)
	local IntakeDisplays = Find(this,"TrafficTerminalIntakeDisplay",4)
	
	for L, dist in pairs(LeftIntakeDisplays) do
		if		 L.Display == "MinSec"	 then DisplayMinSec = L	print("Found MinSec display")
		elseif	 L.Display == "MaxSec"	 then DisplayMaxSec = L	print("Found MaxSec display")
		elseif	 L.Display == "Insane"	 then DisplayInsane = L	print("Found Insane display")
		end
	end
	
	for R, dist in pairs(RightIntakeDisplays) do
		if		 R.Display == "Normal"	 then DisplayNormal = R		print("Found Normal display")
		elseif	 R.Display == "SuperMax" then DisplaySuperMax = R	print("Found SuperMax display")
		elseif	 R.Display == "DeathRow" then DisplayDeathRow = R	print("Found DeathRow display")
		end
	end
	
	for I, dist in pairs(IntakeDisplays) do
		if I.HomeUID == this.HomeUID then DisplayIntake = I end	print("Found Intake display")
	end
	
	for CL, dist in pairs(LeftCargoDisplays) do
		if CL.HomeUID == this.HomeUID then DisplayCargoL = CL end	print("Found CargoL display")
	end
	
	for CR, dist in pairs(RightCargoDisplays) do
		if CR.HomeUID == this.HomeUID then DisplayCargoR = CR end	print("Found CargoR display")
	end
end

function FindQueuedStackAreas()
    for thatTopArea in next, Find(this,"StackInQueueTop",5) do
		QueuedStackAreaTop = thatTopArea
	end
    for thatBottomArea in next, Find(this,"StackInQueueBottom",5) do
		QueuedStackAreaBottom = thatBottomArea
	end
end

function FindMyChecker(PosX,PosY)
	local qFound = false
	local nearbyCheckers = Find(this,"QueuedStackChecker",5)
	for thatChecker, dist in pairs(nearbyCheckers) do
		MyChecker = thatChecker
		qFound = true
	end
	nearbyCheckers = nil
	if qFound == false then
		MyChecker = Object.Spawn("QueuedStackChecker",PosX,PosY)
		Set(MyChecker,"HomeUID",this.HomeUID)
	end
end




	-------------------------------------------------------------------------------------------
	-- Prisoners related
	-------------------------------------------------------------------------------------------
function ResetPrisonerNeeds()
	if TotalQueuedPrisoners > 0 then
		for T = 1,7 do
			for N = 1,#PrisonersInQueue[PrisonerDest[T]] do
				PrisonersInQueue[PrisonerDest[T]][N].FailedToFindCell = 0
				for thatNeed, distance in pairs(PrisonersInQueue[PrisonerDest[T]][N].Needs.NeedsMetaTable.GetterTable) do -- walk through a list of the prisoners available needs
					if thatNeed == "Warmth" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Warmth = 0 end
					if thatNeed == "Literacy" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Literacy = 0 end
					if thatNeed == "Spirituality" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Spirituality = 0 end
					if thatNeed == "Clothing" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Clothing = 0 end
					if thatNeed == "Freedom" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Freedom = 0 end
					if thatNeed == "Privacy" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Privacy = 0 end
					if thatNeed == "Environment" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Environment = 0 end
					if thatNeed == "Comfort" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Comfort = 0 end
					if thatNeed == "Recreation" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Recreation = 0 end
					if thatNeed == "Family" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Family = 0 end
					if thatNeed == "Exercise" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Exercise = 0 end
					if thatNeed == "Hygiene" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Hygiene = 0 end
					if thatNeed == "Safety" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Safety = 0 end
					if thatNeed == "Bowels" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Bowels = 0 end
					if thatNeed == "Bladder" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Bladder = 0 end
					if thatNeed == "Sleep" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Sleep = 0 end
					if thatNeed == "Food" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Food = 0 end
					if thatNeed == "Alcohol" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Alcohol = 0 end
					if thatNeed == "Drugs" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Drugs = 0 end
					if thatNeed == "BabyPlay" then PrisonersInQueue[PrisonerDest[T]][N].Needs.BabyPlay = 0 end
					if thatNeed == "BabySleep" then PrisonersInQueue[PrisonerDest[T]][N].Needs.BabySleep = 0 end
					if thatNeed == "Barbery" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Barbery = 0 end
					if thatNeed == "Evacuation" then PrisonersInQueue[PrisonerDest[T]][N].Needs.Evauation = 0 end
				end
			end
		end
		if this.IntakeMethod == "AUTO" then
			if StationOrPadFound == true then
				AutoSpawn("Intake")			-- spawns prisoner bus or chinooks
			end
		end
	end
	if DisplayIntake.SubType == 2 then
		if Get(this,"IntakeMethod") == "AUTO" then
			local isIdle = false
			for I = 1,#Traffic do
				if Traffic[I] ~= nil and Exists(Traffic[I].CargoStation) and Traffic[I].CargoStation.CargoType == "Intake" and Traffic[I].CargoStation.InUse == "no" then
					isIdle = true
				end
			end
			if isIdle == true then DisplayIntake.SubType = 1 end
		end
	end
end

function FindKnownPrisoners()
	print("FindKnownPrisoners")
	local KnownPrisonersToFind = Find(this,"Prisoner",2)
	local KnownHoldersToFind = Find(this,"PrisonerStackHolder",2)
	if next(KnownHoldersToFind) then
		for thatHolder, distance in pairs(KnownHoldersToFind) do
			for thatPrisoner, dist in pairs(KnownPrisonersToFind) do
				if Get(thatPrisoner,"CarrierId.i") == thatHolder.Id.i then
				
					local ForDestination = thatPrisoner.Category
					
					table.insert( PrisonersInQueue[ForDestination], thatPrisoner )		-- add the prisoner at the end of the specific PrisonersInQueue table
					local numP = #PrisonersInQueue[ForDestination]
					print("FindKnownPrisoners -->> Known Prisoner found for SecLevel "..PrisonersInQueue[ForDestination][ numP ].Category)
					print("FindKnownPrisoners -->> PrisonersInQueue "..ForDestination.." has "..numP.." records")
					
					table.insert( HoldersInQueue[ForDestination], thatHolder )		-- add the holder at the end of the specific HoldersInQueue table
					local numH = #HoldersInQueue[ForDestination]
					print("FindKnownPrisoners -->> Moved new Prisoner for "..HoldersInQueue[ForDestination][ numH ].HolderCategory.." to TrafficTerminal")
					print("FindKnownPrisoners -->> HoldersInQueue "..ForDestination.." has "..numH.." records")
					break
				end
			end
		end
	end
	UpdatePrisonerDisplays()
end

function AddNewPrisoners()
	print("AddNewPrisoners")
	local IncomingPrisonersToFind = Find(MyStackTransferrer,"Prisoner",2)
	local IncomingHoldersToFind = Find(MyStackTransferrer,"PrisonerStackHolder",2)
	if next(IncomingHoldersToFind) then
		for thatHolder, distance in pairs(IncomingHoldersToFind) do
			for thatPrisoner, dist in pairs(IncomingPrisonersToFind) do
				if Get(thatPrisoner,"CarrierId.i") == thatHolder.Id.i then
					SortPrisoner(thatPrisoner, thatHolder)
					Set(thatHolder,"Pos.x",this.Pos.x)
					Set(thatHolder,"Pos.y",this.Pos.y-0.45)
					
					local ForDestination = thatPrisoner.Category
					
					table.insert( PrisonersInQueue[ForDestination], thatPrisoner )		-- add the prisoner at the end of the specific PrisonersInQueue table
					local numP = #PrisonersInQueue[ForDestination]
					Set(PrisonersInQueue[ForDestination][ N ],"MapBottom",World.NumCellsY)
					print("AddNewPrisoners -->> Sorted new Prisoner ID: "..thatPrisoner.Id.i.." to "..PrisonersInQueue[ForDestination][ numP ].Category)
					print("AddNewPrisoners -->> PrisonersInQueue "..ForDestination.." has "..numP.." records")
					
					table.insert( HoldersInQueue[ForDestination], thatHolder )		-- add the holder at the end of the specific HoldersInQueue table
					local numH = #HoldersInQueue[ForDestination]
					Set(HoldersInQueue[ForDestination][ numH ],"HolderCategory",thatPrisoner.Category)
					Set(HoldersInQueue[ForDestination][ numH ],"Tooltip","ID: "..thatHolder.Id.i.."\nSorted by Traffic Terminal\nSorted to: "..thatHolder.HolderCategory)
					print("AddNewPrisoners -->> Moved new Prisoner for "..HoldersInQueue[ForDestination][ numH ].HolderCategory.." to TrafficTerminal")
					print("AddNewPrisoners -->> HoldersInQueue "..ForDestination.." has "..numH.." records")
					thatPrisoner = nil
					break
				end
			end
		end
	end
	UpdatePrisonerDisplays()
end

function UpdatePrisonerDisplays()

	DisplayMinSec.SubType = 0
	DisplayNormal.SubType = 0
	DisplayMaxSec.SubType = 0
	DisplaySuperMax.SubType = 0
	DisplayInsane.SubType = 0
	DisplayDeathRow.SubType = 0
	
	TotalQueuedPrisoners = 0
	for T = 1,7 do
		TotalQueuedPrisoners = TotalQueuedPrisoners + #PrisonersInQueue[PrisonerDest[T]]
	end
	
	local Min = #PrisonersInQueue[PrisonerDest[1]]
	local Med = #PrisonersInQueue[PrisonerDest[2]]
	local Max = #PrisonersInQueue[PrisonerDest[3]]
	local Prot = #PrisonersInQueue[PrisonerDest[4]]
	local Sup = #PrisonersInQueue[PrisonerDest[5]]
	local DR = #PrisonersInQueue[PrisonerDest[6]]
	local Ins = #PrisonersInQueue[PrisonerDest[7]]
	
	this.Tooltip = { "tooltip_TrafficTerminal",this.DeliveryMethod,"X",this.IntakeMethod,"Y",TotalQueuedStack,"A",TotalQueuedPrisoners,"B",
		#PrisonersInQueue[PrisonerDest[1]],"C",
		#PrisonersInQueue[PrisonerDest[2]],"D",
		#PrisonersInQueue[PrisonerDest[3]],"E",
		#PrisonersInQueue[PrisonerDest[4]],"F",
		#PrisonersInQueue[PrisonerDest[5]],"G",
		#PrisonersInQueue[PrisonerDest[6]],"H",
		#PrisonersInQueue[PrisonerDest[7]],"I" }

	if Get(this,"IntakeMethod") == "SUSPEND" then
		if TotalQueuedPrisoners > 0 then
			DisplayIntake.SubType = 4
		else
			DisplayIntake.SubType = 0
		end
	else
		if TotalQueuedPrisoners > 0 then
			DisplayIntake.SubType = 3
		else
			DisplayIntake.SubType = 1
		end
	end
	if Min > 0 then DisplayMinSec.SubType = 1 end
	if Med > 0 then DisplayNormal.SubType = 1 end
	if Max > 0 then DisplayMaxSec.SubType = 2 end
	if Sup > 0 then DisplaySuperMax.SubType = 2 end
	if Prot > 0 or Ins > 0 then DisplayInsane.SubType = 3 end
	if DR > 0 then DisplayDeathRow.SubType = 3 end
end

function SortPrisoner(NewPrisoner,NewHolder)
	print("SortPrisoner ID: "..NewPrisoner.Id.i)
	local NewCategory = { ["MinSec"] = 1, ["Normal"] = 2, ["MaxSec"] = 3, ["Protected"] = 4, ["SuperMax"] = 5, ["DeathRow"] = 6, ["Insane"] = 7 }
	
	if NewPrisoner.SnitchTimer~=0 then
		if NewPrisoner.Category=="MinSec" and SortMin=="YES" then
			Set(NewPrisoner,"Category",4)
			Object.Sound("TrafficTerminal","SnitchFound")
		elseif NewPrisoner.Category=="Normal" and SortMed=="YES" then
			Set(NewPrisoner,"Category",4)
			Object.Sound("TrafficTerminal","SnitchFound")
		elseif NewPrisoner.Category=="MaxSec" and SortMax=="YES" then
			Set(NewPrisoner,"Category",4)
			Object.Sound("TrafficTerminal","SnitchFound")
		elseif NewPrisoner.Category=="SuperMax" and SortSuper=="YES" then
			Set(NewPrisoner,"Category",4)
			Object.Sound("TrafficTerminal","SnitchFound")
		elseif NewPrisoner.Category=="Protected" then
			Object.Sound("TrafficTerminal","SnitchFound")
		end
	end
	if SortLegendary ~= "NO" and NewPrisoner.Gang.Rank==3 then
		if NewPrisoner.Category~="DeathRow" then
			Set(NewPrisoner,"Category",NewCategory[this.SortLegendary])
			Object.Sound("TrafficTerminal","SnitchFound")
		end
	end
	if SortLieutenant ~= "NO" and NewPrisoner.Gang.Rank==2 then
		if NewPrisoner.Category~="DeathRow" then
			Set(NewPrisoner,"Category",NewCategory[this.SortLieutenant])
			Object.Sound("TrafficTerminal","SnitchFound")
		end
	end
	if SortRedGang ~= "NO" and NewPrisoner.Gang.Id==2 then
		if NewPrisoner.Category~="DeathRow" then
			Set(NewPrisoner,"Category",NewCategory[this.SortRedGang])
			Object.Sound("TrafficTerminal","SnitchFound")
		end
	end
	if SortGreenGang ~= "NO" and NewPrisoner.Gang.Id==3 then
		if NewPrisoner.Category~="DeathRow" then
			Set(NewPrisoner,"Category",NewCategory[this.SortGreenGang])
			Object.Sound("TrafficTerminal","SnitchFound")
		end
	end
	if SortBlueGang ~= "NO" and NewPrisoner.Gang.Id==4 then
		if NewPrisoner.Category~="DeathRow" then
			Set(NewPrisoner,"Category",NewCategory[this.SortBlueGang])
			Object.Sound("TrafficTerminal","SnitchFound")
		end
	end
	if SortAddicted ~= "NO" then
		if NewPrisoner.Category~="DeathRow" then
			for thatNeed, distance in pairs(NewPrisoner.Needs.NeedsMetaTable.GetterTable) do -- walk through a list of the prisoners available needs
				if thatNeed == "Alcohol" or thatNeed == "Drugs" then
					Set(NewPrisoner,"Category",NewCategory[this.SortAddicted])
					Object.Sound("TrafficTerminal","SnitchFound")
				end
			end
		end
	end
	if SortMothers ~= "NO" then
		if NewPrisoner.Category~="DeathRow" then
			for thatNeed, distance in pairs(NewPrisoner.Needs.NeedsMetaTable.GetterTable) do -- walk through a list of the prisoners available needs
				if thatNeed == "BabyPlay" or thatNeed == "BabySleep" then
					Set(NewPrisoner,"Category",NewCategory[this.SortMothers])
					Set(NewPrisoner,"AvailableMoney",100)	-- grant some cash so mothers who don't work can still settle Luxuries needs via vending machines or shop
					Object.Sound("TrafficTerminal","SnitchFound")
				end
			end
		end
	end
	if SortInsane ~= "NO" and NewPrisoner.Category ~= "Insane" and NewPrisoner.RequiredCellType == "PaddedCell" then
		Object.Sound("TrafficTerminal","SnitchFound")
		if this.SortInsane ~= "Insane" then
			local PrisSub = NewPrisoner.SubType
			NewPrisoner.Delete()
			local SpawnedPrisoner = Object.Spawn("Prisoner",NewHolder.Pos.x,NewHolder.Pos.y)
			SpawnedPrisoner.SubType = PrisSub
			SpawnedPrisoner.Shackled = true
			SpawnedPrisoner.IsNewIntake = true
			Set(SpawnedPrisoner,"Category",NewCategory[this.SortInsane])
			Set(NewHolder,"Tooltip",SpawnedPrisoner.Category.." Prisoner")
			Set(NewHolder,"HolderCategory",SpawnedPrisoner.Category)
			Set(NewHolder,"Slot0.i",SpawnedPrisoner.Id.i)
			Set(NewHolder,"Slot0.u",SpawnedPrisoner.Id.u)
			Set(SpawnedPrisoner,"CarrierId.i",NewHolder.Id.i)
			Set(SpawnedPrisoner,"CarrierId.u",NewHolder.Id.u)
			Set(SpawnedPrisoner,"Loaded",true)
			Set(SpawnedPrisoner,"Locked",true)
			return SpawnedPrisoner
		else
			Set(NewPrisoner,"Category",NewCategory[this.SortInsane])
		end
	end
end



	-------------------------------------------------------------------------------------------
	-- Find CargoStations
	-------------------------------------------------------------------------------------------
function FindCargoStations()
	print("FindCargoStations")
	StationOrPadFound = false
	Traffic = {}
	local StationsToSort={}
    local MyCargoStations = Find(this,"CargoStopSign",10000)
	local StationCounter=0
	for theStation,dist in pairs(MyCargoStations) do
		StationCounter=StationCounter + 1
		print("Found Cargo stop "..StationCounter.." is at "..theStation.Pos.x.." "..theStation.Pos.y.."  ID: "..theStation.Id.u.." Number: "..theStation.Number)
		StationsToSort[StationCounter]=theStation.Number
	end
	table.sort(StationsToSort)
	StationCounter=0
	for i,n in ipairs(StationsToSort) do 
		for theStation,distance in pairs(MyCargoStations) do
			if theStation.Number==StationsToSort[i] then
				StationCounter=StationCounter + 1
				print("Sorted Cargo stop "..StationCounter.." is at: "..theStation.Pos.x.." "..theStation.Pos.y.." ID: "..theStation.Id.u.." Number: "..theStation.Number)
				Traffic[StationCounter] = {}
				Traffic[StationCounter].CargoStation=theStation
				Traffic[StationCounter].CargoStation.Tooltip = { "tooltip_CargoStopSign",theStation.HomeUID,"X",theStation.CargoStationID,"Y",theStation.Number,"Z" }
				StationOrPadFound = true
			end
		end
	end
	
	StationCounter=StationCounter + 1
	
	MyCargoStations = nil
	
	
	-------------------------------------------------------------------------------------------
	-- Find helipads
	-------------------------------------------------------------------------------------------
    local MyHeliPads = Find(this,"CargoHelipad",10000)
    if next(MyHeliPads) then
		for thatHeliPad,dist in pairs(MyHeliPads) do
			if thatHeliPad.HelipadMade == true then
				print("Found HeliPad "..StationCounter)
				Traffic[StationCounter] = {}
				Traffic[StationCounter].CargoStation = thatHeliPad
				Traffic[StationCounter].CargoStation.Number = StationCounter
				Traffic[StationCounter].CargoStation.Tooltip = { "tooltip_CargoHelipad",thatHeliPad.HomeUID,"Y",StationCounter,"Z" }
				StationOrPadFound = true
				StationCounter=StationCounter + 1
			end
		end
	end
	MyHeliPads = nil
	Set(this,"UpdateTraffic",false)
	return StationOrPadFound
end

	
	-------------------------------------------------------------------------------------------
	--Buttons
	-------------------------------------------------------------------------------------------
	
function toggleAnimateChinookClicked()
	if Get(this,"AnimateChinook") == "no" then
		Set(this,"AnimateChinook","yes")
	else
		Set(this,"AnimateChinook","no")
	end
	this.SetInterfaceCaption("toggleAnimateChinook","tooltip_TrafficTerminal_Button_AnimateChinook",this.AnimateChinook,"X")
end

function toggleIntakeMethodClicked()
	if Get(this,"IntakeMethod") == "SUSPEND" then
		Set(this,"IntakeMethod","AUTO")
	else
		Set(this,"IntakeMethod","SUSPEND")
	end
	UpdatePrisonerDisplays()
	this.Tooltip = { "tooltip_TrafficTerminal",this.DeliveryMethod,"X",this.IntakeMethod,"Y",TotalQueuedStack,"A",TotalQueuedPrisoners,"B",
		#PrisonersInQueue[PrisonerDest[1]],"C",
		#PrisonersInQueue[PrisonerDest[2]],"D",
		#PrisonersInQueue[PrisonerDest[3]],"E",
		#PrisonersInQueue[PrisonerDest[4]],"F",
		#PrisonersInQueue[PrisonerDest[5]],"G",
		#PrisonersInQueue[PrisonerDest[6]],"H",
		#PrisonersInQueue[PrisonerDest[7]],"I" }

	this.SetInterfaceCaption("toggleIntakeMethod","tooltip_TrafficTerminal_IntakeMethod",this.IntakeMethod,"X")
	if Get(this,"IntakeMethod") == "SUSPEND" then		-- put prisoners back beneath the terminal
		tmpTrucks = Find("CargoStationTruck",10000)
		for thatTruck, dist in pairs(tmpTrucks) do
			if thatTruck.SkinType == "Intake" then
				Set(thatTruck,"DeleteMe",true)
			end
		end
		tmpTrucks = nil
		tmpChinooks = Find("Chinook2",10000)
		for thatChinook, dist in pairs(tmpChinooks) do
			if thatChinook.MyType == "Intake" then
				Set(thatChinook,"DeleteMe",true)
			end
		end
		tmpChinooks = nil
		
	end
	this.Sound("_Deployment","SetNone")
end

function toggleDeliveryMethodClicked()
	if Get(this,"DeliveryMethod") == "SUSPEND" then
		Set(this,"DeliveryMethod","AUTO")
	else
		Set(this,"DeliveryMethod","SUSPEND")
	end
	if this.DeliveryMethod == "SUSPEND" then
		if TotalQueuedStack > 0 then
			DisplayCargoL.SubType = 4
		else
			DisplayCargoL.SubType = 0
		end
		DisplayCargoR.SubType = 0
	else
		if TotalQueuedStack > 0 then
			DisplayCargoL.SubType = 3
		else
			DisplayCargoL.SubType = 2
		end
		DisplayCargoR.SubType = 1
	end
	if not this.GrantCheckerSpawned then
		local GrantChecker = Object.Spawn("GrantCheckerTerminal",this.Pos.x+3,this.Pos.y+2)
	end
	this.Tooltip = { "tooltip_TrafficTerminal",this.DeliveryMethod,"X",this.IntakeMethod,"Y",TotalQueuedStack,"A",TotalQueuedPrisoners,"B",
		#PrisonersInQueue[PrisonerDest[1]],"C",
		#PrisonersInQueue[PrisonerDest[2]],"D",
		#PrisonersInQueue[PrisonerDest[3]],"E",
		#PrisonersInQueue[PrisonerDest[4]],"F",
		#PrisonersInQueue[PrisonerDest[5]],"G",
		#PrisonersInQueue[PrisonerDest[6]],"H",
		#PrisonersInQueue[PrisonerDest[7]],"I" }
	this.SetInterfaceCaption("toggleDeliveryMethod","tooltip_TrafficTerminal_DeliveryMethod",this.DeliveryMethod,"X")
	if Get(this,"DeliveryMethod") == "SUSPEND" then		-- put deliveries from CargoStationTrucks back beneath the terminal
		tmpTrucks = Find("CargoStationTruck",10000)
		for thatTruck, dist in pairs(tmpTrucks) do
			if thatTruck.SkinType == "Deliveries" then
				Set(thatTruck,"DeleteMe",true)
			end
		end
		tmpTrucks = nil
		tmpChinooks = Find("Chinook2",10000)
		for thatChinook, dist in pairs(tmpChinooks) do
			if thatChinook.MyType == "Cargo" then
				Set(thatChinook,"DeleteMe",true)
			end
		end
		tmpChinooks = nil
		
	end
	this.Sound("_Deployment","SetNone")
end

function AddSnitchButtons()
	Interface.AddComponent(this,"TT_CaptionSnitchOptions", "Caption", "tooltip_TrafficTerminal_TerminalSnitchConfig")
	Interface.AddComponent(this,"toggleSortMin", "Button", "tooltip_TrafficTerminal_Button_minsec","tooltip_TrafficTerminal_"..this.SortMin,"X")
	Interface.AddComponent(this,"toggleSortMed", "Button", "tooltip_TrafficTerminal_Button_medsec","tooltip_TrafficTerminal_"..this.SortMed,"X")
	Interface.AddComponent(this,"toggleSortMax", "Button", "tooltip_TrafficTerminal_Button_maxsec","tooltip_TrafficTerminal_"..this.SortMax,"X")
	Interface.AddComponent(this,"toggleSortSuper", "Button", "tooltip_TrafficTerminal_Button_supmax","tooltip_TrafficTerminal_"..this.SortSuper,"X")
	Interface.AddComponent(this,"TT_PrisonerSorter", "Caption", "tooltip_TrafficTerminal_TerminalPrisonerSort")
	Interface.AddComponent(this,"toggleSortLegendary", "Button", "tooltip_TrafficTerminal_Button_legendary","tooltip_TrafficTerminal_"..this.SortLegendary,"X")
	Interface.AddComponent(this,"toggleSortLieutenant", "Button", "tooltip_TrafficTerminal_Button_lieutenant","tooltip_TrafficTerminal_"..this.SortLieutenant,"X")
	Interface.AddComponent(this,"toggleSortRedGang", "Button", "tooltip_TrafficTerminal_Button_red","tooltip_TrafficTerminal_"..this.SortRedGang,"X")
	Interface.AddComponent(this,"toggleSortGreenGang", "Button", "tooltip_TrafficTerminal_Button_green","tooltip_TrafficTerminal_"..this.SortGreenGang,"X")
	Interface.AddComponent(this,"toggleSortBlueGang", "Button", "tooltip_TrafficTerminal_Button_blue","tooltip_TrafficTerminal_"..this.SortBlueGang,"X")
	Interface.AddComponent(this,"toggleSortAddicted", "Button", "tooltip_TrafficTerminal_Button_addicted","tooltip_TrafficTerminal_"..this.SortAddicted,"X")
	Interface.AddComponent(this,"toggleSortMothers", "Button", "tooltip_TrafficTerminal_Button_mother","tooltip_TrafficTerminal_"..this.SortMothers,"X")
	Interface.AddComponent(this,"toggleSortInsane", "Button", "tooltip_TrafficTerminal_Button_insane","tooltip_TrafficTerminal_"..this.SortInsane,"X")
end

function ToggleYesNo(property,var)
	local Property = Get(this,property)
	if Property == "YES" then Property = "NO" else Property = "YES" end
	Set(this,property,Property)
	var = Property
	return var
end

function ToggleSecLevel(property,var)
	local Property = Get(this,property)
	if Property == "NO" then Property = "MinSec"
	elseif Property == "MinSec" then Property = "Normal"
	elseif Property == "Normal" then Property = "MaxSec"
	elseif Property == "MaxSec" then Property = "SuperMax"
	elseif Property == "SuperMax" then Property = "Protected"
	elseif Property == "Protected" then Property = "DeathRow"
	elseif Property == "DeathRow" then Property = "NO" end
	Set(this,property,Property)
	var = Property
	return var
end

function toggleSortMinClicked()
	this.SetInterfaceCaption("toggleSortMin", "tooltip_TrafficTerminal_Button_minsec","tooltip_TrafficTerminal_"..ToggleYesNo("SortMin",SortMin),"X")
end

function toggleSortMedClicked()
	this.SetInterfaceCaption("toggleSortMed", "tooltip_TrafficTerminal_Button_medsec","tooltip_TrafficTerminal_"..ToggleYesNo("SortMed",SortMed),"X")
end

function toggleSortMaxClicked()
	this.SetInterfaceCaption("toggleSortMax", "tooltip_TrafficTerminal_Button_maxsec","tooltip_TrafficTerminal_"..ToggleYesNo("SortMax",SortMax),"X")
end

function toggleSortSuperClicked()
	this.SetInterfaceCaption("toggleSortSuper", "tooltip_TrafficTerminal_Button_supmax","tooltip_TrafficTerminal_"..ToggleYesNo("SortSuper",SortSuper),"X")
end

function toggleSortLegendaryClicked()
	this.SetInterfaceCaption("toggleSortLegendary", "tooltip_TrafficTerminal_Button_legendary","tooltip_TrafficTerminal_"..ToggleSecLevel("SortLegendary",SortLegendary),"X")
end

function toggleSortLieutenantClicked()
	this.SetInterfaceCaption("toggleSortLieutenant", "tooltip_TrafficTerminal_Button_lieutenant","tooltip_TrafficTerminal_"..ToggleSecLevel("SortLieutenant",SortLieutenant),"X")
end

function toggleSortRedGangClicked()
	this.SetInterfaceCaption("toggleSortRedGang", "tooltip_TrafficTerminal_Button_red","tooltip_TrafficTerminal_"..ToggleSecLevel("SortRedGang",SortRedGang),"X")
end

function toggleSortGreenGangClicked()
	this.SetInterfaceCaption("toggleSortGreenGang", "tooltip_TrafficTerminal_Button_green","tooltip_TrafficTerminal_"..ToggleSecLevel("SortGreenGang",SortGreenGang),"X")
end

function toggleSortBlueGangClicked()
	this.SetInterfaceCaption("toggleSortBlueGang", "tooltip_TrafficTerminal_Button_blue","tooltip_TrafficTerminal_"..ToggleSecLevel("SortBlueGang",SortBlueGang),"X")
end

function toggleSortAddictedClicked()
	this.SetInterfaceCaption("toggleSortAddicted", "tooltip_TrafficTerminal_Button_addicted","tooltip_TrafficTerminal_"..ToggleSecLevel("SortAddicted",SortAddicted),"X")
end

function toggleSortMothersClicked()
	this.SetInterfaceCaption("toggleSortMothers", "tooltip_TrafficTerminal_Button_mother","tooltip_TrafficTerminal_"..ToggleSecLevel("SortMothers",SortMothers),"X")
end

function toggleSortInsaneClicked()
	this.SetInterfaceCaption("toggleSortInsane", "tooltip_TrafficTerminal_Button_insane","tooltip_TrafficTerminal_"..ToggleSecLevel("SortInsane",SortInsane),"X")
end


function RemoveStackClicked()
	local myStack = Find(this,"Stack",4)
	for thatStack, dist in pairs(myStack) do
		thatStack.Delete()
	end
	local myBox = Find(this,"Box",4)
	for thatBox, dist in pairs(myBox) do
		thatBox.Delete()
	end
	local myMails = Find(this,"MailSatchel",4)
	for thatMail, dist in pairs(myMails) do
		thatMail.Delete()
	end
	
	local myStackHolders = Find(this,"PrisonerStackHolder",5)
	for thatStackHolder, dist in pairs(myStackHolders) do
		thatStackHolder.Delete()
	end
	myStackHolders = nil
	
	StackInQueue = {  Food = {},
						Laundry = {},
						Vending = {},
						Forest = {},
						Workshop1 = {},
						Workshop2 = {},
						Workshop3 = {},
						Workshop4 = {},
						Workshop5 = {},
						Building = {},
						Floor = {},
						Other = {}
					}
	TotalQueuedStack = 0
	for T = 1,12 do
		TotalQueuedStack = TotalQueuedStack + #StackInQueue[StackDest[T]]
	end
	
	this.Tooltip = { "tooltip_TrafficTerminal",this.DeliveryMethod,"X",this.IntakeMethod,"Y",TotalQueuedStack,"A",TotalQueuedPrisoners,"B",
	#PrisonersInQueue[PrisonerDest[1]],"C",
	#PrisonersInQueue[PrisonerDest[2]],"D",
	#PrisonersInQueue[PrisonerDest[3]],"E",
	#PrisonersInQueue[PrisonerDest[4]],"F",
	#PrisonersInQueue[PrisonerDest[5]],"G",
	#PrisonersInQueue[PrisonerDest[6]],"H",
	#PrisonersInQueue[PrisonerDest[7]],"I" }
	
	QueuedStackAreaTop.Tooltip = { "tooltip_StackInQueueTop_Totals",
	#StackInQueue[StackDest[1]],"A",
	#StackInQueue[StackDest[2]],"B",
	#StackInQueue[StackDest[3]],"C",
	#StackInQueue[StackDest[4]],"D",
	#StackInQueue[StackDest[5]],"E",
	#StackInQueue[StackDest[6]],"F" }
	
	QueuedStackAreaBottom.Tooltip = { "tooltip_StackInQueueBottom_Totals",
	#StackInQueue[StackDest[7]],"A",
	#StackInQueue[StackDest[8]],"B",
	#StackInQueue[StackDest[9]],"C",
	#StackInQueue[StackDest[10]],"D",
	#StackInQueue[StackDest[11]],"E",
	#StackInQueue[StackDest[12]],"F" }
end

function DeleteTerminalClicked()
	local OldStuff = {"TrafficTerminalIntakeDisplayLeft","TrafficTerminalIntakeDisplayRight", "StackInQueueTop","QueuedStackHolder",
						"TrafficTerminalCargoDisplayLeft","TrafficTerminalCargoDisplayRight", "StackInQueueBottom","QueuedStackChecker",
						"TrafficTerminalIntakeDisplay", "WallLight", "NewStackChecker","StreetManager2" }
	for _, typ in pairs(OldStuff) do
		local nearbyObjects = Find(this,typ,6)
		for thatObject, _ in pairs(nearbyObjects) do
			if thatObject.HomeUID == this.HomeUID then
				thatObject.Delete()
			end
		end
	end
	
	RemoveStackClicked()
	
	for C = 1, #Traffic do
		Traffic[C].CargoStation.Number = 0
		Traffic[C].CargoStation.Status = "TerminalRemoved"
		Traffic[C].CargoStation.Tooltip = "tooltip_CargoStopSign_TrafficTerminalRequired"
	end
	
	local x = math.floor(this.Pos.x)+1
	local y = math.floor(this.Pos.y)
	local Ymin = 0
	local Ymax = 0
	local Xmin = 0
	local Xmax = 0
	for i=Ymin-4,Ymax+4 do	for j=Xmin-5,Xmax+4 do	local cell = World.GetCell(x+j,y+i);	cell.Mat = "LooseStone"; cell.Ind = false end	end

	World.ImmediateMaterials = nil
	this.Delete()
end

	-------------------------------------------------------------------------------------------
	-- Only one terminal may exist on the map
	-------------------------------------------------------------------------------------------
	
function DeleteOtherTerminals()
	OtherTerminals = Find("TrafficTerminal",10000)
	for thatTerminal, dist in pairs(OtherTerminals) do
		if thatTerminal.Id.i ~= this.Id.i then
		
			local nearbyTopQAreas = Find(thatTerminal,"StackInQueueTop",5)
			if next(nearbyTopQAreas) then
				for thatQArea, dist in pairs(nearbyTopQAreas) do
					QueuedStackAreaTop = thatQArea
					Set(QueuedStackAreaTop,"HomeUID",this.HomeUID)
					Set(QueuedStackAreaTop,"Pos.x",this.Pos.x+0.5)
					Set(QueuedStackAreaTop,"Pos.y",this.Pos.y-2)
				end
			end
			nearbyTopQAreas = nil
			
			local nearbyBottomQAreas = Find(thatTerminal,"StackInQueueBottom",5)
			if next(nearbyBottomQAreas) then
				for thatQArea, dist in pairs(nearbyBottomQAreas) do
					QueuedStackAreaBottom = thatQArea
					Set(QueuedStackAreaBottom,"HomeUID",this.HomeUID)
					Set(QueuedStackAreaBottom,"Pos.x",this.Pos.x+0.5)
					Set(QueuedStackAreaBottom,"Pos.y",this.Pos.y+2)
				end
			end
			nearbyBottomQAreas = nil
			
			local X = this.Pos.x-4
			local Y = this.Pos.y-4
			local IncomingStuffToFind = { "Stack", "Box", "MailSatchel" }
			for S, typ in pairs(IncomingStuffToFind) do
				local incomingObjects = Find(thatTerminal,typ,5)
				if next(incomingObjects) then
					local A = 0
					for thatItem, distance in pairs(incomingObjects) do
						if thatItem.Sorted == nil then
							if thatItem.Type ~= "MailSatchel" then
								print("DeleteOtherTerminals -->> Transferring new item: "..thatItem.Contents.." ID: "..thatItem.Id.i)
								Set(thatItem,"CarrierId.i",-1)
								Set(thatItem,"CarrierId.u",-1)
								Set(thatItem,"Loaded",false)
								local X = this.Pos.x-3+A	-- put the stuff on a random floor row at the terminal room
								local Y = this.Pos.y
								if math.random() > 0.90 then X = this.Pos.x-3+A; Y = this.Pos.y-3
								elseif math.random() > 0.70 then X = this.Pos.x-3+A; Y = this.Pos.y-1
								elseif math.random() > 0.50 then X = this.Pos.x-3+A; Y = this.Pos.y
								elseif math.random() > 0.30 then X = this.Pos.x+4-A; Y = this.Pos.y+1
								elseif math.random() > 0.20 then X = this.Pos.x+4-A; Y = this.Pos.y
								else X = this.Pos.x+4-A; Y = this.Pos.y-1
								end
								Set(thatItem,"Pos.x",X)
								Set(thatItem,"Pos.y",Y)
								Object.ApplyVelocity(thatItem,-0.5+math.random(),-0.5+math.random(),false)
								Set(thatItem,"Tooltip","Transferred by Traffic Terminal\nID: "..thatItem.Id.i)
								print(thatItem.Type.." ID: "..thatItem.Id.i.." Transferred by Traffic Terminal")
								A = A + 1
								if A > 7 then A = 0 end
							else
								print("DeleteOtherTerminals -->> Transferring new item: MailSatchel ID: "..thatItem.Id.i)
								Set(thatItem,"CarrierId.i",-1)
								Set(thatItem,"CarrierId.u",-1)
								Set(thatItem,"Loaded",false)
								Set(thatItem,"Pos.x",this.Pos.x-3+math.random(1,8))
								Set(thatItem,"Pos.y",this.Pos.y+3)
								Object.ApplyVelocity(thatItem,-0.5+math.random(),-0.5+math.random(),false)
								Set(thatItem,"Tooltip","Transferred by Traffic Terminal\nID: "..thatItem.Id.i)
								print(thatItem.Type.." ID: "..thatItem.Id.i.." Transferred by Traffic Terminal")
								A = A + 1
								if A > 7 then A = 0 end
							end
						else
							print("DeleteOtherTerminals -->> Transferring known item: "..thatItem.Contains.." ID: "..thatItem.Id.i)
							SortedTo = thatItem.Sorted
							local ForDestination = StackDest[SortedTo]
							table.insert( StackInQueue[ForDestination], thatItem )
							local num = #StackInQueue[ForDestination]
							Set(StackInQueue[ForDestination][ num ],"Sorted",SortedTo)
							Set(StackInQueue[ForDestination][ num ],"Contains",thatItem.Contents)
							Set(StackInQueue[ForDestination][ num ],"Tooltip","ID: "..thatItem.Id.i.."\nSorted by Traffic Terminal\nSorted to: "..StackDest[thatItem.Sorted].."\nContains: "..thatItem.Contains)

							StackSpotsCounter = StackSpotsCounter + 1	-- puts stuff on the specific tiles at QueuedStackAreas, laying items on top of each other in an X shape
							Set(StackInQueue[ForDestination][ num ],"Pos.x",X+HolderXY[thatItem.Sorted].X + StackSpots[StackSpotsCounter].X)
							Set(StackInQueue[ForDestination][ num ],"Pos.y",Y+HolderXY[thatItem.Sorted].Y + StackSpots[StackSpotsCounter].Y)
							if StackSpotsCounter >= 16 then StackSpotsCounter = 0 end	-- there are 16 spots for drawing an X on the floor tile
						end
					end
				end
				incomingObjects = nil
			end
		
			OtherPrisonerHolders = Find(thatTerminal,"PrisonerStackHolder",4)
			for thatPrisonerHolder, dist in pairs(OtherPrisonerHolders) do
				if Get(thatPrisonerHolder,"TrafficTerminalID") == thatTerminal.Id.i then --?
					Set(thatPrisonerHolder,"TrafficTerminalID",this.Id.i)
					Set(thatPrisonerHolder,"Pos.x",this.Pos.x-0.25 + (math.random(1,10) / 10) - 0.35)
					Set(thatPrisonerHolder,"Pos.y",this.Pos.y-0.45)
				end
			end
			OtherPrisonerHolders = nil
			
			local OldStuff = {"TrafficTerminalIntakeDisplayLeft","TrafficTerminalIntakeDisplayRight","QueuedStackChecker",
								"TrafficTerminalCargoDisplayLeft","TrafficTerminalCargoDisplayRight","NewStackChecker",
								"TrafficTerminalIntakeDisplay","WallLight","StreetManager2" }
			for _, typ in pairs(OldStuff) do
				local nearbyObjects = Find(thatTerminal,typ,5)
				for thatObject, _ in pairs(nearbyObjects) do
					if thatObject.HomeUID == thatTerminal.HomeUID then
						thatObject.Delete()
					end
				end
				nearbyObjects = nil
			end
			
			local x = math.floor(thatTerminal.Pos.x)+1
			local y = math.floor(thatTerminal.Pos.y)
			local Ymin = 0
			local Ymax = 0
			local Xmin = 0
			local Xmax = 0
			for i=Ymin-4,Ymax+4 do	for j=Xmin-5,Xmax+4 do	local cell = World.GetCell(x+j,y+i);	cell.Mat = "LooseStone"; cell.Ind = false end	end

			Set(this,"SubType_Ambulance",thatTerminal.SubType_Ambulance)
			Set(this,"SubType_FireEngine",thatTerminal.SubType_FireEngine)
			Set(this,"SubType_EmergencyStationTruck",thatTerminal.SubType_EmergencyStationTruck)
			Set(this,"SubType_IntakeStationTruck",thatTerminal.SubType_IntakeStationTruck)
			Set(this,"SubType_RiotVan",thatTerminal.SubType_RiotVan)
			Set(this,"SubType_DeliveriesStationTruck",thatTerminal.SubType_DeliveriesStationTruck)
			Set(this,"SubType_ExportsStationTruck",thatTerminal.SubType_ExportsStationTruck)
			Set(this,"SubType_GarbageStationTruck",thatTerminal.SubType_GarbageStationTruck)
			Set(this,"SubType_Troop",thatTerminal.SubType_Troop)
			
			Set(this,"SortMin",thatTerminal.SortMin)
			Set(this,"SortMed",thatTerminal.SortMed)
			Set(this,"SortMax",thatTerminal.SortMax)
			Set(this,"SortSuper",thatTerminal.SortSuper)
			Set(this,"SortLegendary",thatTerminal.SortLegendary)
			Set(this,"SortLieutenant",thatTerminal.SortLieutenant)
			Set(this,"SortRedGang",thatTerminal.SortRedGang)
			Set(this,"SortGreenGang",thatTerminal.SortGreenGang)
			Set(this,"SortBlueGang",thatTerminal.SortBlueGang)
			Set(this,"SortAddicted",thatTerminal.SortAddicted)
			Set(this,"SortMothers",thatTerminal.SortMothers)
			Set(this,"SortInsane",thatTerminal.SortInsane)
			
			thatTerminal.Delete()
			OtherTerminalDeleted = true
		end
	end
	OtherTerminals = nil
end

function RemoveTrees(from,dist)
	for j = 1, #TreeTypes do
		for thatTree in next, Find(from,TreeTypes[j],dist) do
			thatTree.Delete()
		end
	end
	-- local nearbyTrees = Find(MyTreeRemover,"Tree",4)
	-- if next(nearbyTrees) then
		-- for thatTree, distance in pairs(nearbyTrees) do
			-- thatTree.Delete()
		-- end
	-- end
	-- nearbyTrees=nil
end

function DoOnce()
	print("DoOnce")
	Set(this,"HomeUID","TrafficTerminal"..me["id-uniqueId"])
	local x = math.floor(this.Pos.x)+1
	local y = math.floor(this.Pos.y)
	local Ymin = 0
	local Ymax = 0
	local Xmin = 0
	local Xmax = 0
	for i=Ymin-4,Ymax+4 do	for j=Xmin-5,Xmax+4 do	local cell = World.GetCell(x+j,y+i);	cell.Mat = "YutaniWall"; cell.Ind = true end	end
	for i=Ymin-3,Ymax+3 do	for j=Xmin-4,Xmax+3 do	local cell = World.GetCell(x+j,y+i);	cell.Mat = "TTFloorA"; cell.Ind = true end	end
	for i=Ymin-2,Ymax-2 do	for j=Xmin-3,Xmax+2 do	local cell = World.GetCell(x+j,y+i);	cell.Mat = "TTFloorB"; cell.Ind = true end	end
	for i=Ymin+2,Ymax+2 do	for j=Xmin-3,Xmax+2 do	local cell = World.GetCell(x+j,y+i);	cell.Mat = "TTFloorB"; cell.Ind = true end	end
	
	RemoveTrees(this,8)
		
	DisplayLightLeft = Object.Spawn("WallLight",this.Pos.x-1.5,this.Pos.y-4)
	DisplayLightRight = Object.Spawn("WallLight",this.Pos.x+2.5,this.Pos.y-4)
	DisplayMinSec = Object.Spawn("TrafficTerminalIntakeDisplayLeft",this.Pos.x-2.5,this.Pos.y-0.5)
	DisplayNormal = Object.Spawn("TrafficTerminalIntakeDisplayRight",this.Pos.x-2.5,this.Pos.y-0.5)
	DisplayMaxSec = Object.Spawn("TrafficTerminalIntakeDisplayLeft",this.Pos.x-1.5,this.Pos.y-0.5)
	DisplaySuperMax = Object.Spawn("TrafficTerminalIntakeDisplayRight",this.Pos.x-1.5,this.Pos.y-0.5)
	DisplayInsane = Object.Spawn("TrafficTerminalIntakeDisplayLeft",this.Pos.x-0.5,this.Pos.y-0.5)
	DisplayDeathRow = Object.Spawn("TrafficTerminalIntakeDisplayRight",this.Pos.x-0.5,this.Pos.y-0.5)
	DisplayIntake = Object.Spawn("TrafficTerminalIntakeDisplay",this.Pos.x+0.5,this.Pos.y-0.5)
	DisplayCargoL = Object.Spawn("TrafficTerminalCargoDisplayLeft",this.Pos.x+1.5,this.Pos.y-0.5)
	DisplayCargoR = Object.Spawn("TrafficTerminalCargoDisplayRight",this.Pos.x+2.5,this.Pos.y-0.5)
		
	Set(DisplayLightLeft,"HomeUID",this.HomeUID)
	Set(DisplayLightRight,"HomeUID",this.HomeUID)
	Set(DisplayMinSec,"HomeUID",this.HomeUID)
	Set(DisplayMinSec,"Display","MinSec")
	Set(DisplayNormal,"HomeUID",this.HomeUID)
	Set(DisplayNormal,"Display","Normal")
	Set(DisplayMaxSec,"HomeUID",this.HomeUID)
	Set(DisplayMaxSec,"Display","MaxSec")
	Set(DisplaySuperMax,"HomeUID",this.HomeUID)
	Set(DisplaySuperMax,"Display","SuperMax")
	Set(DisplayInsane,"HomeUID",this.HomeUID)
	Set(DisplayInsane,"Display","Insane")
	Set(DisplayDeathRow,"HomeUID",this.HomeUID)
	Set(DisplayDeathRow,"Display","DeathRow")
	
	Set(DisplayIntake,"HomeUID",this.HomeUID)
	
	Set(DisplayCargoL,"HomeUID",this.HomeUID)
	Set(DisplayCargoR,"HomeUID",this.HomeUID)
	
	DisplayCargoL.SubType = 1
	DisplayCargoR.SubType = 1
	DisplayIntake.SubType = 0

	Set(this,"AnimateChinook","no")
	
	Set(this,"SnitchRange",2)
	Set(this,"SortMin","NO")
	Set(this,"SortMed","NO")
	Set(this,"SortMax","NO")
	Set(this,"SortSuper","NO")
	Set(this,"SortLegendary","NO")
	Set(this,"SortLieutenant","NO")
	Set(this,"SortRedGang","NO")
	Set(this,"SortGreenGang","NO")
	Set(this,"SortBlueGang","NO")
	Set(this,"SortAddicted","NO")
	Set(this,"SortMothers","NO")
	Set(this,"SortInsane","NO")
	
	Set(this,"DeliveryMethod","SUSPEND")
	Set(this,"IntakeMethod","SUSPEND")
	
	Set(this,"OrderCat",1)
	Set(this,"OrderCategory","MinSec")
	Set(this,"OrderPris",4)
	Set(this,"OrderPlaced","NO")
	Set(this,"NumOfnoPrisoners",0)
	Set(this,"NumOfALLPrisoners",0)
	Set(this,"NumOfMinSecPrisoners",0)
	Set(this,"NumOfNormalPrisoners",0)
	Set(this,"NumOfMaxSecPrisoners",0)
	Set(this,"NumOfSuperMaxPrisoners",0)
	Set(this,"NumOfProtectedPrisoners",0)
	Set(this,"NumOfInsanePrisoners",0)
	Set(this,"NumOfDeathRowPrisoners",0)
	
	for thatTruck in next, Find(this,"SupplyTruck",10000) do
		for thatWorkman in next, Find(thatTruck,"Workman",6) do
			if thatWorkman.CarrierId.i == thatTruck.Id.i then
				for A = 0,7 do
					Set(thatTruck,"Slot"..A..".i",-1)
					Set(thatTruck,"Slot"..A..".u",-1)
				end
				thatWorkman.CarrierId.i = -1
				thatWorkman.CarrierId.u = -1
				thatWorkman.Loaded = false
			end
		end
		thatTruck.Pos.x,thatTruck.Pos.y = this.Pos.x,this.Pos.y
		thatTruck.Delete()
	end
	
	DeleteOtherTerminals()
	
	SnitchRange = this.SnitchRange
	SortMin = this.SortMin
	SortMed = this.SortMed
	SortMax = this.SortMax
	SortSuper = this.SortSuper
	SortLegendary = this.SortLegendary
	SortLieutenant = this.SortLieutenant
	SortRedGang = this.SortRedGang
	SortGreenGang = this.SortGreenGang
	SortBlueGang = this.SortBlueGang
	SortAddicted = this.SortAddicted
	SortMothers = this.SortMothers
	
	if not OtherTerminalDeleted then
		QueuedStackAreaTop = Object.Spawn("StackInQueueTop",this.Pos.x+0.5,this.Pos.y-2)
		QueuedStackAreaBottom = Object.Spawn("StackInQueueBottom",this.Pos.x+0.5,this.Pos.y+2)
		
		Set(QueuedStackAreaTop,"HomeUID",this.HomeUID)
		Set(QueuedStackAreaBottom,"HomeUID",this.HomeUID)
		
		Set(this,"SubType_Ambulance",0)
		Set(this,"SubType_FireEngine",0)
		Set(this,"SubType_EmergencyStationTruck",0)
		Set(this,"SubType_IntakeStationTruck",0)
		Set(this,"SubType_RiotVan",0)
		Set(this,"SubType_DeliveriesStationTruck",0)
		Set(this,"SubType_ExportsStationTruck",0)
		Set(this,"SubType_GarbageStationTruck",0)
		Set(this,"SubType_Troop",0)
	end
	
	StreetManager = Object.Spawn("StreetManager2",this.Pos.x+3.5,this.Pos.y)
	Set(StreetManager,"HomeUID",this.HomeUID)
	
	Set(this,"UpdateTraffic",false)
	Set(this,"InitDone",true)
end


function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end
