
local timeTot = 1
local timePerUpdate = 0.25

local Get = Object.GetProperty
local Set = Object.SetProperty

function getEntity(id,dist)
	local entityGroup = { "Prisoner", "Workman", "Guard", "ArmedGuard",
				"Orderly", "Cook", "Gardener", "Janitor",
				"DogHandler", "Sniper", "Chief",
				"Foreman", "Psychologist", "Psychiatrist", "Accountant",
				"Lawyer", "SystemAdministrator", "ComputerNerd",
				"SimulationOfficeManager", "YogaMaster",
				"GraveDigger", "VendingManager",
				"LotteryOfficial",
				"ForestryWorker", "BarberChief",
				"Barber",
				"CarMechanic2", "CraneOperator2",
				"SmartPhoneGenius", "GardenWorker", "GreenhouseWorker",
				"PlantationWorker", "Tailor",
				"TeslaMaticExpert", "ShadyTeslaDude",
				"TeslaMaticExpert3", "ShadyTeslaDude3",
				"PrisonFiremanA0", "PrisonFiremanA1", "PrisonFiremanA2", "PrisonFiremanA3", "PrisonFiremanB0", "PrisonFiremanB1", "PrisonFiremanB2", "PrisonFiremanB3",
				"PrisonFiremanC0", "PrisonFiremanC1", "PrisonFiremanC2", "PrisonFiremanC3", "PrisonFiremanD0", "PrisonFiremanD1", "PrisonFiremanD2", "PrisonFiremanD3"
				 }

	for _, typ in pairs(entityGroup) do
		local entityType = Object.GetNearbyObjects(typ,dist or 1)
		for thatEntity, _ in pairs(entityType) do
			if thatEntity.Id.i == id then
				print("Found "..thatEntity.Type)
				this.UseActiveFlag = EntityCanUseActiveFlag(thatEntity.Type)
				return thatEntity
			end
		end
		entityType = nil
	end
	entityGroup = nil
end

function EntityCanUseActiveFlag(CurrentEntity)
	local entityGroup = { "Prisoner", "Workman", "Guard", "Gardener", "Janitor", "DogHandler", "Sniper" }
	local ActiveFlag = false
	for _, typ in pairs(entityGroup) do
		if typ == CurrentEntity then
			ActiveFlag = true
			break
		end
	end
	entityGroup = nil
	return ActiveFlag
end

function Create()
	this.ItemToSpawn = "VendingSpawned"..string.sub(this.Type,12,-1)..this.SubType
	this.VendingActivated = false
	this.ItemToEquip0 = 0
	this.ItemToEquip1 = 0
end

function Update(timePassed)
	if this.FindEntity == nil then return end
	timeTot = timeTot + timePassed
	if timeTot > timePerUpdate then
		timeTot = 0
		timePerUpdate = 3
		if not Exists(theEntity) then
			theEntity = getEntity(this.FindEntity,2)
			if Exists(theEntity) then
				if this.VendingActivated == false then
					ActivateVendingEquipment()
				else													-- delete after loadgame
					DeactivateVendingEquipment()
					this.Delete()
				end
			else
				this.Delete()
			end
		else
			DeactivateVendingEquipment()
			this.Delete()
		end
	end
	if Exists(theEntity) then
		this.Pos.x,this.Pos.y = theEntity.Pos.x,theEntity.Pos.y+0.1
	end
end

function ActivateVendingEquipment()
	if this.UseActiveFlag == true then
		if theEntity.Equipment ~= nil then
			this.TmpEquipment = theEntity.Equipment						-- temp store entities equipment
		end
		theEntity.Equipment = Get(this,"ItemToEquip"..this.SubType)		-- set sold vending equipment
		theEntity.Active = true											-- show entity holding equipment in hand, bug: NOT supported by Orderly and modded staffmembers
		this.SubType = 2												-- transparent sprite subtype
	--else
		-- this entity can't seem to hold equipment in the hand, so we don't hide and just show the original sold vending item
	end
	this.VendingActivated = true
end

function DeactivateVendingEquipment()
	if this.UseActiveFlag == true then
		theEntity.Equipment = 0											-- remove sold vending equipment
		if this.TmpEquipment ~= nil then
			for i = 0,1000 do
				theEntity.Equipment = i
				if theEntity.Equipment == this.TmpEquipment then		-- if restore entities previous equipment
					break
				end
			end
		end
		theEntity.Active = false										-- hides the entities hand
	end
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end
