
local timeTot = 0

local Find = Object.GetNearbyObjects
local Get = Object.GetProperty
local Set = Object.SetProperty
local PrintJobTime = math.random(15,45)

function Create()
	Set(this,"Uploading",false)
	Set(this,"PrintJobRequest",false)
	Set(this,"PrintJobTimer",0)
	Set(this,"GatewayID",0)
	UpdateServers()
end

function UpdateServers()
	local nearbyServers = Find(this,"Server",10000)
	if next(nearbyServers) then
		for thatServer,dist in pairs(nearbyServers) do
			Set(thatServer,"UpdateClients",true)
		end
	end
end

function IsGatewayOrSwitch()
	if tonumber(this.TriggeredBy.i) > -1 and tonumber(this.TriggeredBy.i) == tonumber(this.GatewayID) then
		return true
	else
		--local ModuleTypes = { "NetworkSwitch", "LogicCircuit" }
		local ModuleTypes = { "LogicCircuit" }
		MyModule = nil
		for _, ModuleType in ipairs(ModuleTypes) do
			local Modules = Find(this,ModuleType,10000)
			for thatModule, _ in next, Modules do
				if thatModule.Id.i == tonumber(this.TriggeredBy.i) and thatModule.AvailableConnections ~= nil and tonumber(thatModule.AvailableConnections) > 0 then
					MyModule = thatModule
					Set(this,"GatewayID",this.TriggeredBy.i)
					break
				end
			end
			Modules = nil
		end
		if MyModule == nil then
			Set(this,"GatewayID",0)
			return false
		else
			return true
		end
	end
end

function FindMyTables()
	local nearbyTables = Find(this,"TableWorkPCLinkUp",2)
	if next(nearbyTables) then
		for thatTable,dist in pairs(nearbyTables) do
			if thatTable.HomeUID == this.HomeUID then
				MyTable = thatTable
				break
			end
		end
	end
	if MyTable == nil then
		local nearbyTables = Find(this,"TableWorkPCLinkDown",2)
		if next(nearbyTables) then
			for thatTable,dist in pairs(nearbyTables) do
				if thatTable.HomeUID == this.HomeUID then
					MyTable = thatTable
					break
				end
			end
		end
	end
	if MyTable == nil then
		this.Delete()
		return
	end
end

function ConnectTable()
	if this.LinkUp == false then
		local theX = MyTable.Pos.x
		local theY = MyTable.Pos.y
		local OrX = MyTable.Or.x
		local OrY = MyTable.Or.y
		this.CarrierId.i = -1
		this.CarrierId.u = -1
		this.Loaded = false
		MyTable.Slot0.i = -1
		MyTable.Slot0.u = -1
		MyTable.Slot1.i = -1
		MyTable.Slot1.u = -1
		MyTable.Slot2.i = -1
		MyTable.Slot2.u = -1
		MyTable.Slot3.i = -1
		MyTable.Slot3.u = -1
		MyTable.Delete()
		MyTable = Object.Spawn( "TableWorkPCLinkUp", theX,theY)
		MyTable.Or.x = OrX
		MyTable.Or.y = OrY
		Set(MyTable,"HomeUID",this.Id.u)
		MyTable.Slot3.i = this.Id.i
		MyTable.Slot3.u = this.Id.u
		this.CarrierId.i = MyTable.Id.i
		this.CarrierId.u = MyTable.Id.u
		this.Loaded = true
		Set(this,"LinkDown",false)
		Set(this,"LinkUp",true)
		this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nReady to use"
	end
end

function DisconnectTable()
	if this.LinkUp == true then
		local theX = MyTable.Pos.x
		local theY = MyTable.Pos.y
		local OrX = MyTable.Or.x
		local OrY = MyTable.Or.y
		this.CarrierId.i = -1
		this.CarrierId.u = -1
		this.Loaded = false
		MyTable.Slot0.i = -1
		MyTable.Slot0.u = -1
		MyTable.Slot1.i = -1
		MyTable.Slot1.u = -1
		MyTable.Slot2.i = -1
		MyTable.Slot2.u = -1
		MyTable.Slot3.i = -1
		MyTable.Slot3.u = -1
		MyTable.Delete()
		MyTable = Object.Spawn( "TableWorkPCLinkDown", theX,theY)
		MyTable.Or.x = OrX
		MyTable.Or.y = OrY
		Set(MyTable,"HomeUID",this.Id.u)
		MyTable.Slot3.i = this.Id.i
		MyTable.Slot3.u = this.Id.u
		this.CarrierId.i = MyTable.Id.i
		this.CarrierId.u = MyTable.Id.u
		this.Loaded = true
		this.SubType = 0 --change display to off
		Set(this,"LinkDown",true)
		Set(this,"LinkUp",false)
		this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nNot connected to Gateway or Server is down"
	end
	Set(this,"TriggeredBy.i",-1)
	Set(this,"TriggeredBy.u",-1)
end

function Update( timePassed )
	if timePerUpdate == nil then
		if this.HomeUID == nil then
			return
		end
		FindMyTables()
		timePerUpdate = (1+math.random()+math.random()) / World.TimeWarpFactor
	end
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		
		if MyTable == nil or MyTable.SubType == nil then this.Delete() end
		
		if tonumber(this.Triggered) >= 4 and IsGatewayOrSwitch() == true then
			ConnectTable()
			this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i
			if tonumber(MyTable.Slot0.i) > -1 and tonumber(MyTable.Slot1.i) > -1 then
				this.SubType = 1 --change display to on
				this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nIn use"
				Set(this,"Uploading",true)
			elseif tonumber(MyTable.Slot0.i) == -1 then 
				this.PrintJobTimer = this.PrintJobTimer + 1
				if this.PrintJobTimer >= PrintJobTime then
					PrintJobTime = math.random(15,45)
					print("Print job issued")
					Set(this,"PrintJobTimer",0)
					Set(this,"PrintJobRequest",true)
					Set(this,"PrintDocType","PiledUpBoringPaperWork")
				end
				this.SubType = 0 --change display to off
				this.Tooltip = "\nNetwork Client: "..this.Id.i.."\nConnection ID: "..this.TriggeredBy.i.."\nReady to use"
				Set(this,"Uploading",false)
			end
			
		else
			DisconnectTable()
			Set(this,"Uploading",false)
		end
		
	end
end
